c @z-------------------d_st.web-----------------------------
c
c This is the web file version of a nonlinear Schrodinger equation
c solver that will eventually  include varying 
c depth, breaking,  etc., and be coupled to Shorecirc.
c
c Author: Andrew Kennedy
c Start Date: April 2, 2001
c Last Revision date: July 12, 2004


           subroutine wavemodule()
           
            include 'params.h'
            include 'pass.h'

            integer  ll1, noutskip

	      character*20 fnames

cc-----------------------------------------------
            call minit()
            call init()
cc  First time step
            it = 0
	print *, it
            call quant1()
            call quant2()
            call derivs()
            call rhs()

c*****************
c modify possibly time steps, etc.

       cnt = int(real(master_dt*n_interval_callwave)/dt)
       dt =  real(master_dt*n_interval_callwave)/real(cnt) 

c  Loop through time steps
          do it = 1, cnt

c              print *, it
             do jt = 1, 4
              if (jt .eq. 1) then
                time = (float(it)-1 )*dt + time_master
              elseif (jt .eq. 2) then
                time = (float(it)-1 + 0.5)*dt  + time_master
              elseif (jt .eq. 3) then
                time = (float(it) -1 + 0.5)*dt  + time_master
              elseif (jt .eq. 4) then
                time = (float(it) -1 + 1)*dt  + time_master
              endif
             call quant2()
             call derivs()
             call rhs() 
		   call rk4a

c**********************
            end do

          end do 
c end of time steps - export to files and master program
c****************************************

           call export1()
        
          open(1,file='junk2.out')
          do i = 1, nx
           write(1,100)(uu(i,j),j=1,ny)
          end do 
          close(1)

          open(1,file='junk4.out')
          do i = 1, nx
           write(1,100)(vv(i,j),j=1,ny)
          end do 
          close(1)
		
		open(1,file='junk1.out')
          do i = 1, nx
           write(1,100)(etac(i,j),j=1,ny)
          end do 
          close(1)

	    open(1,file='junk3.out')
              do i = 1, nx
               write(1,100)
     &           ( abs(amp(i,j)),j=1,ny )
              end do 
              close(1)
c--------------------------------------

  100  format(401(f10.4))

c If proper number of intervals, print out sequential data files
        noutskip = int( time/(master_dt*n_interval_callwave) + 0.5)
	  if ( mod(noutskip,ncallskip) .eq. 0) then
	    noutskip = noutskip/ncallskip
        
               write(fnames,'(a8,i1,i1,i1,i1,i1,a4)')'data/amp',
     &     mod(noutskip/10000,10), mod(noutskip/1000,10),   
     &      mod(noutskip/100,10),
     &        mod(noutskip/10,10),mod(noutskip,10),'.out'
              open(1,file= fnames, status = 'unknown',
     &          access='direct', recl=i_hard*ny)
        do i = 1, nx
          write(1,rec=i),(abs(amp(i,j)), j=1,ny)
        end do
        close(1)
	 
	write(fnames,'(a8,i1,i1,i1,i1,i1,a4)')'data/eta', 
     &        mod(noutskip/10000,10), mod(noutskip/1000,10), 
     &        mod(noutskip/100,10),
     &        mod(noutskip/10,10),mod(noutskip,10),'.out'
        open(1,file= fnames, status = 'unknown', 
     &          access='direct', recl=i_hard*ny)
        do i = 1, nx
          write(1,rec=i),(etac(i,j), j=1,ny)
        end do
        close(1)

            write(fnames,'(a6,i1,i1,i1,i1,i1,a4)')'data/u',
     &       mod(noutskip/10000,10), mod(noutskip/1000,10), 
     &        mod(noutskip/100,10),
     &        mod(noutskip/10,10),mod(noutskip,10),'.out'
        open(1,file= fnames, status = 'unknown',
     &          access='direct', recl=i_hard*ny)
        do i = 1, nx
          write(1,rec=i),(uu(i,j), j=1,ny)
        end do
        close(1)

            write(fnames,'(a6,i1,i1,i1,i1,i1,a4)')'data/v',
     &        mod(noutskip/10000,10), mod(noutskip/1000,10), 
     &        mod(noutskip/100,10),
     &        mod(noutskip/10,10),mod(noutskip,10),'.out'
        open(1,file= fnames, status = 'unknown',
     &          access='direct', recl=i_hard*ny)
        do i = 1, nx
          write(1,rec=i),(vv(i,j), j=1,ny)
        end do
        close(1)


	  end if

          end

c*************************************************
c    Read in initial quantities and  set up system
         
         subroutine init()
           
          include 'params.h'
          include 'pass.h' 

          real ar, ai, tmp1, ldom, dum1
          
          complex im1

          integer k      


c Stuff input from shorecirc - overrides all other values
c**************** May 9 Temporarily removed
          dx = cdx
          dy = cdy
          nt = 1
          dt = cdt/float(nt)
          nx = cnx0
          ny = cny0

c cper = ...
c om = ...
           bc1 = mbcy          

           dx2 = 2.0*dx
           dy2 = 2.*dy
           dxsq = dx*dx
           dysq = dy*dy

           do j = 1, ny
            do i = 1, nx
             h(i,j) = ch(i,j)
             etac(i,j) = ceta(i,j)
c             etac(i,j) = 0.0
            end do
           end do


c***************************
c New stuff
          do i = 1, nx
             tmp1 = 0.0
             do j = 1, ny
              tmp1 = tmp1 + h(i,j)
             end do
             tmp1 = tmp1/float(ny)
             do j = 1, ny
              hbar(i,j) = max(tmp1, 0.01)
             end do
          end do 
          

           open(1,file='freqs.dat')
           read(1,*)nfreqs
           dum1 = 2.*pi/(dy*ny)
           do k = 1, nfreqs
             read(1,*) sfreq(k), famp(k), phase(k), wll(k)
             if (bc1 .eq. 1) then
               wll(k) = 0
             elseif (bc1 .eq. 3) then
               wll(k) = dum1*int(wll(k)/dum1+0.5)
               print *, wll(k), dum1,'ll'
             end if
           end do
           close(1)  
c******************
c  Take the first longshore wavenumber as the
c  representative longshore wavenumber for  underlying
c  vector wavenumber field

           cwnl = wll(1)
           per = 2.*pi/sfreq(1)
           om = sfreq(1)

	call kapsolve()
c*****************

          do i = 1, nx     
            do j = 1, ny
              uu(i,j) = intp_u_wave(i,j)
              vv(i,j) = intp_v_wave(i,j)
              etac(i,j) = intp_eta_wave(i,j)
            end do 
           end do
 
         do j = 1, ny
          do i = 1, nx 
           kapbar(i,j) = sqrt(kbar(i,j)**2 + lbar(i,j)**2)
          end do
         end do
         

	   do j = 1, ny
	     do i = 1, nx/10
	       wc(i,j) = 0.01*float(nx/10-i)/float(nx/10)
     &               *sqrt(g/(h(i,j)+0.1))
	     end do
	   end do
	   do j = 1, ny
	     do i = 1, nx
	        wc(i,j) = wc(i,j) + 0.0001*sqrt(g/(h(i,j)+0.1))
	     end do
	   end do
            

  100  format(401(f10.4))

          end 

c*********************************************************
c    Computes needed derivatives

        subroutine derivs()

          include 'params.h'
          include 'pass.h'
          real temp1
          integer  k

c  Symmetry and initialisation
c BC1 ** (1)=Wall, (2)=Open, (3)=Periodic
          do j = 1, ny
           amp(1,j) = ain2(j)
          end do
	

         if (bc1 .eq. 1) then
          do i = 1, nx
           amp(i,0) = amp(i,2)
           amp(i,ny+1) = amp(i,ny-1)
           cgb(i,ny+1) = - cgb(i,ny-1)
           cgb(i,0) = - cgb(i,2)
          end do
         elseif (bc1 .eq. 2) then
          do i = 1, nx
           amp(i,0) = amp(i,2)
           amp(i,ny+1) = amp(i,ny-1)
           cgb(i,ny+1) = cgb(i,ny-1)
           cgb(i,0) = cgb(i,2)
          end do
         elseif (bc1 .eq. 3) then
           do i = 1, nx
           amp(i,0) = amp(i,ny)
           amp(i,ny+1) = amp(i,1)
           cgb(i,ny+1) = cgb(i,1)
           cgb(i,0) = cgb(i,ny)
          end do
         end if 


c          print *, amp(1,1), amp(2,1),'amp'

c   Ax
          do j = 1, ny
            ax(2,j) = (amp(2,j) - amp(1,j))/dx
            ax(1,j) = ax(2,j) 
            do i = 3, nx
c               ax(i,j) = (3.*amp(i,j) - 4.*amp(i-1,j) 
c     &                  + amp(i-2,j) )/dx2
               ax(i,j) = (amp(i,j)-amp(i-1,j))/dx
            end do
          end do


c   Ay at lateral boundaries is complicated
c Wall boundary
          if (bc1 .eq. 1) then
            do  i = 1, nx
             ay(i,1) = 0.0
             ay(i,ny) = 0.0
            end do
c Open boundary
           elseif (bc1 .eq. 2) then
            do i = 1, nx
             ay(i,1) = 0.0
             ay(i,ny) = 0.0
            end do
c Periodic boundary
           elseif (bc1 .eq. 3) then
             do i = 1, nx
              j = 1 
              if ( cgb(i,j) .gt. 0.0) then
c               ay(i,j) = (3.*amp(i,j) - 4.*amp(i,j-1)
c     &                    + amp(i,ny-1))/dy2
               ay(i,j) = (amp(i,j)-amp(i,j-1))/dy
              else
c                 ay(i,j) = -(3.*amp(i,j) - 4.*amp(i,j+1)
c     &                     + amp(i,j+2))/dy2
                 ay(i,j) = (amp(i,j+1)-amp(i,j))/dy
              end if
              if (cgb(i,j) .eq. 0.0) then
                ay(i,j) = 0.0
              end if
             j = ny
             if ( cgb(i,j) .gt. 0.0) then
c               ay(i,j) = (3.*amp(i,j) - 4.*amp(i,j-1)
c     &                    + amp(i,j-2))/dy2
                ay(i,j) = (amp(i,j)-amp(i,j-1))/dy
              else
c                 ay(i,j) = -(3.*amp(i,j) - 4.*amp(i,j+1)
c     &                     + amp(i,2))/dy2
                  ay(i,j) = (amp(i,j+1)-amp(i,j))/dy
              end if
              if (cgb(i,j) .eq. 0.0) then
                ay(i,j) = 0.0
              end if
              end do
            end if

c more Ay
c         Difference direction depends on direction of cg + u
c**        
          do i = 1, nx
           do j = 2, ny-1
            if ( cgb(i,j) .gt. 0.0) then
c              ay(i,j) = (3.*amp(i,j) - 4.*amp(i,j-1)
c     &                   + amp(i,j-2))/dy2
               ay(i,j) = (amp(i,j)-amp(i,j-1))/dy
            else
c               ay(i,j) = -(3.*amp(i,j) - 4.*amp(i,j+1)
c     &                   + amp(i,j+2))/dy2
              ay(i,j) = (amp(i,j+1)-amp(i,j))/dy
            end if
            if (cgb(i,j) .eq. 0.0) then
              ay(i,j) = 0.0
            end if

           end do
c**
          end do

          do i = 1, nx
            do j = 1, ny
              ayc(i,j) = (amp(i,j+1) - amp(i,j-1))/(2.*dy)
            end do
          end do


c   Axy
c Axy doesn't need special boundary conditions because of symmetry,
c etc. at the beginning of the subroutine.
c Same with Axx, Ayy
c Start at i = 2  
        do i = 2, nx

         do j = 1, ny
           axy(i,j) = ( amp(i+1,j+1) - amp(i-1,j+1)
     &    - amp(i+1,j-1) + amp(i-1,j-1))/(4.*dx*dy)

         end do
        end do
        do j = 1, ny
         axy(1,j) = 0.0
         axy(nx,j) = 0.0
        end do

c   Ayy

          do j = 1, ny
            do i = 1, nx
              ayy(i,j) = (amp(i,j+1)-2.*amp(i,j)+amp(i,j-1))/dysq
            end do
          end do
           

c   Axx
          do j = 1, ny
            do i = 2, nx-1
              axx(i,j) = (amp(i+1,j)-2.*amp(i,j)+ amp(i-1,j))/dxsq 
            end do
cc           Set last (and first?) row of Axx = 0
             axx(1,j) = 0.0
             axx(nx,j) = (0.0, 0.0)
          end do                 

c  deldot ( (u+cg)/sigma ) 
c part1= cga/sigma, part2 = cgb/sigma 
c Wall BC 
         if (bc1 .eq. 1) then
          do i = 1, nx         
           part1(i,0) = part1(i,2)
           part1(i,ny+1) = part1(i,ny-1)
           part2(i,0) =   - part2(i,2)
           part2(i,ny+1) = - part2(i,ny-1)
          end do
c Open BC
         elseif (bc1 .eq. 2) then
          do i = 1, nx         
           part1(i,0) = part1(i,2)
           part1(i,ny+1) = part1(i,ny-1)
           part2(i,0) =   part2(i,2)
           part2(i,ny+1) =  part2(i,ny-1)
          end do
c Periodic BC
         elseif (bc1 .eq. 3) then
          do i = 1, nx         
           part1(i,0) = part1(i,ny)
           part1(i,ny+1) = part1(i,1)
           part2(i,0) =   part2(i,ny)
           part2(i,ny+1) =  part2(i,1)
          end do
         end if

          do j = 1, ny
           part1(0,j) =  part1(2,j)
           part1(nx+1,j) = 2.*part1(nx,j) - part1(nx-1,j)
           part2(0,j) = part2(2,j)
           part2(nx+1,j) = part2(nx,j)
          end do

          do j = 1, ny
           ddot12(1,j) = (part1(i,j)-part1(i-1,j))/dx
     &                 + (part2(i,j+1) - part2(i,j-1))/dy2
           do i = 2, nx
            ddot12(i,j) = 
     &       ( part1(i+1,j) -part1(i-1,j) )/dx2
     &         + (part2(i,j+1) - part2(i,j-1))/dy2
           end do
          end do
          


          end


c*************************************************
c     Computes RHS of time stepping equation

       subroutine rhs()

        include 'params.h'
        include 'pass.h'
        integer  k
     
        real kh, ka, uhat, vhat, khat, lhat, rho, swfac
        complex im1, qu1

        im1 = (0.0,1.0)
        rho = 1015.0

         call brkroel()

        do j = 1, ny
         do i = 2, nx
           kh = wnk(i,j)*h(i,j)
           ka = wnk(i,j)*abs(amp(i,j))

           qu1 = ( axx(i,j)*kk(i,j)**2 
     &           + 2*axy(i,j)*kk(i,j)*ll(i,j)
     &           + ayy(i,j)*ll(i,j)**2 )/wnk(i,j)**2





           at(i,j) = 0.0 
     &         - cga(i,j)*ax(i,j) 
     &              - cgb(i,j)*ay(i,j)
     &        - 0.5*sigma(i,j)*ddot12(i,j)*amp(i,j)
     &  + (    0.5*im1*cg(i,j)/wnk(i,j)*(axx(i,j)+ ayy(i,j))
     &     - 0.5*im1*(cg(i,j)/wnk(i,j) - sigkk(i,j))*qu1
     &     -im1*sigma(i,j)/2.*amp(i,j)*( (1 + f1(i,j)*ka**2*dd(i,j))
     &      *tanh(kh + f2(i,j)*ka)/tanh(kh) -1 ) 
     &      )

      
           
c*******************************************
c New terms for crossing characteristics
      
            at(i,j) = at(i,j) + ( 
     &          - 0.5*im1*amp(i,j)*(
c     &       -2.*(khat*uu(i,j) + lhat*vv(i,j))
     &         - 2.*cg(i,j)
     &         *kaphat(i,j) )
     &         )

c***********************8

c   Breaking from brkroel subroutine     
           at(i,j) = at(i,j) - w(i,j)*amp(i,j)

         end do
        end do


        end

c*******************************************
c    Predictor time stepping
c    Fourth order Runge-Kutta

        subroutine rk4a()
           
         include 'params.h'
         include 'pass.h'
         
       if (jt. eq. 1) then
         do j = 1, ny
          do i = 2, nx

           aold(i,j) = amp(i,j)
           amp(i,j) = aold(i,j) + 0.5*dt*at(i,j)
           at1(i,j) = at(i,j)

          end do
         end do
 
       elseif (jt .eq. 2) then
         do j = 1, ny
          do i = 2, nx
           
           amp(i,j) = aold(i,j) + 0.5*dt*at(i,j)
           at2(i,j) = at(i,j)

          end do
         end do

       elseif (jt .eq. 3) then
         do j = 1, ny
          do i = 2, nx

           amp(i,j) = aold(i,j) + dt*at(i,j)
           at3(i,j) = at(i,j)
          
          end do
         end do

        elseif (jt. eq. 4) then
          do j = 1, ny
          do i = 2, nx
        
           amp(i,j) = aold(i,j) + dt/6.*( at(i,j)
     &       + 2.*at2(i,j) + 2.*at3(i,j) + at1(i,j) )

          end do
         end do

       end if

        end

c************************************
c    Calculate lots of quantities
       
      subroutine quant1()
      include 'params.h'
      include 'pass.h'
     
      real kh

      do j = 1, ny
       do i = 1, nx


c*************************************
c New stuff for diffraction - wavenumber field adjustment

        q(i,j) = kapbar(i,j)*(hbar(i,j))

        sigbar(i,j) = sqrt( g*kapbar(i,j)*tanh(q(i,j)) )

        omk(i,j) = sigbar(i,j) 

        call kap3(i,j)
        kk(i,j) = kbar(i,j)*(wnk(i,j)/kapbar(i,j))
        ll(i,j) = lbar(i,j)*(wnk(i,j)/kapbar(i,j))
        


c***************************8


        q(i,j) = wnk(i,j)*h(i,j)
        
        kh = q(i,j)
        nn(i,j) = 0.5*(1.0 + 2.*kh/sinh(2.*q(i,j)))
        sigma(i,j) = sqrt( g *wnk(i,j)*tanh(q(i,j)))

        sigkk(i,j) = sigma(i,j)/wnk(i,j)**2 *
     &  ( q(i,j)*cosh(kh)/sinh(kh) - nn(i,j)**2 - 2*nn(i,j)*q(i,j)
     &    *tanh(q(i,j)) )

         
        f1(i,j) = tanh(q(i,j))**5
        f2(i,j) = (q(i,j)/sinh(q(i,j)))**4

        dd(i,j) = (cosh(4.*kh) + 8 - 2.*tanh(kh)**2)/ 
     &        (8.* sinh(kh)**4)


        cg(i,j) = nn(i,j)*sigma(i,j)/wnk(i,j)


       end do
      end do


      end
c******************************************************8
      subroutine quant2()
      include 'params.h'
      include 'pass.h'

      real kh, thet, junk1, ldom, het
      complex im1
      integer  k

c   Amplitude of input wave at boundary
           ldom = 2.*pi/(float(ny)*dy)
           im1 = (0.,1.)
            do j = 1, ny
             ain2(j) = (0., 0.)
             do k = 1, nfreqs

               ain2(j) = ain2(j) + famp(k)
     &        *exp( im1*( (wll(k) - cwnl) *float(j-1)*dy
     &      -(sfreq(k)-om)*time + phase(k) ) )
             end do
             ain2(j) = ain2(j)*tanh(time/250.)
     &
            end do



      do j = 1, ny
       do i = 1, nx

         cga(i,j) = cg(i,j)*kk(i,j)/wnk(i,j)

        cgb(i,j) = cg(i,j)*ll(i,j)/wnk(i,j) 


        part1(i,j) = cga(i,j)/sigma(i,j)
        part2(i,j) = cgb(i,j)/sigma(i,j)


        end do
       end do
c ***************************************
c    Mass transport
        do j = 1, ny
        do i = 1, nx
           cwh(i,j) = 2.*abs(amp(i,j))
          cmf(i,j) = 1./8.*g*cwh(i,j)**2/(sigma(i,j)/wnk(i,j))
        end do
       end do

c****************************************8
c Angle

       do j = 1, ny
        do i = 1, nx
         junk1 = (Ax(i,j)*kk(i,j) + Ayc(i,j)*ll(i,j))/wnk(i,j)**2
         if ( (abs(amp(i,j)) .gt. 1.0e-6) .and. (ang_use .eq. 2) ) then
          ctheta(i,j) = 
     &    atan( imag( (Ax(i,j)/amp(i,j) +im1*kk(i,j) )/
     &                (Ayc(i,j)/amp(i,j) +im1*ll(i,j) ) ) )

        else
         ctheta(i,j) = atan( ll(i,j) / kk(i,j) )
        end if
        end do
       end do

c*************************************************
c     wavenumber perturbation

       do j = 1, ny
        do i = 1, nx
          het = max(h(i,j)+etac(i,j), 0.01)

         kaphat(i,j) = - wnk(i,j)*(
     & (uu(i,j)*cos(ctheta(i,j))+vv(i,j)*sin(ctheta(i,j))
     &     -cmf(i,j)/het)
     & /cg(i,j)  
     &     + (het-hbar(i,j))/hbar(i,j)
     &     *(nn(i,j)-0.5)/nn(i,j) )

        end do
       end do

       end

c**********************************************

c************************************************************************
c  Roelvink breaking subroutine

        subroutine brkroel()

        include 'params.h'
        include 'pass.h'
       real gambr, kbr, het, brtmp, wh, brc1, temp2, thr1, rho
       real tempx, tempy, aabs, fp
       integer  nexp

       gambr = 0.55
       nexp = 10

       do i = 1, nx
        do j = 1, ny
          aabs = abs(amp(i,j))

          temp2 = 
     &     1. - exp( -(2.*aabs/(gambr*h(i,j)))**nexp )
          fp = om/(2.*pi)
          w(i,j) = temp2*fp
c increase dissipation
     &            *1.0

        end do
       end do

        end



c************************************************************************
c   Compute wavenumber from frequency using linear dispersion 

       
       subroutine kap3(i,j)
       include 'params.h'
       include 'pass.h'

       real tmp1, dtmp1,tmp2, itfrac
       integer  k

        itfrac = 1.0
        wnk(i,j) = kapbar(i,j)

       do k = 1, 5

        kk(i,j) = kbar(i,j)*wnk(i,j)/kapbar(i,j)
        ll(i,j) = lbar(i,j)*wnk(i,j)/kapbar(i,j)

         sigma(i,j) = omk(i,j)
      
        tmp2 = wnk(i,j)*(h(i,j))    

        tmp1 = sigma(i,j)**2 - g*wnk(i,j)*tanh(tmp2)

        dtmp1 = - g*tanh(tmp2) 
     &          - g*tmp2/cosh(tmp2)**2


        wnk(i,j) = wnk(i,j) - itfrac *tmp1/dtmp1

       end do


       end

c*************************************8

       subroutine kapsolve()
c  Solves kappa_bar for u_hat = 0, etac_hat = 0, h_bar

       include 'params.h'
       include 'pass.h'

       real tmp1, dtmp1,tmp2, itfrac
       integer k

        itfrac = 1.0

       do j = 1, ny
       do i = 1, nx


       kapbar(i,j) = om**2/(g*sqrt(tanh(om**2*hbar(i,j)/g)))

       do k = 1, 5

        tmp2 = kapbar(i,j)*(hbar(i,j))    

        tmp1 = om**2 - g*kapbar(i,j)*tanh(tmp2)

        dtmp1 = - g*tanh(tmp2) 
     &        - g*(sqrt(tmp2)/cosh(tmp2))*(sqrt(tmp2)/cosh(tmp2))

        kapbar(i,j) = kapbar(i,j) - itfrac *tmp1/dtmp1

       end do

c  Constant longshore component of wavenumber
         lbar(i,j) = cwnl
         kbar(i,j) = sqrt( kapbar(i,j)**2 - lbar(i,j)**2)
       
       end do
       end do

  100  format(401(f10.4))


       end


c****************************************************************

       subroutine export1()

       include 'params.h'
       include 'pass.h'
       
       real eps1, thr1, br1, sm, sp, gg, khet, wtmp1, wtmp2
       real rho, junk1, het, croll, thetmp
       complex im1

  
       eps1 = 1.0e-8
       thr1 = 0.7  
       rho = 1015.0
       croll = 5.0

c Absolute horizontal bottom velocity

       do j = 1, ny
        do i = 1, nx
         pass_ubott(i,j)= wnk(i,j)*abs(amp(i,j))*g/( sigma(i,j)*
     &      cosh(wnk(i,j)*(h(i,j)) ) )
        end do
       end do

c Sigma, wavenumber, wave height
       
        do j = 1, ny
         do i = 1, nx
          csigma(i,j) = sigma(i,j)
          cwn(i,j) = wnk(i,j)
          pass_height(i,j) = 2.*abs(amp(i,j))
          cwh(i,j) = pass_height(i,j)
          pass_cg(i,j) = cg(i,j)
          pass_c(i,j) = cg(i,j)/nn(i,j)
          pass_wavenum(i,j) = wnk(i,j)
         end do
        end do
        pass_period = 2*pi/om

c Radiation stress
        
       do j = 1, ny
        do i = 1, nx
       
         junk1 = (Ax(i,j)*kk(i,j) + Ayc(i,j)*ll(i,j))/wnk(i,j)**2
         if (abs(amp(i,j)) .gt. 1.0e-6) then
         thetmp =
     &   atan( ( imag( (ayc(i,j)-junk1*ll(i,j))
     &          /(amp(i,j))) + ll(i,j) )/
     &    ( imag((ax(i,j)-junk1*kk(i,j))
     &          /(amp(i,j))) + kk(i,j) ) )
        else
         thetmp = atan( ll(i,j) / kk(i,j) )
        end if


          khet = wnk(i,j)*h(i,j) 
          gg = 2.*khet/sinh(2.*khet)
          wtmp1 = 1./16.*g*cwh(i,j)**2
          csxx(i,j) = wtmp1*(1.+gg)*cos(thetmp)**2
     &                + wtmp1*gg          
          csxy(i,j) =wtmp1*(1.+gg)*cos(thetmp)*sin(thetmp)
          csyy(i,j) = wtmp1*(1.+gg)*sin(thetmp)**2
     &                + wtmp1*gg  
          pass_sxx(i,j) = csxx(i,j)*1030.          
          pass_sxy(i,j) = csxy(i,j)*1030.
          pass_syy(i,j) = csyy(i,j)*1030.

          pass_theta(i,j) = thetmp
        end do
       end do
   

c Wave induced mass transport
       
       do j = 1, ny
        do i = 1, nx
                    
c         if ( brfrac(i,j) .lt. 0.7) then
          pass_massfluxu(i,j) = 
     &    1./8.*g*cwh(i,j)**2/(csigma(i,j)/cwn(i,j)) 
     &    *cos(ctheta(i,j)) 

          pass_massfluxv(i,j) = 
     &    1./8.*g*cwh(i,j)**2/(csigma(i,j)/cwn(i,j))
     &    *sin(ctheta(i,j)) 


        end do
       end do


        if (mbcy .eq. 3) then
          do i = 1, nx
            csigma(i,ny+1) = csigma(i,1)
            cwn(i,ny+1) = cwn(i,1)
            cwh(i,ny+1) = cwh(i,1) 
            csxx(i,ny+1) = csxx(i,1)
            csxy(i,ny+1) = csxy(i,1)
            csyy(i,ny+1) = csyy(i,1)
            cmf(i,ny+1) = cmf(i,1)
            cdiss(i,ny+1) = cdiss(i,1)
            cubott(i,ny+1) = cubott(i,1)
            ctheta(i,ny+1) = ctheta(i,1)
          end do
       end if


          do i = 1, nx
            do j = 1, ny
              dsxxdx(i,j) = (csxx(i+1,j)-csxx(i-1,j))/dx2
              dsxydx(i,j) = (csxy(i+1,j)-csxy(i-1,j))/dx2
            dsyydy(i,j) = (csyy(i,j+1)-csyy(i,j-1))/dy2
              dsxydy(i,j) = (csxy(i,j+1)-csxy(i,j-1))/dy2
            end do
           end do

          do j = 1, ny
            dsxxdx(nx,j) = (csxx(nx,j)-csxx(nx-1,j))/dx
            dsxydx(nx,j) = (csxy(nx,j)-csxy(nx-1,j))/dx
            dsxxdx(1,j) = (csxx(2,j)-csxx(1,j))/dx
            dsxydx(1,j) = (csxy(2,j)-csxy(1,j))/dx
          end do 



c Energy Dissipation
       do j = 1, ny
        do i = 1, nx
           pass_diss(i,j) =  rho*g*abs(amp(i,j)**2)*w(i,j)
           pass_wave_fy(i,j) = 
     &     - 1./(h(i,j)+etac(i,j))*( dsxydx(i,j) + dsyydy(i,j))
                      cdiss(i,j) =  rho*g*abs(amp(i,j)**2)*w(i,j)
           pass_wave_fx(i,j) = 
     &     - 1./(h(i,j)+etac(i,j))*( dsxydy(i,j) + dsxxdx(i,j))
           
           

        end do
       end do

  100  format(401(f10.4))

        end

c**********************************************************************************
c****************************************************
c   Read in initial quantities

       subroutine minit()

       include 'params.h'
       include 'pass.h'

       real  temp,temp1,temp2
       integer xcor,ycor,err

        open (1,file='winput.dat')

        read(1,*) cdx
        read(1,*) cdy
        read(1,*) cdt
        read(1,*) mbcy
	  read(1,*) ncallskip
	  read(1,*) i_hard
	  read(1,*) ang_use
        

        close(1)

c master program things

       cnt = int(real(master_dt*n_interval_callwave)/dt)
       dt =  real(master_dt*n_interval_callwave)/real(cnt)
       cnx0 = nx_wave
       cny0 = ny_wave
       
        do i = 1, cnx0
          do j = 1, cny0
            ch(i,j) = depth_wave(i,j) +pass_tide
          end do
        end do


       end


c***********************************************************************************

