%-----------------------------------------------------------
% Matlab program for vector plot of results from "SHORECIRC"
%-----------------------------------------------------------
clear

load status.dat
dx = status(1,1); dy = status(1,2); dt=status(1,3); cr=status(1,4);
nx = status(2,1); ny = status(2,2); ntime=status(2,3); dtplot=status(2,4);

filename=['fort.311'];
 fid=fopen(filename);
H=fread(fid,[ny,nx],'float');

ext = input('enter fort-datafile extension number ','s');
filename=['fort.',num2str(ext)];
fid=fopen(filename);
all=fread(fid,[ny,3*nx],'float');
z=all(:,1:nx); qx=all(:,nx+1:2*nx); qy=all(:,2*nx+1:3*nx);
x=0:dx:(nx-1)*dx;
y=0:dy:(ny-1)*dy;

% read bathymetry
fid=fopen('fort.311');
ht=fread(fid,[ny,nx],'float');

%read Qwy
fid=fopen('fort.327');
qwy=fread(fid,[ny,nx],'float');
%Vw=qwy./ht;
Vw=qwy./(ht+z);

%read Qwx
fid=fopen('fort.326');
qwx=fread(fid,[ny,nx],'float');
%Uw=qwx./ht;
Uw=qwx./(ht+z);

%read shoreline position
fid=fopen('fort.701');
nxa=fscanf(fid,'%d',ny);
xnxa(1,1:ny)=y; xnxa(2,1:ny)=nxa'*dx;



% vector plot of the velocities ------------------------------------------
lt=2;
k = 0;
for i=1:lt:nx;
   k = k+1;
   xx(k) = x(i);
   m = 0;
   for j=1:lt:ny;
     m = m+1;
     yy(m) = y(j);
     hh0(m,k) = ht(j,i); zit(m,k)=z(j,i);
% total velocities/fluxes
     u0(m,k) = qx(j,i)/(ht(j,i)+z(j,i));
     v0(m,k) = qy(j,i)/(ht(j,i)+z(j,i));
     qx0(m,k) = qx(j,i);
     qy0(m,k) = qy(j,i);
     qq(m,k)  = sqrt(qx0(m,k)^2+qy0(m,k)^2);
% bellow-trough velocities/fluxes
     um(m,k) = (qx(j,i)-qwx(j,i))/(ht(j,i)+z(j,i));
     vm(m,k) = (qy(j,i)-qwy(j,i))/(ht(j,i)+z(j,i));
% test for values near shoreline
%     if (xx(k)>=300) & (qq(m,k) <= 0.1) & (abs(zit(m,k)+hh0(m,k)) <= 0.2)
%     if (xx(k)>=300) &  (abs(zit(m,k)+hh0(m,k)) <= 0.3)
     if xx(k) >= xnxa(2,j);
	u0(m,k)=0; v0(m,k)=0; 
     end 
   end
end


% "Cropping" flow variables past the shoreline position
for j=1:ny;
  for i=1:nx;
    if x(i) >= xnxa(2,j);
       Um(j,i)=0; Vm(j,i)=0; U0(j,i)=0; V0(j,i)=0; Vw(j,i)=0; Uw(j,i)=0;
    else
	U0(j,i) = qx(j,i)/(ht(j,i)+z(j,i));	%total depth-averaged velocity
	V0(j,i) = qy(j,i)/(ht(j,i)+z(j,i));	%total depth-averaged velocity
	Um(j,i) = U0(j,i)-Uw(j,i);		%undertow
	Vm(j,i) = V0(j,i)-Vw(j,i);		%bellow-trough longshore current
        if (x(i)>=300) & (abs(z(j,i)+ht(j,i)) <= 0.3)
	   Vw(j,i)=0; Uw(j,i)=0;
	   V0(j,i)=0; U0(j,i)=0;
	   Um(j,i) = U0(j,i)-Uw(j,i);
	   Vm(j,i) = V0(j,i)-Vw(j,i);
        end
    end
  end
end
Umax = max(max(abs(U0)))
Vmax = max(max(abs(V0)))
UVmax = max(max(sqrt(U0.^2+V0.^2)));




figure(2);clf;orient tall

it=dtplot*(str2num(ext)-100);
%cf = contour(x,y,z);
cf = contour(x,y,H);
hold on;

%quiver(xx,yy,um,vm,1.3); title(['Undertow Velocity vectors; it=',num2str(it)])
quiver(xx,yy,u0,v0,1.3); title([pwd,'  V_\alpha; it=',num2str(it)])
%quiver(xx,yy,qx0,qy0); title(['Flux vectors; it=',num2str(it)])
axis('equal');xlabel('x (m)');ylabel('y (m)')
 grid on
xmax = max(x); xmin = min(x); ymax = max(y); ymin = min(y);

set(gca,'XLim',[xmin xmax]); ...
set(gca,'YLim',[ymin ymax]); ...

line(xnxa(2,1:ny),xnxa(1,1:ny), 'linestyle','-','Linewidth',[1.2])
orient tall


hold off;
