C ------------------------------------------------------------------
c   Common blocks for interface of Nearshore Community Model
c   It is used in master program, wave module, circulation module,
c   and sediment module.
c      Fyshi 01/21/2002   
c ------------------------------------------------------------------

       integer Nx_Max, Ny_Max, Nx_Circ, Ny_Circ, Nx_Wave,Ny_Wave,
     &         Nx_Mast, Ny_Mast, Nx_Sedi, Ny_Sedi
  
       parameter (Nx_Max = 1000, Ny_Max = 1000) 
 
c -- wave module:

       real Pass_Sxx(Nx_Max,Ny_Max), Pass_Sxy(Nx_Max,Ny_Max),
     &      Pass_Syy(Nx_Max,Ny_Max),
     &      Pass_Sxx_body(Nx_Max,Ny_Max),Pass_Sxy_body(Nx_Max,Ny_Max),
     &      Pass_Syy_body(Nx_Max,Ny_Max),
     &      Pass_Sxx_surf(Nx_Max,Ny_Max),
     &      Pass_Sxy_surf(Nx_Max,Ny_Max),
     &      Pass_Syy_surf(Nx_Max,Ny_Max),
     &      Pass_Wave_Fx(Nx_Max,Ny_Max),Pass_Wave_Fy(Nx_Max,Ny_Max), 
     &      Pass_MassFluxU(Nx_Max,Ny_Max),
     &      Pass_MassFluxV(Nx_Max,Ny_Max),
     &      Pass_MassFlux(Nx_Max,Ny_Max),	
     &      Pass_Diss(Nx_Max,Ny_Max),
     &      Pass_WaveNum(Nx_Max,Ny_Max), Pass_Theta(Nx_Max,Ny_Max),
     &      Pass_ubott(Nx_Max,Ny_Max), Pass_Height(Nx_Max,Ny_Max),
     &      Pass_freq,Pass_C(Nx_Max,Ny_Max),Pass_Cg(Nx_Max,Ny_Max),	      
     &      Pass_period,
     &      Intp_U_Wave(Nx_Max,Ny_Max), Intp_V_Wave(Nx_Max,Ny_Max)
  	
       real Pass_ibrk(Nx_Max,Ny_Max)

c -- circulation module:

       real Pass_U(Nx_Max,Ny_Max),Pass_V(Nx_Max,Ny_Max),
     &      Pass_eta(Nx_Max,Ny_Max),
     &      Pass_d11(Nx_Max,Ny_Max), Pass_d12(Nx_Max,Ny_Max),
     &      Pass_e11(Nx_Max,Ny_Max), Pass_e12(Nx_Max,Ny_Max),
     &      Pass_f11(Nx_Max,Ny_Max), Pass_f12(Nx_Max,Ny_Max)

c -- sediment module:

	real Pass_Dupdated(Nx_Max,Ny_Max),
     &      Intp_U_Sedi(Nx_Max,Ny_Max),
     &      Intp_V_Sedi(Nx_Max,Ny_Max)

c -- coordinate systems, depth and ...

       real Depth_Circ(Nx_Max,Ny_Max),Depth_Wave(Nx_Max,Ny_Max),
     &      X_Wave(Nx_Max,Ny_Max),Y_Wave(Nx_Max,Ny_Max), 
     &      X_Circ(Nx_Max,Ny_Max),
     &      Y_Circ(Nx_Max,Ny_Max), Pass_tide,  
     &      U_wind,V_wind,
     &      Depth_Sedi(Nx_max,Ny_Max),X_Sedi(Nx_Max,Ny_Max),
     &      Y_Sedi(Nx_Max,Ny_Max),
     &      X_Mast(Nx_Max,Ny_Max),Y_Mast(Nx_Max,Ny_Max),
     &      Depth_Mast(Nx_Max,Ny_Max)
 
c -- control parameters

       integer Master_Start

       real T_Interval_CallWave,T_Interval_CallCirc,T_Interval_CallSedi,
     &     T_Interval_Output   
       real Total_Time, Master_dt,Time
       logical Grid_Mast_Wave_Same, Grid_Mast_Circ_Same,
     &         Grid_Mast_Sedi_Same, Grid_Wave_Circ_Same,
     &         Grid_Wave_Sedi_Same, Grid_Circ_Sedi_Same,
     &         Wave_Staggered, Circ_Staggered,Sedi_Staggered,
     &         Wave_Structured, Circ_Structured, Sedi_Structured,
     &         Grid_Extrapolation,
     &         Wave_Curr_Interact,
     &         Wave_Bed_Interact,
     &         Curr_Bed_Interact

c -- file names

      character*255 f_name1,f_name2,f_name3,f_name4,f_name5,
     &              f_name6,f_name7,
     &              f_name8,
     &              f_name9,f_name10,f_name11,f_name12,
     &              f_name13,f_name14,
     &              f_name15,f_name16

c -- common blocks

       common/waves/Pass_Sxx,Pass_Sxy,Pass_Syy,
     &             Pass_Sxx_body,Pass_Sxy_body,Pass_Syy_body,
     &             Pass_Sxx_surf,Pass_Sxy_surf,Pass_Syy_surf,
     &             Pass_Wave_Fx,Pass_Wave_Fy,	 
     &             Pass_MassFluxU,
     &             Pass_MassFluxV,Pass_MassFlux,
     &             Pass_Diss, Pass_WaveNum, Pass_Theta,    
     &             Pass_ubott,Pass_Height, Pass_tide,
     &             Depth_Wave,Nx_Wave,Ny_Wave,
     &             X_Wave,Y_Wave,
     &             Pass_freq,Pass_C,Pass_Cg,
     &             Pass_ibrk,Pass_period,
     &             Intp_U_Wave, Intp_V_Wave
        common/circ/Depth_Circ,Pass_U,Pass_V,
     &              Nx_Circ,Ny_Circ,
     &              X_Circ,Y_Circ,
     &              Pass_eta,U_wind, V_wind,
     &              Pass_d11,Pass_d12,Pass_e11,Pass_e12,
     &              Pass_f11,Pass_f12

        common/sedi/Pass_Dupdated,Nx_Sedi,Ny_Sedi,
     &              Depth_Sedi,X_Sedi,Y_Sedi,
     &              Intp_U_Sedi,Intp_V_Sedi	 

	common/contr/Nx_Mast,Ny_Mast,
     &              X_Mast,Y_Mast,	
     &              T_Interval_CallCirc, T_Interval_CallWave, 
     &              T_Interval_CallSedi, T_Interval_Output,
     &              Master_Start, Depth_Mast,
     &              Total_Time, Master_dt, Time,
     &              Grid_Mast_Wave_Same, Grid_Mast_Circ_Same,
     &              Grid_Mast_Sedi_Same,
     $              Grid_Wave_Circ_Same,
     &              Grid_Wave_Sedi_Same, Grid_Circ_Sedi_Same, 
     &              Wave_Staggered, Circ_Staggered,Sedi_Staggered,
     &              Wave_structured, Circ_Structured, Sedi_Structured,
     &              Grid_Extrapolation,
     &              Wave_Curr_Interact,
     &              Wave_Bed_Interact,
     &              Curr_Bed_Interact            


      common/filename/f_name1,f_name2,f_name3,f_name4,
     &        f_name5,f_name6,f_name7,
     &        f_name8,
     &        f_name9,f_name10,f_name11,f_name12,f_name13,f_name14,
     &        f_name15,f_name16
