C***********************************************************************
C
C     Common blocks for pom2k.f
C
C***********************************************************************
C
C     source_c should agree with source in pom2k.f.
C
      implicit none
      character*40 source_c

      parameter(source_c='pom nearshore  2004-02-14')
     
C
C***********************************************************************
C
C     Array sizes:
C
      include "imjmkb.h"
C constants
      include "def.h"
C
C     Scalars:
C
cpn   new common blocks
      integer istrat,ibcon,ibot,islip,isurf,iprod,impflg,ibc,
     *  iwind,itflux,iread,itbc,nav,ipert
      common/pom_flgs/
     $  istrat        ,ibcon           ,ibot           ,islip          ,   
     $  isurf         ,iprod           ,ibc            ,impflg(IM,JM)  ,
     $  iwind         ,itflux          ,iread          ,itbc           ,
     $  nav           ,ipert 
c
C
      logical lramp
      integer 
     $  nadv1          ,nitera1        ,nread          ,isplit         ,
     $  nadv2          ,nitera2        ,irstrt         ,iave           ,
     $  icm            ,ncmout         ,io(ICMO)       ,jo(ICMO)       ,
     $  ko(ICMO)       ,nbct           ,nbcs           ,iend           ,
     $  ispadv         ,iswtch         

      real 
     $  hours          ,prtd1          ,prtd2          ,swtch          , 
     $  cbcmin         ,cbcmax         ,horcon         ,sw             ,
     $  smoth          ,f0             ,period         ,time0          ,
     $  xl1            ,xl2            ,rollerb        ,windinu        ,
     $  windinv        ,xl3            ,xl4            ,ispi           ,
     $  isp2i          ,ton            ,ave            ,wfact          ,
     $  tramp          ,amp            ,at             ,b1t            ,
     $  onethrd        ,tfluxin        ,tswin          ,xlast          ,
     $  deltap         ,toff           ,xpert

      common/pom_inipom/
     $  hours          ,prtd1          ,prtd2          ,swtch          , 
     $  cbcmin         ,cbcmax         ,horcon         ,sw             ,
     $  smoth          ,f0             ,period         ,time0          ,
     $  ispi           ,isp2i          ,xl1            ,xl2            ,
     $  rollerb        ,windinu        ,windinv        ,xl3            ,
     $  xl4            ,ton            ,ave            ,wfact          ,
     $  tramp          ,amp            ,at             ,b1t            ,
     $  onethrd        ,tfluxin        ,tswin          ,xlast          ,
     $  deltap         ,toff           ,xpert          ,
     $  nadv1          ,nitera1        ,nread          ,isplit         ,
     $  nadv2          ,nitera2        ,ncmout         ,irstrt         ,
     $  io             ,jo             ,ko             ,lramp          ,
     $  nbct           ,nbcs           ,ispadv         ,
     $  iend           ,iswtch         ,icm            ,iave

      real
     $  wavg           ,omu            ,
     $  omv            ,theta          ,kk             ,ubotw          ,
     $  waveper        ,omega          ,hrms           ,wubody         ,
     $  wvbody         ,pros           ,mx             ,my             ,
     $  wv1            ,wu1            ,wbv            ,wbu            ,
     $  pert           ,fact3
 
      common/pom_wves/
     $                  wavg(IM,JM)    ,
     $  theta(IM,JM)   ,kk(IM,JM)      ,omu(IM,JM)     ,omv(IM,JM)     ,
     $  waveper        ,omega          ,hrms(IM,JM)    ,ubotw(IM,JM)   ,
     $  wubody(IM,JM)  ,wvbody(IM,JM)  ,pros(IM,JM,KB) ,mx(IDB,JDB)    ,
     $  my(IDB,JDB)    ,wv1(IM,JM)     ,wu1(IM,JM)     ,wbv(IM,JM)     ,
     $  wbu(IM,JM)     ,pert(IM,JM)    ,fact3(IDB,JDB)

cpn end new common blocks
cpn note that some variables have been added to blocks where they seemed
cpn to belong 

      integer
     $  iint           ,iprint         ,iskp           ,jskp           ,
     $  kl1            ,kl2            ,mode           ,ntp             

      real
     $  alpha          ,dte            ,dti            ,dti2           ,  
     $  hmax           ,dte2           ,
     $  ramp           ,rfe            ,rfn            ,rfs            ,
     $  rfw            ,rhoref         ,sbias          ,slmax          ,
     $  small          ,tbias          ,time           ,tprni          ,
     $  umol           ,vmaxl          ,z0sflg         ,zref   

      common/pom_blkcon/ 
     $  alpha          ,dte            ,dti            ,dti2           ,
     $  hmax           ,dte2           , 
     $  ramp           ,rfe            ,rfn            ,rfs            ,
     $  rfw            ,rhoref         ,sbias          ,slmax          ,
     $  small          ,tbias          ,time           ,tprni          ,
     $  umol           ,vmaxl          ,z0sflg         ,zref           ,
     $  iint           ,iprint         ,iskp           ,jskp           ,
     $  kl1            ,kl2            ,mode           ,ntp     
C
C-----------------------------------------------------------------------
C
C     1-D arrays:
C
      real
     $  dz             ,dzz            ,z              ,zz
C
      common/pom_blk1d/ 
     $  dz(KB)         ,dzz(KB)        ,z(KB)          ,zz(KB) 
C
C-----------------------------------------------------------------------
C
C     2-D arrays:
C
      real
     $  aam2d          ,advua          ,advva          ,adx2d          ,
     $  ady2d          ,art            ,aru            ,arv            ,
     $  cbc            ,cor            ,d              ,drx2d          ,
     $  dry2d          ,dt             ,dum            ,dvm            ,
     $  dx             ,dy             ,east_c         ,east_e         ,
     $  east_u         ,east_v         ,e_atmos        ,egb            ,
     $  egf            ,el             ,elb            ,elf            ,
     $  et             ,etb            ,etf            ,fluxua         ,
     $  fluxva         ,fsm            ,h              ,north_c        ,
     $  north_e        ,north_u        ,north_v        ,psi            ,
     $  rot            ,ssurf          ,swrad          ,z0s            ,
     $  tps            ,tsurf          ,ua             ,z0c            ,
     $  uab            ,uaf            ,utb            ,utf            ,
     $  va             ,vab            ,vaf            ,vflux          ,
     $  vtb            ,vtf            ,wssurf         ,wtsurf         ,
     $  wubot          ,wusurf         ,wvbot          ,wvsurf         ,
     $  rot_c          ,wusurfn        ,wvsurfn        ,cbc0


C
      common/pom_blk2d/
     $  aam2d(IM,JM)   ,advua(IM,JM)   ,advva(IM,JM)   ,adx2d(IM,JM)   ,
     $  ady2d(IM,JM)   ,art(IM,JM)     ,aru(IM,JM)     ,arv(IM,JM)     ,
     $  cbc(IM,JM)     ,cor(IM,JM)     ,d(IM,JM)       ,drx2d(IM,JM)   ,
     $  dry2d(IM,JM)   ,dt(IM,JM)      ,dum(IM,JM)     ,dvm(IM,JM)     ,
     $  dx(IM,JM)      ,dy(IM,JM)      ,east_c(IM,JM)  ,east_e(IM,JM)  ,
     $  east_u(IM,JM)  ,east_v(IM,JM)  ,e_atmos(IM,JM) ,egb(IM,JM)     ,
     $  egf(IM,JM)     ,el(IM,JM)      ,elb(IM,JM)     ,elf(IM,JM)     ,
     $  et(IM,JM)      ,etb(IM,JM)     ,etf(IM,JM)     ,fluxua(IM,JM)  ,
     $  fluxva(IM,JM)  ,fsm(IM,JM)     ,h(IM,JM)       ,north_c(IM,JM) ,
     $  north_e(IM,JM) ,north_u(IM,JM) ,north_v(IM,JM) ,psi(IM,JM)     ,
     $  rot(IM,JM)     ,ssurf(IM,JM)   ,swrad(IM,JM)   ,z0s(IM,JM)     ,
     $  tps(IM,JM)     ,tsurf(IM,JM)   ,ua(IM,JM)      ,z0c(IM,JM)     ,
     $  uab(IM,JM)     ,uaf(IM,JM)     ,utb(IM,JM)     ,utf(IM,JM)     ,
     $  va(IM,JM)      ,vab(IM,JM)     ,vaf(IM,JM)     ,vflux(IM,JM)   ,
     $  vtb(IM,JM)     ,vtf(IM,JM)     ,wssurf(IM,JM)  ,wtsurf(IM,JM)  ,
     $  wubot(IM,JM)   ,wusurf(IM,JM)  ,wvbot(IM,JM)   ,wvsurf(IM,JM)  ,
     $  rot_c(IM,JM)   ,wusurfn(IM,JM) ,wvsurfn(IM,JM) ,cbc0(IM,JM)
C
C-----------------------------------------------------------------------
C
C     3-D arrays:
C
      real 
     $  aam            ,advx           ,advy           ,a              ,
     $  c              ,drhox          ,drhoy          ,dtef           ,
     $  ee             ,gg             ,kh             ,km             ,
     $  kq             ,l              ,q2b            ,q2             ,
     $  q2lb           ,q2l            ,rho            ,rmean          ,
     $  sb             ,sclim          ,s              ,tb             ,
     $  tclim          ,t              ,ub             ,uf             ,
     $  u              ,vb             ,vf             ,v              ,
     $  w              ,zflux
C
      common/pom_blk3d/
     $  aam(IM,JM,KB)  ,advx(IM,JM,KB) ,advy(IM,JM,KB) ,a(IM,JM,KB)    ,
     $  c(IM,JM,KB)    ,drhox(IM,JM,KB),drhoy(IM,JM,KB),dtef(IM,JM,KB) ,
     $  ee(IM,JM,KB)   ,gg(IM,JM,KB)   ,kh(IM,JM,KB)   ,km(IM,JM,KB)   ,
     $  kq(IM,JM,KB)   ,l(IM,JM,KB)    ,q2b(IM,JM,KB)  ,q2(IM,JM,KB)   ,
     $  q2lb(IM,JM,KB) ,q2l(IM,JM,KB)  ,rho(IM,JM,KB)  ,rmean(IM,JM,KB),
     $  sb(IM,JM,KB)   ,sclim(IM,JM,KB),s(IM,JM,KB)    ,tb(IM,JM,KB)   ,
     $  tclim(IM,JM,KB),t(IM,JM,KB)    ,ub(IM,JM,KB)   ,uf(IM,JM,KB)   ,
     $  u(IM,JM,KB)    ,vb(IM,JM,KB)   ,vf(IM,JM,KB)   ,v(IM,JM,KB)    ,
     $  w(IM,JM,KB)    ,zflux(IM,JM,KB)
      real uav         ,vav            ,wav            ,kmav           ,
     $  q2av           ,lav            ,etav           ,wusav          ,
     $  wubav          ,wvsav          ,wvbav          ,wubdav         ,
     $  wvbdav   ,sigtav       ,tav            ,sav  
      common/pom_avfld/
     $  uav(IM,JM,KB)  ,vav(IM,JM,KB)  ,wav(IM,JM,KB)  ,kmav(IM,JM,KB) ,
     $  lav(IM,JM,KB)  ,q2av(IM,JM,KB) ,etav(IM,JM)    ,wusav(IM,JM)   ,
     $  wvsav(IM,JM)   ,wubav(IM,JM)   ,wvbav(IM,JM)   ,wubdav(IM,JM)  ,
     $  wvbdav(IM,JM)  ,sigtav(IM,JM,KB),sav(IM,JM,KB) ,tav(IM,JM,KB)

C
C-----------------------------------------------------------------------
C
C     1 and 2-D boundary value arrays:
C
      real
     $  ele            ,eln            ,els            ,elw            ,
     $  sbe            ,sbn            ,sbs            ,sbw            ,
     $  tbe            ,tbn            ,tbs            ,tbw            ,
     $  uabe           ,uabw           ,ube            ,ubw            ,
     $  vabn           ,vabs           ,vbn            ,vbs            ,
     $  etbc           ,ubc            ,vbc            ,tbc            ,
     $  sbc            ,uabc           ,vabc           ,dbc
C
      common/pom_bdry/
     $  ele(JM)        ,eln(IM)        ,els(IM)        ,elw(JM)        ,
     $  sbe(JM,KB)     ,sbn(IM,KB)     ,sbs(IM,KB)     ,sbw(JM,KB)     ,
     $  tbe(JM,KB)     ,tbn(IM,KB)     ,tbs(IM,KB)     ,tbw(JM,KB)     ,
     $  uabe(JM)       ,uabw(JM)       ,ube(JM,KB)     ,ubw(JM,KB)     ,
     $  vabn(IM)       ,vabs(IM)       ,vbn(IM,KB)     ,vbs(IM,KB)     ,
     $  etbc           ,ubc(KB)        ,vbc(KB)       ,tbc(KB)         ,
     $  sbc(KB)        ,uabc           ,vabc           ,dbc
C
C-----------------------------------------------------------------------
C
C     Character variables:
C
      character*80 
     $  netcdf_file
      character*26
     $  time_start
C
      character*40
     $  source,title
C
      common/pom_blkchar/
     $  time_start     ,source         ,title         ,netcdf_file
C
C-----------------------------------------------------------------------
C
C     End of common blocks
C
C-----------------------------------------------------------------------
C
