
load wht.dat
load kxt.dat
load kyt.dat
load sigt.dat

load inp.mt

figure(1)
dt=inp(5);
xloc=inp(6);
yloc=inp(7);
t=(0:dt:(length(wht)-3)*dt);
subplot(4,1,1),plot(t,wht(3:end)),ylabel('H (m)')
eval(['title(''Time series at (x,y)=(',int2str(xloc),',',int2str(yloc),') m '')'])
subplot(4,1,2),plot(t,kxt(3:end)),ylabel('k_x (rad/m)')
subplot(4,1,3),plot(t,kyt(3:end)),ylabel('k_y (rad/m)')
subplot(4,1,4),plot(t,sigt(3:end)),ylabel('\omega (rad/s)')
xlabel('t (sec)')

print -depsc test_fig1.eps

load zeta.dat

load kx.dat
load ky.dat
load waveh.dat
load hh.dat
load u.dat


load phi.dat
load y.dat
mt=length(phi);
myt=length(y);
[PHI,Y]=meshgrid(phi,y);

n=length(zeta);
nt=n/myt;
z=reshape(zeta,myt,nt)';
kx=reshape(kx,myt,nt)';
ky=reshape(ky,myt,nt)';
wh=reshape(waveh,myt,nt)';
h=reshape(hh,myt,nt)';
u=reshape(u,myt,nt)';


k=sqrt(kx.^2+ky.^2);

aa=size(z);
m=aa(1);
n=m/mt;
%ii=(14:2:n);
ii=(1:round(n/6):n);


orient portrait
for i=1:length(ii)
si=int2str(ii(i));
ns=((ii(i)-1)*mt)+1;
ne=(ii(i)*mt);
eval(['z',si,'(1:mt,1:myt)=z(ns:ne,1:myt);'])
eval(['kx',si,'(1:mt,1:myt)=kx(ns:ne,1:myt);'])
eval(['ky',si,'(1:mt,1:myt)=ky(ns:ne,1:myt);'])
eval(['k',si,'(1:mt,1:myt)=k(ns:ne,1:myt);'])

eval(['wh',si,'(1:mt,1:myt)=wh(ns:ne,1:myt);'])
eval(['h',si,'(1:mt,1:myt)=h(ns:ne,1:myt);'])
eval(['u',si,'(1:mt,1:myt)=u(ns:ne,1:myt);'])

end

figure(2)
in=0;
for i=1:1:length(ii)
in=in+1;
si=int2str(ii(i));
subplot(3,2,in)
eval(['plot(z',si,',-h',si,')']);
xlabel('x (m)'),ylabel('-h (m)')
end

print -depsc test_fig2.eps

figure(3)
in=0;
for i=1:1:length(ii)
in=in+1;
si=int2str(ii(i));
subplot(3,2,in)
eval(['plot(z',si,',wh',si,')']);
xlabel('x (m)'),ylabel('H (m)')
end

print -depsc test_fig3.eps

figure(4)
in=0;
for i=1:1:length(ii)
in=in+1;
si=int2str(ii(i));
subplot(3,2,in)
eval(['plot(z',si,',kx',si,')']);
xlabel('x (m)'),ylabel('k_x (rad/m)')
end

print -depsc test_fig4.eps

figure(5)
in=0;
for i=1:1:length(ii)
in=in+1;
si=int2str(ii(i));
subplot(3,2,in)
eval(['plot(z',si,',ky',si,')']);
xlabel('x (m)'),ylabel('k_y (rad/m)')
end

print -depsc test_fig5.eps

figure(6)
in=0;
for i=1:1:length(ii)
in=in+1;
si=int2str(ii(i));
subplot(3,2,in)
eval(['plot(z',si,',u',si,')']);
xlabel('x (m)'),ylabel('u (m/s)')
end

print -depsc test_fig6.eps

figure(7)
%Snapshots at the last step

subplot(2,2,1)
pcolor(z21',y,wh21'),
shading flat, axis equal, axis tight
xlabel('x (m)'),ylabel('y (m)')
title('H (m)')
colorbar

subplot(2,2,2)
pcolor(z21',y,kx21'),
shading flat, axis equal, axis tight
xlabel('x (m)'),ylabel('y (m)')
title('k_x (rad/m)')
colorbar

subplot(2,2,3)
pcolor(z21',y,ky21'),
shading flat, axis equal, axis tight
xlabel('x (m)'),ylabel('y (m)')
title('k_y (rad/m)')
colorbar

subplot(2,2,4)
pcolor(z21',y,u21'),
shading flat, axis equal, axis tight
xlabel('x (m)'),ylabel('y (m)')
title('u (m/s)')
colorbar

print -depsc test_fig7.eps

