c #####################################################################
c Mixed DERIVATIVES
      subroutine dmixed(qx,qy,dqxdxdy,
     .                 dqydydy,nxflag)
c	LAST MODIFICATION:						
c	- Nov  15, 2001							
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer i, j,  nxflag, nxj(nmax), minnxa
      real*8 qx(nxm,nym), qy(nxm,nym),
     . dqxdxdy(nxm,nym), dqydxdy(nxm,nym),
     . spqx(nmax),spqy(nmax),dernum

c=====================================================================

c ##  set number of points where to take derivative based on flag
c---- nxflag=0 : perform derivatives until nx
c---- nxflag=1 : perform derivatives until last wet point
      if (nxflag .eq. 0) then
	 minnxa=nx
         do j = 1,ny
	    nxj(j) = nx
         end do
      else
	 minnxa=nx
         do j = 1,ny
	    nxj(j) = nxa(j)
         end do
      end if	 


c------- mixed derivatives ---
       do j = 2,ny-1
         i = 1
         dernum = -3d0*(qx(1,j+1)-qx(1,j-1))+4d0*(qx(2,j+1)-qx(2,j-1))
     .        -(qx(3,j+1)-qx(3,j-1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum = -3d0*(qy(1,j+1)-qy(1,j-1))+4d0*(qy(2,j+1)-qy(2,j-1))
     .        -(qy(3,j+1)-qy(3,j-1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
      do i = 2,nxj(j)-1
         dernum = qx(i+1,j+1)+qx(i-1,j-1)-qx(i-1,j+1)-qx(i+1,j-1)
         dqxdxdy(i,j) = dernum/(dx*dy*4)
         dernum = qy(i+1,j+1)+qy(i-1,j-1)-qy(i-1,j+1)-qy(i+1,j-1)
         dqydxdy(i,j) = dernum/(dx*dy*4)
      end do
         i = nxj(j)
         dernum =3d0*(qx(i,j+1)-qx(i,j-1))-4d0*(qx(i-1,j+1)-qx(i-1,j-1))
     .        +(qx(i-2,j+1)-qx(i-2,j-1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =3d0*(qy(i,j+1)-qy(i,j-1))-4d0*(qy(i-1,j+1)-qy(i-1,j-1))
     .        +(qy(i-2,j+1)-qy(i-2,j-1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
      end do

      if (ipery.eq.1) then
      i=1
      j=1
         dernum =-3d0*(qx(i,j+1)-qx(i,ny-1))
     .     +4d0*(qx(i+1,j+1)-qx(i+1,ny-1))
     .     -(qx(i+2,j+1)-qx(i+2,ny-1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =-3d0*(qy(i,j+1)-qy(i,ny-1))
     .     +4d0*(qy(i+1,j+1)-qy(i+1,ny-1))
     .     -(qy(i+2,j+1)-qy(i+2,ny-1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
       i=1
       j=ny
         dernum =3d0*(qx(i,j-1)-qx(i,2))
     .      -4d0*(qx(i+1,j-1)-qx(i+1,2))
     .     +(qx(i+2,j-1)-qx(i+2,2))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =3d0*(qy(i,j-1)-qy(i,2))
     .      -4d0*(qy(i+1,j-1)-qy(i+1,2))
     .     +(qy(i+2,j-1)-qy(i+2,2))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
       j=ny
       i=nxj(j)
         dernum =-3d0*(qx(i,j-1)-qx(i,2))
     .      +4d0*(qx(i-1,j-1)-qx(i-1,2))
     .     -(qx(i-2,j-1)-qx(i-2,2))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =-3d0*(qy(i,j-1)-qy(i,2))
     .      +4d0*(qy(i-1,j-1)-qy(i-1,2))
     .     -(qy(i-2,j-1)-qy(i-2,2))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
       j=1
       i=nxj(j)
         dernum =3d0*(qx(i,j+1)-qx(i,ny-1))
     .      -4d0*(qx(i-1,j+1)-qx(i-1,ny-1))
     .     +(qx(i-2,j+1)-qx(i-2,ny-1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =3d0*(qy(i,j+1)-qy(i,ny-1))
     .      -4d0*(qy(i-1,j+1)-qy(i-1,ny-1))
     .     +(qy(i-2,j+1)-qy(i-2,ny-1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)

         j=1
         do i=2,nxj(j)-1
           dernum = qx(i+1,j+1)+qx(i-1,ny-1)-qx(i-1,j+1)-qx(i+1,ny-1)
           dqxdxdy(i,j) = dernum/(dx*dy*4)
           dernum = qy(i+1,j+1)+qy(i-1,ny-1)-qy(i-1,j+1)-qy(i+1,ny-1)
           dqydxdy(i,j) = dernum/(dx*dy*4)
         end do
         j=ny
         do i=2,nxj(j)-1
           dernum = qx(i+1,2)+qx(i-1,j-1)-qx(i-1,2)-qx(i+1,j-1)
           dqxdxdy(i,j) = dernum/(dx*dy*4)
           dernum = qy(i+1,2)+qy(i-1,j-1)-qy(i-1,2)-qy(i+1,j-1)
           dqydxdy(i,j) = dernum/(dx*dy*4)
         end do
c     Not Periodic
         else
      i=1
      j=1
         dernum =9d0*qx(i,j)+16d0*qx(i+1,j+1)+qx(i+2,j+2)
     .     -12d0*(qx(i,j+1)+qx(i+1,j))+3d0*(qx(i,j+2)+qx(i+2,j))
     .     -4d0*(qx(i+1,j+2)+qx(i+2,j+1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =9d0*qy(i,j)+16d0*qy(i+1,j+1)+qy(i+2,j+2)
     .     -12d0*(qy(i,j+1)+qy(i+1,j))+3d0*(qy(i,j+2)+qy(i+2,j))
     .     -4d0*(qy(i+1,j+2)+qy(i+2,j+1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
      i=1
      j=ny
         dernum =-9d0*qx(i,j)-16d0*qx(i+1,j-1)-qx(i+2,j-2)
     .     +12d0*(qx(i,j-1)+qx(i+1,j))-3d0*(qx(i,j-2)+qx(i+2,j))
     .     +4d0*(qx(i+1,j-2)+qx(i+2,j-1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =-9d0*qy(i,j)-16d0*qy(i+1,j-1)-qy(i+2,j-2)
     .     +12d0*(qy(i,j-1)+qy(i+1,j))-3d0*(qy(i,j-2)+qy(i+2,j))
     .     +4d0*(qy(i+1,j-2)+qy(i+2,j-1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
      j=1
      i=nxj(j)
         dernum =-9d0*qx(i,j)-16d0*qx(i-1,j+1)-qx(i-2,j+2)
     .     +12d0*(qx(i,j+1)+qx(i-1,j))-3d0*(qx(i,j+2)+qx(i-2,j))
     .     +4d0*(qx(i-1,j+2)+qx(i-2,j+1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =-9d0*qy(i,j)-16d0*qy(i-1,j+1)-qy(i-2,j+2)
     .     +12d0*(qy(i,j+1)+qy(i-1,j))-3d0*(qy(i,j+2)+qy(i-2,j))
     .     +4d0*(qy(i-1,j+2)+qy(i-2,j+1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)
      j=ny
      i=nxj(j)
         dernum =9d0*qx(i,j)+16d0*qx(i-1,j-1)+qx(i-2,j-2)
     .     -12d0*(qx(i,j-1)+qx(i-1,j))+3d0*(qx(i,j-2)+qx(i-2,j))
     .     -4d0*(qx(i-1,j-2)+qx(i-2,j-1))
         dqxdxdy(i,j) = dernum/(dx*dy*4d0)
         dernum =9d0*qy(i,j)+16d0*qy(i-1,j-1)+qy(i-2,j-2)
     .     -12d0*(qy(i,j-1)+qy(i-1,j))+3d0*(qy(i,j-2)+qy(i-2,j))
     .     -4d0*(qy(i-1,j-2)+qy(i-2,j-1))
         dqydxdy(i,j) = dernum/(dx*dy*4d0)

         j=1
         do i=2,nxj(j)-1
            dernum=-3d0*(qx(i+1,j)-qx(i-1,j))
     .           +4d0*(qx(i+1,j+1)-qx(i-1,j+1))
     .           -(qx(i+1,j+2)-qx(i-1,j+2))
           dqxdxdy(i,j) = dernum/(dx*dy*4)
            dernum=-3d0*(qy(i+1,j)-qy(i-1,j))
     .           +4d0*(qy(i+1,j+1)-qy(i-1,j+1))
     .           -(qy(i+1,j+2)-qy(i-1,j+2))
           dqydxdy(i,j) = dernum/(dx*dy*4)
         end do
         j=ny
         do i=2,nxj(j)-1
            dernum=3d0*(qx(i+1,j)-qx(i-1,j))
     .           -4d0*(qx(i+1,j-1)-qx(i-1,j-1))
     .           +(qx(i+1,j-2)-qx(i-1,j-2))
           dqxdxdy(i,j) = dernum/(dx*dy*4)
           dqxdxdy(i,j) = dernum/(dx*dy*4)
            dernum=3d0*(qy(i+1,j)-qy(i-1,j))
     .           -4d0*(qy(i+1,j-1)-qy(i-1,j-1))
     .           +(qy(i+1,j-2)-qy(i-1,j-2))
           dqydxdy(i,j) = dernum/(dx*dy*4)
         end do
         end if
       do j = 1,ny
          do i=nxj(j)+1,nx
             dqxdxdy(i,j)=0.d0
             dqydxdy(i,j)=0.d0
          end do
       end do
      return
      end
c #####################################################################
c DERIVATIVES
      subroutine deriv(zeta,qx,qy,dzetadx,dzetady,dqxdx,
     .                 dqydy,ncode,nxflag)
c	LAST MODIFICATION:						
c	- Sep 15, 1999							
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer i, j, ncode, nxflag, nxj(nmax), minnxa
      real*8 zeta(nxm,nym), qx(nxm,nym), qy(nxm,nym),
     . dzetadx(nxm,nym), dzetady(nxm,nym),
     . dqxdx(nxm,nym), dqydy(nxm,nym),
     . spz(nmax),spqx(nmax),spqy(nmax),dzeta(nmax),
     . dqx(nmax),dqy(nmax)

c=====================================================================

c ##  set number of points where to take derivative based on flag
c---- nxflag=0 : perform derivatives until nx
c---- nxflag=1 : perform derivatives until last wet point
      if (nxflag .eq. 0) then
	 minnxa=nx
         do j = 1,ny
	    nxj(j) = nx
         end do
      else
	 minnxa=nx
         do j = 1,ny
	    nxj(j) = nxa(j)
         end do
      end if	 

c ##  Calculating the x-derivatives ----------------------------------

      if (ncode.eq.1) then
c------- 1st derivatives of higher order : dx^4 ---
         do j = 1,ny
            do i = 1, nxj(j)
               spz(i)  = zeta(i,j)
               spqx(i) = qx(i,j)
               dzeta(i) = 0.d0
               dqx(i) = 0.d0
            end do
            call splinex(nxj(j), spz, dzeta)
            call splinex(nxj(j), spqx, dqx)
            do i = 1, nxj(j)
               dzetadx(i,j) = dzeta(i)
               dqxdx(i,j)   = dqx(i)
            end do
            do i = nxj(j)+1,nx
               dzetadx(i,j) = 0.d0
               dqxdx(i,j)   = 0.d0
            end do
	 end do
      elseif (ncode.eq.3) then
c------- 1st derivatives of lower order : dx^2 ---

         do j = 1,ny
            do i = 1, nxj(j)
               spz(i)  = zeta(i,j)
               spqx(i) = qx(i,j)
               dzeta(i) = 0.d0
            end do




            call splinex2(nxj(j), spz, dzeta)
            call splinex2(nxj(j), spqx, dqx)

            do i = 1, nxj(j)
               dzetadx(i,j) = dzeta(i)
               dqxdx(i,j)   = dqx(i)
            end do

            do i = nxj(j)+1,nx
               dzetadx(i,j) = 0.d0
               dqxdx(i,j)   = 0.d0
            end do

	 end do

      elseif (ncode.eq.2) then
c------- 3rd derivatives ---
         do j = 1,ny
            do i = 1, nxj(j)
               spz(i)  = zeta(i,j)
               spqx(i) = qx(i,j)
               dzeta(i) = 0.d0
               dqx(i) = 0.d0
            end do
            call triplex(nxj(j), spz, dzeta)
            call triplex(nxj(j), spqx, dqx)
            do i = 1, nxj(j)
               dzetadx(i,j) = dzeta(i)
               dqxdx(i,j)   = dqx(i)
            end do
            do i = nxj(j)+1,nx
               dzetadx(i,j) = 0.d0
               dqxdx(i,j)   = 0.d0
            end do
	 end do
      elseif (ncode.eq.4) then
c------- 2nd derivatives ---
         do j = 1,ny
            do i = 1, nxj(j)
               spz(i)  = zeta(i,j)
               spqx(i) = qx(i,j)
               dzeta(i) = 0.d0
               dqx(i) = 0.d0
            end do
            call doublex(nxj(j), spz, dzeta)
            call doublex(nxj(j), spqx, dqx)
            do i = 1, nxj(j)
               dzetadx(i,j) = dzeta(i)
               dqxdx(i,j)   = dqx(i)
            end do
            do i = nxj(j)+1,nx
               dzetadx(i,j) = 0.d0
               dqxdx(i,j)   = 0.d0
            end do
	 end do
      end if


c ##  Calculating the y-derivatives ----------------------------------

      if (ncode.eq.1) then
c------- 1st derivatives  of higher order : dy^4 ---
         do i = 1,minnxa
            do j = 1,ny
               spz(j)  = zeta(i,j)
               spqy(j) = qy(i,j)
               dzeta(i) = 0.d0
               dqy(i) = 0.d0
            end do
            call spliney(ny, spz, dzeta)
            call spliney(ny, spqy, dqy)
            do j = 1,ny
               dzetady(i,j) = dzeta(j)
               dqydy(i,j)   = dqy(j)
            end do
         end do
         do j = 1,ny
               do i = nxj(j)+1,nx
                dzetady(i,j) = 0.d0
                dqydy(i,j)   = 0.d0
               end do
         end do
      elseif (ncode.eq.3) then
c------- 1st derivatives  of lower order : dy^2 ---
         do i = 1,minnxa
            do j = 1,ny
               spz(j)  = zeta(i,j)
               spqy(j) = qy(i,j)
               dzeta(i) = 0.d0
               dqy(i) = 0.d0
            end do
            call spliney2(ny, spz, dzeta)
            call spliney2(ny, spqy, dqy)
            do j = 1,ny
               dzetady(i,j) = dzeta(j)
               dqydy(i,j)   = dqy(j)
            end do
         end do
            do j = 1,ny
               do i =nxj(j)+1,nx
                 dzetady(i,j) = 0.d0
                 dqydy(i,j)   = 0.d0
            end do
         end do
      elseif (ncode.eq.2) then
c------- 3rd derivatives ---
         do i = 1,minnxa
            do j = 1,ny
               spz(j)  = zeta(i,j)
               spqy(j) = qy(i,j)
               dzeta(i) = 0.d0
               dqy(i) = 0.d0
            end do
            call tripley(ny, spz, dzeta)
            call tripley(ny, spqy, dqy)
            do j = 1,ny
               dzetady(i,j) = dzeta(j)
               dqydy(i,j)   = dqy(j)
            end do
         end do
            do j = 1,ny
                do i = nxj(j)+1,nx
                 dzetady(i,j) = 0.d0
                 dqydy(i,j)   = 0.d0
            end do
         end do
      elseif (ncode.eq.4) then
c------- 2nd derivatives ---
         do i = 1,minnxa
            do j = 1,ny
               spz(j)  = zeta(i,j)
               spqy(j) = qy(i,j)
               dzeta(i) = 0.d0
               dqy(i) = 0.d0
            end do
            call doubley(ny, spz, dzeta)
            call doubley(ny, spqy, dqy)
            do j = 1,ny
               dzetady(i,j) = dzeta(j)
               dqydy(i,j)   = dqy(j)
            end do
         end do
            do j = 1,ny
              do i = nxj(j)+1,nx
               dzetady(i,j) = 0.d0
               dqydy(i,j)   = 0.d0
            end do
         end do
      end if


      return
      end


c #####################################################################
c SPLINE X, 2nd Order
      subroutine splinex2(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer i, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum

c=====================================================================

      do i = 2,ndata-1
         dernum = fdata(i+1) - fdata(i-1)
         fxdata(i) = dernum/(2.d0*dx)
      end do

      if (iperx.eq.1) then
         dernum = fdata(2) - fdata(ndata-1)
         fxdata(1) = dernum/(2.d0*dx)
         fxdata(ndata) = fxdata(1)
      else
         i = 1
         dernum = -3.d0*fdata(i) + 4.d0*fdata(i+1) - fdata(i+2)
         fxdata(i) = dernum/(2.d0*dx)
c         dernum = -fdata(i) + fdata(i+1)
c         fxdata(i) = dernum/dx
         i = ndata
         dernum = 3.d0*fdata(i) - 4.d0*fdata(i-1) + fdata(i-2)
         fxdata(i) = dernum/(2.d0*dx)
c         dernum = fdata(i) - fdata(i-1)
c         fxdata(i) = dernum/dx
      end if

      return
      end


c #####################################################################
c SPLINE X, 4th Order
      subroutine splinex(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer i, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum, aux1, aux2

c=====================================================================

      aux1 = 1.d0/(12.d0*dx)
      aux2 = 1.d0/(2.d0*dx)
      if (iperx.eq.1) then
         i = 1
         dernum = -fdata(i+2)+8.d0*fdata(i+1)-8.d0*fdata(ndata-1)
     .         +fdata(ndata-2)
         fxdata(i) = dernum *aux1
         i = 2
         dernum = -fdata(i+2)+8.d0*fdata(i+1)-8.d0*fdata(i-1)
     .         +fdata(ndata-1)
         fxdata(i) = dernum *aux1
      else
         i = 1
         dernum = -3.d0*fdata(i) + 4.d0*fdata(i+1) - fdata(i+2)
         fxdata(i) = dernum *aux2
         i = 2
         dernum = fdata(i+1) - fdata(i-1)
         fxdata(i) = dernum *aux2
      end if

      do i = 3,ndata-2
         dernum = -fdata(i+2)+8.d0*fdata(i+1)-8.d0*fdata(i-1)+fdata(i-2)
         fxdata(i) = dernum *aux1
      end do

      if (iperx.eq.1) then
         fxdata(ndata) = fxdata(1)
         i = ndata-1
         dernum = -fdata(2)+8.d0*fdata(i+1)-8.d0*fdata(i-1)+fdata(i-2)
         fxdata(i) = dernum *aux1
      else
         i = ndata-1
         dernum = fdata(i+1) - fdata(i-1)
         fxdata(i) = dernum *aux2
         i = ndata
         dernum = 3.d0*fdata(i) - 4.d0*fdata(i-1) + fdata(i-2)
         fxdata(i) = dernum *aux2
      end if

      return
      end


c #####################################################################
c SPLINE Y, 2nd Order
      subroutine spliney2(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'
c--- Local variables -------------------------------------------------
      integer j, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum

c=====================================================================

      do j = 2,ndata-1
         dernum = fdata(j+1) - fdata(j-1)
         fxdata(j) = dernum/(2.d0*dy)
      end do

      if (ipery.eq.1) then
         dernum = fdata(2) - fdata(ndata-1)
         fxdata(1) = dernum/(2.d0*dy)
         fxdata(ndata) = fxdata(1)
      else
         j=1
         dernum = -3.d0*fdata(j) + 4.d0*fdata(j+1) - fdata(j+2)
         fxdata(1) = dernum/(2.d0*dy)
         j = ndata
         dernum = 3.d0*fdata(j) - 4.d0*fdata(j-1) + fdata(j-2)
         fxdata(j) = dernum/(2.d0*dy)
      end if

      return
      end


c #####################################################################
c SPLINE Y, 4th Order
      subroutine spliney(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'
c--- Local variables -------------------------------------------------
      integer j, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum, aux1, aux2

c=====================================================================

      aux1 = 1.d0/(12.d0*dy)
      aux2 = 1.d0/(2.d0*dy)
      if (ipery.eq.1) then
         j = 1
         dernum = -fdata(j+2)+8.d0*fdata(j+1)-8.d0*fdata(ndata-1)
     .         +fdata(ndata-2)
         fxdata(j) = dernum *aux1
         j = 2
         dernum = -fdata(j+2)+8.d0*fdata(j+1)-8.d0*fdata(j-1)
     .         +fdata(ndata-1)
         fxdata(j) = dernum *aux1
      else
         j = 1
         dernum = -3.d0*fdata(j) + 4.d0*fdata(j+1) - fdata(j+2)
         fxdata(1) = dernum *aux2
         j = 2
         dernum = fdata(j+1) - fdata(j-1)
         fxdata(j) = dernum *aux2
      end if

      do j = 3,ndata-2
         dernum = -fdata(j+2)+8.d0*fdata(j+1)-8.d0*fdata(j-1)+fdata(j-2)
         fxdata(j) = dernum *aux1
      end do

      if (ipery.eq.1) then
         fxdata(ndata) = fxdata(1)
         j = ndata-1
         dernum = -fdata(2)+8.d0*fdata(j+1)-8.d0*fdata(j-1)+fdata(j-2)
         fxdata(j) = dernum *aux1
      else
         j = ndata-1
         dernum = fdata(j+1) - fdata(j-1)
         fxdata(j) = dernum *aux2
         j = ndata
         dernum = 3.d0*fdata(j) - 4.d0*fdata(j-1) + fdata(j-2)
         fxdata(j) = dernum *aux2
      end if

      return
      end


c #####################################################################
c DOUBLE X
      subroutine doublex(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer i, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum

c=====================================================================
c
      if (iperx.eq.1) then
         i = 1
         dernum = fdata(2)-2.d0*fdata(1)+fdata(ndata-1)
         fxdata(i) = dernum/(dx**2)
      else
         i = 1
         dernum = 2.d0*fdata(1)-5.d0*fdata(2)+4.d0*fdata(3)-fdata(4)
         fxdata(i) = dernum/(dx**2)
      end if
      do i = 2,ndata-1
         dernum = fdata(i+1)-2.d0*fdata(i)+fdata(i-1)
         fxdata(i) = dernum/(dx**2)
      end do
      if (iperx.eq.1) then
         fxdata(ndata) = fxdata(1)
      else
         i = ndata
         dernum= 2.d0*fdata(ndata)-5.d0*fdata(ndata-1)
     .          +4.d0*fdata(ndata-2)-fdata(ndata-3)
         fxdata(i) = dernum/(dx**2)
      end if

      return
      end


c #####################################################################
c DOUBLE Y
      subroutine doubley(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer j, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum

c=====================================================================

c    only for ipery

      if (ipery.eq.1) then
       j = 1
       dernum = fdata(2)-2.d0*fdata(1)+fdata(ndata-1)
       fxdata(j) = dernum/(dy**2)
      end if
c
      do j = 2,ndata-1
         dernum = fdata(j+1)-2.d0*fdata(j)+fdata(j-1)
         fxdata(j) = dernum/(dy**2)
      end do
c
      if (ipery.eq.1) then
       fxdata(ndata) = fxdata(1)
       j = ndata-1
      end if
c
      return
      end


c #####################################################################
c TRIPLE X
      subroutine triplex(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer i, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum

c=====================================================================
c
      if (iperx.eq.1) then
       i = 1
       dernum = fdata(3)-2.d0*fdata(2)+2.d0*fdata(ndata-1)
     .		-fdata(ndata-2)
       fxdata(i) = dernum/(2.d0*(dx**3))
       i= 2
       dernum = fdata(4)-2.d0*fdata(3)+2.d0*fdata(1)-fdata(ndata-1)
       fxdata(i) = dernum/(2.d0*(dx**3))
      else
       i = 1
       dernum = fdata(1)-3.d0*fdata(2)+3.d0*fdata(3)-fdata(4)
       fxdata(i) = dernum/((2.d0*dx)**3)
       i = 2
       dernum = -fdata(1)+3.d0*fdata(2)-3.d0*fdata(3)+fdata(4)
       fxdata(i) = dernum/(2.d0*(dx**3))
      end if
c
      do i = 3,ndata-2
         dernum = fdata(i+2)-2.d0*fdata(i+1)+2.d0*fdata(i-1)
     .		-fdata(i-2)
         fxdata(i) = dernum/(2.d0*(dx**3))
      end do
c
      if (iperx.eq.1) then
       fxdata(ndata) = fxdata(1)
       i=ndata
       dernum = fdata(3)-2.d0*fdata(2)+2.d0*fdata(ndata-1)
     .		-fdata(ndata-2)
       fxdata(i) = dernum/(2.d0*(dx**3))
       i = ndata-1
       dernum = fdata(2)-2.d0*fdata(1)+2.d0*fdata(ndata-2)
     .		-fdata(ndata-3)
       fxdata(i) = dernum/(2.d0*(dx**3))

      else
       i = ndata
       dernum = -fdata(ndata)+3.d0*fdata(ndata-1)-3.d0*fdata(ndata-2)
     .          +fdata(ndata-3)
       fxdata(i) = dernum/((2.d0*dx)**3)
       i = ndata-1
       dernum = fdata(ndata)-3.d0*fdata(ndata-1)+3.d0*fdata(ndata-2)
     .          -fdata(ndata-3)
       fxdata(i) = dernum/(2.d0*(dx**3))

      end if
c

      return
      end


c #####################################################################
c TRIPLE Y
      subroutine tripley(ndata,fdata,fxdata)
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'

c--- Local variables -------------------------------------------------
      integer j, ndata
      real*8 fdata(ndata), fxdata(ndata), dernum

c=====================================================================

      if (ipery.eq.1) then
       j = 1
       dernum = fdata(3)-2.d0*fdata(2)+2.d0*fdata(ndata-1)
     .    -fdata(ndata-2)
       fxdata(j) = dernum/(2.d0*(dy**3))
       j= 2
       dernum = fdata(4)-2.d0*fdata(3)+2.d0*fdata(1)-fdata(ndata-1)
       fxdata(j) = dernum/(2.d0*(dy**3))
      else
       j = 1
       dernum = fdata(1)-3.d0*fdata(2)+3.d0*fdata(3)-fdata(4)
       fxdata(j) = dernum/((2.d0*dy)**3)
       j = 2
       dernum = -fdata(1)+3.d0*fdata(2)-3.d0*fdata(3)+fdata(4)
       fxdata(j) = dernum/(2.d0*(dy**3))
      end if
c
      do j = 3,ndata-2
         dernum = fdata(j+2)-2.d0*fdata(j+1)+2.d0*fdata(j-1)-fdata(j-2)
         fxdata(j) = dernum/(2.d0*(dy**3))
      end do
c
      if (ipery.eq.1) then
       fxdata(ndata) = fxdata(1)
       j = ndata-1
       dernum = fdata(2)-2.d0*fdata(1)+2.d0*fdata(ndata-2)
     .		-fdata(ndata-3)
       fxdata(j) = dernum/(2.d0*(dy**3))

      else
       j = ndata
       dernum = -fdata(ndata)+3.d0*fdata(ndata-1)-3.d0*fdata(ndata-2)
     .          +fdata(ndata-3)
       fxdata(j) = dernum/((2.d0*dy)**3)
       j = ndata-1
       dernum = fdata(ndata)-3.d0*fdata(ndata-1)+3.d0*fdata(ndata-2)
     .          -fdata(ndata-3)
       fxdata(j) = dernum/(2.d0*(dy**3))

      end if
c
      return
      end


c #####################################################################
c!!!! Predictor/corrector coeff.s as computed by Uday
      subroutine predcor(nord,coeff1,coeff2,denom1,denom2)
c #####################################################################
CDIR$ FLOW

c--- Local variables -------------------------------------------------
      integer i, nord
      real*8 coeff1(10), coeff2(10), denom1, denom2

c=====================================================================

      do i = 1,10
         coeff1(i) = 0.d0
         coeff2(i) = 0.d0
      end do
c
      if (nord.eq.1) then
         coeff1(1) = 1.d0
          coeff2(1) = 1.d0
          coeff2(2) = 1.d0
         denom1 = 1.d0
         denom2 = 2.d0
      else
         if (nord.eq.2) then
              coeff1(1) = 23.d0
              coeff1(2) = -16.d0
              coeff1(3) = 5.d0
               coeff2(1) = 5.d0
               coeff2(2) = 8.d0
               coeff2(3) = -1.d0
              denom1 = 12.d0
              denom2 = 12.d0
         else
              if (nord.eq.3) then
                   coeff1(1) = 23.d0
                   coeff1(2) = -16.d0
                   coeff1(3) = 5.d0
                    coeff2(1) = 9.d0
                    coeff2(2) = 19.d0
                    coeff2(3) = -5.d0
                    coeff2(4) = 1.d0
                   denom1 = 12.d0
                   denom2 = 24.d0
              else
                   if (nord.eq.4) then
                        coeff1(1) = 55.d0
                        coeff1(2) = -59.d0
                        coeff1(3) = 37.d0
                        coeff1(4) = -9.d0
                         coeff2(1) = 251.d0
                         coeff2(2) = 646.d0
                         coeff2(3) = -264.d0
                         coeff2(4) = 106.d0
                         coeff2(5) = -19.d0
                        denom1 = 24.d0
                        denom2 = 720.d0
                   else
                        if (nord.eq.5) then
                             coeff1(1) = 1901.d0
                             coeff1(2) = -2774.d0
                             coeff1(3) = 2616.d0
                             coeff1(4) = -1274.d0
                             coeff1(5) = 251.d0
                              coeff2(1) = 251.d0
                              coeff2(2) = 646.d0
                              coeff2(3) = -264.d0
                              coeff2(4) = 106.d0
                              coeff2(5) = -19.d0
                             denom1 = 720.d0
                             denom2 = 720.d0
                        end if
                   end if
              end if
         end if
      end if
c
      return
      end


c###############################################################################
