C
      subroutine advave
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates horizontal advection and diffusion.      *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'combal3.h'
C
      real curv2d(IM,JM)
      integer i,j
C
C     u-advection and diffusion:
C
C     Advective fluxes:
C
      do j=1,JM
        do i=1,IM
          advua(i,j)=0.e0
        end do
      end do
C
      do j=2,JM
        do i=2,IMM1
          fluxua(i,j)=.125e0*((d(i+1,j)+d(i,j))*ua(i+1,j)
     $                       +(d(i,j)+d(i-1,j))*ua(i,j))
     $                      *(ua(i+1,j)+ua(i,j))
        end do
      end do
C
      do j=2,JM
        do i=2,IM
          fluxva(i,j)=.125e0*((d(i,j)+d(i,j-1))*va(i,j)
     $                       +(d(i-1,j)+d(i-1,j-1))*va(i-1,j))
     $                      *(ua(i,j)+ua(i,j-1))
        end do
      end do
C
C     Add viscous fluxes:
C
      do j=2,JM
        do i=2,IMM1
          fluxua(i,j)=fluxua(i,j)
     $                 -d(i,j)*2.e0*aam2d(i,j)*(uab(i+1,j)-uab(i,j))
     $                   /dx(i,j)
        end do
      end do
C
      do j=2,JM
        do i=2,IM
          tps(i,j)=.25e0*(d(i,j)+d(i-1,j)+d(i,j-1)+d(i-1,j-1))
     $              *(aam2d(i,j)+aam2d(i,j-1)
     $                +aam2d(i-1,j)+aam2d(i-1,j-1))
     $              *((uab(i,j)-uab(i,j-1))
     $                 /(dy(i,j)+dy(i-1,j)+dy(i,j-1)+dy(i-1,j-1))
     $               +(vab(i,j)-vab(i-1,j))
     $                 /(dx(i,j)+dx(i-1,j)+dx(i,j-1)+dx(i-1,j-1)))
          fluxua(i,j)=fluxua(i,j)*dy(i,j)
          fluxva(i,j)=(fluxva(i,j)-tps(i,j))*.25e0
     $                 *(dx(i,j)+dx(i-1,j)+dx(i,j-1)+dx(i-1,j-1))
        end do
      end do
      if(ibcon.eq.0)call perchan1(fluxva)
C
      do j=2,JMM1
        do i=2,IMM1
          advua(i,j)=fluxua(i,j)-fluxua(i-1,j)
     $                +fluxva(i,j+1)-fluxva(i,j)
        end do
      end do
      if(ibal.ne.0)then
        do j=2,JM
          do i=2,IM
            fluxva(i,j)=-tps(i,j)*.25e0*dy(i,j)
     $                 *(dx(i,j)+dx(i-1,j)+dx(i,j-1)+dx(i-1,j-1))
          end do
        end do
        do j=2,JM
          do i=1,IMM1
            fluxua(i,j)=-d(i,j)*2.e0*aam2d(i,j)*(uab(i+1,j)-uab(i,j))
     $                   /dx(i,j)
          end do
        end do
        if(ibcon.eq.0)call perchan1(fluxva)
          do j=2,JMM1
            do i=2,IMM1
              udia(i,j)=fluxua(i,j)-fluxua(i-1,j)
     $                +fluxva(i,j+1)-fluxva(i,j)
          end do
        end do
      endif
C
C     v-advection and diffusion:
C
      do j=1,JM
        do i=1,IM
          advva(i,j)=0.e0
        end do
      end do
C
C     Advective fluxes:
C
      do j=2,JM
        do i=2,IM
          fluxua(i,j)=.125e0*((d(i,j)+d(i-1,j))*ua(i,j)
     $                       +(d(i,j-1)+d(i-1,j-1))*ua(i,j-1))
     $                      *(va(i-1,j)+va(i,j))
        end do
      end do
C
      do j=2,JMM1
        do i=2,IM
          fluxva(i,j)=.125e0*((d(i,j+1)+d(i,j))*va(i,j+1)
     $                       +(d(i,j)+d(i,j-1))*va(i,j))
     $                      *(va(i,j+1)+va(i,j))
        end do
      end do
C
C     Add viscous fluxes:
C
      do j=2,JMM1
        do i=2,IM
          fluxva(i,j)=fluxva(i,j)
     $                 -d(i,j)*2.e0*aam2d(i,j)*(vab(i,j+1)-vab(i,j))
     $                   /dy(i,j)
        end do
      end do
C
      do j=2,JM
        do i=2,IM
          fluxva(i,j)=fluxva(i,j)*dx(i,j)
          fluxua(i,j)=(fluxua(i,j)-tps(i,j))*.25e0
     $                 *(dy(i,j)+dy(i-1,j)+dy(i,j-1)+dy(i-1,j-1))
        end do
      end do
      if(ibcon.eq.0)call perchan1(fluxva)
C
      do j=2,JMM1
        do i=2,IMM1
          advva(i,j)=fluxua(i+1,j)-fluxua(i,j)
     $                +fluxva(i,j)-fluxva(i,j-1)
        end do
      end do
      if(ibal.ne.0)then
        do j=2,JMM1
          do i=2,IM
            fluxva(i,j)=-d(i,j)*2.e0*aam2d(i,j)*(vab(i,j+1)-vab(i,j))
     $            *dx(i,j)/dy(i,j)
          end do
        end do
        do j=2,JM
          do i=2,IM
            fluxua(i,j)=-tps(i,j)*.25e0
     $                 *(dy(i,j)+dy(i-1,j)+dy(i,j-1)+dy(i-1,j-1))
          end do
        end do
        if(ibcon.eq.0)call perchan1(fluxva)
        do j=2,JMM1
          do i=2,IMM1
            vdia(i,j)=fluxua(i+1,j)-fluxua(i,j)
     $                +fluxva(i,j)-fluxva(i,j-1)
          end do
        end do
      endif
C
      if(mode.eq.2) then
        if(ibot.eq.0)then
          write(0,*)'mode 2, ibot=0 incompatible'
          stop
        endif
C
        do j=2,JMM1
          do i=2,IMM1
            wubot(i,j)=-0.5e0*(cbc(i,j)+cbc(i-1,j))
     $                  *sqrt(uab(i,j)**2
     $                        +(.25e0*(vab(i,j)+vab(i,j+1)
     $                                 +vab(i-1,j)+vab(i-1,j+1)))**2)
     $                  *uab(i,j)
          end do
        end do
        if(ibcon.eq.0)call perchanu1(wubot)

C
        do j=2,JMM1
          do i=2,IMM1
            wvbot(i,j)=-0.5e0*(cbc(i,j)+cbc(i,j-1))
     $                  *sqrt(vab(i,j)**2
     $                        +(.25e0*(uab(i,j)+uab(i+1,j)
     $                                +uab(i,j-1)+uab(i+1,j-1)))**2)
     $                  *vab(i,j)
          end do
        end do
        if(ibcon.eq.0)call perchanv1(wvbot)
               
C
        do j=2,JMM1
          do i=2,IMM1
            curv2d(i,j)=.25e0
     $                   *((va(i,j+1)+va(i,j))*(dy(i+1,j)-dy(i-1,j))
     $                    -(ua(i+1,j)+ua(i,j))*(dx(i,j+1)-dx(i,j-1)))
     $                   /(dx(i,j)*dy(i,j))
          end do
        end do
C
        do j=2,JMM1
          do i=3,IMM1
            advua(i,j)=advua(i,j)-aru(i,j)*.25e0
     $                  *(curv2d(i,j)*d(i,j)
     $                    *(va(i,j+1)+va(i,j))
     $                    +curv2d(i-1,j)*d(i-1,j)
     $                    *(va(i-1,j+1)+va(i-1,j)))
          end do
        end do
C
        do j=2,JMM1
          do i=2,IMM1
            advva(i,j)=advva(i,j)+arv(i,j)*.25e0
     $                  *(curv2d(i,j)*d(i,j)
     $                    *(ua(i+1,j)+ua(i,j))
     $                    +curv2d(i,j-1)*d(i,j-1)
     $                    *(ua(i+1,j-1)+ua(i,j-1)))
          end do
        end do
C
      endif
C
      return
C
      end
C
      subroutine advct
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates the horizontal portions of momentum      *
C *                advection well in advance of their use in advu and  *
C *                advv so that their vertical integrals (created in   *
C *                the main program) may be used in the external (2-D) *
C *                mode calculation.                                   *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'combal3.h'
C
      real xflux(IM,JM,KB),yflux(IM,JM,KB),xdflux(im,jm,kb),
     *  ydflux(im,jm,kb)
      real curv(IM,JM,KB)
      real dtaam
      integer i,j,k
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            curv(i,j,k)=0.e0
            advx(i,j,k)=0.e0
            xflux(i,j,k)=0.e0
            yflux(i,j,k)=0.e0
            xdflux(i,j,k)=0.e0
            ydflux(i,j,k)=0.e0
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            curv(i,j,k)=.25e0*((v(i,j+1,k)+v(i,j,k))
     $                         *(dy(i+1,j)-dy(i-1,j))
     $                         -(u(i+1,j,k)+u(i,j,k))
     $                         *(dx(i,j+1)-dx(i,j-1)))
     $                       /(dx(i,j)*dy(i,j))
          end do
        end do
      end do
      if(ibcon.eq.0)call perchanv(curv)
C
C     Calculate x-component of velocity advection:
C
C     Calculate horizontal advective fluxes:
C
      do k=1,KBM1
        do j=1,JM
          do i=2,IMM1
            xflux(i,j,k)=.125e0*((dt(i+1,j)+dt(i,j))*u(i+1,j,k)
     $                           +(dt(i,j)+dt(i-1,j))*u(i,j,k))
     $                         *(u(i+1,j,k)+u(i,j,k))
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            yflux(i,j,k)=.125e0*((dt(i,j)+dt(i,j-1))*v(i,j,k)
     $                           +(dt(i-1,j)+dt(i-1,j-1))*v(i-1,j,k))
     $                         *(u(i,j,k)+u(i,j-1,k))
          end do
        end do
      end do
C
C    Add horizontal diffusive fluxes:
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IMM1
            xdflux(i,j,k)=
     $                    -dt(i,j)*aam(i,j,k)*2.e0
     $                    *(ub(i+1,j,k)-ub(i,j,k))/dx(i,j)
            dtaam=.25e0*(dt(i,j)+dt(i-1,j)+dt(i,j-1)+dt(i-1,j-1))
     $             *(aam(i,j,k)+aam(i-1,j,k)
     $               +aam(i,j-1,k)+aam(i-1,j-1,k))
            ydflux(i,j,k)=
     $                    -dtaam*((ub(i,j,k)-ub(i,j-1,k))
     $                            /(dy(i,j)+dy(i-1,j)
     $                              +dy(i,j-1)+dy(i-1,j-1))
     $                            +(vb(i,j,k)-vb(i-1,j,k))
     $                            /(dx(i,j)+dx(i-1,j)
     $                              +dx(i,j-1)+dx(i-1,j-1)))
C
            xflux(i,j,k)=dy(i,j)*xflux(i,j,k)
            yflux(i,j,k)=.25e0*(dx(i,j)+dx(i-1,j)
     $                          +dx(i,j-1)+dx(i-1,j-1))*yflux(i,j,k)
            xdflux(i,j,k)=dy(i,j)*xdflux(i,j,k)
            ydflux(i,j,k)=.25e0*(dx(i,j)+dx(i-1,j)
     $                          +dx(i,j-1)+dx(i-1,j-1))*ydflux(i,j,k)
          end do
        end do
      end do
      if(ibcon.eq.0)then
        call perchan(yflux)
        call perchan(ydflux)
      endif
C
C     Do horizontal advection:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            advx(i,j,k)=xflux(i,j,k)-xflux(i-1,j,k)
     $                   +yflux(i,j+1,k)-yflux(i,j,k)
     $                   +xdflux(i,j,k)-xdflux(i-1,j,k)
     $                   +ydflux(i,j+1,k)-ydflux(i,j,k)
     $                   +wubody(i,j)*aru(i,j)
          end do
        end do
      end do
      do k=1,KBM1
        do j=2,JMM1
          do i=3,IMM1
            advx(i,j,k)=advx(i,j,k)
     $                   -aru(i,j)*.25e0
     $                     *(curv(i,j,k)*dt(i,j)
     $                        *(v(i,j+1,k)+v(i,j,k))
     $                       +curv(i-1,j,k)*dt(i-1,j)
     $                        *(v(i-1,j+1,k)+v(i-1,j,k)))
          end do
        end do
      end do
      if(ibal.ne.0)then
        do k=1,KBM1
          do j=2,JMM1
            do i=3,IMM1
! possible to separate out parts of advection
c              uadvx(i,j,k)=xflux(i,j,k)-xflux(i-1,j,k)
c              uadvy(i,j,k)=yflux(i,j+1,k)-yflux(i,j,k)
c              ucurv(i,j,k)=-aru(i,j)*.25e0*(curv(i,j,k)*dt(i,j)
c     $                        *(v(i,j+1,k)+v(i,j,k))
c     $                       +curv(i-1,j,k)*dt(i-1,j)
c     $                        *(v(i-1,j+1,k)+v(i-1,j,k)))
c              uadv(i,j,k)=uadvx(i,j,k)+uadvy(i,j,k)
c              udix(i,j,k)=xdflux(i,j,k)-xdflux(i-1,j,k)
c              udiy(i,j,k)=ydflux(i,j+1,k)-ydflux(i,j,k)
              uadv(i,j,k)=xflux(i,j,k)-xflux(i-1,j,k)+
     *           yflux(i,j+1,k)-yflux(i,j,k)-
     *           aru(i,j)*.25e0*(curv(i,j,k)*dt(i,j)
     $                        *(v(i,j+1,k)+v(i,j,k))
     $                       +curv(i-1,j,k)*dt(i-1,j)
     $                        *(v(i-1,j+1,k)+v(i-1,j,k)))
              udi(i,j,k)=xdflux(i,j,k)-xdflux(i-1,j,k)+
     *           ydflux(i,j+1,k)-ydflux(i,j,k)
            end do
          end do
        end do
      endif
C
C
C-----------------------------------------------------------------------
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            advy(i,j,k)=0.e0
            xflux(i,j,k)=0.e0
            yflux(i,j,k)=0.e0
            xdflux(i,j,k)=0.e0
            ydflux(i,j,k)=0.e0
          end do
        end do
      end do
C
C     Calculate y-component of velocity advection:
C
C     Calculate horizontal advective fluxes:
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=.125e0*((dt(i,j)+dt(i-1,j))*u(i,j,k)
     $                           +(dt(i,j-1)+dt(i-1,j-1))*u(i,j-1,k))
     $                         *(v(i,j,k)+v(i-1,j,k))
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=1,IM
            yflux(i,j,k)=.125e0*((dt(i,j+1)+dt(i,j))*v(i,j+1,k)
     $                           +(dt(i,j)+dt(i,j-1))*v(i,j,k))
     $                         *(v(i,j+1,k)+v(i,j,k))
          end do
        end do
      end do
C
C    Add horizontal diffusive fluxes:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IM
            dtaam=.25e0*(dt(i,j)+dt(i-1,j)+dt(i,j-1)+dt(i-1,j-1))
     $             *(aam(i,j,k)+aam(i-1,j,k)
     $               +aam(i,j-1,k)+aam(i-1,j-1,k))
            xdflux(i,j,k)=-dtaam*((ub(i,j,k)-ub(i,j-1,k))
     $                            /(dy(i,j)+dy(i-1,j)
     $                              +dy(i,j-1)+dy(i-1,j-1))
     $                            +(vb(i,j,k)-vb(i-1,j,k))
     $                            /(dx(i,j)+dx(i-1,j)
     $                              +dx(i,j-1)+dx(i-1,j-1)))
            ydflux(i,j,k)=-dt(i,j)*aam(i,j,k)*2.e0
     $                    *(vb(i,j+1,k)-vb(i,j,k))/dy(i,j)
C
            xflux(i,j,k)=.25e0*(dy(i,j)+dy(i-1,j)
     $                          +dy(i,j-1)+dy(i-1,j-1))*xflux(i,j,k)
            yflux(i,j,k)=dx(i,j)*yflux(i,j,k)
            xdflux(i,j,k)=.25e0*(dy(i,j)+dy(i-1,j)
     $                          +dy(i,j-1)+dy(i-1,j-1))*xdflux(i,j,k)
            ydflux(i,j,k)=dx(i,j)*ydflux(i,j,k)
          end do
        end do
      end do
      if(ibcon.eq.0)then
         call perchan(yflux)
         call perchan(ydflux)
      endif
C
C     Do horizontal advection:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            advy(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)
     $                   +yflux(i,j,k)-yflux(i,j-1,k)
     $                   +xdflux(i+1,j,k)-xdflux(i,j,k)
     $                   +ydflux(i,j,k)-ydflux(i,j-1,k)
     $                   +wvbody(i,j)*arv(i,j)
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            advy(i,j,k)=advy(i,j,k)
     $                   +arv(i,j)*.25e0
     $                     *(curv(i,j,k)*dt(i,j)
     $                        *(u(i+1,j,k)+u(i,j,k))
     $                       +curv(i,j-1,k)*dt(i,j-1)
     $                        *(u(i+1,j-1,k)+u(i,j-1,k)))
          end do
        end do
      end do
      if(ibal.ne.0)then
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
! leaving possibility of subdividing terms
c              vadvx(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)
c              vadvy(i,j,k)=yflux(i,j,k)-yflux(i,j-1,k)
c              vdix(i,j,k)=xdflux(i+1,j,k)-xdflux(i,j,k)
c              vdiy(i,j,k)=ydflux(i,j,k)-ydflux(i,j-1,k)
c              vcurv(i,j,k)=arv(i,j)*.25e0*(curv(i,j,k)*dt(i,j)
c     $                        *(u(i+1,j,k)+u(i,j,k))
c     $                       +curv(i,j-1,k)*dt(i,j-1)
c     $                        *(u(i+1,j-1,k)+u(i,j-1,k)))

c              vadv(i,j,k)=vadvx(i,j,k)+vadvy(i,j,k)

               vadv(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)+
     *            yflux(i,j,k)-yflux(i,j-1,k)+
     *            arv(i,j)*.25e0*(curv(i,j,k)*dt(i,j)
     $                        *(u(i+1,j,k)+u(i,j,k))
     $                       +curv(i,j-1,k)*dt(i,j-1)
     $                        *(u(i+1,j-1,k)+u(i,j-1,k)))
              vdi(i,j,k)=xdflux(i+1,j,k)-xdflux(i,j,k)+
     *            ydflux(i,j,k)-ydflux(i,j-1,k)
            end do
          end do
        end do
      endif
C
      return
C
      end
C
      subroutine advq1
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates horizontal advection and diffusion, and  *
C *                vertical advection for turbulent quantities.        *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real xflux(IM,JM,KB),yflux(IM,JM,KB)
      integer i,j,k
C
C     Do horizontal advection:
C
c advect q2 with uf as q2f
      do k=1,kb
        do j=1,jm
          do i=1,im
            xflux(i,j,k)=0.
            yflux(i,j,k)=0.
          enddo
        enddo
      enddo
      do k=2,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=.125e0*(q2(i,j,k)+q2(i-1,j,k))
     $                    *(dt(i,j)+dt(i-1,j))*(u(i,j,k)+u(i,j,k-1))
            yflux(i,j,k)=.125e0*(q2(i,j,k)+q2(i,j-1,k))
     $                    *(dt(i,j)+dt(i,j-1))*(v(i,j,k)+v(i,j,k-1))
          end do
        end do
      end do
C
C     Do horizontal diffusion:
C
      do k=2,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=xflux(i,j,k)
     $                    -.25e0*(aam(i,j,k)+aam(i-1,j,k)
     $                            +aam(i,j,k-1)+aam(i-1,j,k-1))
     $                          *(h(i,j)+h(i-1,j))
     $                          *(q2b(i,j,k)-q2b(i-1,j,k))*dum(i,j)
     $                          /(dx(i,j)+dx(i-1,j))
            yflux(i,j,k)=yflux(i,j,k)
     $                    -.25e0*(aam(i,j,k)+aam(i,j-1,k)
     $                            +aam(i,j,k-1)+aam(i,j-1,k-1))
     $                          *(h(i,j)+h(i,j-1))
     $                          *(q2b(i,j,k)-q2b(i,j-1,k))*dvm(i,j)
     $                          /(dy(i,j)+dy(i,j-1))
            xflux(i,j,k)=.5e0*(dy(i,j)+dy(i-1,j))*xflux(i,j,k)
            yflux(i,j,k)=.5e0*(dx(i,j)+dx(i,j-1))*yflux(i,j,k)
          end do
        end do
      end do
      if(ibcon.eq.0) call perchan(yflux)
C
C     Do vertical advection, add flux terms, then step forward in time:
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            uf(i,j,k)=(w(i,j,k-1)*q2(i,j,k-1)-w(i,j,k+1)*q2(i,j,k+1))
     $                 *art(i,j)/(dz(k)+dz(k-1))
     $                 +xflux(i+1,j,k)-xflux(i,j,k)
     $                 +yflux(i,j+1,k)-yflux(i,j,k)
            uf(i,j,k)=((h(i,j)+etb(i,j))*art(i,j)
     $                 *q2b(i,j,k)-dti2*uf(i,j,k))
     $                /((h(i,j)+etf(i,j))*art(i,j))
          end do
        end do
      end do
c advect q2l
      do k=1,kb
        do j=1,jm
          do i=1,im
            xflux(i,j,k)=0.
            yflux(i,j,k)=0.
          enddo
        enddo
      enddo
      do k=2,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=.125e0*(q2l(i,j,k)+q2l(i-1,j,k))
     $                    *(dt(i,j)+dt(i-1,j))*(u(i,j,k)+u(i,j,k-1))
            yflux(i,j,k)=.125e0*(q2l(i,j,k)+q2l(i,j-1,k))
     $                    *(dt(i,j)+dt(i,j-1))*(v(i,j,k)+v(i,j,k-1))
          end do
        end do
      end do
C
C     Do horizontal diffusion:
C
      do k=2,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=xflux(i,j,k)
     $                    -.25e0*(aam(i,j,k)+aam(i-1,j,k)
     $                            +aam(i,j,k-1)+aam(i-1,j,k-1))
     $                          *(h(i,j)+h(i-1,j))
     $                          *(q2lb(i,j,k)-q2lb(i-1,j,k))*dum(i,j)
     $                          /(dx(i,j)+dx(i-1,j))
            yflux(i,j,k)=yflux(i,j,k)
     $                    -.25e0*(aam(i,j,k)+aam(i,j-1,k)
     $                            +aam(i,j,k-1)+aam(i,j-1,k-1))
     $                          *(h(i,j)+h(i,j-1))
     $                          *(q2lb(i,j,k)-q2lb(i,j-1,k))*dvm(i,j)
     $                          /(dy(i,j)+dy(i,j-1))
            xflux(i,j,k)=.5e0*(dy(i,j)+dy(i-1,j))*xflux(i,j,k)
            yflux(i,j,k)=.5e0*(dx(i,j)+dx(i,j-1))*yflux(i,j,k)
          end do
        end do
      end do
      if(ibcon.eq.0) call perchan(yflux)
C
C     Do vertical advection, add flux terms, then step forward in time:
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            vf(i,j,k)=(w(i,j,k-1)*q2l(i,j,k-1)-w(i,j,k+1)*q2l(i,j,k+1))
     $                 *art(i,j)/(dz(k)+dz(k-1))
     $                 +xflux(i+1,j,k)-xflux(i,j,k)
     $                 +yflux(i,j+1,k)-yflux(i,j,k)
            vf(i,j,k)=((h(i,j)+etb(i,j))*art(i,j)
     $                 *q2lb(i,j,k)-dti2*vf(i,j,k))
     $                /((h(i,j)+etf(i,j))*art(i,j))
          end do
        end do
      end do
C
      return
C
      end
      subroutine advq2
C modified for q2 and q2l locations
C**********************************************************************
C   THIS SUBROUTINE CALCULATES THE 3D ADVECTION OF PASSIVE SCALAR     *
C   TRACERS BY A FIRST-ORDER UPSTREAM SCHEME. TO REDUCE IMPLICIT      *
C   DIFFUSION THE SMOLARKIEWICZ ITERATIVE UPSTREAM SCHEME WITH A      *
C   SPECIAL DEFINED ANTIDIFFUSIVE VELOCITY IS USED.                   *
C                                                                     *  
C       Gianmaria Sannino'          Vincenzo Artale''                 *
C                                                                     *
C  '  Inter-University Computing Consortium (CASPUR)                  *
C        Universita' "La Sapienza", Rome, ITALY                       *
C                                                                     *
C ''  Italian National Agency for New Technology and Environment      *
C     (ENEA C.R. Casaccia), Rome, ITALY                               *
C                                                                     *
C   Input:                                                            * 
C    qB -----> As Subroutine ADVq in POM                              *
C    q ------> As Subroutine ADVq in POM                              *
C    DTI2 ---> As Subroutine ADVq in POM                              *
C    NItera -> Number of iteration                                    *
C   Output:                                                           *
C    qF -----> As Subroutine ADVq in POM source code                  *
C                                                                     *
C  Smolarkiewicz, P.K. "A Fully Multidimensional Positive Definite    *
C   Advection Transport Algorithm with Small Implicit Diffusion"      *
C   Journal of Computational Physics 54, 325-362 (1984)               *
C                                                                     *
C  Notes for POM users:                                               *
C  1. replaces subroutine ADVT                                        *
C  2. suggested number of iterations: 1 to 4 (1 is standard upstream; *
C     more iterations are less diffusive; 3 itr. adds 50% to POM)     *
C  3. can run with no additional diff. (TPRNI=0.)                     *
C  4. the shock switch option may not work for most cases, to ignore  * 
C     it set SW=Constant (should be 1, but smaller value gives        * 
C     smoother solution with less overshoot for NItera>1 ).           * 
C                                                                     * 
C  (Try on your own risk, no advice or support will be provided) T.E. *
C**********************************************************************
C
      INCLUDE 'pom2k.h'
C
       
      real fbmEM1(IM,JM,KB),eta(IM,JM),fbmem2(IM,JM,KB)
      real xmassflux1(IM,JM,KB),ymassflux1(IM,JM,KB),
     *      zwflux1(IM,JM,KB)
      real xmassflux2(IM,JM,KB),ymassflux2(IM,JM,KB),
     *   zwflux2(IM,JM,KB)
      real xflux1(IM,JM,KB),yflux1(IM,JM,KB),zflux1(IM,JM,KB)
      real xflux2(IM,JM,KB),yflux2(IM,JM,KB),zflux2(IM,JM,KB)
      common/pom_smlq/xmassflux1,xmassflux2,ymassflux1,ymassflux2,
     *    zwflux1,zwflux2
      integer i,j,k,itera
C
C-----------------------------------------------------------------------
C                 HORIZONTAL MASS fluXES: DY*U*D  &  DX*V*D
C-----------------------------------------------------------------------
      do  k=1,KB
        do j=1,JM
          do i=1,IM
            xmassflux1(I,J,K)=0.e0
            ymassflux1(I,J,K)=0.e0
            xmassflux2(I,J,K)=0.e0
            ymassflux2(I,J,K)=0.e0
          enddo
        enddo
      enddo
C
      do K=2,KBM1
        do j=2,JMM1
          do i=2,IM
            xmassflux1(i,j,k)=0.25e0*(dy(i-1,j)+dy(i,j))*
     *         (dt(i-1,j)+dt(i,j))*.5e0*(u(i,j,k)+u(i,j,k-1))
            xmassflux2(I,J,K)=xmassflux1(i,j,k)
          enddo
        enddo 
        do j=2,JM
          do i=2,IMM1
            ymassflux1(i,j,k)=0.25e0*(dx(i,j-1)+dx(i,j))*
     *         (dt(i,j-1)+dt(i,j))*.5e0*(v(i,j,k)+v(i,j,k-1))
            ymassflux2(i,j,k)=ymassflux1(i,j,k)
          enddo
        enddo
      enddo 
C
      do j=1,JM
        do i=1,IM
          eta(i,j)=etb(i,j)
        enddo
      enddo
C
      do k=2,KB
        do j=1,JM
          do i=1,IM
            zwflux1(i,j,k)=.5e0*(w(i,j,k)+w(i,j,k-1))
            zwflux2(I,J,k)=.5e0*(w(i,j,k)+w(i,j,k-1))
            fbmem1(i,j,k)=q2b(I,J,K)
            fbmem2(i,j,k)=q2lb(i,j,k)
          enddo
        enddo
      enddo
      if(ibcon.eq.0)then
        call perchanv(fbmem1)
        call perchanv(fbmem2)
      endif
C-----------------------------------------------------------------------
C       SMOLARKIEWICZ SCHEME 
C-----------------------------------------------------------------------
      do itera=1,nitera2
C-----------------------------------------------------------------------
C           UPWIND ADVECTION SCHEME 
C-----------------------------------------------------------------------
        do  k=2,KBM1
          do j=2,JM
            do i=2,IM
              xflux1(i,j,k)=0.5e0*(
     &             (xmassflux1(i,j,k)+abs(xmassflux1(i,j,k)))
     &             *fbmem1(I-1,J,K)+
     &             (xmassflux1(i,j,k)-abs(xmassflux1(i,j,k)))
     &             *fbmem1(I,J,K)) 
              xflux2(I,J,K)=0.5e0*(
     &             (xmassflux2(i,j,k)+abs(xmassflux2(i,j,k)))
     &             *fbmem2(I-1,J,K)+
     &             (xmassflux2(i,j,k)-abs(xmassflux2(i,j,k)))
     &             *fbmem2(I,J,K)) 
C
              yflux1(I,J,K)=0.5e0*(
     &             (ymassflux1(I,J,K)+abs(ymassflux1(I,J,K)))
     &             *fbmem1(I,J-1,K)+
     &             (ymassflux1(I,J,K)-abs(YMassflux1(I,J,K)))
     &             *fbmem1(I,J,K)) 
              yflux2(I,J,K)=0.5e0*(
     &             (ymassflux2(I,J,K)+abs(YMassflux2(I,J,K)))
     &             *fbmem2(I,J-1,K)+
     &             (ymassflux2(I,J,K)-abs(YMassflux2(I,J,K)))
     &             *fbmem2(I,J,K)) 
          enddo
        enddo
      enddo
      if(ibcon.eq.0)then
         call perchan(ymassflux1)
         call perchan(ymassflux2)
      endif
C
        do j=2,JMM1
          do i=2,IMM1
            zflux2(i,j,kb)=0.0e0
            zflux1(i,j,kb)=0.0e0
          enddo
        enddo
C
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              zflux1(i,j,k)=0.5e0*(
     &             (zwflux1(i,j,k)+abs(zwflux1(i,j,k)))
     &             *fbmem1(i,j,k)+
     &             (zwflux1(i,j,k)-abs(zwflux1(i,j,k)))
     &             *fbmem1(i,j,k-1))
              zflux2(i,j,k)=0.5e0*(
     &             (zwflux2(i,j,k)+abs(zwflux2(i,j,k)))
     &             *fbmem2(i,j,k)+
     &             (zwflux2(i,j,k)-abs(zwflux2(i,j,k)))
     &             *fbmem2(i,j,k-1))
              zflux1(i,j,k)=zflux1(i,j,k)*art(i,j)
              zflux2(i,j,k)=zflux2(i,j,k)*art(i,j)
            enddo
          enddo
        enddo
C-----------------------------------------------------------------------
C        ADD NET ADVECTIVE fluXES; THEN STEP FORWARD IN TIME 
C-----------------------------------------------------------------------
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              vf(i,j,k)=xflux2(i+1,j,k)-xflux2(i,j,k)
     &              +yflux2(i,j+1,k)-yflux2(i,j,k)
     &             +(zflux2(I,J,K)-zflux2(i,j,k+1))/dz(k)
              vf(i,j,k)=(fbmem2(i,j,k)*(h(i,j)+eta(i,j))*art(i,j)-
     &             dti2*vf(i,j,k))/((h(i,j)+etf(i,j))*art(i,j))
              uf(I,J,K)=xflux1(i+1,j,k)-xflux1(i,j,k)
     &              +yflux1(i,j+1,k)-yflux1(i,j,k)
     &             +(zflux1(i,j,k)-zflux1(i,j,k+1))/dz(k)
              uf(i,j,k)=(fbmem1(i,j,k)*(h(i,j)+eta(i,j))*art(i,j)-
     &             dti2*uf(i,j,k))/((h(i,j)+etf(i,j))*art(i,j))
            enddo
          enddo
        enddo
        if(ibcon.eq.0)then
          call perchanv(uf)
          call perchanv(vf)
        endif
C-----------------------------------------------------------------------
C                ANTIDIFFUSION VELOCITY 
C-----------------------------------------------------------------------
        call smol_adifq
C
        do j=1,JM
          do i=1,IM
            eta(i,j)=etf(i,j)
            do k=1,KB
              fbmem1(i,j,k)=uf(i,j,k)
              fbmem2(i,j,k)=vf(i,j,k)
            enddo
          enddo
        enddo
      enddo
C-----------------------------------------------------------------------
C             END
C    SMOLARKIEWICZ SCHEME 
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C         ADD HORIZONTAL DIFFUSIVE fluXES 
C-----------------------------------------------------------------------
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xmassflux1(i,j,k)=0.5e0*(aam(i,j,k)+aam(i-1,j,k))
            ymassflux1(I,J,K)=0.5e0*(aam(i,j,k)+aam(i,j-1,k))
          enddo
        enddo
      enddo
C 
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xflux1(i,j,k)=
     &        -xmassflux1(i,j,k)*(h(i,j)+h(i-1,j))
     &        *(q2b(i,j,k)-q2b(i-1,j,k))*dum(i,j)/(dx(i,j)+dx(i-1,j))
     &        *0.5e0*(dy(i,j)+dy(i-1,j))
            yflux1(i,j,k)=
     &        -ymassflux1(i,j,k)*(h(i,j)+h(i,j-1))
     &        *(q2b(i,j,k)-q2b(i,j-1,k))/(dy(i,j)+dy(i,j-1))
     &        *0.5e0*(dx(i,j)+dx(i,j-1))
            xflux2(i,j,k)=
     &        -xmassflux1(i,j,k)*(h(i,j)+h(i-1,j))
     &        *(q2lb(i,j,k)-q2lb(i-1,j,k))*dum(i,j)/(dx(i,j)+dx(i-1,j))
     &        *0.5e0*(dy(i,j)+dy(i-1,j))
            yflux2(i,j,k)=
     &        -ymassflux1(i,j,k)*(h(i,j)+h(i,j-1))
     &        *(q2lb(i,j,k)-q2lb(i,j-1,k))/(dy(i,j)+dy(i,j-1))
     &        *0.5e0*(dx(i,j)+dx(i,j-1))
          enddo
        enddo
      enddo

C
C
C----- ADD NET HORIZONTAL fluXES; THEN STEP FORWARD IN TIME --------
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            vf(i,j,k)=vf(i,j,k)-dti2*(
     &              +xflux2(i+1,j,k)-xflux2(i,j,k)
     &              +yflux2(i,j+1,k)-yflux2(i,j,k))
     &                    /((h(i,j)+etf(i,j))*art(i,j))
            uf(i,j,k)=uf(i,j,k)-dti2*(
     &              +xflux1(i+1,j,k)-xflux1(i,j,k)
     &              +yflux1(i,j+1,k)-Yflux1(i,j,k))
     &                    /((h(i,j)+etf(I,J))*art(i,j))
C--------------------------------------------------------------------
          enddo
        enddo
      enddo
      return
      end
C
      subroutine advt1
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Integrates conservative scalar equations.           *
C *                                                                    *
C *                This is centred scheme, as originally provide in    *
C *                POM (previously called advt).                       *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real xflux(IM,JM,KB),yflux(IM,JM,KB)
      integer i,j,k
C
      do j=1,JM
        do i=1,IM
           t(i,j,KB)=t(i,j,KBM1)
           tb(i,j,KB)=tb(i,j,KBM1)
        end do
      end do
C
C     Do advective fluxes:
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=.25e0*((dt(i,j)+dt(i-1,j))
     $                          *(t(i,j,k)+t(i-1,j,k))*u(i,j,k))
            yflux(i,j,k)=.25e0*((dt(i,j)+dt(i,j-1))
     $                          *(t(i,j,k)+t(i,j-1,k))*v(i,j,k))
          end do
        end do
      end do
C
C     Add diffusive fluxes:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            tb(i,j,k)=tb(i,j,k)-tclim(i,j,k)
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=xflux(i,j,k)
     $                    -.5e0*(aam(i,j,k)+aam(i-1,j,k))
     $                         *(h(i,j)+h(i-1,j))*tprni
     $                         *(tb(i,j,k)-tb(i-1,j,k))*dum(i,j)
     $                         /(dx(i,j)+dx(i-1,j))
            yflux(i,j,k)=yflux(i,j,k)
     $                    -.5e0*(aam(i,j,k)+aam(i,j-1,k))
     $                         *(h(i,j)+h(i,j-1))*tprni
     $                         *(tb(i,j,k)-tb(i,j-1,k))*dvm(i,j)
     $                         /(dy(i,j)+dy(i,j-1))
            xflux(i,j,k)=.5e0*(dy(i,j)+dy(i-1,j))*xflux(i,j,k)
            yflux(i,j,k)=.5e0*(dx(i,j)+dx(i,j-1))*yflux(i,j,k)
          end do
        end do
      end do
C
      if(ibcon.eq.0)call perchan(yflux)
      do k=1,KB
        do j=1,JM
          do i=1,IM
            tb(i,j,k)=tb(i,j,k)+tclim(i,j,k)
          end do
        end do
      end do
C
C     Do vertical advection:
C
      do j=2,JMM1
        do i=2,IMM1
          zflux(i,j,1)=t(i,j,1)*vflux(i,j)*art(i,j)
          zflux(i,j,KB)=0.e0
        end do
      end do
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            zflux(i,j,k)=.5e0*(t(i,j,k-1)+t(i,j,k))*w(i,j,k)*art(i,j)
          end do
        end do
      end do
C
C     Add net horizontal fluxes and then step forward in time:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            uf(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)
     $                 +yflux(i,j+1,k)-yflux(i,j,k)
     $                 +(zflux(i,j,k)-zflux(i,j,k+1))/dz(k)
C
            uf(i,j,k)=(tb(i,j,k)*(h(i,j)+etb(i,j))*art(i,j)
     $                 -dti2*uf(i,j,k))
     $                 /((h(i,j)+etf(i,j))*art(i,j))
          end do
        end do
      end do
C
      if(istrat.eq.2)then
        do k=1,kb
          do j=1,jm
            do i=1,im
              xflux(i,j,k)=0.
              yflux(i,j,k)=0.
            enddo
          enddo
        enddo
        do j=1,JM
          do i=1,IM
            s(i,j,KB)=s(i,j,KBM1)
            sb(i,j,KB)=sb(i,j,KBM1)
          end do
        end do
C
C     Do advective fluxes:
C
        do k=1,KBM1
          do j=2,JM
            do i=2,IM
              xflux(i,j,k)=.25e0*((dt(i,j)+dt(i-1,j))
     $                          *(s(i,j,k)+s(i-1,j,k))*u(i,j,k))
              yflux(i,j,k)=.25e0*((dt(i,j)+dt(i,j-1))
     $                          *(s(i,j,k)+s(i,j-1,k))*v(i,j,k))
            end do
          end do
        end do
C
C     Add diffusive fluxes:
C
        do k=1,KB
          do j=1,JM
            do i=1,IM
              sb(i,j,k)=sb(i,j,k)-sclim(i,j,k)
            end do
          end do
        end do
C
        do k=1,KBM1
          do j=2,JM
            do i=2,IM
              xflux(i,j,k)=xflux(i,j,k)
     $                    -.5e0*(aam(i,j,k)+aam(i-1,j,k))
     $                         *(h(i,j)+h(i-1,j))*tprni
     $                         *(sb(i,j,k)-sb(i-1,j,k))*dum(i,j)
     $                         /(dx(i,j)+dx(i-1,j))
              yflux(i,j,k)=yflux(i,j,k)
     $                    -.5e0*(aam(i,j,k)+aam(i,j-1,k))
     $                         *(h(i,j)+h(i,j-1))*tprni
     $                         *(sb(i,j,k)-sb(i,j-1,k))*dvm(i,j)
     $                         /(dy(i,j)+dy(i,j-1))
              xflux(i,j,k)=.5e0*(dy(i,j)+dy(i-1,j))*xflux(i,j,k)
              yflux(i,j,k)=.5e0*(dx(i,j)+dx(i,j-1))*yflux(i,j,k)
            end do
          end do
        end do
        if(ibcon.eq.0)call perchan(yflux)
C
        do k=1,KB
          do j=1,JM
            do i=1,IM
              sb(i,j,k)=sb(i,j,k)+sclim(i,j,k)
            end do
          end do
        end do
C
C     Do vertical advection:
C
        do j=2,JMM1
          do i=2,IMM1
            zflux(i,j,1)=s(i,j,1)*vflux(i,j)*art(i,j)
            zflux(i,j,KB)=0.e0
          end do
        end do
C
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              zflux(i,j,k)=.5e0*(s(i,j,k-1)+s(i,j,k))*
     $             w(i,j,k)*art(i,j)
            end do
          end do
        end do
C
C     Add net horizontal fluxes and then step forward in time:
C
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              vf(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)
     $                 +yflux(i,j+1,k)-yflux(i,j,k)
     $                 +(zflux(i,j,k)-zflux(i,j,k+1))/dz(k)
C
              vf(i,j,k)=(sb(i,j,k)*(h(i,j)+etb(i,j))*art(i,j)
     $                 -dti2*uf(i,j,k))
     $                 /((h(i,j)+etf(i,j))*art(i,j))
            end do
          end do
        end do
C
      endif
      return
C
      end
C
      subroutine advt2
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Integrates conservative scalar equations.           *
C *                                                                    *
C *                This is a first-order upstream scheme, which        *
C *                reduces implicit diffusion using the Smolarkiewicz  *
C *                iterative upstream scheme with an antidiffusive     *
C *                velocity.                                           *
C *                                                                    *
C *                It is based on the subroutines of Gianmaria Sannino *
C *                (Inter-university Computing Consortium, Rome, Italy)*
C *                and Vincenzo Artale (Italian National Agency for    *
C *                New Technology and Environment, Rome, Italy),       *
C *                downloaded from the POM FTP site on 1 Nov. 2001.    *
C *                The calculations have been simplified by removing   *
C *                the shock switch option. It should be noted that    *
C *                this implementation does not include cross-terms    *
C *                which are in the original formulation.              *
C *                                                                    *
C *                fb,f,fclim,ff . as used in subroutine advt1         *
C *                xflux,yflux ... working arrays used to save memory  *
C *                nitera ........ number of iterations. This should   *
C *                                be in the range 1 - 4. 1 is         *
C *                                standard upstream differencing;     *
C *                                3 adds 50% CPU time to POM.         *
C *                sw ............ smoothing parameter. This should    *
C *                                preferably be 1, but 0 < sw < 1     *
C *                                gives smoother solutions with less  *
C *                                overshoot when nitera > 1.          *
C *                                                                    *
C *                Reference:                                          *
C *                                                                    *
C *                Smolarkiewicz, P.K.; A fully multidimensional       *
C *                  positive definite advection transport algorithm   *
C *                  with small implicit diffusion, Journal of         *
C *                  Computational Physics, 54, 325-362, 1984.         *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real xflux(IM,JM,KB),yflux(IM,JM,KB)
      real fbmem(IM,JM,KB),eta(IM,JM)
      real xmassflux(IM,JM,KB),ymassflux(IM,JM,KB),zwflux(IM,JM,KB)
      integer i,j,k,itera
C
C     Calculate horizontal mass fluxes:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            xmassflux(i,j,k)=0.e0
            ymassflux(i,j,k)=0.e0
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IM
            xmassflux(i,j,k)=0.25e0*(dy(i-1,j)+dy(i,j))
     $                             *(dt(i-1,j)+dt(i,j))*u(i,j,k)
          end do
        end do
C
        do j=2,JM
          do i=2,IMM1
            ymassflux(i,j,k)=0.25e0*(dx(i,j-1)+dx(i,j))
     $                             *(dt(i,j-1)+dt(i,j))*v(i,j,k)
          end do
        end do
      end do
      if(ibcon.eq.0)call perchan(ymassflux)
C
      do j=1,JM
        do i=1,IM
          tb(i,j,KB)=tb(i,j,KBM1)
          eta(i,j)=etb(i,j)
        end do
      end do
C
      do k=2,KB
        do j=1,JM
          do i=1,IM
            zwflux(i,j,k)=w(i,j,k)
            fbmem(i,j,k)=tb(i,j,k)
          end do
        end do
      end do
      do j=1,JM
        do i=1,IM
          zwflux(i,j,1)=vflux(i,j)
          fbmem(i,j,1)=tb(i,j,k)
        enddo
      enddo
C
C     Start Smolarkiewicz scheme:
C
      do itera=1,nitera1
C
C     Upwind advection scheme:
C
C
        do k=1,KBM1
          do j=2,JM
            do i=2,IM
              xflux(i,j,k)=0.5e0
     $                      *((xmassflux(i,j,k)+abs(xmassflux(i,j,k)))
     $                        *fbmem(i-1,j,k)+
     $                        (xmassflux(i,j,k)-abs(xmassflux(i,j,k)))
     $                        *fbmem(i,j,k))
C
              yflux(i,j,k)=0.5e0
     $                      *((ymassflux(i,j,k)+abs(ymassflux(i,j,k)))
     $                        *fbmem(i,j-1,k)+
     $                        (ymassflux(i,j,k)-abs(ymassflux(i,j,k)))
     $                        *fbmem(i,j,k))
            end do
          end do
        end do
        if(ibcon.eq.0)call perchan(yflux)
        do j=2,JMM1
          do i=2,IMM1
            zflux(i,j,1)=0.e0
            if(itera.eq.1) zflux(i,j,1)=vflux(i,j)*t(i,j,1)*art(i,j)
            zflux(i,j,KB)=0.e0
          end do
        end do
C
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              zflux(i,j,k)=0.5e0
     $                      *((zwflux(i,j,k)+abs(zwflux(i,j,k)))
     $                       *fbmem(i,j,k)+
     $                        (zwflux(i,j,k)-abs(zwflux(i,j,k)))
     $                       *fbmem(i,j,k-1))
              zflux(i,j,k)=zflux(i,j,k)*art(i,j)
            end do
          end do
        end do
C
C     Add net advective fluxes and step forward in time:
C
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              uf(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)
     $                 +yflux(i,j+1,k)-yflux(i,j,k)
     $                 +(zflux(i,j,k)-zflux(i,j,k+1))/dz(k)
              uf(i,j,k)=(fbmem(i,j,k)*(h(i,j)+eta(i,j))*art(i,j)
     $                   -dti2*uf(i,j,k))/((h(i,j)+etf(i,j))*art(i,j))
            end do
          end do
        end do
C
C     Calculate antidiffusion velocity:
C
        call smol_adif(xmassflux,ymassflux,zwflux,uf)
C
        do j=1,JM
          do i=1,IM
            eta(i,j)=etf(i,j)
            do k=1,KB
              fbmem(i,j,k)=uf(i,j,k)
            end do
          end do
        end do
C
C     End of Smolarkiewicz scheme
C
      end do
C
C     Add horizontal diffusive fluxes:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            tb(i,j,k)=tb(i,j,k)-tclim(i,j,k)
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xmassflux(i,j,k)=0.5e0*(aam(i,j,k)+aam(i-1,j,k))
            ymassflux(i,j,k)=0.5e0*(aam(i,j,k)+aam(i,j-1,k))
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
           xflux(i,j,k)=-xmassflux(i,j,k)*(h(i,j)+h(i-1,j))*tprni
     $                   *(tb(i,j,k)-tb(i-1,j,k))*dum(i,j)
     $                   *(dy(i,j)+dy(i-1,j))*0.5e0/(dx(i,j)+dx(i-1,j))
           yflux(i,j,k)=-ymassflux(i,j,k)*(h(i,j)+h(i,j-1))*tprni
     $                   *(tb(i,j,k)-tb(i,j-1,k))*dvm(i,j)
     $                   *(dx(i,j)+dx(i,j-1))*0.5e0/(dy(i,j)+dy(i,j-1))
          end do
        end do
      end do
      if(ibcon.eq.0)call perchan(yflux)
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            tb(i,j,k)=tb(i,j,k)+tclim(i,j,k)
          end do
        end do
      end do
C
C     Add net horizontal fluxes and step forward in time:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            uf(i,j,k)=uf(i,j,k)-dti2*(xflux(i+1,j,k)-xflux(i,j,k)
     $                               +yflux(i,j+1,k)-yflux(i,j,k))
     $                           /((h(i,j)+etf(i,j))*art(i,j))
          end do
        end do
      end do
      if(istrat.eq.2)then
      do k=1,KB
        do j=1,JM
          do i=1,IM
            xmassflux(i,j,k)=0.e0
            ymassflux(i,j,k)=0.e0
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IM
            xmassflux(i,j,k)=0.25e0*(dy(i-1,j)+dy(i,j))
     $                             *(dt(i-1,j)+dt(i,j))*u(i,j,k)
          end do
        end do
C
        do j=2,JM
          do i=2,IMM1
            ymassflux(i,j,k)=0.25e0*(dx(i,j-1)+dx(i,j))
     $                             *(dt(i,j-1)+dt(i,j))*v(i,j,k)
          end do
        end do
      end do
C
      do j=1,JM
        do i=1,IM
          sb(i,j,KB)=sb(i,j,KBM1)
          eta(i,j)=etb(i,j)
        end do
      end do
C
      do k=2,KB
        do j=1,JM
          do i=1,IM
            zwflux(i,j,k)=w(i,j,k)
            fbmem(i,j,k)=sb(i,j,k)
          end do
        end do
      end do
      do j=1,JM
        do i=1,IM
          zwflux(i,j,1)=vflux(i,j)
          fbmem(i,j,1)=sb(i,j,k)
        enddo
      enddo
C
C     Start Smolarkiewicz scheme:
C
      do itera=1,nitera1
C
C     Upwind advection scheme:
C
C
        do k=1,KBM1
          do j=2,JM
            do i=2,IM
              xflux(i,j,k)=0.5e0
     $                      *((xmassflux(i,j,k)+abs(xmassflux(i,j,k)))
     $                        *fbmem(i-1,j,k)+
     $                        (xmassflux(i,j,k)-abs(xmassflux(i,j,k)))
     $                        *fbmem(i,j,k))
C
              yflux(i,j,k)=0.5e0
     $                      *((ymassflux(i,j,k)+abs(ymassflux(i,j,k)))
     $                        *fbmem(i,j-1,k)+
     $                        (ymassflux(i,j,k)-abs(ymassflux(i,j,k)))
     $                        *fbmem(i,j,k))
            end do
          end do
        end do
        if(ibcon.eq.0)call perchan(yflux)
        do j=2,JMM1
          do i=2,IMM1
            zflux(i,j,1)=0.e0
            if(itera.eq.1) zflux(i,j,1)=vflux(i,j)*s(i,j,1)*art(i,j)
            zflux(i,j,KB)=0.e0
          end do
        end do
C
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              zflux(i,j,k)=0.5e0
     $                      *((zwflux(i,j,k)+abs(zwflux(i,j,k)))
     $                       *fbmem(i,j,k)+
     $                        (zwflux(i,j,k)-abs(zwflux(i,j,k)))
     $                       *fbmem(i,j,k-1))
              zflux(i,j,k)=zflux(i,j,k)*art(i,j)
            end do
          end do
        end do
C
C     Add net advective fluxes and step forward in time:
C
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              vf(i,j,k)=xflux(i+1,j,k)-xflux(i,j,k)
     $                 +yflux(i,j+1,k)-yflux(i,j,k)
     $                 +(zflux(i,j,k)-zflux(i,j,k+1))/dz(k)
              vf(i,j,k)=(fbmem(i,j,k)*(h(i,j)+eta(i,j))*art(i,j)
     $                   -dti2*vf(i,j,k))/((h(i,j)+etf(i,j))*art(i,j))
            end do
          end do
        end do
C
C     Calculate antidiffusion velocity:
C
        call smol_adif(xmassflux,ymassflux,zwflux,vf)
C
        do j=1,JM
          do i=1,IM
            eta(i,j)=etf(i,j)
            do k=1,KB
              fbmem(i,j,k)=vf(i,j,k)
            end do
          end do
        end do
C
C     End of Smolarkiewicz scheme
C
      end do
C
C     Add horizontal diffusive fluxes:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            sb(i,j,k)=sb(i,j,k)-sclim(i,j,k)
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xmassflux(i,j,k)=0.5e0*(aam(i,j,k)+aam(i-1,j,k))
            ymassflux(i,j,k)=0.5e0*(aam(i,j,k)+aam(i,j-1,k))
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
           xflux(i,j,k)=-xmassflux(i,j,k)*(h(i,j)+h(i-1,j))*tprni
     $                   *(sb(i,j,k)-sb(i-1,j,k))*dum(i,j)
     $                   *(dy(i,j)+dy(i-1,j))*0.5e0/(dx(i,j)+dx(i-1,j))
           yflux(i,j,k)=-ymassflux(i,j,k)*(h(i,j)+h(i,j-1))*tprni
     $                   *(sb(i,j,k)-sb(i,j-1,k))*dvm(i,j)
     $                   *(dx(i,j)+dx(i,j-1))*0.5e0/(dy(i,j)+dy(i,j-1))
          end do
        end do
      end do
      if(ibcon.eq.0)call perchan(yflux)
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            sb(i,j,k)=sb(i,j,k)+sclim(i,j,k)
          end do
        end do
      end do
C
C     Add net horizontal fluxes and step forward in time:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            vf(i,j,k)=vf(i,j,k)-dti2*(xflux(i+1,j,k)-xflux(i,j,k)
     $                               +yflux(i,j+1,k)-yflux(i,j,k))
     $                           /((h(i,j)+etf(i,j))*art(i,j))
          end do
        end do
      end do
      endif
C
      return
C
      end
C
      subroutine advu
C **********************************************************************
C *                                                                    *
C * ROUTINE NAME:  advu                                                *
C *                                                                    *
C * FUNCTION    :  Does horizontal and vertical advection of           *
C *                u-momentum, and includes coriolis, surface slope    *
C *                and baroclinic terms.                               *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'combal3.h'
      real uadvz
C
      integer i,j,k
C
C     Do vertical advection:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            uf(i,j,k)=0.e0
          end do
        end do
      end do
C
      do j=1,JM
         do i=1,IM
            uf(i,j,1)=omu(i,j)*u(i,j,1)
         enddo
      enddo
      do k=2,KBM1
        do j=1,JM
          do i=2,IM
            uf(i,j,k)=.25e0*(w(i,j,k)+w(i-1,j,k))
     $                     *(u(i,j,k)+u(i,j,k-1))
          end do
        end do
      end do
      if(ibal.ne.0)then
        if(idiv.ne.0)then
          do j=2,JMM1
            do i=2,IMM1
              tps(i,j)=
     *          2./((h(i,j)+etf(i,j)+h(i-1,j)+etf(i-1,j))*aru(i,j))
            enddo
          enddo
          else
          do j=2,JMM1
            do i=2,IMM1
              tps(i,j)=1./aru(i,j)
            enddo
          enddo
        endif
        do j=2,JMM1
          do i=2,IMM1
            ubod(i,j)=wubody(i,j)*aru(i,j)*tps(i,j)
          enddo
        enddo
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              uadvz=(uf(i,j,k)-uf(i,j,k+1))*aru(i,j)/dz(k)
              up(I,J,K)= (grav*.125e0*(dt(i,j)+dt(i-1,j))
     $                   *(egf(i,j)-egf(i-1,j)+egb(i,j)-egb(i-1,j)
     $                     +(e_atmos(i,j)-e_atmos(i-1,j))*2.e0)
     $                   *(dy(i,j)+dy(i-1,j)))*tps(i,j)
              ucor(i,j,k)=-aru(i,j)*.25*(cor(i,j)*dt(i,j)*
     *                  (v(i,j+1,k)+v(i,j,k))
     2                  +cor(i-1,j)*dt(i-1,j)*
     3                  (v(i-1,j+1,k)+v(i-1,j,k)))*tps(i,j)
              udi(i,j,k)=udi(i,j,k)*tps(i,j)
              uadv(i,j,k)=(uadv(i,j,k)+uadvz)*tps(i,j)
            enddo
          enddo
        enddo
        if(istrat.ne.0)then
          do k=1,KBM1
            do j=2,JMM1
              do i=2,IMM1
                  up(i,j,k)=up(i,j,k)+drhox(i,j,k)*tps(i,j)
              end do
            end do
          end do
        endif 
      endif

C
C     Combine horizontal and vertical advection with coriolis, surface
C     slope and baroclinic terms:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            uf(i,j,k)=advx(i,j,k)
     $                 +(uf(i,j,k)-uf(i,j,k+1))*aru(i,j)/dz(k)
     $                 -aru(i,j)*.25e0
     $                   *(cor(i,j)*dt(i,j)
     $                      *(v(i,j+1,k)+v(i,j,k))
     $                     +cor(i-1,j)*dt(i-1,j)
     $                       *(v(i-1,j+1,k)+v(i-1,j,k)))
     $                 +grav*.125e0*(dt(i,j)+dt(i-1,j))
     $                   *(egf(i,j)-egf(i-1,j)+egb(i,j)-egb(i-1,j)
     $                     +(e_atmos(i,j)-e_atmos(i-1,j))*2.e0)
     $                   *(dy(i,j)+dy(i-1,j))
          end do
        end do
      end do

      if(istrat.ne.0)then
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
                 uf(i,j,k)=uf(i,j,k)+drhox(i,j,k)
            end do
          end do
        end do
      endif
C
C     Step forward in time:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            uf(i,j,k)=((h(i,j)+etb(i,j)+h(i-1,j)+etb(i-1,j))
     $                 *aru(i,j)*ub(i,j,k)
     $                 -2.e0*dti2*uf(i,j,k))
     $                /((h(i,j)+etf(i,j)+h(i-1,j)+etf(i-1,j))
     $                  *aru(i,j))
          end do
        end do
      end do
C
      return
C
      end
C
      subroutine advv
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Does horizontal and vertical advection of           *
C *                v-momentum, and includes coriolis, surface slope    *
C *                and baroclinic terms.                               *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'combal3.h'
      real vadvz
C
      integer i,j,k
C
C     Do vertical advection:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            vf(i,j,k)=0.e0
          end do
        end do
      end do
C
      do j=1,JM
         do i=1,IM
            vf(i,j,1)=omv(i,j)*v(i,j,1)
         enddo
      enddo
      do k=2,KBM1
        do j=2,JM
          do i=1,IM
            vf(i,j,k)=.25e0*(w(i,j,k)+w(i,j-1,k))
     $                     *(v(i,j,k)+v(i,j,k-1))
          end do
        end do
      end do
C
C     Combine horizontal and vertical advection with coriolis, surface
C     slope and baroclinic terms:
C
      if(ibal.ne.0)then
        if(idiv.ne.0)then
          do j=2,jmm1
            do i=2,imm1
              tps(i,j)=
     *           2./((h(i,j)+etf(i,j)+h(i,j-1)+etf(i,j-1))*arv(i,j))
            enddo
          enddo
        else
          do j=2,jmm1
            do i=2,imm1
            tps(i,j)=1./arv(i,j)
            enddo
          enddo
        endif
        do j=2,JMM1
          do i=2,IMM1
            vbod(i,j)=wvbody(i,j)*arv(i,j)*tps(i,j)
          enddo
        enddo
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              vadvz=(vf(i,j,k)-vf(i,j,k+1))*arv(i,j)/dz(k)
              vcor(i,j,k)=arv(i,j)*.25e0*(cor(i,j)*dt(i,j)
     $                      *(u(i+1,j,k)+u(i,j,k))
     $                     +cor(i,j-1)*dt(i,j-1)
     $                      *(u(i+1,j-1,k)+u(i,j-1,k)))*tps(i,j)
              vp(i,j,k)=(+grav*.125e0*(dt(i,j)+dt(i,j-1))
     $                   *(egf(i,j)-egf(i,j-1)+egb(i,j)-egb(i,j-1)
     $                     +(e_atmos(i,j)-e_atmos(i,j-1))*2.e0)
     $                   *(dx(i,j)+dx(i,j-1)))*tps(i,j)
              vdi(i,j,k)=vdi(i,j,k)*tps(i,j)
              vadv(i,j,k)=(vadv(i,j,k)+vadvz)*tps(i,j)
            end do
          end do
        end do
        if(istrat.ne.0)then
          do k=1,KBM1
            do j=2,JMM1
              do i=2,IMM1
                vp(i,j,k)=vp(i,j,k)+drhoy(i,j,k)*tps(i,j)
              end do
            end do
          end do
        endif     
      endif
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            vf(i,j,k)=advy(i,j,k)
     $                 +(vf(i,j,k)-vf(i,j,k+1))*arv(i,j)/dz(k)
     $                 +arv(i,j)*.25e0
     $                   *(cor(i,j)*dt(i,j)
     $                      *(u(i+1,j,k)+u(i,j,k))
     $                     +cor(i,j-1)*dt(i,j-1)
     $                       *(u(i+1,j-1,k)+u(i,j-1,k)))
     $                 +grav*.125e0*(dt(i,j)+dt(i,j-1))
     $                   *(egf(i,j)-egf(i,j-1)+egb(i,j)-egb(i,j-1)
     $                     +(e_atmos(i,j)-e_atmos(i,j-1))*2.e0)
     $                   *(dx(i,j)+dx(i,j-1))
          end do
        end do
      end do
C
      if(istrat.ne.0)then 
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              vf(i,j,k)=vf(i,j,k)+drhoy(i,j,k)
            end do
          end do
        end do
      endif
C     Step forward in time:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            vf(i,j,k)=((h(i,j)+etb(i,j)+h(i,j-1)+etb(i,j-1))
     $                 *arv(i,j)*vb(i,j,k)
     $                 -2.e0*dti2*vf(i,j,k))
     $                /((h(i,j)+etf(i,j)+h(i,j-1)+etf(i,j-1))
     $                  *arv(i,j))
          end do
        end do
      end do
C
      return
C
      end
C
      subroutine areas_masks
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates areas and masks.                         *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      integer i,j
C
C     Calculate areas of "t" and "s" cells:
C
      do j=1,JM
        do i=1,IM
          art(i,j)=dx(i,j)*dy(i,j)
        end do
      end do
C
C     Calculate areas of "u" and "v" cells:
C
      do j=2,JM
        do i=2,IM
          aru(i,j)=.25e0*(dx(i,j)+dx(i-1,j))*(dy(i,j)+dy(i-1,j))
          arv(i,j)=.25e0*(dx(i,j)+dx(i,j-1))*(dy(i,j)+dy(i,j-1))
        end do
      end do
C
      do j=1,JM
        aru(1,j)=aru(2,j)
        arv(1,j)=arv(2,j)
      end do
C
      do i=1,IM
        aru(i,1)=aru(i,2)
        arv(i,1)=arv(i,2)
      end do
C
C     Initialise and set up free surface mask:
C     mask at cell center is read in setup
      do j=1,JM
        do i=1,IM
          dum(i,j)=0.e0
          dvm(i,j)=0.e0
        end do
      end do
C
C     Set up velocity masks:
C
      do j=2,JM
        do i=2,IM
          dum(i,j)=fsm(i,j)*fsm(i-1,j)
          dvm(i,j)=fsm(i,j)*fsm(i,j-1)
        end do
          dum(1,j)=fsm(1,j)
      end do
c  only dum  used for periodic channel
      if(ibcon.eq.0)then
         do j=1,jm
           do i=1,im
             dvm(i,j)=1 
             fsm(i,j)=1
           enddo
         enddo
         call perchan1(dum)
       endif
C
      return
C
      end
      subroutine avebal
      include 'pom2k.h'  
      include "combal3.h"
      integer i,j,k,iopen
      data iopen/0/
c     write 3d fields
c     for example u v w km q2 rho
c     write(30)(((ub(i,j),i=2,IMM1),j=2,JMM1,k=1,kbm1)
      if(iopen.eq.0)then
        iopen=1
        open(unit=150,file='udtav',form='unformatted',status='new')
        open(unit=151,file='vdtav',form='unformatted',status='new')
        open(unit=152,file='uadvav',form='unformatted',status='new')
        open(unit=153,file='vadvav',form='unformatted',status='new') 
        open(unit=154,file='udihav',form='unformatted',status='new') 
        open(unit=155,file='vdihav',form='unformatted',status='new')
        open(unit=156,file='upav',form='unformatted',status='new')
        open(unit=157,file='vpav',form='unformatted',status='new')
        open(unit=158,file='udivav',form='unformatted',status='new')
        open(unit=159,file='vdivav',form='unformatted',status='new')
        open(unit=160,file='ucorav',form='unformatted',status='new')
        open(unit=161,file='vcorav',form='unformatted',status='new')
        open(unit=162,file='ubodav',form='unformatted',status='new')
        open(unit=163,file='vbodav',form='unformatted',status='new')
        open(unit=164,file='udiav',form='unformatted',status='new')
        open(unit=165,file='vdiav',form='unformatted',status='new')
      endif
      do k=1,KBM1
        write(150)((udtav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(151)((vdtav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(152)((uadvav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(153)((vadvav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(154)((udiav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(155)((vdiav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(156)((upav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(157)((vpav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(158)((uverav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(159)((vverav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(160)((ucorav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(161)((vcorav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(162)((ubodav(i,j),i=2,IMM1),j=2,JMM1)
        write(163)((vbodav(i,j),i=2,IMM1),j=2,JMM1)
        write(164)((udiav(i,j,k)+uverav(i,j,k),i=2,IMM1),j=2,JMM1)
        write(165)((vdiav(i,j,k)+vverav(i,j,k),i=2,IMM1),j=2,JMM1)
      enddo
c  
      return
      end
      subroutine avebal2
      include 'pom2k.h'  
      include "combal3.h"
      integer i,j,k,iopen
      data iopen/0/
      real ufora,vfora
      real sum,sem,svm,umax,vmax,emax
      if(iopen.eq.0)then
        iopen=1
        open(unit=166,file='dtel.av',form='unformatted',status='new')
        open(unit=167,file='flux.av',form='unformatted',status='new')
        open(unit=168,file='fluy.av',form='unformatted',status='new')
        open(unit=169,file='fluz.av',form='unformatted',status='new')
        open(unit=170,file='uadt.av',form='unformatted',status='new')
        open(unit=171,file='uap.av',form='unformatted',status='new')
        open(unit=172,file='uaadv.av',form='unformatted',status='new')
        open(unit=173,file='uadis.av',form='unformatted',status='new')
        open(unit=174,file='uasurf.av',form='unformatted',status='new')
        open(unit=175,file='uabot.av',form='unformatted',status='new')
        open(unit=176,file='uabod.av',form='unformatted',status='new')
        open(unit=177,file='uafor.av',form='unformatted',status='new')
        open(unit=178,file='uacor.av',form='unformatted',status='new')
        open(unit=179,file='vadt.av',form='unformatted',status='new')
        open(unit=180,file='vap.av',form='unformatted',status='new')
        open(unit=181,file='vaadv.av',form='unformatted',status='new')
        open(unit=182,file='vadis.av',form='unformatted',status='new')
        open(unit=183,file='vasurf.av',form='unformatted',status='new')
        open(unit=184,file='vabot.av',form='unformatted',status='new')
        open(unit=185,file='vabod.av',form='unformatted',status='new')
        open(unit=186,file='vafor.av',form='unformatted',status='new')
        open(unit=187,file='vacor.av',form='unformatted',status='new')
      endif
      emax=0.e0
      umax=0.e0
      vmax=0.e0
      do j=2,JMM1
        do i=2,IMM1
          ufora=(usurfaav(i,j)+ubodaav(i,j))*dum(i,j)
          ubotaav(i,j)=ubotaav(i,j)*dum(i,j)
          udtaav(i,j)=udtaav(i,j)*dum(i,j)
          uadvaav(i,j)=uadvaav(i,j)*dum(i,j)
          ucoraav(i,j)=ucoraav(i,j)*dum(i,j)
          udiaav(i,j)=udiaav(i,j)*dum(i,j)
          vdtaav(i,j)=vdtaav(i,j)*dvm(i,j)
          vfora=(vsurfaav(i,j)+vbodaav(i,j))*dvm(i,j)
          vbotaav(i,j)=vbotaav(i,j)*dvm(i,j)
          vadvaav(i,j)=vadvaav(i,j)*dvm(i,j)
          vcoraav(i,j)=vcoraav(i,j)*dvm(i,j)
          vdiaav(i,j)=vdiaav(i,j)*dvm(i,j)
          sum=udtaav(i,j)+uadvaav(i,j)+udiaav(i,j)+upaav(i,j)
     *       +ubotaav(i,j)+ufora+ucoraav(i,j)
          svm=vdtaav(i,j)+vadvaav(i,j)+vdiaav(i,j)+vpaav(i,j)
     *        +vbotaav(i,j)+vfora+vcoraav(i,j)
          umax=max(umax,abs(sum))
          vmax=max(vmax,abs(svm))
          sem=dtelav(i,j)+fluav(i,j)+flvav(i,j)+flwav(i,j)
          emax=max(emax,abs(sem))
        enddo
      enddo
      write(166)((dtelav(i,j),i=2,IMM1),j=2,JMM1)
      write(167)((fluav(i,j),i=2,IMM1),j=2,JMM1)
      write(168)((flvav(i,j),i=2,IMM1),j=2,JMM1)
      write(169)((flwav(i,j),i=2,IMM1),j=2,JMM1)
      write(170)((udtaav(i,j),i=2,IMM1),j=2,JMM1)
      write(171)((upaav(i,j),i=2,IMM1),j=2,JMM1)
      write(172)((uadvaav(i,j),i=2,IMM1),j=2,JMM1)
      write(173)((udiaav(i,j),i=2,IMM1),j=2,JMM1)
      write(174)((usurfaav(i,j),i=2,IMM1),j=2,JMM1)
      write(175)((ubotaav(i,j),i=2,IMM1),j=2,JMM1)
      write(176)((ubodaav(i,j),i=2,IMM1),j=2,JMM1)
      write(177)((ubodaav(i,j)+usurfaav(i,j),i=2,IMM1),j=2,JMM1)
      write(178)((ucora(i,j),i=2,IMM1),j=2,JMM1)
      write(179)((vdtaav(i,j),i=2,IMM1),j=2,JMM1)
      write(180)((vpaav(i,j),i=2,IMM1),j=2,JMM1)
      write(181)((vadvaav(i,j),i=2,IMM1),j=2,JMM1)
      write(182)((vdiaav(i,j),i=2,IMM1),j=2,JMM1)
      write(183)((vsurfaav(i,j),i=2,IMM1),j=2,JMM1)
      write(184)((vbotaav(i,j),i=2,IMM1),j=2,JMM1)
      write(185)((vbodaav(i,j),i=2,IMM1),j=2,JMM1)
      write(186)((vsurfaav(i,j)+vbodaav(i,j),i=2,IMM1),j=2,JMM1)
      write(187)((vcora(i,j),i=2,IMM1),j=2,JMM1)
      return
      end
      subroutine aver9(f1)
      implicit none
      include "imjmkb.h"
      real f1(IM,JM,KB),tm1(IM,JM)
      real av9,a1,a2,a3,a4,a5,a6,a7,a8,a0
      integer i,j,k,jpp,jmm,ipp,imm
c      statement fcn
      av9(a1,a2,a3,a4,a5,a6,a7,a8,a0) =.25*a1+.125*(a2+a3+a4+a5)+.0625*
     &   (a6+a7+a8+a0)

      do k=2,KBM1
        do j=2,JMM1
          jpp=j+1
          jmm=j-1
          do i=2,IMM1
            ipp=i+1
            imm=i-1
            tm1(i,j) = av9(f1(i,j,k),f1(i,jpp,k),f1(i,jmm,k),
     &                  f1(ipp,j,k),f1(imm,j,k),f1(imm,jpp,k),
     &                   f1(imm,jmm,k),
     &                  f1(ipp,jpp,k),f1(ipp,jmm,k))
          enddo
        enddo
        do i=1,IM
          do j=2,JMM1
            f1(i,j,k)=tm1(i,j)
          enddo
        enddo
      enddo
      return
      end
c
      subroutine averf(f1)
      implicit none
      include "imjmkb.h"
      real f1(IM,JM),tm1(IM,JM)
      real av9,a1,a2,a3,a4,a5,a6,a7,a8,a0
      integer i,j,jpp,jmm,ipp,imm
c      statement fcn
      av9(a1,a2,a3,a4,a5,a6,a7,a8,a0) =.25*a1+.125*(a2+a3+a4+a5)+.0625*
     &   (a6+a7+a8+a0)
      do j=2,JMM1
        jpp=j+1
        jmm=j-1
        do i=2,IMM1
          ipp=i+1
          imm=i-1
          tm1(i,j) = av9(f1(i,j),f1(i,jpp),f1(i,jmm),
     &                    f1(ipp,j),f1(imm,j),f1(imm,jpp),
     &                     f1(imm,jmm),f1(ipp,jpp),f1(ipp,jmm))
        enddo
      enddo
      do j=2,JMM1
        do i=2,IMM1
          f1(i,j)=tm1(i,j)
        enddo
      enddo
      return
      end
      subroutine balavg(navi,nave)
      include "pom2k.h"
      include "combal3.h"
      integer navi,nave
      integer i,j,k
cc    increment internal averages
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            udtav(i,j,k)=udtav(i,j,k)+udt(i,j,k)
            vdtav(i,j,k)=vdtav(i,j,k)+vdt(i,j,k)
            ucorav(i,j,k)=ucorav(i,j,k)+ucor(i,j,k)
            vcorav(i,j,k)=vcorav(i,j,k)+vcor(i,j,k)
            uadvav(i,j,k)=uadvav(i,j,k)+uadv(i,j,k)
            vadvav(i,j,k)=vadvav(i,j,k)+vadv(i,j,k)
            udiav(i,j,k)=udiav(i,j,k)+udi(i,j,k)
            vdiav(i,j,k)=vdiav(i,j,k)+vdi(i,j,k)
            upav(i,j,k)=upav(i,j,k)+up(i,j,k)
            vpav(i,j,k)=vpav(i,j,k)+vp(i,j,k)
            uverav(i,j,k)=uverav(i,j,k)+uver(i,j,k)
            vverav(i,j,k)=vverav(i,j,k)+vver(i,j,k)
          enddo
        enddo
      enddo
      do j=2,JMM1
        do i=2,IMM1
          ubodav(i,j)=ubodav(i,j)+ubod(i,j)
          vbodav(i,j)=vbodav(i,j)+vbod(i,j)
        enddo
      enddo
      navi=navi+1
      if(mod(iint,ibala).eq.0)then
        if(navi.ne.ibala)then
          write(*,*)'navi, ibala, iint',navi,ibala,iint
        endif
        do j=2,JMM1
          do i=2,IMM1
            ubodav(i,j)=ubodav(i,j)/real(navi)
            vbodav(i,j)=vbodav(i,j)/real(navi)
          enddo
        enddo
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              udtav(i,j,k)=udtav(i,j,k)/real(navi)
              vdtav(i,j,k)=vdtav(i,j,k)/real(navi)
              uadvav(i,j,k)=uadvav(i,j,k)/real(navi)
              vadvav(i,j,k)=vadvav(i,j,k)/real(navi)
              ucorav(i,j,k)=ucorav(i,j,k)/real(navi)
              vcorav(i,j,k)=vcorav(i,j,k)/real(navi)
              udiav(i,j,k)=udiav(i,j,k)/real(navi)
              vdiav(i,j,k)=vdiav(i,j,k)/real(navi)
              upav(i,j,k)=upav(i,j,k)/real(navi)
              vpav(i,j,k)=vpav(i,j,k)/real(navi)
              uverav(i,j,k)=uverav(i,j,k)/real(navi)
              vverav(i,j,k)=vverav(i,j,k)/real(navi)
            enddo
          enddo
        enddo
        navi=0.
        call avebal
        call avebal2
        if(nave.ne.0)write(*,*)'nave at iint',nave,iint
c             write(*,*)'averaged balances written at ',time, 'iint ',iint
c  z ero all averaged arrays
        do i=2,IMM1
          do j=2,JMM1
            ubodav(i,j)=0.
            vbodav(i,j)=0.
            ubotaav(i,j)=0.
            ubodaav(i,j)=0.
            usurfaav(i,j)=0.
            vbotaav(i,j)=0.
            vbodaav(i,j)=0.
            vsurfaav(i,j)=0.
            dtelav(i,j)=0.
            fluav(i,j)=0.
            flvav(i,j)=0.
            flwav(i,j)=0.
            ucoraav(i,j)=0.
            upaav(i,j)=0.
            udtaav(i,j)=0.
            udiaav(i,j)=0.
            uadvaav(i,j)=0.
            vcoraav(i,j)=0.
            vpaav(i,j)=0.
            vdtaav(i,j)=0.
            vdiaav(i,j)=0.
            vadvaav(i,j)=0.
          enddo
        enddo
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              ucorav(i,j,k)=0.
              vcorav(i,j,k)=0.
              udtav(i,j,k)=0.
              vdtav(i,j,k)=0.
              uadvav(i,j,k)=0.
              vadvav(i,j,k)=0.
              udiav(i,j,k)=0.
              vdiav(i,j,k)=0.
              upav(i,j,k)=0.
              vpav(i,j,k)=0.
              uverav(i,j,k)=0.
              vverav(i,j,k)=0.
            enddo
          enddo
        enddo
        navi=0
      endif
      return
      end
C
      subroutine baropg
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates  baroclinic pressure gradient.           *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      integer i,j,k
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            rho(i,j,k)=rho(i,j,k)-rmean(i,j,k)
          end do
        end do
      end do
C
C     Calculate x-component of baroclinic pressure gradient:
C
      do j=2,JMM1
        do i=2,IMM1
          drhox(i,j,1)=.5e0*grav*(-zz(1))*(dt(i,j)+dt(i-1,j))
     $                  *(rho(i,j,1)-rho(i-1,j,1))
        end do
      end do
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            drhox(i,j,k)=drhox(i,j,k-1)
     $                    +grav*.25e0*(zz(k-1)-zz(k))
     $                      *(dt(i,j)+dt(i-1,j))
     $                      *(rho(i,j,k)-rho(i-1,j,k)
     $                        +rho(i,j,k-1)-rho(i-1,j,k-1))
     $                    +grav*.25e0*(zz(k-1)+zz(k))
     $                      *(dt(i,j)-dt(i-1,j))
     $                      *(rho(i,j,k)+rho(i-1,j,k)
     $                        -rho(i,j,k-1)-rho(i-1,j,k-1))
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            drhox(i,j,k)=.25e0*(dt(i,j)+dt(i-1,j))
     $                        *drhox(i,j,k)*dum(i,j)
     $                        *(dy(i,j)+dy(i-1,j))
          end do
        end do
      end do
C
C     Calculate y-component of baroclinic pressure gradient:
C
      do j=2,JMM1
        do i=2,IMM1
          drhoy(i,j,1)=.5e0*grav*(-zz(1))*(dt(i,j)+dt(i,j-1))
     $                  *(rho(i,j,1)-rho(i,j-1,1))
        end do
      end do
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            drhoy(i,j,k)=drhoy(i,j,k-1)
     $                    +grav*.25e0*(zz(k-1)-zz(k))
     $                      *(dt(i,j)+dt(i,j-1))
     $                      *(rho(i,j,k)-rho(i,j-1,k)
     $                        +rho(i,j,k-1)-rho(i,j-1,k-1))
     $                    +grav*.25e0*(zz(k-1)+zz(k))
     $                      *(dt(i,j)-dt(i,j-1))
     $                      *(rho(i,j,k)+rho(i,j-1,k)
     $                        -rho(i,j,k-1)-rho(i,j-1,k-1))
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IMM1
            drhoy(i,j,k)=.25e0*(dt(i,j)+dt(i,j-1))
     $                        *drhoy(i,j,k)*dvm(i,j)
     $                        *(dx(i,j)+dx(i,j-1))
          end do
        end do
      end do
C
      do k=1,KB
        do j=2,JMM1
          do i=2,IMM1
            drhox(i,j,k)=ramp*drhox(i,j,k)
            drhoy(i,j,k)=ramp*drhoy(i,j,k)
          end do
        end do
      end do
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            rho(i,j,k)=rho(i,j,k)+rmean(i,j,k)
          end do
        end do
      end do
C
      return
C
      end

      subroutine bblm(ub,ab,ur,zr,phicw)
      implicit none
      include 'def.h'
c calculates bottom stress
      real epsilon,ro,phicw,mu
      real ub,ab,ur,zr,abokb,fwm,z1,z2
      real ustarwm,ubokur,chi,znotp,sigma
      real a1,b1,c1,fofa,fofb,fofc
      real lcw,z1ozn,z2lzn,ubouwm,sgn,z2ozn,row
      real shld,shdnrm,kbs,zrozn
      integer idx,jj
      include 'bblcom.h'

C set constants & parameters

      if(ur.ne.0.) ubokur=ub/(kappa*ur)

C Check #1 - if wave = 0 and ur = 0 then no calculation, set
C ustarc and znot to default values, then exit

      if(ub .le. 0  .and. ur .le. 0) then
        ustarc=ustarcdef
        znot=znotdef
        znotc=znot
        return
      endif

C Check #2 - if wave = 0 then pure current.  Set znot=default, then exit

      if(ub .le. 0) then
        print *, 'ub = 0 ub ur',ub,ur
        znot=znotdef
        znotc=znotdef
        if(zr/znot .le. 1) then
          print *,'warning!!! zr/znot < 1',zr/znot
          ustarc=ustarcdef
          return
        endif
        ustarc=ur*kappa/log(zr/znot)
        return
      endif

C Check znot flag to see if we calculate znot or implement the default.
C If znotflg equal 0, then compute znot based on ripple height,
C otherwise (znotflg = 1), take the default znot.

      if(zntflg .eq. 1) then
        znot=znotdef
        chi=4.e0*nu*ub**2/(dd*((ss-1.e0)*
     Z           g*dd)**1.5e0)
        if(chi .le. 2.e0) then
          eta=ab*0.32e0*chi**(-0.34e0)
          lambda=ab*2.04e0*chi**(-0.23e0)
        else
          eta=ab*0.52e0*chi**(-1.01e0)
          lambda=ab*2.7e0*chi**(-0.78e0)
        endif
      else
C check initiation of sediment motion criteria, to see if we
C compute znot based on the wave-formed ripples.  If the skin
C friction calculation indicates that sediment is NOT in motion,
C the ripple model is invalid and take the default znot.
C Compute critical Shield's parameter based on grain diameter (dd).


C Calculate skin friction shear stress based on Ole Madsen's (1994)
C empirical formula.  

        abokb=ab/dd
        if(abokb .le. 100.e0) then
          fwm=exp(7.02e0*abokb**(-0.078e0)-8.82e0)
        else
          fwm=exp(5.61e0*abokb**(-0.109e0)-7.30e0)
        endif
        ustarwm=sqrt(fwm/2.e0)*ub
        shdnrm=(ss-1.e0)*dd*g
        shld=ustarwm**2.e0/shdnrm

        if(shld/shldcr .le. 1.e0) then
          znot=znotdef
          eta=0.e0
          lambda=0.e0
        else
C Calculate ripple height and length and bottom roughness
          chi=4.e0*nu*ub**2.e0/(dd*((ss-1.e0)*
     Z               g*dd)**1.5e0)
          if(chi .le. 2.e0) then
            eta=ab*0.32e0*chi**(-0.34e0)
            lambda=ab*2.04e0*chi**(-0.23e0)
          else
            eta=ab*0.52e0*chi**(-1.01e0)
            lambda=ab*2.7e0*chi**(-0.78e0)
          endif
          kbs=ab*0.0655e0*
     Z             (ub**2/((ss-1.e0)*g*ab))**1.4e0
          znot=(dd+2.3e0*eta+kbs)/30.e0
        endif
      endif

C Check #3 - if zr/znot is less than one, set ustarc
C to default value, return.

      zrozn=zr/znot

      if(zrozn .le. 1.e0) then
        ustarc=ustarcdef
        znotc=znotdef
        znot=znotc
        print *,'warning!!! zr/znot < 1',zr/znot
        return
      endif

C Check #4 - if ur = 0 then pure wave.  Calculate wave stress
C based on Ole Madsen's (1994) empirical formula.  Set ustarc
C to a small value to keep model from blowing up and return.

      if(ur .le. 0.e0) then
        abokb=ab/(30.e0*znot)
        row=ab/znot
        if(abokb .le. 100.e0) then
          fwm=exp(7.02e0*abokb**(-0.078e0)-8.82e0)
        else
          fwm=exp(5.61e0*abokb**(-0.109e0)-7.30e0)
        endif
        ubouwm=sqrt(2.e0/fwm)
        call purwv(row,ubouwm,znotp,ro)
        ustarwm=ub/ubouwm
        ustarc=ustarcdef
        znotc=znotcdef
        return
      endif

C calculate bottom stresses based on ripple roughness

      row=ab/znot
      a1=1.0e-6
      call bstrssn(row,zrozn,a1,phicw,ubokur,
     Z                mu,epsilon,ro,fofa)
      abokb=ab/(30.e0*znot)
      if(abokb .le. 100.e0) then
        fwm=exp(7.02e0*abokb**(-0.078e0)-8.82e0)
      else
        fwm=exp(5.61e0*abokb**(-0.109e0)-7.30e0)
      endif
      ubouwm=sqrt(2.e0/fwm)
      call purwv(row,ubouwm,znotp,ro)
      b1=ubouwm
      fofb=-1.e0*fofa
      c1=0.5e0*(a1+b1)
      call bstrssn(row,zrozn,c1,phicw,ubokur,
     Z                mu,epsilon,ro,fofc)
      idx=1
      do jj=1,n
        if(idx .eq. 1) then
          sgn=fofb*fofc
          if(sgn .lt. 0.e0) then
             a1=c1
          else
            b1=c1
          endif
          c1=0.5e0*(a1+b1)
          call bstrssn(row,zrozn,c1,phicw,
     Z                       ubokur,mu,epsilon,ro,
     Z                      fofc)
          if(b1-c1 .lt. tol) idx=0
        endif
      enddo
      sigma=c1

C calculate apparent hydraulic roughness & u100
      lcw=kappa*ab/sigma
      z1=alphab*lcw
      z2=z1/epsilon
      ustarcw=ub/sigma
      ustarc=epsilon*ustarcw
      z1ozn=z1/znot
      z2ozn=z2/znot

      znotc=z2*
     Z         exp(-1.e0*(1.e0-epsilon+epsilon*log(z1ozn)))
      return
      end
C
      subroutine bcond(idx)
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Applies open boundary conditions.                   *
C *                                                                    *
C *                Closed boundary conditions are automatically        *
C *                enabled through specification of the masks, dum,    *
C *                dvm and fsm, in which case the open boundary        *
C *                conditions, included below, will be overwritten.    *
C *                                                                    *
C *                                The C-Grid                          *
C *                                **********                          *
C *                                                                    *
C *                The diagram below and some of the text was provided *
C *                by D.-S. Ko. It is for the case where u and v are   *
C *                the primary boundary conditions together with t and *
C *                s (co-located with e). e = el itself is rather      *
C *                unimportant and is substituted from an adjacent     *
C *                interior point.                                     *
C *                                                                    *
C *                The dotted line (.......) bounds the interior       *
C *                (non-boundary) grid points. In general, only those  *
C *                variables in the interior are computed and          *
C *                variables at open boundary have to be specified.    *
C *                All interpolations are centered in space except     *
C *                those at lateral open boundary where an upstream    *
C *                scheme is usually used. "BU" indictates a line of   *
C *                points where the boundary conditions should be      *
C *                specified.                                          *
C *                                                                    *
C *                Horizontal locations of e(el), t and s (etc.) are   *
C *                coincident. Unused points are indicated by "NU" and *
C *                "*". However, for attractive output, adjacent       *
C *                interior values may be filled in at these points.   *
C *                                                                    *
C *                People not acquainted with sigma coordinates have   *
C *                often asked what kind of boundary condition is      *
C *                applied along closed horizontal boundaries.         *
C *                Although the issue is not as important as it might  *
C *                be  for z-level grids, a direct answer is "half-    *
C *                slip" which, of course, is between free slip and    *
C *                non-slip.                                           *
C *                                                                    **********
C-------------------------------------------------------------------------------*
C     |                               N O R T H                                 *
C     |                                                                         *
C     |    1     2     3           i-1   i    i+1         im-2  im-1   im       *
C-----+-------------------------------------------------------------------------*
C     |   NU BC BC                                                    BC BC     *
C     |    v  v  v                                                     v  v     *
C     |                                                                         *
C     |BC> u* e  u  e  u  e  .  .  u  e  u  e  u  e  .  .  u  e  u  e  u  e  <BC*
C     |    |     |     |           |     |     |           |     |     |        *
C  jm |BC> +--v--+--v--+--v--   .  +--v--+--v--+--v--   .  +--v--+--v--+--v- <BC*
C     |    |     | ....|...........|.....|.....|...........|.....|.... |        *
C     |    u* e  u :e  u  e  .  .  u  e  u  e  u  e  .  .  u  e  u  e: u  e     *
C     |    |     | :   |           |     |     |           |     |   : |        *
C jm-1|    +--v--+--v--+--v--   .  +--v--+--v--+--v--   .  +--v--+--v--+--v-    *
C     |    |     | :   |           |     |     |           |     |   : |        *
C     |    u* e  u :e  u  e  .  .  u  e  u  e  u  e  .  .  u  e  u  e: u  e     *
C     |    |     | :   |           |     |     |           |     |   : |        *
C jm-2|    +--v--+--v--+--v--   .  +--v--+--v--+--v--   .  +--v--+--v--+--v-    *
C     |            :                                                 :          *
C W   |       .  . :.  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .: .  .    E*
C E   |            :                    INTERIOR                     :         A*
C S   |       .    :.     .     .     .     .     .     .     .     .:    .    S*
C T   |            :                                                 :         T*
C     |    |     | :   |           |     |     |           |     |   : |        *
C     |    u* e  u :e  u  e  .  .  u  e  u  e  u  e  .  .  u  e  u  e: u  e     *
C     |    |     | :   |           |     |     |           |     |   : |        *
C   3 |    +--v--+--v--+--v--   .  +--v--+--v--+--v--   .  +--v--+--v--+--v-    *
C     |    |     | :   |           |     |     |           |     |   : |        *
C     |    u* e  u :e  u  e  .  .  u  e  u  e  u  e  .  .  u  e  u  e: u  e     *
C     |    |     | ....|...........|.....|.....|...........|.....|.... |        *
C   2 |BC> +--v--+--v--+--v--   .  +--v--+--v--+--v--   .  +--v--+--v--+--v- <BC*
C     |    |     |     |           |     |     |           |     |     |        *
C     |BC> u* e  u  e  u  e  .  .  u  e  u  e  u  e  .  .  u  e  u  e  u  e  <BC*
C     |    |     |     |           |     |     |           |     |     |      --*
C   1 |NU> +--v*-+--v*-+--v*-   .  +--v*-+--v*-+--v*-   .  +--v*-+--v*-+--v* <NU*
C     |                                                                         *
C     |    ^  ^  ^                                                     ^  ^     *
C     |   NU BC BC                                                    BC BC     *
C-----+-------------------------------------------------------------------------*
C     |    1     2     3           i-1   i     i+1         im-2  im-1  im       *
C     |                                                                         *
C     |                                S O U T H                                *
C-------------------------------------------------------------------------------*
C                                                                               *
C *******************************************************************************
C
C
      include 'pom2k.h'
C
      integer idx
      real ga,u1,wm
      integer i,j,k
C
      if(idx.eq.1) then
C
C-----------------------------------------------------------------------
C
C     External (2-D) boundary conditions:
C
C     In this example, the governing boundary conditions are a radiation
C     condition on uaf in the east and in the west, and vaf in the north
C     and south. The tangential velocities are set to zero on both
C     boundaries. These are only one set of possibilities and may not
C     represent a choice which yields the most physically realistic
C     result.
C
C     Elevation (in this application, elevation is not a primary
C     boundary condition):
C
        do j=1,JM
          elf(1,j)=elf(2,j)
          elf(IM,j)=elf(IMM1,j)
        end do
C
        do i=1,IM
          elf(i,1)=elf(i,2)
          elf(i,JM)=elf(i,JMM1)
        end do
C
        if(ibcon.eq.2)return
        do j=1,JM
          do i=1,IM
            elf(i,j)=elf(i,j)*fsm(i,j)
          end do
        end do
C
        return
C
      else if(idx.eq.2) then
C
C     External (2-D) velocity:
C
        if(ibcon.eq.2)then
          do i=2,IMM1
             vaf(i,1)=0.
             vaf(i,2)=0.
             vaf(i,JM)=0.
             uaf(i,1)=vaf(i,2)
             uaf(i,JM)=vaf(i,JMM1)     
          enddo 
          do j=1,JM
             uaf(1,j)=0.
             uaf(2,j)=0.
             uaf(IM,j)=0.
             vaf(1,j)=vaf(2,j)
             vaf(IM,j)=vaf(IMM1,j)
          enddo
          return
        endif
        do j=2,JMM1
C
C     East:
C
          uaf(IM,j)=uabe(j)
     $               +rfe*sqrt(grav/h(IMM1,j))
     $                         *(el(IMM1,j)-ele(j))
          uaf(IM,j)=ramp*uaf(IM,j)
          vaf(IM,j)=0.e0
C
C     West:
C
          uaf(2,j)=uabw(j)
     $              -rfw*sqrt(grav/h(2,j))
     $                        *(el(2,j)-elw(j))
          uaf(2,j)=ramp*uaf(2,j)
          uaf(1,j)=uaf(2,j)
          vaf(1,j)=0.e0
C
        end do
C
        do i=2,IMM1
C
C     North:
C
          vaf(i,JM)=vabn(i)
     $               +rfn*sqrt(grav/h(i,JMM1))
     $                         *(el(i,JMM1)-eln(i))
          vaf(i,JM)=ramp*vaf(i,JM)
          uaf(i,JM)=0.e0
C
C     South:
C
          vaf(i,2)=vabs(i)
     $              -rfs*sqrt(grav/h(i,2))
     $                        *(el(i,2)-els(i))
          vaf(i,2)=ramp*vaf(i,2)
          vaf(i,1)=vaf(i,2)
          uaf(i,1)=0.e0
C
        end do
C
        do j=1,JM
          do i=1,IM
            uaf(i,j)=uaf(i,j)*dum(i,j)
            vaf(i,j)=vaf(i,j)*dvm(i,j)
          end do
        end do
C
        return
C
      else if(idx.eq.3) then
C
C-----------------------------------------------------------------------
C
C     Internal (3-D) boundary conditions:
C
C     Velocity (radiation conditions; smoothing is used in the direction
C     tangential to the boundaries):
C
        if(ibcon.eq.2)then
          do k=1,KBM1
            do i=1,IM
               uf(i,1,k)=uf(i,2,k)
               uf(i,JM,k)=uf(i,JMM1,k)
               vf(i,1,k)=0.
               vf(i,2,k)=0.
               vf(i,JM,k)=0.
            enddo
            do j=1,JM
               uf(1,j,k)=0.
               uf(2,j,k)=0.
               uf(IM,j,k)=0.
               vf(1,j,k)=vf(2,j,k)
               vf(IM,j,k)=vf(IMM1,j,k)
            enddo 
          enddo
          return
        endif
        do k=1,KBM1
          do j=2,JMM1
C
C     East:
C
            ga=sqrt(h(IM,j)/hmax)
            uf(IM,j,k)=ga*(.25e0*u(IMM1,j-1,k)+.5e0*u(IMM1,j,k)
     $                     +.25e0*u(IMM1,j+1,k))
     $                  +(1.e0-ga)*(.25e0*u(IM,j-1,k)+.5e0*u(IM,j,k)
     $                    +.25e0*u(IM,j+1,k))
            vf(IM,j,k)=0.e0
C
C     West:
C
            ga=sqrt(h(1,j)/hmax)
            uf(2,j,k)=ga*(.25e0*u(3,j-1,k)+.5e0*u(3,j,k)
     $                    +.25e0*u(3,j+1,k))
     $                 +(1.e0-ga)*(.25e0*u(2,j-1,k)+.5e0*u(2,j,k)
     $                   +.25e0*u(2,j+1,k))
            uf(1,j,k)=uf(2,j,k)
            vf(1,j,k)=0.e0
          end do
        end do
C
        do k=1,KBM1
          do i=2,IMM1
C
C     North:
C
            ga=sqrt(h(i,JM)/hmax)
            vf(i,JM,k)=ga*(.25e0*v(i-1,JMM1,k)+.5e0*v(i,JMM1,k)
     $                     +.25e0*v(i+1,JMM1,k))
     $                  +(1.e0-ga)*(.25e0*v(i-1,JM,k)+.5e0*v(i,JM,k)
     $                    +.25e0*v(i+1,JM,k))
            uf(i,JM,k)=0.e0
C
C     South:
C
            ga=sqrt(h(i,1)/hmax)
            vf(i,2,k)=ga*(.25e0*v(i-1,3,k)+.5e0*v(i,3,k)
     $                    +.25e0*v(i+1,3,k))
     $                 +(1.e0-ga)*(.25e0*v(i-1,2,k)+.5e0*v(i,2,k)
     $                   +.25e0*v(i+1,2,k))
            vf(i,1,k)=vf(i,2,k)
            uf(i,1,k)=0.e0
          end do
        end do
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              uf(i,j,k)=uf(i,j,k)*dum(i,j)
              vf(i,j,k)=vf(i,j,k)*dvm(i,j)
            end do
          end do
        end do
C
        return
C
      else if(idx.eq.4) then
C
C     Temperature and salinity boundary conditions (using uf and vf,
C     respectively):
C
        if(ibcon.eq.2)then
          do k=1,KBM1
             do i=1,IM
                uf(i,1,k)=uf(i,2,k)
                vf(i,1,k)=vf(i,2,k)
                uf(i,JM,k)=uf(i,JMM1,k)
                vf(i,JM,k)=vf(i,JMM1,k)
             enddo
             do j=1,JM
                uf(1,j,k)=uf(2,j,k)
                vf(1,j,k)=vf(2,j,k)
                uf(IM,j,k)=uf(IMM1,j,k)
                vf(IM,j,k)=vf(IMM1,j,k)
             enddo
           enddo  
           return
        endif     
        do k=1,KBM1
          do j=1,JM
C
C     East:
C
            u1=2.e0*u(IM,j,k)*dti/(dx(IM,j)+dx(IMM1,j))
            if(u1.le.0.e0) then
              uf(IM,j,k)=t(IM,j,k)-u1*(tbe(j,k)-t(IM,j,k))
              vf(IM,j,k)=s(IM,j,k)-u1*(sbe(j,k)-s(IM,j,k))
            else
              uf(IM,j,k)=t(IM,j,k)-u1*(t(IM,j,k)-t(IMM1,j,k))
              vf(IM,j,k)=s(IM,j,k)-u1*(s(IM,j,k)-s(IMM1,j,k))
              if(k.ne.1.and.k.ne.KBM1) then
                wm=.5e0*(w(IMM1,j,k)+w(IMM1,j,k+1))*dti
     $              /((zz(k-1)-zz(k+1))*dt(IMM1,j))
                uf(IM,j,k)=uf(IM,j,k)-wm*(t(IMM1,j,k-1)-t(IMM1,j,k+1))
                vf(IM,j,k)=vf(IM,j,k)-wm*(s(IMM1,j,k-1)-s(IMM1,j,k+1))
              endif
            endif
C
C     West:
C
            u1=2.e0*u(2,j,k)*dti/(dx(1,j)+dx(2,j))
            if(u1.ge.0.e0) then
              uf(1,j,k)=t(1,j,k)-u1*(t(1,j,k)-tbw(j,k))
              vf(1,j,k)=s(1,j,k)-u1*(s(1,j,k)-sbw(j,k))
            else
              uf(1,j,k)=t(1,j,k)-u1*(t(2,j,k)-t(1,j,k))
              vf(1,j,k)=s(1,j,k)-u1*(s(2,j,k)-s(1,j,k))
              if(k.ne.1.and.k.ne.KBM1) then
                wm=.5e0*(w(2,j,k)+w(2,j,k+1))*dti
     $              /((zz(k-1)-zz(k+1))*dt(2,j))
                uf(1,j,k)=uf(1,j,k)-wm*(t(2,j,k-1)-t(2,j,k+1))
                vf(1,j,k)=vf(1,j,k)-wm*(s(2,j,k-1)-s(2,j,k+1))
              endif
            endif
          end do
        end do
C
        do k=1,KBM1
          do i=1,IM
C
C     North:
C
            u1=2.e0*v(i,JM,k)*dti/(dy(i,JM)+dy(i,JMM1))
            if(u1.le.0.e0) then
              uf(i,JM,k)=t(i,JM,k)-u1*(tbn(i,k)-t(i,JM,k))
              vf(i,JM,k)=s(i,JM,k)-u1*(sbn(i,k)-s(i,JM,k))
            else
              uf(i,JM,k)=t(i,JM,k)-u1*(t(i,JM,k)-t(i,JMM1,k))
              vf(i,JM,k)=s(i,JM,k)-u1*(s(i,JM,k)-s(i,JMM1,k))
              if(k.ne.1.and.k.ne.KBM1) then
                wm=.5e0*(w(i,JMM1,k)+w(i,JMM1,k+1))*dti
     $              /((zz(k-1)-zz(k+1))*dt(i,JMM1))
                uf(i,JM,k)=uf(i,JM,k)-wm*(t(i,JMM1,k-1)-t(i,JMM1,k+1))
                vf(i,JM,k)=vf(i,JM,k)-wm*(s(i,JMM1,k-1)-s(i,JMM1,k+1))
              endif
            endif
C
C     South:
C
            u1=2.e0*v(i,2,k)*dti/(dy(i,1)+dy(i,2))
            if(u1.ge.0.e0) then
              uf(i,1,k)=t(i,1,k)-u1*(t(i,1,k)-tbs(i,k))
              vf(i,1,k)=s(i,1,k)-u1*(s(i,1,k)-sbs(i,k))
            else
              uf(i,1,k)=t(i,1,k)-u1*(t(i,2,k)-t(i,1,k))
              vf(i,1,k)=s(i,1,k)-u1*(s(i,2,k)-s(i,1,k))
              if(k.ne.1.and.k.ne.KBM1) then
                wm=.5e0*(w(i,2,k)+w(i,2,k+1))*dti
     $              /((zz(k-1)-zz(k+1))*dt(i,2))
                uf(i,1,k)=uf(i,1,k)-wm*(t(i,2,k-1)-t(i,2,k+1))
                vf(i,1,k)=vf(i,1,k)-wm*(s(i,2,k-1)-s(i,2,k+1))
              endif
            endif
          end do
        end do
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              uf(i,j,k)=uf(i,j,k)*fsm(i,j)
              vf(i,j,k)=vf(i,j,k)*fsm(i,j)
            end do
          end do
        end do
C
        return
C
      else if(idx.eq.5) then
C
C     Vertical velocity boundary conditions:
C
        if(ibcon.eq.2)then
          do k=1,KB
            do j=1,JM
              w(1,j,k)=w(2,j,k)
              w(IM,j,k)=w(IMM1,j,k)
            enddo
            do i=1,IM
              w(i,1,k)=w(i,2,k)
              w(i,JM,k)=w(i,JMM1,k)
            enddo
          enddo
          return
        endif
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              w(i,j,k)=w(i,j,k)*fsm(i,j)
            end do
          end do
        end do
C
        return
C
      else if(idx.eq.6) then
C
C     q2 and q2l boundary conditions:
C
        if(ibcon.eq.2)then
          do k=1,KB
            do i=1,IM
              uf(i,1,k)=uf(i,2,k)
              uf(i,JM,k)=uf(i,JMM1,k) 
              vf(i,1,k)=vf(i,2,k)
              vf(i,JM,k)=vf(i,JMM1,k) 
            enddo
            do j=1,JM
              uf(1,j,k)=uf(2,j,k)
              uf(IM,j,k)=uf(IMM1,j,k)
              vf(1,j,k)=vf(2,j,k)
              vf(IM,j,k)=vf(IMM1,j,k)
            enddo
          enddo
          return
        endif
        do k=1,KB
          do j=1,JM
C
C     East:
C
            u1=2.e0*u(IM,j,k)*dti/(dx(IM,j)+dx(IMM1,j))
            if(u1.le.0.e0) then
              uf(IM,j,k)=q2(IM,j,k)-u1*(small-q2(IM,j,k))
              vf(IM,j,k)=q2l(IM,j,k)-u1*(small-q2l(IM,j,k))
            else
              uf(IM,j,k)=q2(IM,j,k)-u1*(q2(IM,j,k)-q2(IMM1,j,k))
              vf(IM,j,k)=q2l(IM,j,k)-u1*(q2l(IM,j,k)-q2l(IMM1,j,k))
            endif
C
C     West:
C
            u1=2.e0*u(2,j,k)*dti/(dx(1,j)+dx(2,j))
            if(u1.ge.0.e0) then
              uf(1,j,k)=q2(1,j,k)-u1*(q2(1,j,k)-small)
              vf(1,j,k)=q2l(1,j,k)-u1*(q2l(1,j,k)-small)
            else
              uf(1,j,k)=q2(1,j,k)-u1*(q2(2,j,k)-q2(1,j,k))
              vf(1,j,k)=q2l(1,j,k)-u1*(q2l(2,j,k)-q2l(1,j,k))
            endif
          end do
        end do
C
        do k=1,KB
          do i=1,IM
C
C     North:
C
            u1=2.e0*v(i,JM,k)*dti/(dy(i,JM)+dy(i,JMM1))
            if(u1.le.0.e0) then
              uf(i,JM,k)=q2(i,JM,k)-u1*(small-q2(i,JM,k))
              vf(i,JM,k)=q2l(i,JM,k)-u1*(small-q2l(i,JM,k))
            else
              uf(i,JM,k)=q2(i,JM,k)-u1*(q2(i,JM,k)-q2(i,JMM1,k))
              vf(i,JM,k)=q2l(i,JM,k)-u1*(q2l(i,JM,k)-q2l(i,JMM1,k))
            endif
C
C     South:
C
            u1=2.e0*v(i,2,k)*dti/(dy(i,1)+dy(i,2))
            if(u1.ge.0.e0) then
              uf(i,1,k)=q2(i,1,k)-u1*(q2(i,1,k)-small)
              vf(i,1,k)=q2l(i,1,k)-u1*(q2l(i,1,k)-small)
            else
              uf(i,1,k)=q2(i,1,k)-u1*(q2(i,2,k)-q2(i,1,k))
              vf(i,1,k)=q2l(i,1,k)-u1*(q2l(i,2,k)-q2l(i,1,k))
            endif
          end do
        end do
C
        do k=1,KB
          do j=1,JM
            do i=1,IM
              uf(i,j,k)=uf(i,j,k)*fsm(i,j)+1.e-10
              vf(i,j,k)=vf(i,j,k)*fsm(i,j)+1.e-10
            end do
          end do
        end do
C
        return
C
      endif
C
      end
C
      subroutine bcondorl(idx)
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  This is an optional subroutine replacing  bcond and *
C *                using Orlanski's scheme (J. Comp. Phys. 21, 251-269,*
C *                1976), specialized for the seamount problem. To     *
C *                make it work for the seamount problem, I (G.M.)     *
C *                have had to add an extra condition on an "if"       *
C *                statement in the t and s open boundary conditions,  *
C *                which involves the sign of the normal velocity.     *
C *                Thus:                                               *
C *                                                                    *
C *            if(cl.eq.0.e0.and.ubw(j,k).ge.0.e0) uf(1,j,k)=tbw(j,k), *
C *                                                                    *
C *                plus 3 others of the same kind.                     *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      integer idx
      real cl,denom
      integer i,j,k
C
      if(idx.eq.1) then
C
C-----------------------------------------------------------------------
C
C     External (2-D) boundary conditions:
C
C     In this example the governing boundary conditions are a radiation
C     condition on uaf(im,j) in the east and an inflow uaf(2,j) in the
C     west. The tangential velocities are set to zero on both
C     boundaries. These are only one set of possibilities and may not
C     represent a choice which yields the most physically realistic
C     result.
C
C     Elevation (in this application, elevation is not a primary
C     boundary condition):
C
        do  j=1,JM
          elf(1,j)=elf(2,j)
          elf(IM,j)=elf(IMM1,j)
        end do
C
        do i=1,IM
          elf(i,1)=elf(i,2)
          elf(i,jm)=elf(i,jmm1)
        end do
C
        do j=1,JM
          do i=1,IM
            elf(i,j)=elf(i,j)*fsm(i,j)
          end do
        end do
C
        return
C
      else if(idx.eq.2) then
C
C     External (2-D) velocity:
C
        do j=2,JMM1
C
C     West:
C
          uaf(2,j)=ramp*uabw(j)-sqrt(grav/h(2,j))*(el(2,j)-elw(j))
          uaf(1,j)=uaf(2,j)
          vaf(1,j)=0.e0
C
C     East:
C
          uaf(IM,j)=ramp*uabe(j)
     $               +sqrt(grav/h(IMM1,j))*(el(IMM1,j)-ele(j))
          vaf(IM,j)=0.e0
C
        end do
C
        do j=1,JM
          do i=1,IM
            uaf(i,j)=uaf(i,j)*dum(i,j)
            vaf(i,j)=vaf(i,j)*dvm(i,j)
          end do
        end do
C
        return
C
      else if(idx.eq.3) then
C
C-----------------------------------------------------------------------
C
C     Internal (3-D) boundary conditions:
C
C     Eastern and western radiation boundary conditions according to
C     Orlanski's explicit scheme:
C
        do k=1,KBM1
          do j=2,JMM1
C
C     West:
C
            denom=(uf(3,j,k)+ub(3,j,k)-2.e0*u(4,j,k))
            if(denom.eq.0.e0)denom=0.01e0
            cl=(ub(3,j,k)-uf(3,j,k))/denom
            if(cl.gt.1.e0) cl=1.e0
            if(cl.lt.0.e0) cl=0.e0
            uf(2,j,k)=(ub(2,j,k)*(1.e0-cl)+2.e0*cl*u(3,j,k))
     $                 /(1.e0+cl)
            uf(1,j,k)=uf(2,j,k)
            vf(1,j,k)=0.e0
C
C     East:
C
            denom=(uf(IMM1,j,k)+ub(IMM1,j,k)-2.e0*u(IM-2,j,k))
            if(denom.eq.0.e0)denom=0.01e0
            cl=(ub(IMM1,j,k)-uf(IMM1,j,k))/denom
            if(cl.gt.1.e0) cl=1.e0
            if(cl.lt.0.e0) cl=0.e0
            uf(IM,j,k)=(ub(IM,j,k)*(1.e0-cl)+2.e0*cl*u(IMM1,j,k))
     $                  /(1.e0+cl)
            vf(IM,j,k)=0.e0
          end do
        end do
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              uf(i,j,k)=uf(i,j,k)*dum(i,j)
              vf(i,j,k)=vf(i,j,k)*dvm(i,j)
            end do
          end do
        end do
C
        return
C
      else if(idx.eq.4) then
C
C     Temperature and salinity boundary conditions (using uf and vf,
C     respectively):
C
        do k=1,KBM1
          do j=1,JM
C
C     West:
C
            ubw(j,k)=ub(2,j,k)
            denom=(uf(2,j,k)+tb(2,j,k)-2.e0*t(3,j,k))
            if(denom.eq.0.e0) denom=0.01e0
            cl=(tb(2,j,k)-uf(2,j,k))/denom
            if(cl.gt.1.e0) cl=1.e0
            if(cl.lt.0.e0) cl=0.e0
            uf(1,j,k)=(tb(1,j,k)*(1.e0-cl)+2.e0*cl*t(2,j,k))/(1.e0+cl)
            if(cl.eq.0.e0.and.ubw(j,k).ge.0.e0) uf(1,j,k)=tbw(j,k)
C
            denom=(vf(2,j,k)+sb(2,j,k)-2.e0*s(3,j,k))
            if(denom.eq.0.e0) denom=0.01e0
            cl=(sb(2,j,k)-vf(2,j,k))/denom
            if(cl.gt.1.e0) cl=1.e0
            if(cl.lt.0.e0) cl=0.e0
            vf(1,j,k)=(sb(1,j,k)*(1.e0-cl)+2.e0*cl*s(2,j,k))/(1.e0+cl)
            if(cl.eq.0.e0.and.ubw(j,k).ge.0.e0) vf(1,j,k)=sbw(j,k)
C
C     East:
C
            ube(j,k)=ub(IM,j,k)
            denom=(uf(IMM1,j,k)+tb(IMM1,j,k)-2.e0*t(IM-2,j,k))
            if(denom.eq.0.e0) denom=0.01e0
            cl=(tb(IMM1,j,k)-uf(IMM1,j,k))/denom
            if(cl.gt.1.e0) cl=1.e0
            if(cl.lt.0.e0) cl=0.e0
            uf(IM,j,k)=(tb(IM,j,k)*(1.e0-cl)+2.e0*cl*t(IMM1,j,k))
     $                  /(1.e0+cl)
            if(cl.eq.0.e0.and.ube(j,k).le.0.e0) uf(IM,j,k)=tbe(j,k)
C
            denom=(vf(IMM1,j,k)+sb(IMM1,j,k)-2.e0*s(IM-2,j,k))
            if(denom.eq.0.e0) denom=0.01e0
            cl=(sb(IMM1,j,k)-vf(IMM1,j,k))/denom
            if(cl.gt.1.e0) cl=1.e0
            if(cl.lt.0.e0) cl=0.e0
            vf(IM,j,k)=(sb(IM,j,k)*(1.e0-cl)+2.e0*cl*s(IMM1,j,k))
     $                  /(1.e0+cl)
            if(cl.eq.0.e0.and.ube(j,k).le.0.e0) vf(IM,j,k)=sbe(j,k)
C
          end do
        end do
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              uf(i,j,k)=uf(i,j,k)*fsm(i,j)
              vf(i,j,k)=vf(i,j,k)*fsm(i,j)
            end do
          end do
        end do
C
        return
C
      else if(idx.eq.5) then
C
C     Vertical velocity boundary conditions:
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              w(i,j,k)=w(i,j,k)*fsm(i,j)
            end do
          end do
        end do
C
        return
C
      else if(idx.eq.6) then
C
C     q2 and q2l boundary conditions:
C
        do k=1,KB
C
          do j=1,JM
            uf(IM,j,k)=1.e-10
            vf(IM,j,k)=1.e-10
            uf(1,j,k)=1.e-10
            vf(1,j,k)=1.e-10
          end do
C
          do j=1,JM
            do i=1,IM
              uf(i,j,k)=uf(i,j,k)*fsm(i,j)
              vf(i,j,k)=vf(i,j,k)*fsm(i,j)
            end do
          end do
        end do
C
        return
C
      endif
C
      end
      subroutine botstr
      INCLUDE 'pom2k.h'    
      include 'bblcom.h'
      real f1,tu,tv,ab,tc
      real ubt,phiang,spd,uref,vref,zza,z1,z2
      real urefb(IM,JM),vrefb(IM,JM),tau(IM,JM)
      integer k1,i,j,k
      do j=2,JMM1
        do i=2,IMM1
          zza=min(zref,dt(i,j)/3.e0)
          if(zza.le.dt(i,j)*(1.e0+zz(KBM1)))then
            zza= dt(i,j)*(1.e0+zz(KBM1))
c zr in meters
            k1 = KBM1
            urefb(i,j)=u(i,j,k1)
            vrefb(i,j)=v(i,j,k1)
            f1=0.
          else
           z1 = (1.e0+zz(KBM2))*dt(i,j)
            do k=KBM2,2,-1
              if(z1.ge.zza)then
                k1 = k
                z2 = (1.e0+zz(k1+1))*dt(i,j)
                f1=log(z1/zza)/log(z1/z2)
                if(z2.ge.zza)then
                  write(0,*)z1,z2,zza,f1,k1,dt(i,j)
                  stop
                endif
                z1=0.e0
              else 
                if(z1.ne.0.e0)z1=(1.e0+zz(k-1))*dt(i,j)
              endif
            enddo
            urefb(i,j) = (1.e0-f1)*u(i,j,k1)+f1*u(i,j,k1+1)*dum(i,j) 
            vrefb(i,j) = (1.e0-f1)*v(i,j,k1)+f1*v(i,j,k1+1)*dvm(i,j) 
            tps(i,j) = zza*100.e0
          endif
        enddo 
        vrefb(1,j)=vrefb(2,j)*dvm(1,j)
        vrefb(2,j)=vrefb(2,j)*dvm(2,j)
        vrefb(im,j)=vrefb(IMM1,j)*dvm(IM,j)
        urefb(1,j)=urefb(2,j)*dum(1,j)
        urefb(2,j)=urefb(2,j)*dum(2,j)
        urefb(IM,j)=urefb(IMM1,j)*dum(IM,j)
      enddo
      if(ibcon.eq.0)then
        call perchan1(vrefb)
        call perchan1(urefb)
      endif
      do j=2,JMM1
        do i=2,IMM1
          if(ubotw(i,j).gt.1.e-6)then
            uref=.5e0*(urefb(i,j)+urefb(i+1,j))
            vref=.5e0*(vrefb(i,j)+vrefb(i,j+1))
            spd=sqrt(uref**2+vref**2)
            phiang=abs(atan2(vref,(uref+small))-theta(i,j))
            if(phiang.gt.pi)phiang=phiang-pi
            ubt=ubotw(i,j)*100.e0
            ab=ubt/omega
! bblm in cgs system
! wave bot vel, excursion, speed at zref, zref (cm), wave-current angle
            call bblm(ubt,ab,spd*100,tps(i,j),phiang)
            tau(i,j)=(ustarc/100.e0)**2
            z0c(i,j)=znotc/100.e0
            impflg(i,j)=0
          else 
            tau(i,j)=0.
            z0c(i,j)=z0b
            impflg(i,j)=1
          endif
        enddo
      enddo
      if(ibcon.eq.0)then
        call perchanv1(tau)
        call perchanv1(z0c)
      endif 
      call averf(tau)
      call averf(z0c)
      if(ibcon.eq.0)then
        call perchanv1(tau)
        call perchanv1(z0c)
      endif 
      do j=2,JMM1
        do i=2,IMM1
! bottom stresses in direction of reference velocities
          if(impflg(i,j).eq.0)then
            tu=urefb(i,j)/(sqrt(urefb(I,J)**2+(.25e0*(vrefb(I,J)
     2        +vrefb(i,j+1)+vrefb(i-1,j)+vrefb(i-1,j+1)))**2)+small)
            tu=-0.5e0*(tau(i,j)+tau(i-1,j))*tu 
!   
            wubot(i,j)=tu*dum(i,j)
!
            tv=vrefb(i,j)/(sqrt((.25e0*(urefb(i,j)+urefb(i+1,j)
     2      +urefb(i,j-1)+urefb(i+1,j-1)))**2+vrefb(I,J)**2)+small)
            tv=-.5e0*(tau(i,j)+tau(i,j-1))*tv
!
             wvbot(i,j)=tv*dvm(i,j)
          else
             wvbot(i,j)=0.
             wubot(i,j)=0.
          endif
        enddo
      enddo
      if(ibcon.eq.0)then
        call perchanu1(wubot)
        call perchanv1(wvbot)
      endif
      return
      end
!
      subroutine bstrssn(row,zrozn,sigma,phicw,
     Z                      ubokur,mu,epsilon,ro,fofx)

      implicit none
      include "def.h"
      include "bblcom.h"
      real x,znotp,z2p,epsilon,mu,sigma,ubokur
      real phi,phicw
      real ber,bei,ker,kei,berp,beip,kerp
      real keip,eps2,fofx
      real ror,ro,row
      real zroz1,zrozn,zroz2,z1ozn,z2ozn
      integer idx,ii,i
      complex bnot,knot
      complex bnotp,knotp,gammai,argi


      idx=1
      do ii=1,n
        if(idx .eq. 1) then
          ro=row/sigma
          znotp=1.e0/(kappa*ro)
          if(z1p/znotp .gt. 1) then
            x=2.e0*sqrt(znotp)
            if(x .le. 8.e0) then
              call klvn2(x,ber,bei,ker,
     Z                         kei,berp,beip,kerp,
     Z                            keip,pi)
            else
              call kel2(x,ker,kei,ber,
     Z                   bei,kerp,keip,berp,beip,pi)
            endif
            bnot=cmplx(ber,bei)
            knot=cmplx(ker,kei)
            bnotp=cmplx(berp,beip)/sqrt(znotp)
            knotp=cmplx(kerp,keip)/sqrt(znotp)
            argi=bnotp*nnb/(bnot*nnb-knot*llb)+
     Z            knotp*llb/(knot*llb-bnot*nnb)
            gammai=-kappa*znotp*argi
            phi=cabs(gammai)
          else
            gammai=-kappa*z1p*mp
            phi=cabs(gammai)
          endif
          if(sigma .gt. 1.e0/phi) then
            sigma=1./phi
          else
            idx=0
          endif
        endif
      enddo

      mu=sqrt(sigma*phi)
      eps2=-mu**2*abs(cos(phicw))+
     Z        sqrt(1.e0-mu**4*(sin(phicw))**2)
      epsilon=sqrt(eps2)
      if(epsilon .eq. 0.e0) return

      z2p=z1p/epsilon
      ror=ro/zrozn
      zroz1=1.e0/(alphab*kappa*ror)
      zroz2=epsilon*zroz1
      z1ozn=alphab*kappa*ro
      z2ozn=z1ozn/epsilon

      if(zroz2 .gt. 1.e0 .and. z1ozn .gt. 1.e0) then
        fofx=ubokur*epsilon*(log(zroz2)+1.e0-epsilon+
     Z         epsilon*log(z1ozn))-sigma

      elseif(zroz2 .le. 1.e0 .and. zroz1 .gt. 1.e0
     Z                 .and. z1ozn .gt. 1.e0) then
        fofx=ubokur*epsilon**2*
     Z            (zroz1-1.e0+log(z1ozn))-sigma

      elseif(zroz1 .le. 1.e0 .and. z1ozn .gt. 1.e0) then
        fofx=ubokur*epsilon**2*log(zrozn)-sigma

      elseif(zroz2 .gt. 1.e0 .and. z1ozn .le. 1.e0
     Z                 .and. z2ozn .gt. 1.e0) then
        fofx=ubokur*epsilon*(log(zroz2)+1.e0
     Z         -1.e0/z2ozn)-sigma

      elseif(zroz2 .le. 1.e0 .and. zroz1 .gt. 1.e0 .and.
     Z    z1ozn .le. 1.e0 .and. z2ozn .gt. 1.e0) then
        fofx=ubokur*epsilon**2*(zroz1-1.e0/z1ozn)-sigma

      elseif(zroz2 .gt. 1.e0 .and. z2ozn .le. 1.e0) then
        fofx=ubokur*epsilon*log(zrozn)-sigma
      endif

      return
      end
c
      subroutine circmodule
C nearshore POM is based on pom2k described below
Cpn        ************      Nearshore POM      ************ 
C **********************************************************************
C *                                                                    *
C *   The last code change as recorded in pom2k.change was on           *
C *                                                                    *
C *                     2002-09-06                                     *
C *                                                                    *
C * FUNCTION    :  This is a version of the three dimensional, time    *
C *                dependent, primitive equation, ocean model          *
C *                developed by Alan Blumberg and George Mellor with   *
C *                subsequent contributions by Leo Oey, Steve Brenner  *
C *                and others. It is now called the Princeton Ocean    *
C *                Model. Two references are:                          *
C *                                                                    *
C *                Blumberg, A.F. and G.L. Mellor; Diagnostic and      *
C *                  prognostic numerical circulation studies of the   *
C *                  South Atlantic Bight, J. Geophys. Res. 88,        *
C *                  4579-4592, 1983.                                  *
C *                                                                    *
C *                Blumberg, A.F. and G.L. Mellor; A description of a  *
C *                  three-dimensional coastal ocean circulation model,*
C *                  Three-Dimensional Coastal Ocean Models, Coastal   *
C *                  and Estuarine Sciences, 4, N.S. Heaps, ed.,       *
C *                  American Geophysical Union, 1-16, 1987.           *
C *                                                                    *
C *                In subroutine profq the model makes use of the      *
C *                turbulence closure sub-model described in:          *
C *                                                                    *
C *                Mellor, G.L. and T. Yamada; Development of a        *
C *                  turbulence closure model for geophysical fluid    *
C *                  problems, Rev. Geophys. Space Phys., 20, No. 4,   *
C *                  851-875, 1982.                                    *
C *                                                                    *
C *                A user's guide is available:                        *
C *                                                                    *
C *                Mellor, G.L.; User's guide for a three-dimensional, *
C *                  primitive equation, numerical ocean model.        *
C *                  Princeton University Report, 1998.                *
C *                                                                    *
C *                In October 2001, the source code underwent          *
C *                revision by John Hunter of the University of        *
C *                Tasmania. Major aspects of the revision were:       *
C *                                                                    *
C *                (1) The revision was based on pom98 updated to      *
C *                    12/9/2001.                                      *
C *                (2) Declaration of all variables.                   *
C *                (3) Rationalisation of the input of all constants.  *
C *                (4) Modifications to the "printer" output.          *
C *                (5) Output to a netCDF file.                        *
C *                (6) Inclusion of surface freshwater flux.           *
C *                (7) Inclusion of atmospheric pressure.              *
C *                (8) Inclusion of an additional problem to check (6) *
C *                    and (7), above.                                 *
C *                (9) Inclusion of option for Smolarkiewicz           *
C *                    advection scheme.                               *
C *                                                                    *
C *                This revised version is functionally almost         *
C *                equivalent to pom98. The output to device 6 from    *
C *                the "seamount" problem should be almost the same,   *
C *                any differences being due to minor format changes   *
C *                and improvements in rounding.                       *
C *                                                                    *
C *                This revision was helped by the following people:   *
C *                Tal Ezer, Peter Holloway, George Mellor, Rich       *
C *                Signell, Ian Webster, Brian Williams and Emma Young.*
C *                                                                    *
Cpn******************** Nearshore POM************************************
Cpn  
Cpn* modifications to PROFQ, PROFU, PROFV to reflect presence of waves,  
Cpn* options for no stratification*
Cpn* forcing by radiation stress as well as wind, body force, BBl model *
Cpn* periodic boundary conditions added                                 *
Cpn* POM output removed, output to unformatted files added              *
Cpn* option of momentum balances added
Cpn* Time series output added
Cpn* modified to be a subroutine of the nearshore community model       *
Cpn* option for offshore boundary conditions to be read from large
Cpn* scale model output (one way nesting)
Cpn* 
Cpn* P. Newberger and J. Allen,   July 2004                              *
Cpn**********************************************************************
C *                                                                    *
C *                                  GENERAL NOTES                     *
C *                                                                    *
C *                1. All units are S.I. (M.K.S.) unless otherwise     *
C *                   stated. NOTE that time is in hours from the      * 
C *                   start of the run.                                *
Cpn*                  BBL wave-current model is cgs, conversion is
Cpn*                  made before/after subroutine calls
C *                                                                    *
C *                2. "b", <nothing> and "f" refers to backward,       *
C *                   central and forward time levels.                 *
C *                                                                    *
C *                3. NetCDF output may be used. In order to omit/use  *
C *                   netCDF, comment/uncomment all statements         *
C *                   carrying the comment "*netCDF*" at the end of    *
C *                   the line (or set netcdf_file='nonetcdf')         *
Cpn*                  This has not been modified for additional output
Cpn*                  for the nearshore case
C *                                                                    *
C *                4. NetCDF is version 3. An attempt has been made to *
C *                   conform to the NetCDF Climate and Forecast (CF)  *
C *                   Metadata Conventions, but this may not yet be    *
C *                   complete (see:                                   *
C *                                                                    *
C *          http://www.cgd.ucar.edu/cms/eaton/netcdf/CF-working.html) *
C *                                                                    *
C *                5. In order to use netCDF, the program should be    *
C *                   compiled with the appropriate library. For       *
C *                   example, if using g77, you may need to type:     *
C *                                                                    *
C *                     g77 -o pom2k pom2k.f /usr/lib/libnetcdf.a      *
C *                                                                    *
C *                   You should also have the "include" file of       *
C *                   netCDF subroutines (pom2k.n).                    * 
C *                                                                    *
C *                6. In order to use netCDF, you may need to change   *
C *                   the name of the "include" file in the statement: *
C *                                                                    *
C *                     include '/usr/include/netcdf.inc'              *
C *                                                                    *
C *                   in subroutine write_netcdf                       *
C *                                                                    *
C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
! to include netcdf support
!      include 'pom2k.n'
      include 'combal3.h'
      include 'bblcom.h'
      include 'pass.h'
      integer i,j,nr
      character nrc*2, filr*10
      save nstep,lo
C
C     New declarations plus ispi,isp2i:
C
      real atot
      real darea,dvol,eaver
      real saver,taver
      real sum,svm,sem,vmax,umax,emax
      real vamax,vtot,tsalt
      real tatm,satm,hpu,hmu,hpv,hmv
      real v4,f1,f2
      integer iext,imax,jmax
      integer k,lo,nstep,ll,imm,jmm
      integer nave,navi,iu,ju,iv,jv
C
C***********************************************************************
C
C     source should agree with source_c in pom2k.h and source_n in pom2k.n.
C
      if(Master_start.eq.1)then
        source='pom nearshore  2004-02-14'
C
        if(source.ne.source_c) then
          write(*,7)
    7   format(/'Incompatible versions of program and include files ',
     $          '..... program terminated'/)
          stop
        endif
C
C***********************************************************************
C
        small=1.e-9           ! Small value
C
        pi=atan(1.e0)*4.e0    ! PI
C
c read in parameters and initial fields
        call init_pom
c user supplied subroutine to set model characteristics is called from
c  init_pom
C
C-----------------------------------------------------------------------
C
C     Initialise netCDF output and output initial set of data:
C     or write initial unformatted fields
C
        
!        if(netcdf_file.ne.'nonetcdf') then
!          call write_netcdf(1)                               ! *netCDF*
!          call write_netcdf(2)                               ! *netCDF*
!        else
          if(iprint.lt.iend)then
            call output2
            call output3
          endif
!        endif
        nstep=N_interval_CallCirc*Master_dt/dti
        lo=0
        return 
      endif
c end of initial call to circulation module
C
C-----------------------------------------------------------------------
C
      do 9000 iint=lo+1,lo+nstep      !  Begin internal (3-D) mode
C
        time=dti*float(iint)/3600.e0+time0
        if(ipert.eq.1 .and. time.gt.toff+time0)then
          pert=0.
          ipert=0
          write(*,*)'perturbations off at t = ',time
        endif
        if(time.le.ton)then
          tramp=.5e0*(1.e0-cos(pi*time/ton))
        else
          tramp=1.e0
        endif
!calculate balances only if they are being averaged or it is time for output
        if(balave .ne. 0. .or. mod(iint,ibalo) .eq. 0)then
          ibal=1
        else
          ibal=0
        endif
C
        if(lramp) then
          ramp=time/period
          if(ramp.gt.1.e0) ramp=1.e0
        else
          ramp=1.e0
        endif
C
C       write(*,2) mode,iint,time
C   2   format(' mode,iint,time =',2i5,f9.2)
C
C-----------------------------------------------------------------------
C
C     Set time dependent, surface and lateral boundary conditions.
C     The latter will be used in subroutine bcond. Users may
C     wish to create a subroutine to supply wusurf, wvsurf, wtsurf,
C     wssurf, swrad and vflux. 
Cpn vflux is replaced by the divergence of the mass flux due to waves 
C     and rollers
C
C
      call force
      if(ibc.gt.1)then
        read(211)(ubc(k),k=1,kbm1)
        uabc=0
        do k=1,kbm1
           uabc=uabc+ubc(k)*dz(k)
        enddo
        do k=1,kbm1
           ubc(k)=ubc(k)-uabc 
        enddo
        uabc=0.e0
        read(212)(vbc(k),k=1,kbm1)
        vabc=0
        do k=1,kbm1
          vabc=vabc+vbc(k)*dz(k)
        enddo
        if(istrat.eq.1)then
          read(213)(tbc(k),k=1,kbm1)
          do k=1,kbm1
            tbc(k)=tbc(k)/rhoref
          enddo
        endif 
        if(istrat.eq.2)then
          read(213)(tbc(k),k=1,kbm1)
          read(214)(sbc(k),k=1,kbm1)
        endif 
      endif
      if(time.lt.time0+toff)then
      do j=2,JMM1
           jmm=j-1
           ju=2*j-2
           jv=2*j-3
        do i=2,IMM1
           iu=2*i-3
           iv=2*i-2
           imm=i-1
           f1=wu1(i,j)*
     *               (1+.5*(pert(i,j)+pert(i,jmm))*fact3(iu,ju))
           f2=wv1(i,j)*
     *               (1+.5*(pert(i,j)+pert(i,jmm))*fact3(iv,jv))
           wusurf(i,j)=(f1+windinu)*tramp*ramp
           wubody(i,j)=wbu(i,j)*tramp*ramp
           wvsurf(i,j)=(f2+windinv)*tramp*ramp
           wvbody(i,j)=wbv(i,j)*tramp*ramp
        enddo
      enddo
      else
      do j=2,JMM1
        do i=2,IMM1
           wusurf(i,j)=(wu1(i,j)+windinu)*tramp*ramp
           wubody(i,j)=wbu(i,j)*tramp*ramp
           wvsurf(i,j)=(wv1(i,j)+windinv)*tramp*ramp
           wvbody(i,j)=wbv(i,j)*tramp*ramp
        enddo
      enddo
      endif
      if(ibcon.eq.0)then
        call perchanu1(wusurf)
        call perchanv1(wvsurf)
        call perchanu1(wubody)
        call perchanv1(wvbody)
      endif
C set  other forcing here
C atmospheric pressure
        do j=2,JMM1
          do i=2,IMM1
            e_atmos(i,j)=0.e0
          enddo
        enddo
C T and S surface conditions
        if(istrat.ne.0)then
          do j=2,JMM1
            do i=2,IMM1
c no advection of temp or salt from surface
               vflux(i,j)=w(i,j,1)
C
C     Set vflux(i,j).ne.0 if one wishes non-zero flow of t and s across
C     the sea surface. See calculation of elf(i,j) below and subroutines
C     vertvl, advt1 (or advt2). If w(1,j,1)=0, and, additionally, there
C     is no net flow across lateral boundaries, the basin volume will be
C     constant; if also vflux(i,j).ne.0, then, for example, the average
C     salinity will change and, unrealistically, so will total salt. 
C
C     Set wtsurf to the sensible heat, the latent heat (which involves
C     only the evaporative component of vflux) and the long wave
C     radiation:
C
            wtsurf(i,j)=tfluxin
C
C     Set swrad to the short wave radiation:
C
            swrad(i,j)=tswin
C
C     To account for change in temperature of flow crossing the sea
C     surface (generally quite small compared to latent heat effect)
C
            tatm=t(i,j,1)+tbias    ! an approximation
            wtsurf(i,j)=wtsurf(i,j)
c+vflux(i,j)*(tatm-t(i,j,1)-tbias)
C
C     Set the salinity of water vapor/precipitation which enters/leaves
C     the atmosphere (or e.g., an ice cover)
C    
            satm=0.e0              
            wssurf(i,j)=vflux(i,j)*(satm-s(i,j,1)-sbias)  
C
            end do
          end do
          if(ibcon.eq.0)then
            call perchanv1(swrad)
            call perchanv1(wssurf)
            call perchanv1(wtsurf)
            call perchanv1(vflux)
          endif
        endif
C
C-----------------------------------------------------------------------
C
C     Set lateral viscosity:
C
C     If mode=2 then initial values of aam2d are used. If one wishes
C     to use Smagorinsky lateral viscosity and diffusion for an
C     external (2-D) mode calculation, then appropiate code can be
C     adapted from that below and installed just before the end of the
C     "if(mode.eq.2)" loop in subroutine advave.
C
C     Calculate Smagorinsky lateral viscosity:
C
C       ( hor visc = horcon*dx*dy*sqrt((du/dx)**2+(dv/dy)**2
C                                     +.5*(du/dy+dv/dx)**2) )
C
        if(mode.ne.2) then
          call advct
          if(istrat.ne.0)call baropg
Cpn calculate Smag. coefficients here if desired
C     Form vertical averages of 3-D fields for use in external (2-D)
C     mode:
          do j=1,JM
            do i=1,IM
              adx2d(i,j)=0.e0
              ady2d(i,j)=0.e0
              drx2d(i,j)=0.e0
              dry2d(i,j)=0.e0
cpn              aam2d(i,j)=0.e0
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                adx2d(i,j)=adx2d(i,j)+advx(i,j,k)*dz(k)
                ady2d(i,j)=ady2d(i,j)+advy(i,j,k)*dz(k)
cpn               aam2d(i,j)=aam2d(i,j)+aam(i,j,k)*dz(k)
              end do
            end do
          end do
cpn no strat option
          if(istrat.ne.0)then
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  drx2d(i,j)=drx2d(i,j)+drhox(i,j,k)*dz(k)
                  dry2d(i,j)=dry2d(i,j)+drhoy(i,j,k)*dz(k)
                end do
              end do
            end do
          endif
C
          call advave
c calculate bottom stress from BBL model

C
c dispersion term for external mode calculation
          do j=1,JM
            do i=1,IM
              adx2d(i,j)=adx2d(i,j)-advua(i,j)+
     *          omu(i,j)*u(i,j,1)*aru(i,j)
              ady2d(i,j)=ady2d(i,j)-advva(i,j)+
     *          omv(i,j)*v(i,j,1)*arv(i,j)
            end do
          end do
C
        endif
C
        do j=1,JM
          do i=1,IM
            egf(i,j)=el(i,j)*ispi
          end do
        end do
C
        do j=2,JM
          do i=2,IM
            utf(i,j)=ua(i,j)*(d(i,j)+d(i-1,j))*isp2i
            vtf(i,j)=va(i,j)*(d(i,j)+d(i,j-1))*isp2i
          end do
        end do
C
C-----------------------------------------------------------------------
C
        do 8000 iext=1,isplit    ! Begin external (2-D) mode 
C
C         write(*,3) iext,time
C   3     format(' iext,time =',i5,f9.2)
C
          do j=2,JM
            do i=2,IM
              fluxua(i,j)=.25e0*(d(i,j)+d(i-1,j))
     $                     *(dy(i,j)+dy(i-1,j))*ua(i,j)
              fluxva(i,j)=.25e0*(d(i,j)+d(i,j-1))
     $                     *(dx(i,j)+dx(i,j-1))*va(i,j)
            end do
          end do
          if(ibcon.eq.0)then
            call perchan1(fluxva)
          endif
C
C     NOTE addition of surface freshwater flux, w(i,j,1), compared
C     with pom98.f. See also modifications to subroutine vertvl.
C
          do j=2,JMM1
            do i=2,IMM1
              elf(i,j)=elb(i,j)
     $                  +dte2*(-(fluxua(i+1,j)-fluxua(i,j)
     $                          +fluxva(i,j+1)-fluxva(i,j))/art(i,j)
     $                          -w(i,j,1))
            end do
          end do
C
          if(ibcon.ne.0)then
            call bcond(1)
          else
            call perchanv1(elf)
          endif
          if(ibal.ne.0)then
            if(balave.ne.0. .or. iext.eq.isplit)then
              do j=2,JMM1
                do i=2,IMM1
                  dtel(i,j)= (elf(i,j)-elb(i,j))/dte2
                  flua(i,j)=(fluxua(i+1,j)-fluxua(i,j))/art(i,j)
                  flva(i,j)=(fluxva(i,j+1)-fluxva(i,j))/art(i,j)
                  flw0(i,j)=w(i,j,1)
                enddo
              enddo
            endif
          endif
          if(mod(iext,ispadv).eq.0) call advave
C
          do j=2,JMM1
            do i=2,IM
              uaf(i,j)=adx2d(i,j)+advua(i,j)
     $                  -aru(i,j)*.25e0
     $                    *(cor(i,j)*d(i,j)*(va(i,j+1)+va(i,j))
     $                     +cor(i-1,j)*d(i-1,j)*(va(i-1,j+1)+va(i-1,j)))
     $                  +.25e0*grav*(dy(i,j)+dy(i-1,j))
     $                    *(d(i,j)+d(i-1,j))
     $                    *((1.e0-2.e0*alpha)
     $                       *(el(i,j)-el(i-1,j))
     $                      +alpha*(elb(i,j)-elb(i-1,j)
     $                             +elf(i,j)-elf(i-1,j))
     $                      +e_atmos(i,j)-e_atmos(i-1,j))
     $                  +drx2d(i,j)+aru(i,j)*(wusurf(i,j)-wubot(i,j))
            end do
          end do
C
          do j=2,JMM1
            do i=2,IM
              uaf(i,j)=((h(i,j)+elb(i,j)+h(i-1,j)+elb(i-1,j))
     $                    *aru(i,j)*uab(i,j)
     $                  -4.e0*dte*uaf(i,j))
     $                 /((h(i,j)+elf(i,j)+h(i-1,j)+elf(i-1,j))
     $                     *aru(i,j))
            end do
          end do
C
          do j=2,JM
            do i=2,IMM1
              vaf(i,j)=ady2d(i,j)+advva(i,j)
     $                  +arv(i,j)*.25e0
     $                    *(cor(i,j)*d(i,j)*(ua(i+1,j)+ua(i,j))
     $                     +cor(i,j-1)*d(i,j-1)*(ua(i+1,j-1)+ua(i,j-1)))
     $                  +.25e0*grav*(dx(i,j)+dx(i,j-1))
     $                    *(d(i,j)+d(i,j-1))
     $                    *((1.e0-2.e0*alpha)*(el(i,j)-el(i,j-1))
     $                      +alpha*(elb(i,j)-elb(i,j-1)
     $                             +elf(i,j)-elf(i,j-1))
     $                      +e_atmos(i,j)-e_atmos(i,j-1))
     $                  +dry2d(i,j)+arv(i,j)*(wvsurf(i,j)-wvbot(i,j))
            end do
          end do
C
          do j=2,JM
            do i=2,IMM1
              vaf(i,j)=((h(i,j)+elb(i,j)+h(i,j-1)+elb(i,j-1))
     $                    *vab(i,j)*arv(i,j)
     $                  -4.e0*dte*vaf(i,j))
     $                 /((h(i,j)+elf(i,j)+h(i,j-1)+elf(i,j-1))
     $                     *arv(i,j))
            end do
          end do
C
          if(ibal.ne.0)then
            if(balave.ne.0. .or. iext.eq.isplit)then
              do j=2,jmm1
                do i=2,imm1
                  hpu=.5*(h(i,j)+elf(i,j)+h(i-1,j)+elf(i-1,j))
                  hmu=.5*(h(i,j)+elb(i,j)+h(i-1,j)+elb(i-1,j))
                  hpv=.5*(h(i,j)+elf(i,j)+h(i,j-1)+elf(i,j-1))
                  hmv=.5*(h(i,j)+elb(i,j)+h(i,j-1)+elb(i,j-1))
                  usurfa(i,j)=wusurf(i,j)*dum(i,j)
                  ubota(i,j)=-wubot(i,j)*dum(i,j)
                  uboda(i,j)=wubody(i,j)*dum(i,j)
                  vsurfa(i,j)=wvsurf(i,j)*dvm(i,j)
                  vbota(i,j)=-wvbot(i,j)*dvm(i,j)
                  vboda(i,j)=wvbody(i,j)*dvm(i,j)
                  vadva(i,j)=ady2d(i,j)+advva(i,j)-
     *                 vboda(i,j)*arv(i,j)-vdia(i,j)
                  uadva(i,j)=adx2d(i,j)+advua(i,j)-
     *                 uboda(i,j)*aru(i,j)-udia(i,j)
                  uadva(i,j)=uadva(i,j)*dum(i,j)/aru(i,j)
                  vadva(i,j)=vadva(i,j)*dvm(i,j)/arv(i,j)
                  udia(i,j)=udia(i,j)*dum(i,j)/aru(i,j)
                  vdia(i,j)=vdia(i,j)*dvm(i,j)/arv(i,j)
                  udta(i,j)=(hpu*uaf(i,j)-hmu*uab(i,j))/dte2*dum(i,j)
                  vdta(i,j)=(hpv*vaf(i,j)-hmv*vab(i,j))/dte2*dvm(i,j)
                  vcora(i,j)=
     $                  +.25e0*(cor(i,j)*d(i,j)*(ua(i+1,j)+ua(i,j))
     $                     +cor(i,j-1)*d(i,j-1)*(ua(i+1,j-1)+ua(i,j-1)))
                  ucora(i,j)=
     $                  -.25e0*(cor(i,j)*d(i,j)*(va(i,j+1)+va(i,j))
     $                     +cor(i-1,j)*d(i-1,j)*(va(i-1,j+1)+va(i-1,j)))
                  vpa(i,j)=
     $                  +.25e0*grav*(dx(i,j)+dx(i,j-1))
     $                    *(d(i,j)+d(i,j-1))
     $                    *((1.e0-2.e0*alpha)*(el(i,j)-el(i,j-1))
     $                      +alpha*(elb(i,j)-elb(i,j-1)
     $                             +elf(i,j)-elf(i,j-1))
     $                      +e_atmos(i,j)-e_atmos(i,j-1))+dry2d(i,j)
                  upa(i,j)=
     $                  +.25e0*grav*(dy(i,j)+dy(i-1,j))
     $                    *(d(i,j)+d(i-1,j))
     $                    *((1.e0-2.e0*alpha)*(el(i,j)-el(i-1,j))
     $                      +alpha*(elb(i,j)-elb(i-1,j)
     $                             +elf(i,j)-elf(i-1,j))
     $                      +e_atmos(i,j)-e_atmos(i-1,j))+drx2d(i,j)
                  vcora(i,j)=vcora(i,j)*dvm(i,j)
                  ucora(i,j)=ucora(i,j)*dum(i,j) 
                  vpa(i,j)=vpa(i,j)*dvm(i,j)/arv(i,j)
                  upa(i,j)=upa(i,j)*dum(i,j)/aru(i,j)
                  if(idiv.eq.1)then
                    usurfa(i,j)=usurfa(i,j)/hpu
                    uboda(i,j)=uboda(i,j)/hpu
                    upa(i,j)=upa(i,j)/hpu
                    ucora(i,j)=ucora(i,j)/hpu
                    udta(i,j)=udta(i,j)/hpu
                    uadva(i,j)=uadva(i,j)/hpu
                    udia(i,j)=udia(i,j)/hpu
                    ubota(i,j)=ubota(i,j)/hpu
                    vsurfa(i,j)=vsurfa(i,j)/hpv
                    vboda(i,j)=vboda(i,j)/hpv
                    vpa(i,j)=vpa(i,j)/hpv 
                    vcora(i,j)=vcora(i,j)/hpv
                    vdta(i,j)=vdta(i,j)/hpv
                    vadva(i,j)=vadva(i,j)/hpv
                    vdia(i,j)=vdia(i,j)/hpv
                    vbota(i,j)=vbota(i,j)/hpv
                  endif
                enddo
              enddo
            endif
          endif
          if(balave.ne.0)then
            do i=2,IMM1
              do j=2,JMM1
                dtelav(i,j)=dtelav(i,j)+dtel(i,j)
                flvav(i,j)=flvav(i,j)+flva(i,j)
                fluav(i,j)=fluav(i,j)+flua(i,j)
                flwav(i,j)=flwav(i,j)+flw0(i,j)
                upaav(i,j)=upaav(i,j)+upa(i,j)
                vpaav(i,j)=vpaav(i,j)+vpa(i,j)
                udtaav(i,j)=udtaav(i,j)+udta(i,j)
                vdtaav(i,j)=vdtaav(i,j)+vdta(i,j)
                ucoraav(i,j)=ucoraav(i,j)+ucora(i,j)
                vcoraav(i,j)=vcoraav(i,j)+vcora(i,j)
                uadvaav(i,j)=uadvaav(i,j)+uadva(i,j)
                vadvaav(i,j)=vadvaav(i,j)+vadva(i,j)
                udiaav(i,j)=udiaav(i,j)+udia(i,j)
                vdiaav(i,j)=vdiaav(i,j)+vdia(i,j)
                usurfaav(i,j)=usurfaav(i,j)+usurfa(i,j)
                ubotaav(i,j)=ubotaav(i,j)+ubota(i,j)
                ubodaav(i,j)=ubodaav(i,j)+uboda(i,j)
                vsurfaav(i,j)=vsurfaav(i,j)+vsurfa(i,j)
                vbotaav(i,j)=vbotaav(i,j)+vbota(i,j)
                vbodaav(i,j)=vbodaav(i,j)+vboda(i,j)
              enddo
            enddo
            nave=nave+1
            if(mod(iint,ibala).eq.0 .and. iext.eq.isplit)then
              do i=2,IMM1
                do j=2,JMM1
                  vadvaav(i,j)=vadvaav(i,j)/nave
                  vdiaav(i,j)=vdiaav(i,j)/nave
                  vpaav(i,j)=vpaav(i,j)/nave
                  vcoraav(i,j)=vcoraav(i,j)/nave
                  vdtaav(i,j)=vdtaav(i,j)/nave
                  vsurfaav(i,j)=vsurfaav(i,j)/nave
                  vbodaav(i,j)=vbodaav(i,j)/nave
                  vbotaav(i,j)=vbotaav(i,j)/nave
!
                  uadvaav(i,j)=uadvaav(i,j)/nave
                  udiaav(i,j)=udiaav(i,j)/nave
                  upaav(i,j)=upaav(i,j)/nave
                  ucoraav(i,j)=ucoraav(i,j)/nave
                  udtaav(i,j)=udtaav(i,j)/nave
                  usurfaav(i,j)=usurfaav(i,j)/nave
                  ubodaav(i,j)=ubodaav(i,j)/nave
                  ubotaav(i,j)=ubotaav(i,j)/nave
!
                  dtelav(i,j)=dtelav(i,j)/nave
                  flvav(i,j)=flvav(i,j)/nave
                  fluav(i,j)=fluav(i,j)/nave
                  flwav(i,j)=flwav(i,j)/nave
                enddo
              enddo
              nave=0
            endif
          endif
!
          if(ibcon.ne.0)then
            call bcond(2)
          else
            if(ibc.eq.0)then
              call perchanv1(vaf)
              call perchanu1(uaf)
            else
              call perchanv1b(vaf,vab)
              call perchanu1b(uaf,uab)
            endif
          endif
C
          if(iext.eq.(isplit-2))then
            do j=1,JM
              do i=1,IM
                etf(i,j)=.25e0*smoth*elf(i,j)
              end do
            end do
C
          else if(iext.eq.(isplit-1)) then
C
            do j=1,JM
              do i=1,IM
                etf(i,j)=etf(i,j)+.5e0*(1.-.5e0*smoth)*elf(i,j)
              end do
            end do
C
          else if(iext.eq.isplit) then
C
            do j=1,JM
              do i=1,IM
                etf(i,j)=(etf(i,j)+.5e0*elf(i,j))*fsm(i,j)
              end do
            end do
C
          endif
C
C     Stop if velocity condition violated (generally due to CFL
C     criterion not being satisfied):
C
          vamax=0.e0
C
          do j=1,JM
            do i=1,IM
              if(abs(vaf(i,j)).ge.vamax) then
                vamax=abs(vaf(i,j))
                imax=i
                jmax=j
              endif
            end do
          end do
C
          if(vamax.le.vmaxl) then
C
C     Apply filter to remove time split and reset time sequence:
C
            do j=1,JM
              do i=1,IM
                ua(i,j)=ua(i,j)
     $                   +.5e0*smoth*(uab(i,j)-2.e0*ua(i,j)+uaf(i,j))
                va(i,j)=va(i,j)
     $                   +.5e0*smoth*(vab(i,j)-2.e0*va(i,j)+vaf(i,j))
                el(i,j)=el(i,j)
     $                   +.5e0*smoth*(elb(i,j)-2.e0*el(i,j)+elf(i,j))
                elb(i,j)=el(i,j)
                el(i,j)=elf(i,j)
                d(i,j)=h(i,j)+el(i,j)
                uab(i,j)=ua(i,j)
                ua(i,j)=uaf(i,j)
                vab(i,j)=va(i,j)
                va(i,j)=vaf(i,j)
              end do
            end do
            if(ibcon.eq.0)then
              call perchanv1(el)
              call perchanv1(d)
              if(ibc.eq.0)then
                call perchanu1(ua)
                call perchanv1(va)
              else
                call perchan1(ua)
                call perchan1(va)
              endif
            endif
C
            if(iext.ne.isplit) then
              do j=2,JM
                do i=2,IM
                  egf(i,j)=egf(i,j)+el(i,j)*ispi
                  utf(i,j)=utf(i,j)+ua(i,j)*(d(i,j)+d(i-1,j))*isp2i
                  vtf(i,j)=vtf(i,j)+va(i,j)*(d(i,j)+d(i,j-1))*isp2i
                end do
              end do
            endif
C
          else
C if it has blown up
C     Write netCDF output:
C
!         if(netcdf_file.ne.'nonetcdf') then
!           call write_netcdf(2)                            ! *netCDF*
!         else
            call output2
            call output3
!         endif
C
C
            write(*,4) time,iint,iext,iprint
C
C
            write(*,6) vamax,imax,jmax
    6       format('************************************************'/
     $             '************ abnormal job end ******************'/
     $             '************* user terminated ******************'/
     $             '************************************************'/
     $             ' vamax =',e12.3,'   imax,jmax =',2i5)
C
C     Close netCDF file:
C
!         if(netcdf_file.ne.'nonetcdf') then
!            call write_netcdf(3)                           ! *netCDF*
!         endif
            stop
          endif
C
 8000 continue        ! End of external (2-D) mode
        if(ibcon.eq.0)then 
          call perchanv1(etf)
          call perchanv1(egf)
          if(ibc.eq.0)then
            call perchanu1(utf)
            call perchanv1(vtf)
          endif
        endif
c        if(mod(iint,icm).eq.0)then
c           write(102,'(500e22.13)')time,(etf(i,2),
c     *       egf(i,2),el(i,2),i=30,100)
c        endif

c     Continue with internal (3-D) mode calculation:
C
        if((iint.ne.1.or.time0.ne.0.e0).and.mode.ne.2) then
C
C     Adjust u(z) and v(z) such that depth average of (u,v) = (ua,va):
C
          do j=1,JM
            do i=1,IM
              tps(i,j)=0.e0
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                tps(i,j)=tps(i,j)+u(i,j,k)*dz(k)
              end do
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                u(i,j,k)=(u(i,j,k)-tps(i,j))+
     $            (utb(i,j)+utf(i,j))/(dt(i,j)+dt(i-1,j))*dum(i,j)
              end do
            end do
          end do

          do j=1,JM
            do i=1,IM
              tps(i,j)=0.e0
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                tps(i,j)=tps(i,j)+v(i,j,k)*dz(k)
              end do
            end do
          end do
C
          do k=1,KBM1
            do j=2,JM
              do i=1,IM
                v(i,j,k)=(v(i,j,k)-tps(i,j))+
     $                (vtb(i,j)+vtf(i,j))/(dt(i,j)+dt(i,j-1))
              end do
            end do
          end do
          if(ibcon.eq.0)then
            if(ibc.eq.0)then
              call perchanv(v)
              call perchanu(u)
            else
              call perchan(v)
              call perchan(u)
            endif
          endif
C
C     vertvl calculates w from u, v, dt (h+et), etf and etb:
C
          call vertvl
          if(ibcon.ne.0)then
            call bcond(5)
          else
            call perchanv(w)
          endif
C
C
          do k=1,KB
            do j=1,JM
              do i=1,IM
                uf(i,j,k)=0.e0
                vf(i,j,k)=0.e0
              end do
            end do
          end do
C
C     Calculate q2f and q2lf using uf, vf, a and c as temporary
C     variables:
C
          if(nadv2.eq.1)then
            call advq1
          else if(nadv2.eq.2)then
            call advq2
          else
            write(*,10)
   10         format(/'Invalid value for nadv2 ..... ',
     $               'program terminated'/)
              stop
          endif
          call profq
          if(ibcon.ne.0)then
            call bcond(6)
          else 
            call perchanv(uf)
            call perchanv(vf)
            call perchanv(kh)
            call perchanv(km)
            call perchanv(kq)
          endif
C
          do k=1,KB
            do j=1,JM
              do i=1,IM
                q2(i,j,k)=q2(i,j,k)
     $                     +.5e0*smoth*(uf(i,j,k)+q2b(i,j,k)
     $                                  -2.e0*q2(i,j,k))
                q2l(i,j,k)=q2l(i,j,k)
     $                     +.5e0*smoth*(vf(i,j,k)+q2lb(i,j,k)
     $                                  -2.e0*q2l(i,j,k))
                q2b(i,j,k)=q2(i,j,k)
                q2(i,j,k)=uf(i,j,k)
                q2lb(i,j,k)=q2l(i,j,k)
                q2l(i,j,k)=vf(i,j,k)
              end do
            end do
          end do
C
C     Calculate tf and sf using uf, vf, a and c as temporary variables:
C
          if(istrat.ne.0) then
C
            if(nadv1.eq.1) then
              call advt1
            else if(nadv1.eq.2) then
              call advt2
            else
              write(*,9)
    9         format(/'Invalid value for nadv1 ..... ',
     $               'program terminated'/)
              stop
            endif
C
            call proft(uf,wtsurf,tsurf,nbct)
            if(istrat.eq.2)call proft(vf,wssurf,ssurf,nbcs)
            if(ibcon.ne.0)then
              call bcond(4)
            else
              if(ibc.eq.0)then
                call perchanv(uf)
                if(istrat.eq.2)call perchanv(vf)
              else
                call perchanvb(uf,tbc)
                if(istrat.eq.2)call perchanvb(vf,sbc)
              endif
            endif
C
            do k=1,KB
              do j=1,JM
                do i=1,IM
                  t(i,j,k)=t(i,j,k)
     $                      +.5e0*smoth*(uf(i,j,k)+tb(i,j,k)
     $                                   -2.e0*t(i,j,k))
                  tb(i,j,k)=t(i,j,k)
                  t(i,j,k)=uf(i,j,k)
                end do
              end do
            end do 
            if(istrat.eq.2)then
              do k=1,KB
                do j=1,JM
                  do i=1,IM
                    s(i,j,k)=s(i,j,k)
     $                      +.5e0*smoth*(vf(i,j,k)+sb(i,j,k)
     $                                   -2.e0*s(i,j,k))
                    sb(i,j,k)=s(i,j,k)
                    s(i,j,k)=vf(i,j,k)
                  end do
                end do
              end do
C
              call dens(s,t,rho)
              if(ibcon.eq.0)then
                if(ibc.eq.0)then
                  call perchanv(rho)
                else
                  call perchanvb(rho,tbc)
                endif
              endif
            else if(istrat.eq.1)then
              do k=1,KBM1
                do i=1,IM
                  do j=1,JM
                    rho(i,j,k)=t(i,j,k)
                  end do
                enddo  
              enddo
            endif
C
          endif
C
C     Calculate uf and vf:
C
C user modified subroutine to calculate or read desired forcing
C nearshore version uses passed variables from wave_module
c          if(mod(iint,10*icm).eq.0)then
c            do i=2,IMM1
c               write(105,'(4e22.13)')(i-2)*dx(i,2),wusurf(i,2),
c     *           (i-1.5)*dx(i,2),wvsurf(i,2)
c            enddo
c          endif
          if(ibot.eq.0)call botstr
          call advu
          call advv
c 
          call profu
          if(ibcon.eq.0)then
            if(ibc.eq.0)then
              call perchanu(uf)
            else
              call perchanub(uf,ubc)
            endif
          endif
          call profv
          if(ibcon.ne.0)then
            call bcond(3)
          else
            if(ibc.eq.0)then
              call perchanu(uf)
              call perchanv(vf)
            else
              call perchanub(uf,ubc)
              call perchanvb(vf,vbc)
            endif
          endif
          if(mod(iint,10*icm).eq.0)then
            do i=2,IMM1
               write(106,'(4e22.13)')(i-2)*dx(i,2),wusurf(i,2),
     *           (i-1.5)*dx(i,2),wvsurf(i,2)
            enddo
          endif
C
          if(mod(iint,ibalo).eq.0)then
            call outbal
            call outbal2
c            write(*,*)'balances written at ',time, 'iint ',iint
          endif

          do j=1,JM
            do i=1,IM
              tps(i,j)=0.e0
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                tps(i,j)=tps(i,j)
     $                    +(uf(i,j,k)+ub(i,j,k)-2.e0*u(i,j,k))*dz(k)
              end do
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                u(i,j,k)=u(i,j,k)
     $                    +.5e0*smoth*(uf(i,j,k)+ub(i,j,k)
     $                                 -2.e0*u(i,j,k)-tps(i,j))
              end do
            end do
          end do
C
          do j=1,JM
            do i=1,IM
              tps(i,j)=0.e0
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                tps(i,j)=tps(i,j)
     $                    +(vf(i,j,k)+vb(i,j,k)-2.e0*v(i,j,k))*dz(k)
              end do
            end do
          end do
C
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                v(i,j,k)=v(i,j,k)
     $                    +.5e0*smoth*(vf(i,j,k)+vb(i,j,k)
     $                                 -2.e0*v(i,j,k)-tps(i,j))
              end do
            end do
          end do
C
          do k=1,KB
            do j=1,JM
              do i=1,IM
                ub(i,j,k)=u(i,j,k)
                u(i,j,k)=uf(i,j,k)
                vb(i,j,k)=v(i,j,k)
                v(i,j,k)=vf(i,j,k)
              end do
            end do
          end do
C
        endif
C
        do j=1,JM
          do i=1,IM
            egb(i,j)=egf(i,j)
            etb(i,j)=et(i,j)
            et(i,j)=etf(i,j)
            dt(i,j)=h(i,j)+et(i,j)
            utb(i,j)=utf(i,j)
            vtb(i,j)=vtf(i,j)
          end do
        end do
        do j=2,JMM1
          do i=2,IMM1
            if(dt(i,j).le..001)then
              write(*,'(a12,3i8)')'small depth ',i,
     *              j,iint
              write(*,'(4e15.5)')time,h(i,j),et(i,j),dt(i,j)
              stop 'depths'
            endif
          end do
        end do
    
        if(ave.ne.0.e0)then
          do k=1,KB
            do j=2,JMM1
              do i=2,IMM1
                wav(i,j,k)=wav(i,j,k)+w(i,j,k)
                uav(i,j,k)=uav(i,j,k)+u(i,j,k)
                vav(i,j,k)=vav(i,j,k)+v(i,j,k)
                q2av(i,j,k)=q2av(i,j,k)+q2(i,j,k) 
                lav(i,j,k)=lav(i,j,k)+l(i,j,k)
                kmav(i,j,k)=kmav(i,j,k)+km(i,j,k)
              enddo
            enddo
          enddo
          if(istrat.ne.0)then
            do k=1,KB
              do j=2,JMM1
                do i=2,IMM1
                  sigtav(i,j,k)=sigtav(i,j,k)+rho(i,j,k)
                enddo
              enddo
            enddo
            if(istrat.eq.2)then       
              do k=1,KB
                do j=2,JMM1
                  do i=2,IMM1
                    tav(i,j,k)=tav(i,j,k)+t(i,j,k)
                    sav(i,j,k)=sav(i,j,k)+s(i,j,k)
                  enddo
                enddo
              enddo
            endif
          endif
          do j=2,JMM1
            do i=2,IMM1
              etav(i,j)=etav(i,j)+et(i,j)
              wusav(i,j)=wusav(i,j)+wusurf(i,j)  
              wvsav(i,j)=wvsav(i,j)+wvsurf(i,j)  
              wubav(i,j)=wubav(i,j)+wubot(i,j)  
              wvbav(i,j)=wvbav(i,j)+wvbot(i,j)  
              wubdav(i,j)=wubdav(i,j)+wubody(i,j)
              wvbdav(i,j)=wvbdav(i,j)+wvbody(i,j)
            enddo
          enddo
          if(mod(iint,iave).eq.0)then   
            do k=1,KB
              do j=2,JMM1
                do i=2,IMM1    
                  wav(i,j,k)=wav(i,j,k)/real(iave)
                  uav(i,j,k)=uav(i,j,k)/real(iave)
                  vav(i,j,k)=vav(i,j,k)/real(iave)
                  q2av(i,j,k)=q2av(i,j,k)/real(iave)
                  lav(i,j,k)=lav(i,j,k)/real(iave)
                  kmav(i,j,k)=kmav(i,j,k)/real(iave)
                enddo
              enddo
            enddo
            if(istrat.ne.0)then
              do k=1,KB
                do j=2,JMM1
                  do i=2,IMM1    
                    sigtav(i,j,k)=sigtav(i,j,k)/real(iave)
                  enddo
                enddo
              enddo
              if(istrat.eq.2)then
                do k=1,KB
                  do j=2,JMM1
                    do i=2,IMM1    
                    enddo
                    tav(i,j,k)=tav(i,j,k)/real(iave)
                    sav(i,j,k)=sav(i,j,k)/real(iave)
                  enddo
                enddo
              endif
            endif
            do j=2,JMM1
              do i=2,IMM1
                etav(i,j)=etav(i,j)/real(iave)
                wusav(i,j)=wusav(i,j)/real(iave)
                wvsav(i,j)=wvsav(i,j)/real(iave)
                wubav(i,j)=wubav(i,j)/real(iave)
                wvbav(i,j)=wvbav(i,j)/real(iave)
                wubdav(i,j)=wubdav(i,j)/real(iave)
                wvbdav(i,j)=wvbdav(i,j)/real(iave)
              enddo
            enddo
            call outave
            do j=2,JMM1
              do i=2,IMM1
                etav(i,j)=0.e0
                wusav(i,j)=0.e0
                wvsav(i,j)=0.e0
                wubav(i,j)=0.e0
                wvbav(i,j)=0.e0
                wubdav(i,j)=0.e0
                wvbdav(i,j)=0.e0
              enddo
            enddo
            do k=1,KB
              do j=2,JMM1
                do i=2,IMM1    
                  wav(i,j,k)=0.e0
                  uav(i,j,k)=0.e0
                  vav(i,j,k)=0.e0
                  q2av(i,j,k)=0.e0
                  lav(i,j,k)=0.e0
                  kmav(i,j,k)=0.e0
                  sigtav(i,j,k)=0.e0
                  tav(i,j,k)=0.e0
                  sav(i,j,k)=0.e0
                enddo
              enddo
            enddo
          endif
        endif
        if(balave.ne.0)call balavg(navi,nave)
C
C-----------------------------------------------------------------------
C     Beginning of print section:
C
      if(mod(iint,icm).eq.0)then
        if(iint.eq.icm)then
          open(unit=18,file='cm.dat',status='new')
c         open(unit=19,file='cmbal.dat',status='new')         
        endif
        write(18,'(f10.4,200e15.5)')time,(u(io(ll),jo(ll),ko(ll)),
     *       v(io(ll),jo(ll),ko(ll)),ll=1,ncmout) 
c       if(ibal.ne.0)then
c         write(19,'(200e15.5)')whatever
c       endif
      endif
      if(iint.ge.iswtch) iprint=nint(prtd2*3600.e0/dti)
C
      if(mod(iint,iprint).eq.0) then
        write(*,4) time,iint,iext,iprint
    4     format(/
     $    ' time =',f9.4,', iint =',i8,', iext =',i8,', iprint =',i8)
C
C
        vtot=0.e0
        atot=0.e0
        taver=0.e0
        saver=0.e0
        eaver=0.e0
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              darea=art(i,j)*fsm(i,j)
              dvol=darea*dt(i,j)*dz(k)
              vtot=vtot+dvol
              taver=taver+tb(i,j,k)*dvol
              saver=saver+sb(i,j,k)*dvol
            end do
          end do
        end do
C
        do j=2,JMM1
          do i=2,IMM1
            darea=art(i,j)*fsm(i,j)
            atot=atot+darea
            eaver=eaver+et(i,j)*darea
          end do
        end do
C
        taver=taver/vtot
        saver=saver/vtot
        eaver=eaver/atot
        tsalt=(saver+sbias)*vtot
C
        write(*,5) vtot,atot,eaver,taver,saver,tsalt
    5     format('vtot = ',e16.7,'   atot = ',e16.7,
     $           '  eaver =',e16.7/'taver =',e16.7,
     $           '   saver =',e16.7,'  tsalt =',e16.7)  
C
C     Write netCDF output:
C
!       if(netcdf_file.ne.'nonetcdf') then
!         call write_netcdf(2)                            ! *netCDF*
!       else
          call output2
          call output3
!       endif
C
C
      endif
       
      if(mod(iint,irstrt).eq.0)then
        nr=nr+1
        write(nrc,'(i2.2)')nr
        filr='restart.'//nrc
        open(unit=200,file=filr,status='new',
     *    form='unformatted')
        write(200) time,
     $     wubot,wvbot,aam2d,ua,uab,va,vab,el,elb,et,etb,egb,
     $     utb,vtb,u,ub,w,v,vb,t,tb,s,sb,rho,adx2d,ady2d,advua,advva,
     $     km,kh,kq,l,q2,q2b,aam,q2l,q2lb,wusurf,wvsurf,z0c
        write(*,*)' restart file ',filr,  ' written at ',time
        close(unit=200)
      endif
C
C     End of print section
C
C-----------------------------------------------------------------------
C
 9000 continue       !  End of internal (3-D) mode
      lo=lo+nstep
      if(lo .ge. iend)then
C
C-----------------------------------------------------------------------
C
        write(*,4) time,iint,iext,iprint
C
C
C     Save this data for a seamless restart:
C
        open(unit=200,file='restart.end',
     *    form='unformatted')
        write(200) time,
     $     wubot,wvbot,aam2d,ua,uab,va,vab,el,elb,et,etb,egb,
     $     utb,vtb,u,ub,w,v,vb,t,tb,s,sb,rho,adx2d,ady2d,advua,advva,
     $     km,kh,kq,l,q2,q2b,aam,q2l,q2lb,wusurf,wvsurf,z0c
        close(200)
C
C     Close netCDF file:
C
!        if(netcdf_file.ne.'nonetcdf') then
!          call write_netcdf(3)                                   ! *netCDF*
!        endif
      endif
C fill passed variables on double grid
      call passit
      return
C
      end


      subroutine cshld(sstar,shldc)
c calculate critical shields parameter
c for initiation of sediment motion
c from shields diagram.
c scf is correction factor.
      implicit none
      real sstar,shldc
      real scf
      scf=1.e0
      if(sstar .gt. 1.5e0) go to 10
         shldc=scf*0.0932e0*sstar**(-.707e0)
      return
   10 if(sstar .gt. 4.0e0) go to 20
         shldc=scf*0.0848e0*sstar**(-.473e0)
      return
   20 if(sstar .gt. 10.0e0) go to 30
         shldc=scf*0.0680e0*sstar**(-.314e0)
      return
   30 if(sstar .gt. 34.0e0) go to 40
         shldc=scf*0.033e0
      return
   40 if(sstar .gt. 270.e0) go to 50
         shldc=scf*0.0134e0*sstar**.255e0
      return
   50 shldc=scf*0.056e0
      return
      end
C
      subroutine dens(si,ti,rhoo)
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates (density-1000.)/rhoref.                  *
C *                                                                    *
C *                (see: Mellor, G.L., 1991, J. Atmos. Oceanic Tech.,  *
C *                609-611.)                                           *
C *                                                                    *
C *                ti is potential temperature                         *
C *                                                                    *
C *                If using 32 bit precision, it is recommended that   *
C *                cr,p,rhor,sr,tr,tr2,tr3 and tr4 be made double      *
C *                precision, and the "e"s in the constants be changed *
C *                to "d"s.                                            *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real si(IM,JM,KB),ti(IM,JM,KB),rhoo(IM,JM,KB)
      real cr,p,rhor,sr,tr,tr2,tr3,tr4
      integer i,j,k
C
      do k=1,KBM1
        do j=1,JM
          do i=1,IM
C
            tr=ti(i,j,k)+tbias
            sr=si(i,j,k)+sbias
            tr2=tr*tr
            tr3=tr2*tr
            tr4=tr3*tr
C
C     Approximate pressure in units of bars:
C
            p=grav*rhoref*(-zz(k)* h(i,j))*1.e-5
C
            rhor=-0.157406e0+6.793952e-2*tr
     $            -9.095290e-3*tr2+1.001685e-4*tr3
     $            -1.120083e-6*tr4+6.536332e-9*tr4*tr
C
            rhor=rhor+(0.824493e0-4.0899e-3*tr
     $            +7.6438e-5*tr2-8.2467e-7*tr3
     $            +5.3875e-9*tr4)*sr
     $            +(-5.72466e-3+1.0227e-4*tr
     $            -1.6546e-6*tr2)*abs(sr)**1.5
     $            +4.8314e-4*sr*sr
C
            cr=1449.1e0+.0821e0*p+4.55e0*tr-.045e0*tr2
     $          +1.34e0*(sr-35.e0)
            rhor=rhor+1.e5*p/(cr*cr)*(1.e0-2.e0*p/(cr*cr))
C
            rhoo(i,j,k)=rhor/rhoref*fsm(i,j)
C
          end do
        end do
      end do
C
      return
C
      end
C
      subroutine depth
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Establishes the vertical sigma grid with log        *
C *                distributions at the top and bottom and a linear    *
C *                distribution in between. The number of layers of    *
C *                reduced thickness are kl1-2 at the surface and      *
C *                KB-kl2-1 at the bottom. kl1 and kl2 are defined in  *
C *                the main program. For no log portions, set kl1=2    *
C *                and kl2=KB-1.                                       *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real delz
      integer kdz(12)
      integer k
C
      data kdz/1,1,2,4,8,16,32,64,128,256,512,1024/
C
      z(1)=0.e0
C
      do k=2,kl1
        z(k)=z(k-1)+kdz(k-1)
      end do
C
      delz=z(kl1)-z(kl1-1)
C
      do k=kl1+1,kl2
        z(k)=z(k-1)+delz
      end do
C
      do k=kl2+1,KB
        dz(k)=float(kdz(KB-k+1))*delz/float(kdz(KB-kl2))
        z(k)=z(k-1)+dz(k)
      end do
C
      do k=1,KB
        z(k)=-z(k)/z(KB)
      end do
C
      do k=1,KB-1
        zz(k)=0.5e0*(z(k)+z(k+1))
      end do
C
      zz(KB)=2.e0*zz(KBM1)-zz(KB-2)
C
      do k=1,KBM1
        dz(k)=z(k)-z(k+1)
        dzz(k)=zz(k)-zz(k+1)
      end do
C
      dz(KB)=0.e0
      dzz(KB)=0.e0
C
Cpn  change output of sigma profile
Cpn      write(*,1)
Cpn   1 format(/2x,'k',7x,'z',9x,'zz',9x,'dz',9x,'dzz',/)
C
      open(unit=12,file='sigma.prof',status='unknown')
      do k=1,KB
        write(12,2) z(k),dz(k),zz(k),dzz(k)
    2   format((4e18.9))
      end do
      close(12)
C
C
      return
C
      end
C
      subroutine findpsi
C **********************************************************************
C *                                                                    *
C * ROUTINE NAME:  findpsi                                             *
C *                                                                    *
C * FUNCTION    :  Calculates the stream function, first assuming      *
C *                zero on the southern boundary and then, using the   *
C *                values on the western boundary, the stream function *
C *                is calculated again. If the elevation field is near *
C *                steady state, the two calculations should agree;    *
C *                otherwise not.                                      *
C *                NOT CALLED and NO OUTPUT INCLUDED                   *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      integer i,j
C
      do j=1,JM
        do i=1,IM
          psi(i,j)=0.e0
        end do
      end do
C
C     Sweep northward:
C
      do j=2,JMM1
        do i=2,IM
          psi(i,j+1)=psi(i,j)
     $                +.25e0*uab(i,j)*(d(i,j)+d(i-1,j))
     $                  *(dy(i,j)+dy(i-1,j))
        end do
      end do
C
c      call prxy('Streamfunction, psi from u              ',
c     $          time,psi,IM,iskp,JM,jskp,0.e0)
C
C    Sweep eastward:
C
      do j=2,JM
        do i=2,IMM1
          psi(i+1,j)=psi(i,j)
     $                -.25e0*vab(i,j)*(d(i,j)+d(i,j-1))
     $                  *(dx(i,j)+dx(i,j-1))
        end do
      end do
C
c      call prxy('Streamfunction, psi from v              ',
c     $          time,psi,IM,iskp,JM,jskp,0.e0)
C
      return
C
      end
C
C
C
      subroutine force
C **********************************************************************
C *                                                                    *
C * FUNCTION    update forcing
C ******** this subroutine must be modified to set up a problem ********
C **********************************************************************
C  Current set up for 
C  nx_master=nx_wave = 2IM-3, ny_master=ny_wave=2jm-3 wave with new terms and 
C  nx_master=IMM1, ny_master=JMM1, no wave forcing
C
      include 'pom2k.h'
      include 'pass.h'
      integer i,j
      integer iwave,nadep
      integer iu,ju,iv,jv,ipp,imm,jpp,jmm
      integer ium,iup,ivm,ivp,jum,jup,jvm,jvp
      real sxyrx,sxyry,sxxrx,syyry,s1u(IM,JM),s1v(IM,JM),s2
      real w0(IM,JM),
     *  xx(IDB,JDB),yy(IDB,JDB),angle(IDB,JDB),crate(IDB,JDB),
     *  er(IDB,JDB),e(IDB,JDB),thdble(IDB,JDB),crat(IDB,JDB),
     *  cthe(IDB,JDB),sthe(IDB,JDB),ce(IDB,JDB),
     *  era(IDB,JDB),er2(IDB,JDB),dxdb(IDB,JDB),dydb(IDB,JDB),
     *  fact(IDB,JDB),fact2(IDB,JDB),ddbl(IDB,JDB),
     *  mm(IDB,JDB),zeros(IDB,JDB),mx1(IDB,JDB),
     *  my1(IDB,JDB),epsr(IDB,JDB)
      real cadu(IDB,JDB),cadv(IDB,JDB)
      real ddym,ddyp,ddxp,ddxm,xl,xout(IM),yl,yout(JM)
      real taux,tauy,tin,tsw,tflux,dtor,denom
c in common omu(IM,JM),omv(IM,JM),w0(IM,JM),theta(IM,JM)
c kk(IM,JM),hrms(IM,JM),mx(IDB,JDB),my(IDB,JDB)
c must enter xl taper length
 
c*** master start all cases:
      dtor=pi/180.d0
      nadep=max(nav,1)
      if(Master_Start.eq.1)then
        if(IDB.ne.Nx_Circ .or. JDB .ne. Ny_Circ)then
        write(*,*)IDB,Nx_Circ,JDB,Ny_Circ
          stop 'grid size'
        endif
c calculate angle at each corner of double grid
c calculate rotation at h and corners of POM grid
        do j=1,JDB
          do i=1,IDB
            zeros(i,j)=0.e0
            xx(i,j)=X_circ(i,j)-X_Circ(1,j)
            yy(i,j)=Y_Circ(i,j)-Y_Circ(i,1)
c depth on double grid including eta
            ddbl(i,j)=depth_circ(i,j)+pass_eta(i,j)
          enddo
        enddo
        if(xlast.eq.0)xlast = .95*xx(IDB,JDB/2)
        if(xpert.eq.0)xpert = xlast
        do j=1,JDB
          do i=1,IDB-1
            angle(i,j)=atan2(y_Circ(i+1,j)-y_Circ(i,j),
     *          x_Circ(i+1,j)-x_Circ(i,j))
            fact3(i,j)=(.5+.5*tanh((xpert-xx(i,j))/xl2))
            dxdb(i,j)=X_Circ(i+1,j)-X_Circ(i,j)
            fact(i,j)=(1-exp(-xx(i,j)/xl1))*
     *         (1-exp(-(xx(idb,j)-xx(i,j))/xl2))
            dxdb(i,j)=X_Circ(i+1,j)-X_Circ(i,j)
          enddo
            angle(IDB,j)=angle(IDB-1,j)
            fact(IDB,j)=0.
            fact3(IDB,j)=0.
            dxdb(IDB,j)=dxdb(IDB-1,j)
        enddo
        do i=1,IDB
          do j=1,JDB-1
            dydb(i,j)=Y_Circ(i,j+1)-Y_Circ(i,j)
          enddo
          dydb(i,JDB)=dydb(i,JDB-1)
        enddo
        if(IDB.eq.2*IM-3)then
          do j=2,JMM1
            jv=2*j-3
            ju=2*j-2
            do i=2,IMM1
              iu=2*i-3
              iv=2*i-2
              rot(i,j)=angle(iv,ju)
              rot_c(i,j)=angle(iu,jv)      
            enddo
          enddo 
          if(xl3.ne.0)then
            do j=1,JDB
                do i=1,IDB
                fact2(i,j)=(1-exp(-xx(i,j)/xl3))
              enddo
            enddo
            if(xl4.ne.0)then
              do j=1,JDB
                do i=1,IDB
                  fact2(i,j)=fact2(i,j)*
     *              (.5+.5*tanh((xlast-xx(i,j))/xl4))
                enddo
              enddo
            endif
          endif          
        else if(IDB.eq.IMM1)then
          do j=2,JM
            do i=2,IM
              rot(i,j)=angle(i-1,j-1)
              rot_c(i,j)=angle(i-1,j-1)      
            enddo
          enddo 
        else
          stop "IDB size"
        endif
C end of initial call
        return
      endif
      if(Sediupdat_for_Circ)then
        if(ibcon.eq.0)call perchandb(Depth_Circ,Nx_max,NY_max)
        if(IDB.eq.2*IM-3)then
          call averw(Depth_Circ,nadep,Nx_Circ,Ny_Circ,ibcon)
          do j=2,JMM1
            ju=j*2-2
            do i=2,IMM1
              iv=i*2-2
              h(i,j)=Depth_Circ(iv,ju)*fsm(i,j)
              d(i,j)=h(i,j)+el(i,j)
              dt(i,j)=h(i,j)+et(i,j)
            end do
          end do
        else
          call averw(Depth_Circ,nadep,Nx_Circ,Ny_Circ,ibcon)
          do j=2,JMM1
            do i=2,IMM1
              h(i,j)=.25e0*(Depth_Circ(i,j)+Depth_Circ(i-1,j)+
     *          Depth_Circ(i,j-1)+Depth_Circ(i-1,j-1))*fsm(i,j)
              d(i,j)=h(i,j)+el(i,j)
              dt(i,j)=h(i,j)+et(i,j)
            end do
          end do
        endif    
        if(ibcon.eq.0)then
           call perchanv1(d)
           call perchanv1(dt)
           call perchanv1(h)
        endif
      endif
C
      if(IDB.eq.2*IM-3)then
        iwave=1
        if(Waveupdat_for_Circ)then
c be sure that angle is in correct orientation
c load variables needed for bbl into pom sized arrays
          waveper=Pass_Period
          if(waveper.ne.0)then
             omega=2.*pi/waveper
          else
             stop 'waveper'
          endif
          if(ibcon.eq.0)then
            call perchandb(Intp_Height_Circ,Nx_max,NY_max)
            call perchandb(Intp_Wavenum_Circ,Nx_max,NY_max)
            call perchandb(Intp_Theta_Circ,Nx_max,NY_max)
            call perchandb(Intp_Cg_Circ,Nx_max,NY_max)
            call perchandb(Intp_C_Circ,Nx_max,NY_max)
            call perchandb(Intp_diss_circ,Nx_max,Ny_max)
            if(wave_to_circ_roller)then
            call perchandb(Intp_dissr_circ,Nx_max,Ny_max)
            call perchandb(Intp_enr_circ,Nx_max,Ny_max)
            endif
          endif
          call averw(intp_height_circ,nav,nx_circ,ny_circ,ibcon)
          call averw(intp_wavenum_circ,nav,nx_circ,ny_circ,ibcon)
          call averw(intp_theta_circ,nav,nx_circ,ny_circ,ibcon)
          call averw(intp_cg_circ,nav,nx_circ,ny_circ,ibcon)
          call averw(intp_c_circ,nav,nx_circ,ny_circ,ibcon)
          call averw(intp_diss_circ,nav,nx_circ,
     *          ny_circ,ibcon)
          if(wave_to_circ_roller)then
c          call averw(intp_dissr_circ,nav,nx_circ,
c     *          ny_circ,ibcon)
          call averw(intp_enr_circ,nav,nx_circ,
     *          ny_circ,ibcon)
          endif
c set surface roughness length from wave height, water depth
          if(z0sflg.ne.0.e0)then
            do i=2,IMM1
              do j=2,JMM1
                z0s(i,j)=min(abs(z0sflg),.5*dt(i,j))
              enddo
            enddo
          else if(isurf.eq.0)then
            do j=2,JMM1
              ju=2*j-2
              do i=2,IMM1
                iv=2*i-2
                z0s(i,j)=min(wfact*Intp_Height_Circ(iv,ju),.5*dt(i,j))
              enddo
            enddo
          else
            do j=2,JMM1
              do i=2,IMM1
                z0s(i,j)=0.
              enddo
            enddo
          endif
          do j=2,JMM1
            ju=2*j-2
            do i=2,IMM1
              iv=2*i-2
              hrms(i,j)=Intp_Height_Circ(iv,ju)
              kk(i,j)=abs(Intp_Wavenum_Circ(iv,ju))
              theta(i,j)=(Intp_Theta_Circ(iv,ju))*dtor-rot(i,j)
            enddo
          enddo
          do i=1,IDB
            do j=1,JDB
              thdble(i,j)=(Intp_Theta_Circ(i,j))*dtor-angle(i,j)
              intp_c_circ(i,j)=abs(intp_c_circ(i,j))
              intp_cg_circ(i,j)=abs(intp_cg_circ(i,j))
              intp_diss_circ(i,j)=-abs(intp_diss_circ(i,j))/1000.
            enddo
          enddo
c update forcing from wave module 
c 1 and IDB are on boundaries
c if alongshore bc's are periodic make sure that forcing is also:
c grid is double size, 
c masking is not currently consistent with this, Assumes that
c xx is offshore distance
          do i=1,IDB
            do j=1,JDB
              cthe(i,j)=cos(thdble(i,j))
              sthe(i,j)=sin(thdble(i,j))
              e(i,j)=.125*grav*Intp_Height_Circ(i,j)**2
            enddo
          enddo
          do j=1,JDB
            do i=1,IDB
               era(i,j)=0.
               er2(i,j)=0.
               er(i,j)=0.
            enddo
          enddo
          if(wave_to_circ_roller)then
            do i=IDB-1,1,-1
              do j=1,JDB-1
                Er(i,j)=Intp_enr_circ(i,j)/1000.
c                epsr(i,j)=abs(Intp_dissr_circ(i,j))
                er2(i,j)=2.*er(i,j)
                era(i,j)=er2(i,j)*cthe(i,j)*sthe(i,j)
              enddo
              if(ibcon.eq.0)then
                 Er(i,JDB)=Er(i,1)
                 er2(i,JDB)=er2(i,1)
                 era(i,JDB)=era(i,1)
              else
C 
                write(0,*)
     *         'Rollers for open boundaries or boxes not done'
c this needs to be checked. should be easy to fix with rollers
c calculated with appropriate bc in wave module
                stop 'roller bc'
              endif
            enddo
          endif
          do j=1,JDB
             mx(IDB,j)=0.
             my(IDB,j)=0.
             mx1(IDB,j)=0.
             my1(IDB,j)=0.
             mm(IDB,j)=0.
             do i=IDB-1,1,-1
               mx(i,j)=(e(i,j))/(Intp_c_Circ(i,j))*
     *             cthe(i,j)*fact(i,j)
               my(i,j)=(e(i,j))/abs(Intp_c_Circ(i,j))*
     *             sthe(i,j)*fact(i,j)
               mx1(i,j)=(er2(i,j)+e(i,j))/abs(Intp_c_Circ(i,j))*
     *             cthe(i,j)*fact(i,j)
               my1(i,j)=(er2(i,j)+e(i,j))/abs(Intp_c_Circ(i,j))*
     *             sthe(i,j)*fact(i,j)
               mm(i,j)=(er2(i,j)+e(i,j))/abs(Intp_c_Circ(i,j))*fact(i,j)
            enddo
          enddo          

          if(ibcon.eq.0)then
            call perchandb(mx1,idb,jdb)
            call perchandb(my1,idb,jdb)
            call perchandb(mx,idb,jdb)
            call perchandb(my,idb,jdb)
            call perchandb(era,idb,jdb)
            call perchandb(er2,idb,jdb)
          endif 
          do j=2,JMM1
            ju=2*j-2
            jup=2*j-1
            jum=2*j-3
            do i=2,IMM1
              iv=2*i-2
              ivp=2*i-1
              ivm=2*i-3
              w0(i,j)=(mx1(ivp,ju)-mx1(ivm,ju))/dx(i,j)
     *          +(my1(iv,jup)-my1(iv,jum))/dy(i,j)
            enddo
          end  do
          do j=2,JMM1
            jum=2*j-3
            ju=2*j-2
            jup=2*j-1
            jpp=j+1
            jmm=j-1
            do i=3,IMM1
              ium=2*i-4
              iu=2*i-3
              iup=2*i-2
              ipp=i+1
              imm=i-1
!
              ddxm=.25*(dx(i,j)+dx(imm,j)+dx(i,jmm)+dx(imm,jmm))
              ddxp=.25*(dx(i,j)+dx(imm,j)+dx(i,jpp)+dx(imm,jpp))
              s1u(i,j)=-ddbl(iu,ju)*.5*(e(iup,ju)/
     *          ddbl(iup,ju)*dy(i,j)-
     *          e(ium,ju)/ddbl(ium,ju)*dy(imm,j))/aru(i,j)
!
!
              sxxrx=(er2(iup,ju)*cthe(iup,ju)**2*dy(i,j)-
     *           er2(ium,ju)*cthe(ium,ju)**2*dy(imm,j))/aru(i,j)
              sxyry=(era(iu,jup)*ddxp-era(iu,jum)*ddxm)/aru(i,j)      
              if(JM.eq.3)then
                if(abs(sxyry).gt.small )write(0,*)'sxyry',i,j,sxyry
                    sxyry=0.
              endif
              wu1(i,j)=((intp_diss_circ(iu,ju)*cthe(iu,ju)/
     *           intp_c_circ(iu,ju)*fact2(iu,ju))+
     *           (sxxrx+sxyry)*fact2(iu,ju))
            enddo
          enddo
c u computed from i=3,imm1, j=2,imm1
          if(JM.gt.3)then
            do j=3,JMM1
              jvm=2*j-4
              jv=2*j-3
              jvp=2*j-2
              jpp=j+1
              jmm=j-1
              do i=2,IMM1
                ivm=2*i-3
                iv=2*i-2
                ivp=2*i-1
                ipp=i+1
                imm=i-1
                ddym=.25*(dy(i,j)+dy(imm,j)+dy(i,jmm)+dy(imm,jmm))
                ddyp=.25*(dy(i,j)+dy(ipp,j)+dy(i,jmm)+dy(ipp,jmm))
                ddxm=.25*(dx(i,j)+dx(imm,j)+dx(i,jmm)+dx(imm,jmm))
                ddxp=.25*(dx(i,j)+dx(imm,j)+dx(i,jpp)+dx(imm,jpp))
!
              s1v(i,j)=-ddbl(iv,jv)*.5*(e(iv,jvp)/
     *          ddbl(iv,jvp)*dx(i,j)-
     *          e(iv,jvm)/ddbl(iv,jvm)*dx(i,jmm))/arv(i,j)
              syyry=(er2(iv,jvp)*sthe(iv,jvp)**2*dx(i,j)-
     *           er2(iv,jvm)*sthe(iv,jvm)**2*dx(i,jmm))/arv(i,j)
!
              sxyrx=(era(ivp,jv)*ddyp-era(ivm,jv)*ddym)/arv(i,j)
              wv1(i,j)=(intp_diss_circ(iv,jv)*sthe(iv,jv)/
     *               intp_c_circ(iv,jv)*fact2(iv,jv)+
     *               (sxyrx+syyry)*fact2(iv,jv))
!
              enddo
            enddo
c periodic
            if(ibcon.eq.0)then
              j=2
              jvm=JDB-1
              jv=2*j-3
              jvp=2*j-2
              jpp=j+1
              jmm=j-1
              do i=2,IMM1
                ivm=2*i-3
                iv=2*i-2
                ivp=2*i-1
                ipp=i+1
                imm=i-1
                ddym=.25*(dy(i,j)+dy(imm,j)+dy(i,jmm)+dy(imm,jmm))
                ddyp=.25*(dy(i,j)+dy(ipp,j)+dy(i,jmm)+dy(ipp,jmm))
              s1v(i,j)=-ddbl(iv,jv)*.5*(e(iv,jvp)/
     *          ddbl(iv,jvp)*dx(i,j)-
     *          e(iv,jvm)/ddbl(iv,jvm)*dx(i,jmm))/arv(i,j)
                syyry=(er2(iv,jvp)*sthe(iv,jvp)**2*dx(i,j)-
     *             er2(iv,jvm)*sthe(iv,jvm)**2*dx(i,jmm))/arv(i,j)
!
                sxyrx=(era(ivp,jv)*ddyp-era(ivm,jv)*ddym)/arv(i,j)
!
                 wv1(i,j)=(intp_diss_circ(iv,jv)*sthe(iv,jv)/
     *             intp_c_circ(iv,jv)*fact2(iv,jv)+
     *             (sxyrx+syyry)*fact2(iv,jv))
              enddo
            endif
          else
c 2d
            j=2
            jv=2
            jmm=2
            jpp=2
            jvm=2
            jvp=2
            ju=2
            do i=2,IMM1
              ivm=2*i-3
              iv=2*i-2
              ivp=2*i-1
              ipp=i+1
              imm=i-1
              ddym=.25*(dy(i,j)+dy(imm,j)+dy(i,jmm)+dy(imm,jmm))
              ddyp=.25*(dy(i,j)+dy(ipp,j)+dy(i,jmm)+dy(ipp,jmm))
              ddxm=.25*(dx(i,j)+dx(imm,j)+dx(i,jmm)+dx(imm,jmm))
              ddxp=.25*(dx(i,j)+dx(imm,j)+dx(i,jpp)+dx(imm,jpp))
!
              syyry=0.
              sxyrx=(era(ivp,jv)*ddyp-era(ivm,jv)*ddym)/arv(i,j)
!
              wv1(i,j)=intp_diss_circ(iv,jv)*sthe(iv,jv)/
     *               intp_c_circ(iv,jv)*fact2(iv,jv)+
     *               sxyrx*fact2(iv,jv)
              s1v(i,j)=0.0
            enddo
          endif
        endif
      else
        iwave=0
        do i=1,IM
          do j=1,JM
            wbu(i,j)=0.
            wu1(i,j)=0.
            wbv(i,j)=0.
            wv1(i,j)=0.
            omu(i,j)=0.
            w0(i,j)=0.
            omv(i,j)=0.
            ubotw(i,j)=0.
            wavg(i,j)=0.
            w(i,j,1)=0.
            mx(i,j)=0.
            my(i,j)=0.
            mm(i,j)=0.
            wvbody(i,j)=0.
            wubody(i,j)=0.
            ubotw(i,j)=0.
            theta(i,j)=0.
            hrms(i,j)=0.
            kk(i,j)=0.
          enddo
        enddo
      endif           
c do every call
      if(iwave.eq.1)then
        if(JM.eq.3)then
          do j=2,JMM1
            jv=2
            ju=2
            jmm=2
            jpp=2
            do i=2,IMM1
              iu=2*i-3
              iv=2*i-2
              ipp=i+1
              imm=i-1
              ddym=.25*(dy(i,j)+dy(imm,j)+dy(i,jmm)+dy(imm,jmm))
              ddyp=.25*(dy(i,j)+dy(ipp,j)+dy(i,jmm)+dy(ipp,jmm))
              s2=.5*my(iu,ju)*((va(i,j)+va(i,jpp))*dy(i,j)-
     *          (va(imm,j)+va(imm,jpp))*dy(imm,j))/aru(i,j)
              wbu(i,j)=-(s1u(i,j)+s2)*fact2(iu,ju)
              s2=-.5*mx(iv,jv)*((va(i,j)+va(ipp,j))*ddyp-
     *           (va(i,j)+va(imm,j))*ddym)/arv(i,j) 
              wbv(i,j)=-s2*fact2(iv,jv)
            enddo
          enddo
        else
          do j=2,JMM1
            ju=2*j-2
            jv=2*j-3
            jpp=j+1
            jmm=j-1
            do i=2,IMM1
              iu=2*i-3
              iv=2*i-2
              ipp=i+1
              imm=i-1
              ddym=.25*(dy(i,j)+dy(imm,j)+dy(i,jmm)+dy(imm,jmm))
              ddyp=.25*(dy(i,j)+dy(ipp,j)+dy(i,jmm)+dy(ipp,jmm))
              ddxm=.25*(dx(i,j)+dx(imm,j)+dx(i,jmm)+dx(imm,jmm))
              ddxp=.25*(dx(i,j)+dx(imm,j)+dx(i,jpp)+dx(imm,jpp))
              s2=.5*my(iu,ju)*((va(i,j)+va(i,jpp))*dy(i,j)-
     *          (va(imm,j)+va(imm,jpp))*dy(imm,j)-
     *          (ua(i,jpp)+ua(i,j))*ddxp+
     *          (ua(i,jmm)+ua(i,j))*ddxm)/aru(i,j)
              wbu(i,j)=-(s1u(i,j)+s2)*fact2(iu,ju)
              s2=-.5*mx(iv,jv)*((va(i,j)+va(ipp,j))*ddyp-
     *           (va(i,j)+va(imm,j))*ddym-(ua(i,j)+ua(ipp,j))*dx(i,j)
     *           +(ua(i,jmm)+ua(ipp,jmm))*dx(i,jmm))/arv(i,j) 
              wbv(i,j)=-(s2+s1v(i,j))*fact2(iv,jv)
            enddo
          enddo
        endif
      endif
      if(iwind.eq.1)then
        read(13,*,end=900,err=900)tin,taux,tauy
        windinu=-taux/rhoref
        windinv=-tauy/rhoref
      endif
      if(itflux.eq.1)then
c units should be correct for temperature or potential density, sign
c changed here
        read(14,*,end=900,err=900)tin,tsw,tflux
        tswin=-tsw
        tfluxin=-tflux
        if(istrat.eq.1)then
          tswin=tswin/rhoref
          tfluxin=tfluxin/rhoref
        endif
      endif
      if(iwave.eq.1)then
        do j=2,JMM1
          do i=2,IMM1
            ubotw(i,j)=(hrms(i,j)*omega*.5/sinh(kk(i,j)*dt(i,j)))
            wavg(i,j)=(w(i,j,1)+w0(i,j)*tramp*ramp)*.5
            w(i,j,1)=w0(i,j)*tramp*ramp
          enddo
        enddo
        do j=2,JMM1
          jvm=2*j-4
          jv=2*j-3
          jvp=2*j-2
          jum=2*j-3
          ju=2*j-2
          jup=2*j-1
          jpp=j+1
          jmm=j-1
          do i=3,IMM1
            iv=2*i-2
            ivm=iv-1
            ivp=iv+1
            iu=2*i-3
            ium=iu-1
            iup=iu+1
            ipp=i+1
            imm=i-1
            omu(i,j)=2.*((mx1(iup,ju)-mx1(ium,ju))/(dx(i,j)+dx(imm,j))
     *         +(my1(iu,jup)-my1(iu,jum))/(dy(i,j)+dy(imm,j)))
     *         *tramp*ramp
          enddo
        enddo
        if(JM.gt.3)then
          do j=3,JMM1
            jvm=2*j-4
            jv=2*j-3
            jvp=2*j-2
            jpp=j+1
            jmm=j-1
            do i=2,IMM1
              iv=2*i-2
              ivm=iv-1
              ivp=iv+1
              ipp=i+1
              imm=i-1
              omv(i,j)=2.*((mx1(ivp,jv)-mx1(ivm,jv))/(dx(i,j)+dx(i,jmm))
     *           +(my1(iv,jvp)-my1(iv,jvm))/(dy(i,j)+dy(i,jmm)))
     *         *tramp*ramp
            enddo
          enddo
          if(ibcon.eq.0)then
            j=2 
            jvm=JDB-1
            jv=2*j-3
            jvp=2*j-2
            jpp=j+1
            jmm=j-1
            do i=2,IMM1
              iv=2*i-2
              ivm=iv-1
              ivp=iv+1
              ipp=i+1
              imm=i-1
              omv(i,j)=2.*((mx1(ivp,jv)-mx1(ivm,jv))/(dx(i,j)+dx(i,jmm))
     *           +(my1(iv,jvp)-my1(iv,jvm))/(dy(i,j)+dy(i,jmm)))
     *         *tramp*ramp
            enddo
          endif
        else
          j=2 
          jvm=2
          jv=2
          jvp=2
          jpp=2
          jmm=2
          do i=2,IMM1
            iv=2*i-2
            ivm=iv-1
            ivp=iv+1
            ipp=i+1
            imm=i-1
!
            omv(i,j)=2.*((mx1(ivp,jv)-mx1(ivm,jv))/(dx(i,j)+dx(i,jmm))
     *          )*tramp*ramp
          enddo
        endif

        if(mod(iint,iprint).eq.0)then
          do i=2,IMM1
            iv=2*i-2
            write(300,'(15e18.10)')xx(iv,2),wu1(i,2),wbu(i,2),wv1(i,2),
     *       wbv(i,2),w0(i,2),mx(iv,2),my(iv,2),mx1(iv,2),my1(iv,2),
     *         theta(i,2)
          enddo
        endif
c          open(unit=198,file='force.out',status='unknown', 
c     *     form='unformatted')
c          write(198)(wu1(i,2),i=3,IMM1)
c          write(198)(wbu(i,2),i=3,IMM1)
c          write(198)(wv1(i,2),i=2,IMM1)
c          write(198)(w0(i,2),i=2,IMM1)
c          write(198)(zeros(i,2),i=2,IMM1)
c          write(198)(theta(i,2),i=2,IMM1)
c          write(198)(kk(i,2),i=2,IMM1)
c          write(198)(e(2*i-2,2),i=2,IMM1)
c          write(198)(er(2*I-2,2),I=2,IMM1)
c          write(198)(mm(2*I-2,2),I=2,IMM1)
c          write(198)(zeros(i,2),i=2,IMM1)
c          close(198)
        if(iint.le.1 .or. Sediupdat_for_Circ )then
           xl=0.
           do i=2,IMM1
             xl=xl+dx(i,2)
             xout(i)=xl-.5*dx(i,2)
           enddo
           yl=0.
           do j=2,JMM1
             yl=yl+dy(2,j)
             yout(j)=yl-.5*dy(2,j)
           enddo
           write(*,'(2i5,2f12.4)')IMM2,JMM2,xl,yl
         if(iint.le.1)open(unit=198,file='topo.out',status='unknown',
     *     form='unformatted')
         write(198)IMM2,JMM2,xl,yl
         write(198)((h(i,j),i=2,IMM1),j=2,JMM1)
         write(198)(xout(i),i=2,IMM1)
         write(198)(yout(j),j=2,JMM1)
         close(198)
        endif
      endif
      Waveupdat_for_circ=.false.
      sediupdat_for_circ=.false.
      return
 900  write(0,*)'last wind time: ',tin
      stop 'wind file'
      end
C
      subroutine init_bbl
      include "pom2k.h"
      include "bblcom.h"
cpn note this module is in cgs
C This submodel calculates mu=ustarwm/ustarcw, epsilon=ustarc/ustarcw
C and sigma=ub/ustarcw based on an eddy viscosity profile
C for the wave that is linear increasing above znot and constant above
C z1.

C Reference: Styles, R. and S. M. Glenn, "An optimized combined wave and
C            current model for arbitrary bed roughness", In prep. to be
C            submitted to J. Atmospheric and Oceanic Tech.

C nd      -nondimensional
C INPUT to bbl model:
C omega   - wave radian frequency (s-1)
C ub      - bed wave orbital velocity (cm/s)
C ab      - bed wave excursion amplitude (cm)
cpn if calculated bed roughness
C d       - sediment grain diameter (cm)  ! not used in this version
C dd      - representative mean grain diameter to calculate ripple
C           properties (cm)
C s       - relative sediment density = sed. density/fluid density
C           ! not used in this version (nd)
C ss      - representative relative sediment density to calculate
C           ripple properties = sed. density/fluid density (nd)
cpn 
c input from circulation module
C ur      - mean current at a known height above the bed, zr (cm/s)
C zr      - height of mean current (cm)
C phicw   - angle between the wave and current (radians)

C OUTPUT:
C sigma   - ratio of bed wave orbital velocity, ub, over combined wave
C           and current shear stress, ustarcw
C mu      - ustarwm/ustarcw (nd)
C epsilon - ustarc/ustarcw (nd)
C ro      - internal friction Rossby number = ustarcw/(omega*znot) (nd)
C eta     - ripple height (cm)
C lambda  - ripple length (cm)
C znot    - hydraulic roughness (cm)
C znotc   - apparent hydraulic roughness (cm)
C ustarc  - time average bottom shear stress (cm/s) for use in POM
C ustarwm - maximum bottom shear stress for the wave (cm/s)
C ustarcw - maximum combined bottom shear stress (cm/s)

C set constants & parameters

      real delta,star
      real ber,bei,berp,beip,ker,kei,kerp,keip,x
      complex b1,k1,b1p,k1p



      alphab=1.e0       ! non-dimensional closure constant (nd)
      dd=0.04e0         ! particle diameter (cm/s)
      ss=2.65e0         ! relative sediment density (nd)
      nu=0.0119e0       ! viscosity of sea water at 15C (cm^2/s)
      g=grav*100.e0     ! acceleration due to gravity (cm/s^2)
Cpn unchanged throughout
      z1p=alphab                ! nd-height of the inner layer (nd)
      delta=1.e0/sqrt(2.e0*z1p) ! (nd)
      mp=cmplx(delta,delta)     ! (nd)
      tol=1.0e-8                ! tolerence (nd)
      ustarcdef=2.0e0           ! default ustarc (cm/s)
      znotdef=z0b*100.e0
      shldcr=0.04e0             ! critical shields parameter for initiation of
                                ! sediment motion (set to a default value) (nd)
      znotcdef=z0b*100.e0       ! default znotc (cm)
      n=50                      ! max # of iterations for bisection method (nd)
cpn
      x=2.e0*sqrt(z1p)
      if(x .le. 8.e0) then
        call klvn2(x,ber,bei,ker,kei,berp,beip,kerp,keip,pi)
      else
        call kel2(x,ker,kei,ber,bei,kerp,keip,berp,beip,pi)
      endif
      b1=cmplx(ber,bei)
      k1=cmplx(ker,kei)
      b1p=cmplx(berp,beip)/sqrt(z1p)
      k1p=cmplx(kerp,keip)/sqrt(z1p)
      llb=mp*b1+b1p
      nnb=mp*k1+k1p
      if(zntflg.eq.0)then
        star=dd/(4.e0*nu)*sqrt((ss-1.e0)*g*dd)
        call cshld(star,shldcr)
        print*,'shldcr',shldcr
      endif
      return
      end
C
      subroutine init_pom
      include 'pom2k.h'
! for netcdf support
!     include 'pom2k.n'
      include 'combal3.h'
      include 'pass.h'
      integer i,j
      namelist/chars/title,netcdf_file,time_start
      namelist/run1/mode,nadv1,nadv2,nitera1,nitera2,sw,
     *   nread,dte,dti,isplit
      namelist/run2/lramp,f0,ibcon,ibc,rstrt,ton,ave,toff
      namelist/force/xl1,xl2,xl3,xl4,
     *   windinu,windinv
      namelist/output/cm,ncmout,io,jo,ko,prtd1,prtd2,swtch
      namelist/strat/istrat,rhoref,tbias,sbias,tswin,tfluxin
      namelist/stres/cbcmin,cbcmax,z0b,horcon,tprni,umol,isurf,
     *   z0sflg,wfact,ibot,zref,zntflg,iprod
      namelist/misc/hmax,vmaxl,slmax,kl1,kl2,ntp,nbct,nbcs,ispadv,
     *   smoth,alpha,nav
      namelist/bals/ibal,balout,balave,idiv
      integer k,lread,nstep
      real cflm,cm,rstrt
      open(unit=11,file='pom.input',status='old')
C***********************************************************************
C
C     initialization of default filenames and constants:
C
C     NOTE that the array sizes IM, JM and KB should be set in 
C     imjmkb.h and must be consistent with the sizes in pass.h
C
C-----------------------------------------------------------------------
C
      title='Run 1                                   ' ! run's title
C
C-----------------------------------------------------------------------
C
c       netcdf_file='pom2k.nc'  ! netCDF output file
       netcdf_file='nonetcdf'  ! disable netCDF output
C
C-----------------------------------------------------------------------
C    Mode
C        2        2-D calculation (bottom stress calculated in advave)
C
C        3        3-D calculation (bottom stress calculated in 
C                 wave-current bbl model or in profu,v)
C
C        4        3-D calculation with t and s held fixed
C
      mode=3
C
C-----------------------------------------------------------------------
C
C     Advection scheme:
C
C      nadv     Advection scheme
C
C        1       Centred scheme, as originally provide in POM
C        2       Smolarkiewicz iterative upstream scheme, based on
C                subroutines provided by Gianmaria Sannino and Vincenzo
C                Artale
c    nadv1 for t, s or potential density
c    nadv2 for q2, q2l
C
      nadv1=2
      nadv2=2
C
C-----------------------------------------------------------------------
C
C     Constants for Smolarkiewicz iterative upstream scheme.
C
C     Number of iterations. This should be in the range 1 - 4. 1 is
C     standard upstream differencing; 3 adds 50% CPU time to POM:
C
      nitera1=2
      nitera2=2
C
C     Smoothing parameter. This should preferably be 1, but 0 < sw < 1
C     gives smoother solutions with less overshoot when nitera > 1:
C
      sw=0.8e0
C
C-----------------------------------------------------------------------
C
C     Index to indicate whether run to start from restart file
C     (nread=0: no restart input file; nread>1: restart input file):
C     for 3D runs nread<0 reads 2D initialization and spreads
C     results in alongshore direction. Useful for initializing
C     nearly alongshore uniform (almost straight beaches) 3D runs.
C
      nread=0
C
C-----------------------------------------------------------------------
C
C     External (2-D (horizontal)) time step (secs.):
C
      dte=0.e0
C     Internal (3-D) time steps (secs.)
      dti=0.e0
C
C-----------------------------------------------------------------------
C
C     <Internal (3-D) time step>/<External (2-D) time step>
C     (dti/dte; dimensionless):
C
      isplit=30
C
C-----------------------------------------------------------------------
C
C     Date and time of start of initial run of model in format (i.e.
C     UDUNITS convention)
C
C       YYYY-MM-DD HH:MM:SS <+/->HH:MM
C
C     where "<+/->HH:MM" is the time zone (positive eastwards from
C     Coordinated Universal Time). Insert your own date
C     and time as required:
C
      time_start='2005-12-18 02:00:00 +08:00'
C-----------------------------------------------------------------------
C
              cm=.05             ! 'Current meter' time series 
                                 ! output interval (hours)
              ncmout=0           ! number of points for time series
              io=0               ! arrays of size ncmout, 
                                 ! for i,j,k for time series
                                 ! output locations (POM coordinates)
              jo=0               ! note that initializing an array
                                 ! this way requires fortran 90
              ko=0
              prtd1=0.5e0        ! Initial print interval (hours)
              prtd2=1.e0         ! Final print interval (hours)
              swtch=1000.e0      ! Time (h) to switch from prtd1 to prtd2 
              ton=.2             ! forcing ramp up time (h) from TIME=0.
              toff=.2            ! shut off time for forcing
                                 ! perturbations (h) from start of 
                                 ! run (not TIME=0).
C
C-----------------------------------------------------------------------
C
C     Logical for inertial ramp (.true. if inertial ramp to be applied
C     to wind stress and baroclinic forcing, otherwise .false.)
C
      lramp=.false.
C     default is no rotation
      f0=0.
C     ibcon boundary condition flag      
C     ibcon=0 periodic channel with option of offshore wall or
C         off shore bc read from file (from larger scale model run)
C     ibcon=1 standard POM calls to subroutine bcond. Land boundaries
C         are half slip (includes half slip box)
C     ibcon=2 free slip box
      ibcon=0
C     ibc flag for reading off shore boundary values for u, v and
C     stratification from file (usually one way nesting from larger
C     scale model, used with ibcon=0. 
C     ibc = 0 do not read boundary values
C     ibc = 1 read one fixed value for each boundary point
C     ibc = 2 read boundary values at each time step
      ibc=0
      iread=0              ! read initial conditions from files
    
C-----------------------------------------------------------------------
C
C     Reference density (recommended values: 1025 for seawater,
C     1000 for freswater; S.I. units):
C
      rhoref=1025.e0
      itflux=0
      tswin=0.e0
      tfluxin=0.e0
C
C-----------------------------------------------------------------------
C
      tbias=0.e0         ! Temperature bias (deg. C)
C
C-----------------------------------------------------------------------
C
      sbias=0.e0         ! Salinity bias
C
C-----------------------------------------------------------------------
C
      grav=9.806e0       ! gravity constant (S.I. units)
C
C-----------------------------------------------------------------------
C
      kappa=0.4e0        ! von Karman's constant
C
C-----------------------------------------------------------------------
C
      z0b=.01e0          ! Bottom roughness (metres)
      ibot=0
C
C-----------------------------------------------------------------------
Cpn
      isurf=0
      wfact=.5
      z0sflg=0.          ! Surface roughness flag (>0 meters)
                         ! if(isurf.eq.0) 0 use min(wfact*hrms,.5*DT),
                         ! Craig and Banner
                         ! else use z0s=z0sflg (possibly zero)
C
      cbcmin=.0025e0     ! Minimum bottom friction coeff.
C
C-----------------------------------------------------------------------
C
      cbcmax=1.e0        ! Maximum bottom friction coeff.
C
C-----------------------------------------------------------------------
      zref = 0.2
      zntflg = 1         ! flag for bbl model
      iprod = 1          ! smooth production in profq
C
      horcon=0.2e0       ! horizontal diffusivity coeff.
C Smagorinski diffusion can be added
C
C-----------------------------------------------------------------------
C
C     Inverse horizontal turbulent Prandtl number
C     (ah/am; dimensionless):
C
C     NOTE that tprni=0.e0 yields zero horizontal diffusivity!
C
      tprni=.0e0
C
C-----------------------------------------------------------------------
C
C     Background viscosity used in subroutines profq, proft, profu and
C     profv (S.I. units):
C
      umol=2.e-7
C
C-----------------------------------------------------------------------
C
C     Maximum depth used in radiation boundary condition in subroutine
C     bcond (metres):
C
      hmax=4500.e0
C
C-----------------------------------------------------------------------
C
C     Maximum magnitude of vaf (used in check that essentially tests
C     for CFL violation):
C
      vmaxl=100.e0
C
C-----------------------------------------------------------------------
C
C     Maximum allowable value of:
C
C       <difference of depths>/<sum of depths>
C
C     for two adjacent cells (dimensionless). This is used in subroutine
C     slpmax. If >= 1, then slpmax is not applied:
C
      slmax=2.e0
C
C-----------------------------------------------------------------------
C
C     Integers defining the number of logarithmic layers at the   
C     surface and bottom (used by subroutine depth). The number of
C     logarithmic layers are kl1-2 at the surface and KB-kl2-1
C     at the bottom. For no log portions, set kl1=2 and kl2=KB-1:
C
      kl1=2
      kl2=KB-1
C
C-----------------------------------------------------------------------
C
C     Water type, used in subroutine proft.
C
C       ntp    Jerlov water type
C
C        1            i
C        2            ia
C        3            ib
C        4            ii
C        5            iii
C
      ntp=5
C
C-----------------------------------------------------------------------
C
C     Surface temperature boundary condition, used in subroutine proft:
C
C       nbct   prescribed    prescribed   short wave
C              temperature      flux      penetration
C
C        1        no           yes           no
C        2        no           yes           yes
C        3        yes          no            no
C        4        yes          no            yes
C
      nbct=2
C
C-----------------------------------------------------------------------
C
C     Surface salinity boundary condition, used in subroutine proft:
C
C       nbcs   prescribed    prescribed
C               salinity      flux
C
C        1        no           yes
C        3        yes          no
C
C     NOTE that only 1 and 3 are allowed for salinity.
C
      nbcs=1
C
C-----------------------------------------------------------------------
C
C     Step interval during which external (2-D) mode advective terms are
C     not updated (dimensionless):
C
      ispadv=1
C
C-----------------------------------------------------------------------
C
C     Constant in temporal filter used to prevent solution splitting
C     (dimensionless):
C
      smoth=0.10e0
C
C-----------------------------------------------------------------------
C
C     Weight used for surface slope term in external (2-D) dynamic
C     equation (a value of alpha = 0.e0 is perfectly acceptable, but the
C     value, alpha=.225e0 permits a longer time step):
C
      alpha=0.225e0
C
C-----------------------------------------------------------------------
C
C
C
C     End of default constants
C***********************************************************************
C
C     Read and Calculate some constants:
C
      read(11,chars)
      write(*,chars)
      read(11,run1)
c      write(0,*)nadv1,nadv2,nitera1,nitera2
      if(dte.eq.0.e0 .and. dti.eq.0.e0)stop 'set dt'
      if(dte.ne.0.e0)then
      dti=dte*float(isplit)
      else
      dte=dti/float(isplit)
      endif
        nstep=N_interval_CallCirc*Master_dt/dti
        dti=N_interval_CallCirc*Master_dt/real(nstep)
        dte=dti/real(isplit)
        write(*,*)'dti = ',dti,'dte = ',dte
      write(*,run1)
      hours=Total_Time/3600.
      dte2=dte*2
      dti2=dti*2
      read(11,run2)
      write(*,run2)
      read(11,output)
      write(*,output)
      icm=nint(cm*3600./dti)
      iave=nint(ave*3600./dti)
      write(*,*)'icm=',icm,' iave=',iave
      read(11,strat)
      if(mode.eq.4)istrat=0
      if(istrat.ne.0)write(*,strat)
c note that input is >0 (if temperature) or { <0 (if sigma_theta) }
c    for warming
c    change sign to conform to original POM convention
      tswin=-tswin
      tfluxin=-tfluxin
      if(istrat.eq.1)then
        tswin=tswin/rhoref
        tfluxin=tfluxin/rhoref
      endif
c note input wind now 
      read(11,stres)
      write(*,stres)
      read(11,misc)
      write(*,misc)
Cpn   nearshore flags
cpn ibcon=0 periodic, free slip
C the following bc's are set in bcond
cpn ibcon=1 pom default bcond, half slip (includes box half slip)
cpn ibcon=2 box, free slip
C
      iend=max0(nint(Total_Time/dti),2)
      iprint=nint(prtd1*3600.e0/dti)
      iswtch=nint(swtch*3600.e0/dti)
      irstrt=nint(rstrt*3600.e0/dti)
      if(ave.eq.0.)iave=iend+10
      ibal=0
      balave=0.
      balout=0.
      idiv=1
      read(11,bals)
      if(ibal.eq.0)then
        ibalo=iend+10
        ibala=iend+10
      else
        ibalo=balout*3600/dti
        if(balave.ne.0)then
          ibala=balave*3600/dti
        else
          ibala=iend+10
        endif
      endif
      write(*,bals)
C
      ispi=1.e0/float(isplit)
      isp2i=1.e0/(2.e0*float(isplit))
C
C-----------------------------------------------------------------------
C
C     Initialise boundary arrays:
C
      do i=1,IM
        vabn(i)=0.e0
        vabs(i)=0.e0
        eln(i)=0.e0
        els(i)=0.e0
        do k=1,KB
          vbn(i,k)=0.e0
          vbs(i,k)=0.e0
          tbn(i,k)=0.e0
          tbs(i,k)=0.e0
          sbn(i,k)=0.e0
          sbs(i,k)=0.e0
        end do
      end do
C
      do j=1,JM
        uabe(j)=0.e0
        uabw(j)=0.e0
        ele(j)=0.e0
        elw(j)=0.e0
        do k=1,KB
          ube(j,k)=0.e0
          ubw(j,k)=0.e0
          tbe(j,k)=0.e0
          tbw(j,k)=0.e0
          sbe(j,k)=0.e0
          sbw(j,k)=0.e0
        end do
      end do
C
C-----------------------------------------------------------------------
C
C     Initialise 2-D and 3-D arrays for safety (this may be overwritten
C     later):
C
      do j=1,JM
        do i=1,IM
          uab(i,j)=0.e0
          vab(i,j)=0.e0
          elb(i,j)=0.e0
          etb(i,j)=0.e0
          e_atmos(i,j)=0.e0
          wusurf(i,j)=0.e0
          wvsurf(i,j)=0.e0
          wtsurf(i,j)=0.e0
          wssurf(i,j)=0.e0
          swrad(i,j)=0.e0
          drx2d(i,j)=0.e0
          dry2d(i,j)=0.e0
        end do
      end do
C
      do k=1,KBM1
        do j=1,JM
          do i=1,IM
            ub(i,j,k)=0.e0
            vb(i,j,k)=0.e0
          end do
        end do
      end do
C
C-----------------------------------------------------------------------
C
C     Set up sigma layers:
C
      call depth
C
C-----------------------------------------------------------------------
C
C set length scales for tapering wave mass flux
      xl1=20e0
      xl2=50e0
      xl3=20e0
      xl4=0.e0
      windinu=0.
      windinv=0.
      deltap=0.01
c     note that reading in a single number for windin u and windin v
c     implies a rectilinear grid, input should be surface stress
c     this is a change previously input was -surface stress 
      read(11,force)
      write(*,force)
      windinu=-windinu
      windinv=-windinv
C     calculate grid data from master input, 
C     set initial and lateral boundary conditions:
C     user supplied subroutine defining the problem
C     initial values if any set in setup
      call setup 
C
Cpn
C
C     Inertial period for temporal filter (hours):
C
      if(f0.ne.0)then
        period=(2.e0*pi)/abs(f0)/3600.e0
      else
        period=1.e-22
      endif
C
C     Initialise time:
C
      time0=0.e0
      time=0.e0
C
C     initialize additional arrays 
C
C     NOTE that lateral thermodynamic boundary conditions are often set
C     equal to the initial conditions and are held constant thereafter.
C     Users can of course create varable boundary conditions.
C
      do i=1,IM
        do j=1,JM
          ua(i,j)=uab(i,j)
          va(i,j)=vab(i,j)
          el(i,j)=elb(i,j)
          et(i,j)=etb(i,j)
          etf(i,j)=et(i,j)
          d(i,j)=h(i,j)+el(i,j)
          dt(i,j)=h(i,j)+et(i,j)
        end do
      end do
      if(ibcon.eq.0)then
         call perchanv1(d)
         call perchanv1(dt)
      endif
C
C
      do k=1,KBM1
        do i=1,IM
          do j=1,JM
            u(i,j,k)=ub(i,j,k)
            v(i,j,k)=vb(i,j,k)
          end do
        end do
      end do
C
Cpn
      if(istrat.ne.0)then
      do k=1,KBM1
        do i=1,IM
          do j=1,JM
            t(i,j,k)=tb(i,j,k)
            s(i,j,k)=sb(i,j,k)
          end do
        end do
      end do
        if(istrat.eq.2)then
          call dens(s,t,rho)
        else
          do k=1,KB
            do j=1,JM
              do i=1,IM
                rho(i,j,k)=t(i,j,k)
              enddo
             enddo
          enddo
        endif
C
        call baropg
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              drx2d(i,j)=drx2d(i,j)+drhox(i,j,k)*dz(k)
              dry2d(i,j)=dry2d(i,j)+drhoy(i,j,k)*dz(k)
            end do
          end do
        end do
      else
        do j=1,JM
          do i=1,IM
            drx2d(i,j)=0.
            dry2d(i,j)=0.
          end do
        end do
      endif
C
C     Calculate bottom friction coefficient:
C
      if(ibot.ne.0)then
        do j=2,JMM1
          do i=2,IMM1
            z0c(i,j)=z0b
            impflg(i,j)=1
          enddo
        enddo
      endif
      do j=2,JMM1
        do i=2,IMM1
          cbc(i,j)=(kappa/log(((1.e0+zz(KBM1))*h(i,j)+z0b)/z0b))**2
          cbc(i,j)=max(cbcmin,cbc(i,j))
C
C     If the following is invoked, then it is probable that the wrong
C     choice of z0b or vertical spacing has been made:
C
          cbc(i,j)=min(cbcmax,cbc(i,j))
        end do
      end do
      if(ibcon.eq.0)call perchanv1(cbc)
      if(ibot.eq.0)then
c initialize the wave current bbl module
        call init_bbl
      endif
C
C     Calculate external (2-D) CFL time step:
C
      cflm=1.e35
      do j=1,JM
        do i=1,IM
          tps(i,j)=0.5e0/sqrt(1.e0/dx(i,j)**2+1.e0/dy(i,j)**2)
     $               /sqrt(grav*(h(i,j)+small))*fsm(i,j)
          cflm=min(cflm,tps(i,j))
        end do
      end do
      write(*,*)'min external CFL time step: ',cflm,' dte: ',dte
C        Initial value of aam:
        do i=1,IM
          do j=1,JM
            aam2d(i,j)=horcon*(dx(i,j)/dx(IMM1,j))**2
            do k=1,KB
              aam(i,j,k)=horcon*(dx(i,j)/dx(IMM1,j))**2
            enddo
          enddo
        enddo
C
C     The following data are needed for a seamless restart. if nread=1,
C     data had been created by a previous run (see write(71) at end of
C     this program). nread=0 denotes a first time run.
C
        if(nread.ne.0)then
          if(nread .gt. 0) then
            open(unit=199,file='restart.in',status='old',
     *        form='unformatted')
            do lread=1,nread
              read(199) time0,
     $           wubot,wvbot,aam2d,ua,uab,va,vab,
     $           el,elb,et,etb,egb,
     $           utb,vtb,u,ub,w,v,vb,t,tb,s,sb,rho,
     $           adx2d,ady2d,advua,advva,
     $           km,kh,kq,l,q2,q2b,aam,q2l,q2lb,wusurf,wvsurf,z0c
C
            enddo
            close(199)
            do j=1,JM
              do i=1,IM
                d(i,j)=h(i,j)+el(i,j)
                dt(i,j)=h(i,j)+et(i,j)
              end do
            end do
C
            time=time0
          else
            call read2d
          endif
          Circupdat_for_wave = .true.
          call passit
        else 
          time=0.
          time0=0.
        endif
C
C-----------------------------------------------------------------------
C

      close(11)
      return
      end

      subroutine kel2(x,ker,kei,ber,bei,kerp,
     Z                   keip,berp,beip,pi)

C THIS SUB-PROGRAM CALCULATES THE KELVIN FUNCTIONS FOR ARGUMENTS
C GREATER THAN 8.
      implicit none
      real x,x8,x8m,ber,bei,ker,kei
      real berp,beip,kerp,keip
      real pi
      complex theta1,thetam,phi1,phim,argp,argm
      complex fofx,gofx

      x8=8.e0/x
      x8m=-8.e0/x

      theta1=cmplx(0.0e0,-0.3926991e0)+
     z    cmplx(0.0110486e0,-0.0110485e0)*x8+
     z    cmplx(0.0e0,-0.0009765e0)*x8**2+
     z    cmplx(-0.0000906e0,-0.0000901e0)*x8**3+
     z    cmplx(-0.0000252e0,0.0e0)*x8**4+
     z    cmplx(-0.0000034e0,0.0000051e0)*x8**5+
     z    cmplx(0.0000006e0,0.0000019e0)*x8**6

      thetam=cmplx(0.0e0,-0.3926991e0)+
     z    cmplx(0.0110486e0,-0.0110485e0)*x8m+
     z    cmplx(0.0e0,-0.0009765e0)*x8m**2+
     z    cmplx(-0.0000906e0,-0.0000901e0)*x8m**3+
     z    cmplx(-0.0000252e0,0.0e0)*x8m**4+
     z    cmplx(-0.0000034e0,0.0000051e0)*x8m**5+
     z    cmplx(0.0000006e0,0.0000019e0)*x8m**6

      phi1=cmplx(0.7071068e0,0.7071068e0)+
     z    cmplx(-0.0625001e0,-0.0000001e0)*x8+
     z    cmplx(-0.0013813e0,0.0013811e0)*x8**2+
     z    cmplx(0.0000005e0,0.0002452e0)*x8**3+
     z    cmplx(0.0000346e0,0.0000338e0)*x8**4+
     z    cmplx(0.0000117e0,-0.0000024e0)*x8**5+
     z    cmplx(0.0000016e0,-0.0000032e0)*x8**6

      phim=cmplx(0.7071068e0,0.7071068e0)+
     z    cmplx(-0.0625001e0,-0.0000001e0)*x8m+
     z    cmplx(-0.0013813e0,0.0013811e0)*x8m**2+
     z    cmplx(0.0000005e0,0.0002452e0)*x8m**3+
     z    cmplx(0.0000346e0,0.0000338e0)*x8m**4+
     z    cmplx(0.0000117e0,-0.0000024e0)*x8m**5+
     z    cmplx(0.0000016e0,-0.0000032e0)*x8m**6

      argm=-1./sqrt(2.e0)*x*cmplx(1.e0,1.e0)+thetam
      fofx=sqrt(pi/(2.e0*x))*exp(argm)
      ker=real(fofx)
      kei=imag(fofx)

      argp=1./sqrt(2.e0)*x*cmplx(1.e0,1.e0)+theta1
      gofx=1./sqrt(2.e0*pi*x)*exp(argp)
      ber=real(gofx)-kei/pi
      bei=imag(gofx)+ker/pi

      kerp=real(-fofx*phim)
      keip=imag(-fofx*phim)

      berp=real(gofx*phi1)-keip/pi
      beip=imag(gofx*phi1)+kerp/pI

      return
      end


      subroutine klvn2(x,ber,bei,ker,kei,berp,
     Z                    beip,kerp,keip,pi)
c this sub-program calculates the kelvin functions for arguments
c less than 8.
      implicit none
      real ker,kei,kerp,keip,ber,bei,berp
      real beip,x,x2,x8
      real pi

      x2=x/2.e0
      x8=x/8.e0

      ber=1.e0-64.e0*(x8**4)+113.77777774e0*(x8**8)-
     Z    32.36345652e0*(x8**12)+2.64191397e0*(x8**16)-
     Z    .08349609e0*(x8**20)+.00122552e0*(x8**24)-
     Z    .00000901e0*(x8**28)

      bei=16.e0*(x8**2)-113.77777774e0*(x8**6)+
     Z    72.81777742e0*(x8**10)-10.56765779e0*(x8**14)+
     Z    .52185615e0*(x8**18)-.01103667e0*(x8**22)+
     Z    .00011346e0*(x8**26)

      ker=-ber*log(x2)+pi/4.e0*bei-
     Z    .57721566e0-59.05819744e0*(x8**4)
     Z    +171.36272133e0*(x8**8)-60.60977451e0*(x8**12)
     Z    +5.65539121e0*(x8**16)-.19636347e0*(x8**20)
     Z    +.00309699e0*(x8**24)-.00002458e0*(x8**28)

      kei=-bei*log(x2)-pi/4.e0*ber+6.76454936e0*(x8**2)
     Z    -142.91827687e0*(x8**6)+124.23569650e0*(x8**10)
     Z    -21.30060904e0*(x8**14)+1.17509064e0*(x8**18)
     Z    -.02695875e0*(x8**22)+.00029532e0*(x8**26)

      berp=x*(-4.e0*(x8**2)+14.22222222e0*(x8**6)-
     Z    6.06814810e0*(x8**10)+.66047849e0*(x8**14)
     Z    -.02609253e0*(x8**18)+.00045957e0*(x8**22)
     Z    -.00000394e0*(x8**26))

      beip=x*(.5e0-10.66666666e0*(x8**4)+11.37777772e0*(x8**8)
     Z    -2.31167514e0*(x8**12)+.14677204e0*(x8**16)
     Z    -.00379386e0*(x8**20)+.00004609e0*(x8**24))

      kerp=-berp*log(x2)-ber/x+pi/4*beip
     Z    +x*(-3.69113734e0*(x8**2)+21.42034017e0*(x8**6)
     Z    -11.36433272e0*(x8**10)+1.41384780e0*(x8**14)
     Z    -.06136358e0*(x8**18)+.00116137e0*(x8**22)
     Z    -.00001075e0*(x8**26))

      keip=-beip*log(x2)-bei/x-pi/4.e0*berp
     Z    +x*(.21139217e0-13.39858846e0*(x8**4)+19.41182758e0*(x8**8)
     Z    -4.65950823e0*(x8**12)+.33049424e0*(x8**16)
     Z    -.00926707e0*(x8**20)+.00011997e0*(x8**24))

      return
      end
C
C
      subroutine osprod
      include 'pom2k.h'
      real z0login,zbotup,zza,scp,zlogin,scz
      real phiang,spd,uref,vref,z1,z2,f1,fphi
      integer i,j,k,k1,n,m
      real urefb(IM,JM),vrefb(IM,JM)
      real zpr(kb)
      real z0log(7),sc1(7),sc2(7)
      real zlog(9),zp(9)
      data z0log/ -6.,  -5.5,   -5.,   -4.5,  -4.,  -3.5,   -3./
      data sc1/  .0083, .0120, .0164, .0220, .0387, .0739, .1350/
      data sc2/  .0300, .0353, .0420, .0502,  .0600, .0716, .0850/
      data zlog/0., -.25, -.5, -.75, -1., -1.25, -1.5, -1.75, -2./
      data zP/   0.,  .08, .27,  .5,  .7,  .85,  .95,     1.,   1./

C
C      Code to determine additional TKE production due to bottom
C      boundary layer oscillations (Mellor, G., 2002: Oscillatory 
C      bottom boundary layers, J. Phys Oceanogr. XX, XXX-XXX.)
C
C      Z = non-dimensional vertical coordinate = 0 at top, -1 at bottom
C      KB # of vertical grid points
C      dt = water column depth (m)
C      omega = frequency (s-1)
C      ab = oscillating velocity amplitude (m s-1)
C      phiang = angle between wall stress vector and wave amplitude
C           vector; 0 < PHI < 90 deg.
C      Z0b = bottom roughness parameter (m)
C      pros = output shear production (m2 s-3)           
      do k=1,KB
        do j=1,JM
          do i=1,IM
            pros(i,j,k)=0.
          enddo
        enddo
      enddo
      do j=2,JMM1
        do i=2,IMM1
          zza=min(zref,dt(i,j)/3.e0)
          if(zza.le.dt(i,j)*(1.e0+zz(KBM1)))then
            zza= dt(i,j)*(1.e0+zz(KBM1))
c zr in meters
            k1 = KBM1
            urefb(i,j)=u(i,j,k1)
            vrefb(i,j)=v(i,j,k1)
            f1=0.
          else
            z1 = (1.e0+zz(KBM2))*dt(i,j)
            do k=KBM2,1,-1
              if(z1.ge.zza)then
                k1 = k
                z2 = (1.e0+zz(k1+1))*dt(i,j)
                f1=log(z1/zza)/log(z1/z2) 
                if(z2.ge.zza)then 
                  write(0,*)z1,z2,zza,f1,k1,dt(i,j) 
                  stop 
                endif 
                z1=0.
              else if(k.lt.1)then
                z1=(1.e0+zz(k-1))*dt(i,j)  
              endif 
            enddo 
            urefb(i,j) = (1.e0-f1)*u(i,j,k1)+f1*u(i,j,k1+1)*dum(i,j) 
            vrefb(i,j) = (1.e0-f1)*v(i,j,k1)+f1*v(i,j,k1+1)*dvm(i,j) 
          endif
        enddo 
        vrefb(1,j)=vrefb(2,j)*dvm(1,j)
        vrefb(2,j)=vrefb(2,j)*dvm(2,j)
        vrefb(im,j)=vrefb(IMM1,j)*dvm(IM,j)
        urefb(1,j)=urefb(2,j)*dum(1,j)
        urefb(2,j)=urefb(2,j)*dum(2,j)
        urefb(IM,j)=urefb(IMM1,j)*dum(IM,j)
      enddo
      if(ibcon.eq.0)then
        call perchan1(vrefb)
        call perchan1(urefb)
      endif
      do j=2,JMM1
        do i=2,IMM1
          uref=.5e0*(urefb(i,j)+urefb(i+1,j))
          vref=.5e0*(vrefb(i,j)+vrefb(i,j+1))
          spd=sqrt(uref**2+vref**2)
          phiang=abs(atan2(vref,(uref+small))-pi-theta(i,j))
          IF(ubotw(i,j).ne.0.e0)then
            z0login=log10(z0b*omega/ubotw(i,j))  
            fphi=1.22e0+.22e0*cos(2.e0*phiang)
            n=min(1+2*ifix(z0login+6.e0),6)
            scP=sc1(n)+(z0login-z0log(n))*(sc1(n+1)-sc1(n))/0.5
            scP=.01*scP
            scz=sc2(n)+(z0login-z0log(n))*(sc2(n+1)-sc2(n))/0.5

            do k=1,KBM1
              zbotup=(z(k)+1.e0)*dt(i,j)
              zlogin=log10(zbotup*omega/(ubotw(i,j)*scz)+small)
              m=1+int(-zlogin/.25)
              if(zlogin.gt.0.)then
                pros(i,j,k)=0.
              else if(m.ge.9)then
                pros(i,j,k)=zp(9)
              else 
                pros(i,j,k)=zp(m)-4.e0*(zlogin-zlog(m))*
     *              (zp(m+1)-zp(m))
              endif
              pros(i,j,k)=pros(i,j,k)*scp*ubotw(i,j)**3*fphi**3/zbotup
            enddo
          endif
        enddo
      enddo
      return 
      end
      subroutine outave
      include "pom2k.h"
      integer i,j,k
c     write 2d fields
c     for example el, ua, va
      if(iint.eq.iave)then
         open(unit=35,file='et.av',form='unformatted',status='new')
         open(unit=36,file='wusurf.av',form='unformatted',status='new')
         open(unit=37,file='wvsurf.av',form='unformatted',status='new')
         open(unit=38,file='wubot.av',form='unformatted',status='new')
         open(unit=39,file='wvbot.av',form='unformatted',status='new')
         open(unit=40,file='wubody.av',form='unformatted',status='new')
         open(unit=41,file='wvbody.av',form='unformatted',status='new')
         open(unit=42,file='w.av',form='unformatted',status='new') 
         open(unit=43,file='u.av',form='unformatted',status='new') 
         open(unit=44,file='v.av',form='unformatted',status='new') 
         open(unit=45,file='q2.av',form='unformatted',status='new') 
         open(unit=46,file='l.av',form='unformatted',status='new') 
         open(unit=47,file='km.av',form='unformatted',status='new') 
         if(istrat.eq.1)
     *     open(unit=48,file='sigt.av',form='unformatted',status='new')
         if(istrat.eq.2)then 
           open(unit=49,file='t.av',form='unformatted',status='new')
           open(unit=29,file='s.av',form='unformatted',status='new')
         endif
      endif
      write(35)((etav(i,j),i=2,imm1),j=2,jmm1)
      write(36)((wusav(i,j),i=2,imm1),j=2,jmm1)
      write(37)((wvsav(i,j),i=2,imm1),j=2,jmm1)
      write(38)((wubav(i,j),i=2,imm1),j=2,jmm1)
      write(39)((wvbav(i,j),i=2,imm1),j=2,jmm1)
      write(40)((wubdav(i,j),i=2,imm1),j=2,jmm1)
      write(41)((wvbdav(i,j),i=2,imm1),j=2,jmm1)
      do k=1,KBM1
        write(42)((wav(i,j,k),i=2,imm1),j=2,jmm1)
        write(43)((uav(i,j,k),i=2,imm1),j=2,jmm1)
        write(44)((vav(i,j,k),i=2,imm1),j=2,jmm1)
        write(45)((q2av(i,j,k),i=2,imm1),j=2,jmm1)
        write(46)((lav(i,j,k),i=2,imm1),j=2,jmm1)
        write(47)((kmav(i,j,k),i=2,imm1),j=2,jmm1)
      enddo
      k=KB
      write(42)((wav(i,j,k),i=2,imm1),j=2,jmm1)
      write(45)((q2av(i,j,k),i=2,imm1),j=2,jmm1)
      write(46)((lav(i,j,k),i=2,imm1),j=2,jmm1)
      write(47)((kmav(i,j,k),i=2,imm1),j=2,jmm1)
      if(istrat.ne.0)then
        do k=1,KBM1
          write(48)((rhoref*sigtav(i,j,k),i=2,imm1),j=2,jmm1)
        enddo
        if(istrat.eq.2)then
          do k=1,KBM1
            write(49)((tav(i,j,k),i=2,imm1),j=2,jmm1)
            write(29)((sav(i,j,k),i=2,imm1),j=2,jmm1)
          enddo
        endif
      endif
      return
      end

       subroutine outbal
       include 'pom2k.h'  
       include "combal3.h"
       integer i,j,k,iopen
       data iopen/0/
c     write 3d fields
c     for example u v w km q2 rho
c      write(30)(((ub(i,j),i=2,imm1),j=2,jmm1,k=1,kbm1)
       if(iopen.eq.0)then
          iopen=1
          open(unit=50,file='uzdt',form='unformatted',status='new')
          open(unit=51,file='vzdt',form='unformatted',status='new')
          open(unit=52,file='uzadv',form='unformatted',status='new')
          open(unit=53,file='vzadv',form='unformatted',status='new') 
          open(unit=54,file='uzdis',form='unformatted',status='new') 
          open(unit=55,file='vzdis',form='unformatted',status='new')
          open(unit=56,file='uzp',form='unformatted',status='new')
          open(unit=57,file='vzp',form='unformatted',status='new')
          open(unit=58,file='uzdif',form='unformatted',status='new')
          open(unit=59,file='vzdif',form='unformatted',status='new')
          open(unit=60,file='uzcor',form='unformatted',status='new')
          open(unit=61,file='vzcor',form='unformatted',status='new')
          open(unit=62,file='uzbod',form='unformatted',status='new')
          open(unit=63,file='vzbod',form='unformatted',status='new')
          open(unit=64,file='uzdit',form='unformatted',status='new')
          open(unit=65,file='vzdit',form='unformatted',status='new')
       endif
          do k=1,kbm1
             write(50)((udt(i,j,k),i=2,imm1),j=2,jmm1)
             write(51)((vdt(i,j,k),i=2,imm1),j=2,jmm1)
             write(52)((uadv(i,j,k),i=2,imm1),j=2,jmm1)
             write(53)((vadv(i,j,k),i=2,imm1),j=2,jmm1)
             write(54)((udi(i,j,k),i=2,imm1),j=2,jmm1)
             write(55)((vdi(i,j,k),i=2,imm1),j=2,jmm1)
             write(56)((up(i,j,k),i=2,imm1),j=2,jmm1)
             write(57)((vp(i,j,k),i=2,imm1),j=2,jmm1)
             write(58)((uver(i,j,k),i=2,imm1),j=2,jmm1)
             write(59)((vver(i,j,k),i=2,imm1),j=2,jmm1)
             write(60)((ucor(i,j,k),i=2,imm1),j=2,jmm1)
             write(61)((vcor(i,j,k),i=2,imm1),j=2,jmm1)
             write(62)((ubod(i,j),i=2,imm1),j=2,jmm1)
             write(63)((vbod(i,j),i=2,imm1),j=2,jmm1)
             write(64)((udi(i,j,k)+uver(i,j,k),i=2,imm1),j=2,jmm1)
             write(65)((vdi(i,j,k)+vver(i,j,k),i=2,imm1),j=2,jmm1)
          enddo
c  
       return
       end
      subroutine outbal2
      include 'pom2k.h'  
      include "combal3.h"
      integer i,j,k,iopen
      real ufora,vfora
      real sum,svm,emax,umax,vmax,sem
      data iopen/0/
!     write 2d fields vertically averaged balances
      if(iopen.eq.0)then
        iopen=1
        open(unit=66,file='dtel',form='unformatted',status='new')
        open(unit=67,file='flux',form='unformatted',status='new')
        open(unit=68,file='fluy',form='unformatted',status='new')
        open(unit=69,file='fluz',form='unformatted',status='new')
        open(unit=70,file='uadt',form='unformatted',status='new')
        open(unit=71,file='uap',form='unformatted',status='new')
        open(unit=72,file='uaadv',form='unformatted',status='new')
        open(unit=73,file='uadis',form='unformatted',status='new')
        open(unit=74,file='uasurf',form='unformatted',status='new')
        open(unit=75,file='uabot',form='unformatted',status='new')
        open(unit=76,file='uabod',form='unformatted',status='new')
        open(unit=77,file='uafor',form='unformatted',status='new')
        open(unit=78,file='uacor',form='unformatted',status='new')
        open(unit=79,file='vadt',form='unformatted',status='new')
        open(unit=80,file='vap',form='unformatted',status='new')
        open(unit=81,file='vaadv',form='unformatted',status='new')
        open(unit=82,file='vadis',form='unformatted',status='new')
        open(unit=83,file='vasurf',form='unformatted',status='new')
        open(unit=84,file='vabot',form='unformatted',status='new')
        open(unit=85,file='vabod',form='unformatted',status='new')
        open(unit=86,file='vafor',form='unformatted',status='new')
        open(unit=87,file='vacor',form='unformatted',status='new')
      endif
      emax=0.e0
      umax=0.e0
      vmax=0.e0
      do j=2,JMM1
        do i=2,IMM1
          sum=udta(i,j)+uadva(i,j)+udia(i,j)+usurfa(i,j)+uboda(i,j)+
     *           ubota(i,j)+upa(i,j)+ucora(i,j)
          svm=vdta(i,j)+vadva(i,j)+vdia(i,j)+vsurfa(i,j)+vboda(i,j)+
     *           vbota(i,j)+vpa(i,j)+vcora(i,j)
          sem=dtel(i,j)+flua(i,j)+flva(i,j)+flw0(i,j)
            vmax=max(vmax,abs(svm))
            emax=max(emax,abs(sem))
            umax=max(umax,abs(sum))
        enddo
      enddo
      write(*,'(a20,6e12.4)')'balance: ua,va eta: ',umax,vmax,emax
      write(66)((dtel(i,j),i=2,IMM1),j=2,JMM1)
      write(67)((flua(i,j),i=2,IMM1),j=2,JMM1)
      write(68)((flva(i,j),i=2,IMM1),j=2,JMM1)
      write(69)((flw0(i,j),i=2,IMM1),j=2,JMM1)
      write(70)((udta(i,j),i=2,IMM1),j=2,JMM1)
      write(71)((upa(i,j),i=2,IMM1),j=2,JMM1)
      write(72)((uadva(i,j),i=2,IMM1),j=2,JMM1)
      write(73)((udia(i,j),i=2,IMM1),j=2,JMM1)
      write(74)((usurfa(i,j),i=2,IMM1),j=2,JMM1)
      write(75)((ubota(i,j),i=2,IMM1),j=2,JMM1)
      write(76)((uboda(i,j),i=2,IMM1),j=2,JMM1)
      write(77)((usurfa(i,j)+uboda(i,j),i=2,IMM1),j=2,JMM1)
      write(78)((ucora(i,j),i=2,IMM1),j=2,JMM1)
      write(79)((vdta(i,j),i=2,IMM1),j=2,JMM1)
      write(80)((vpa(i,j),i=2,IMM1),j=2,JMM1)
      write(81)((vadva(i,j),i=2,IMM1),j=2,JMM1)
      write(82)((vdia(i,j),i=2,IMM1),j=2,JMM1)
      write(83)((vsurfa(i,j),i=2,IMM1),j=2,JMM1)
      write(84)((vbota(i,j),i=2,IMM1),j=2,JMM1)
      write(85)((vboda(i,j),i=2,IMM1),j=2,JMM1)
      write(86)((vsurfa(i,j)+vboda(i,j),i=2,IMM1),j=2,JMM1)
      write(87)((vcora(i,j),i=2,IMM1),j=2,JMM1)
      return
      end
      subroutine output2
      include "pom2k.h"
      include "pass.h"
      integer i,j
c     write 2d fields
c     for example el, ua, va
      if(iint.eq.0)then
         open(unit=30,file='et',form='unformatted',status='new')
         open(unit=31,file='wusurf',form='unformatted',status='new')
         open(unit=32,file='wvsurf',form='unformatted',status='new')
         open(unit=33,file='wubot',form='unformatted',status='new')
         open(unit=34,file='wvbot',form='unformatted',status='new')
         if(Curr_Bed_Interact)open(unit=15,file='depth',form=
     *      'unformatted',status='new')
      endif
      if(curr_bed_interact)write(15)((h(i,j),i=2,imm1),j=2,jmm1)
      write(30)((et(i,j),i=2,imm1),j=2,jmm1)
      write(31)((wusurf(i,j),i=2,imm1),j=2,jmm1)
      write(32)((wvsurf(i,j),i=2,imm1),j=2,jmm1)
      write(33)((wubot(i,j),i=2,imm1),j=2,jmm1)
      write(34)((wvbot(i,j),i=2,imm1),j=2,jmm1)
      return
      end
      subroutine output3
      include "pom2k.h"
      integer i,j,k
c     write 3d fields
c     for example u v w km q2 rho
c      write(30)(((ub(i,j),i=2,IMM1),j=2,JMM1,k=1,KBM1)
      if(iint.eq.0)then
c        open(unit=16,file='kh',form='unformatted',status='new')
        open(unit=20,file='u',form='unformatted',status='new')
        open(unit=21,file='v',form='unformatted',status='new')
        open(unit=22,file='km',form='unformatted',status='new') 
        open(unit=23,file='q2',form='unformatted',status='new') 
        open(unit=24,file='omega',form='unformatted',status='new')
        open(unit=25,file='l',form='unformatted',status='new')
        if(istrat.eq.1)then
          open(unit=26,file='sigt',form='unformatted',status='new')
        endif
        if(istrat.eq.2)then
          open(unit=26,file='rho',form='unformatted',status='new')
          open(unit=27,file='temper',form='unformatted',status='new')
          open(unit=28,file='salin',form='unformatted',status='new')
        endif 
      endif 
      do k=1,KBM1
        write(20)((u(i,j,k),i=2,IMM1),j=2,JMM1)
        write(21)((v(i,j,k),i=2,IMM1),j=2,JMM1)
        write(22)((km(i,j,k),i=2,IMM1),j=2,JMM1)
c        write(16)((kh(i,j,k),i=2,IMM1),j=2,JMM1)
        write(23)((q2(i,j,k),i=2,IMM1),j=2,JMM1)
        write(24)((w(i,j,k),i=2,IMM1),j=2,JMM1)
        write(25)((l(i,j,k),i=2,IMM1),j=2,JMM1)
      enddo
c      write(16)((kh(i,j,KB),i=2,IMM1),j=2,JMM1)
      write(22)((km(i,j,KB),i=2,IMM1),j=2,JMM1)
      write(23)((q2(i,j,KB),i=2,IMM1),j=2,JMM1)
      write(24)((w(i,j,KB),i=2,IMM1),j=2,JMM1)
      write(25)((l(i,j,KB),i=2,IMM1),j=2,JMM1)
      if(istrat.ne.0)then
        do k=1,KBM1
           write(26)((rhoref*rho(i,j,k),i=2,IMM1),j=2,JMM1)
        enddo
      endif
      if(istrat.eq.2)then
        do k=1,KBM1
          write(27)((t(i,j,k),i=2,IMM1),j=2,JMM1)
          write(28)((s(i,j,k),i=2,IMM1),j=2,JMM1)
        enddo
      endif
c  
      return
      end
      subroutine passit
      include 'pom2k.h'
      include 'pass.h'
      integer i,j,nap
      integer ju,iv
      integer ivm,jum,ivmm,jumm
c interpolate internal points
c linearly at present
      if(IDB.ne.NX_Circ .or. JDB.ne.NY_Circ)stop 'size'
      if(IDB.eq.IM*2-3)then
c u and v at center points rotated
        do j=2,JMM1
          ju=2*j-2
          do i=2,IMM1
            iv=2*i-2
            Pass_U(iv,ju)=.5*((ua(i,j)+ua(i+1,j))*
     *       cos(rot(i,j))+(va(i,j)+va(i,j+1))*sin(rot(i,j)))
            Pass_V(iv,ju)=.5*(-(ua(i,j)+ua(i+1,j))*sin(rot(i,j))+
     *        (va(i,j)+va(i,j+1))*cos(rot(i,j)))
            Pass_Ub(iv,ju)=.5*((u(i,j,KBM1)+u(i+1,j,KBM1))*
     *       cos(rot(i,j))+(v(i,j,KBM1)+v(i,j+1,KBM1))*sin(rot(i,j)))
            Pass_Vb(iv,ju)=.5*(-(u(i,j,KBM1)+u(i+1,j,KBM1))*
     *       sin(rot(i,j))+(v(i,j,KBM1)+v(i,j+1,KBM1))*cos(rot(i,j)))
            Pass_eta(iv,ju)=et(i,j)
          enddo
        enddo
!  option for x-z model
        do iv=4,IDB-1,2
          ivm=iv-1
          ivmm=iv-2
          Pass_U(ivm,2)=.5*(Pass_U(iv,2)+Pass_U(ivmm,2))  
          Pass_V(ivm,2)=.5*(Pass_V(iv,2)+Pass_V(ivmm,2))  
          Pass_Ub(ivm,2)=.5*(Pass_Ub(iv,2)+Pass_Ub(ivmm,2))  
          Pass_Vb(ivm,2)=.5*(Pass_Vb(iv,2)+Pass_Vb(ivmm,2))  
          Pass_eta(ivm,2)=.5*(Pass_eta(iv,2)+Pass_eta(ivmm,2))  
        enddo
        if(JM.gt.3)then
          do ju=4,JDB-1,2
            jum=ju-1
            jumm=ju-2
            Pass_U(2,jum)=.5e0*(Pass_U(2,ju)+Pass_U(2,jumm))
            Pass_V(2,jum)=.5e0*(Pass_V(2,ju)+Pass_V(2,jumm))
            Pass_Ub(2,jum)=.5e0*(Pass_Ub(2,ju)+Pass_Ub(2,jumm))
            Pass_Vb(2,jum)=.5e0*(Pass_Vb(2,ju)+Pass_Vb(2,jumm))
            Pass_eta(2,jum)=.5e0*(Pass_eta(2,ju)+Pass_eta(2,jumm))
            do iv=4,IDB-1,2
              ivm=iv-1
              ivmm=iv-2
              Pass_U(iv,jum)=.5e0*(Pass_U(iv,ju)+Pass_U(iv,jumm))
              Pass_U(ivm,jum)=.25e0*(Pass_U(iv,ju)+Pass_U(iv,jumm)+
     *          Pass_U(ivmm,ju)+Pass_U(ivmm,jumm))
              Pass_U(ivm,ju)=.5e0*(Pass_U(iv,ju)+Pass_U(ivmm,ju))
              Pass_V(ivm,jum)=.25e0*(Pass_V(iv,ju)+Pass_V(iv,jumm)+
     *          Pass_V(ivmm,ju)+Pass_V(ivmm,jumm))
              Pass_V(ivm,ju)=.5e0*(Pass_V(iv,ju)+Pass_V(ivmm,ju))
              Pass_V(iv,jum)=.5e0*(Pass_V(iv,ju)+Pass_V(iv,jumm))
              Pass_Ub(iv,jum)=.5e0*(Pass_Ub(iv,ju)+Pass_Ub(iv,jumm))
              Pass_Ub(ivm,jum)=.25e0*(Pass_Ub(iv,ju)+Pass_Ub(iv,jumm)+
     *          Pass_Ub(ivmm,ju)+Pass_Ub(ivmm,jumm))
              Pass_Ub(ivm,ju)=.5e0*(Pass_Ub(iv,ju)+Pass_Ub(ivmm,ju))
              Pass_Vb(iv,jum)=.5e0*(Pass_Vb(iv,ju)+Pass_Vb(iv,jumm))
              Pass_Vb(ivm,jum)=.25e0*(Pass_Vb(iv,ju)+Pass_Vb(iv,jumm)+
     *          Pass_Vb(ivmm,ju)+Pass_Vb(ivmm,jumm))
              Pass_Vb(ivm,ju)=.5e0*(Pass_Vb(iv,ju)+Pass_Vb(ivmm,ju))
              Pass_eta(iv,jum)=.5e0*(Pass_eta(iv,ju)+Pass_eta(iv,jumm))
              Pass_eta(ivm,jum)=.25e0*(Pass_eta(iv,ju)+
     *         Pass_eta(iv,jumm)+Pass_eta(ivmm,ju)+Pass_eta(ivmm,jumm))
              Pass_eta(ivm,ju)=.5e0*(Pass_eta(iv,ju)+Pass_eta(ivmm,ju))
            enddo
          enddo   
!  no gradient in x direction
          do ju=2,JDB-1
            j=(2+ju)/2
            Pass_U(1,ju)=Pass_U(2,ju)*dum(2,j)*dum(2,j+1)
            Pass_V(1,ju)=0.
            Pass_Ub(1,ju)=Pass_Ub(2,ju)*dum(2,j)*dum(2,j+1)
            Pass_Vb(1,ju)=0.
            Pass_eta(1,ju)=0.
            Pass_U(IDB,ju)=Pass_U(IDB-1,ju)*dum(IM,j)*dum(IM,j+1)
            Pass_V(IDB,ju)=0.
            Pass_Ub(IDB,ju)=Pass_Ub(IDB-1,ju)*dum(IM,j)*dum(IM,j+1)
            Pass_Vb(IDB,ju)=0.
            Pass_eta(IDB,ju)=0.
          enddo
!  extrapolate or periodic in y direction
          if(ibcon.ne.0)then
! extrapolate
            do iv=1,IDB
              Pass_U(iv,1)=2.e0*Pass_U(iv,2)-Pass_U(iv,3)
              Pass_V(iv,1)=2.e0*Pass_V(iv,2)-Pass_V(iv,3)
              Pass_Ub(iv,1)=2.e0*Pass_Ub(iv,2)-Pass_Ub(iv,3)
              Pass_Vb(iv,1)=2.e0*Pass_Vb(iv,2)-Pass_Vb(iv,3)
              Pass_eta(iv,1)=2.e0*Pass_eta(iv,2)-Pass_eta(iv,3)
              Pass_U(iv,JDB)=2.e0*Pass_U(iv,JDB-1)-Pass_U(iv,JDB-2)
              Pass_V(iv,JDB)=2.e0*Pass_V(iv,JDB-1)-Pass_V(iv,JDB-2)
              Pass_Ub(iv,JDB)=2.e0*Pass_Ub(iv,JDB-1)-Pass_Ub(iv,JDB-2)
              Pass_Vb(iv,JDB)=2.e0*Pass_Vb(iv,JDB-1)-Pass_Vb(iv,JDB-2)
              Pass_eta(iv,JDB)=2.e0*Pass_eta(iv,JDB-1)-
     *            Pass_eta(iv,JDB-2)
            enddo
          else
            do iv=1,IDB
              Pass_U(iv,1)=.5e0*(Pass_U(iv,JDB-1)+Pass_U(iv,2))
              Pass_V(iv,1)=.5e0*(Pass_V(iv,JDB-1)+Pass_V(iv,2))
              Pass_Ub(iv,1)=.5e0*(Pass_Ub(iv,JDB-1)+Pass_Ub(iv,2))
              Pass_Vb(iv,1)=.5e0*(Pass_Vb(iv,JDB-1)+Pass_Vb(iv,2))
              Pass_eta(iv,1)=.5e0*(Pass_eta(iv,JDB-1)+Pass_eta(iv,2))
              Pass_U(iv,JDB)=Pass_U(iv,1)
              Pass_V(iv,JDB)=Pass_V(iv,1)
              Pass_Ub(iv,JDB)=Pass_Ub(iv,1)
              Pass_Vb(iv,JDB)=Pass_Vb(iv,1)
              Pass_eta(iv,JDB)=Pass_eta(iv,1)
            enddo
          endif
        else   
          do iv=4,IDB-1,2
            ivm=iv-1
            ivmm=iv-2
            Pass_U(ivm,2)=.5e0*(Pass_U(iv,2)+Pass_U(ivmm,2))
            Pass_V(ivm,2)=.5e0*(Pass_V(iv,2)+Pass_V(ivmm,2))
            Pass_Ub(ivm,2)=.5e0*(Pass_Ub(iv,2)+Pass_Ub(ivmm,2))
            Pass_Vb(ivm,2)=.5e0*(Pass_Vb(iv,2)+Pass_Vb(ivmm,2))
            Pass_eta(ivm,2)=.5e0*(Pass_eta(iv,j)+Pass_eta(ivmm,2))
          enddo
          do ju=1,3
            do i=2,IDB-1
              Pass_U(i,ju)=Pass_U(i,2)
              Pass_V(i,ju)=Pass_V(i,2)
              Pass_Ub(i,ju)=Pass_Ub(i,2)
              Pass_Vb(i,ju)=Pass_Vb(i,2)
              Pass_eta(i,ju)=Pass_eta(i,2)
            enddo
            Pass_U(1,ju)=Pass_U(2,2)*dum(2,2)
            Pass_V(1,ju)=Pass_V(2,2)*dvm(2,2)
            Pass_Ub(1,ju)=Pass_Ub(2,2)*dum(2,2)
            Pass_Vb(1,ju)=Pass_Vb(2,2)*dvm(2,2)
            Pass_eta(1,ju)=Pass_eta(2,2)*fsm(2,2)
            Pass_U(IDB,ju)=Pass_U(IDB-1,2)*dum(IM,2)
            Pass_V(IDB,ju)=Pass_V(IDB-1,2)*dvm(IM,2)
            Pass_Ub(IDB,ju)=Pass_Ub(IDB-1,2)*dum(IM,2)
            Pass_Vb(IDB,ju)=Pass_Vb(IDB-1,2)*dvm(IM,2)
            Pass_eta(IDB,ju)=Pass_eta(IDB-1,2)*fsm(IM,2)
          enddo
        endif
      else
c interpolate u v to corner and rotate there, rot should be at corner
        do j=2,JM
          do i=2,IM
            Pass_U(i-1,j-1)=.5*((ua(i,j)+ua(i,j-1))*cos(rot(i,j))+
     *        (va(i,j)+va(i-1,j))*sin(rot(i,j)))
            Pass_V(i-1,j-1)=.5*(-(ua(i,j)+ua(i,j-1))*sin(rot(i,j))+
     *        (va(i,j)+va(i-1,j))*cos(rot(i,j)))
            Pass_Ub(i-1,j-1)=.5*((u(i,j,KBM1)+u(i,j-1,KBM1))*
     *        cos(rot(i,j))+
     *        (v(i,j,KBM1)+v(i-1,j,KBM1))*sin(rot(i,j)))
            Pass_Vb(i-1,j-1)=.5*(-(u(i,j,KBM1)+u(i,j-1,KBM1))*
     *         sin(rot(i,j))+
     *        (v(i,j,KBM1)+v(i-1,j,KBM1))*cos(rot(i,j)))
            Pass_eta(i-1,j-1)=.25*(et(i,j)+et(i,j-1)+et(i-1,j)+
     *         et(i-1,j-1))
          enddo
        enddo
      endif
      nap=max(nav,20)
      call averw(Pass_eta,nap,nx_circ,ny_circ,ibcon)
      call averw(Pass_u,nap,nx_circ,ny_circ,ibcon)
      call averw(Pass_v,nap,nx_circ,ny_circ,ibcon)
      call averw(Pass_ub,nap,nx_circ,ny_circ,ibcon)
      call averw(Pass_vb,nap,nx_circ,ny_circ,ibcon)
      return
      end
      subroutine perchan(x)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM,KB)
      integer i,k
      do k=1,KB
        do i=1,IM
          x(i,1,k)=x(i,JMM1,k)
          x(i,JM,k)=x(i,2,k)
        enddo
      enddo
      return
      end
      subroutine perchandb(x,isize,jsize)
      implicit none
      include 'imjmkb.h'
      integer isize,jsize
      real x(isize,jsize)
      integer i,k
      if(JM.eq.3)then
        do i=1,IDB
          x(i,1)=x(i,JDB-1)
          x(i,JDB)=x(i,2)
        enddo
      else
        do i=1,IDB
          x(i,1)=.5*(x(i,1)+x(i,JDB))
          x(i,JDB)=x(i,1)
        enddo
      endif
      return
      end
      subroutine perchan1(x)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM)
      integer i,k
      do i=1,IM
        x(i,1)=x(i,JMM1)
        x(i,JM)=x(i,2)
      enddo
      return
      end
      subroutine perchanu(x)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM,KB)
      integer i,j,k
      do k=1,KB
        do i=2,IMM1
          x(i,1,k)=x(i,JMM1,k)
          x(i,JM,k)=x(i,2,k)
        enddo
        do j=1,JM
          x(1,j,k)=0.
          x(2,j,k)=0.
          x(IM,j,k)=0.
        enddo
      enddo
      return
      end
      subroutine perchanu1(x)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM)
      integer i,j
      do i=2,IMM1
        x(i,1)=x(i,JMM1)
        x(i,JM)=x(i,2)
      enddo
      do j=1,JM
        x(1,j)=0.
        x(2,j)=0.
        x(IM,j)=0.
      enddo
      return
      end
      subroutine perchanu1b(x,xbc)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM),xbc
      integer i,j
      do i=2,IMM1
        x(i,1)=x(i,JMM1)
        x(i,JM)=x(i,2)
      enddo
      do j=1,JM
        x(1,j)=0.
        x(2,j)=0.
        x(IM,j)=xbc
      enddo
      return
      end
 
      subroutine perchanub(x,xbc)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM,KB),xbc(KB)
      integer i,j,k
      do k=1,KB
        do i=2,IMM1
          x(i,1,k)=x(i,JMM1,k)
          x(i,JM,k)=x(i,2,k)
        enddo
        do j=1,JM
          x(1,j,k)=0.
          x(2,j,k)=0.
          x(IM,j,k)=xbc(k)
        enddo
      enddo
      return
      end
      subroutine perchanv(x)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM,KB)
      integer i,j,k
      do k=1,KB
        do i=2,IMM1
          x(i,1,k)=x(i,JMM1,k)
          x(i,JM,k)=x(i,2,k)
        enddo
        do j=1,JM
          x(1,j,k)=x(2,j,k)
          x(IM,j,k)=x(IMM1,j,k)
        enddo
      enddo
      return
      end
      subroutine perchanv1(x)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM)
      integer i,j
      do i=2,IMM1
        x(i,1)=x(i,JMM1)
        x(i,JM)=x(i,2)
      enddo
      do j=1,JM
        x(1,j)=x(2,j)
        x(IM,j)=x(IMM1,j)
      enddo
      return
      end
      subroutine perchanv1b(x,xbc)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM),xbc
      integer i,j
      do i=2,IMM1
        x(i,1)=x(i,JMM1)
        x(i,JM)=x(i,2)
      enddo
      do j=1,JM
        x(1,j)=x(2,j)
        x(IM,j)=xbc
      enddo
      return
      end
      subroutine perchanvb(x,xbc)
      implicit none
      include 'imjmkb.h'
      real x(IM,JM,KB),xbc(KB)
      integer i,j,k
      do k=1,KB
        do i=2,IMM1
          x(i,1,k)=x(i,JMM1,k)
          x(i,JM,k)=x(i,2,k)
        enddo
        do j=1,JM
          x(1,j,k)=x(2,j,k)
          x(IM,j,k)=xbc(k)
        enddo
      enddo
      return
      end
C
      subroutine profq
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Solves for q2 (twice the turbulent kinetic energy), *
C *                q2l (q2 x turbulent length scale), km (vertical     *
C *                kinematic viscosity) and kh (vertical kinematic     *
C *                diffusivity), using a simplified version of the     *
C *                level 2 1/2 model of Mellor and Yamada (1982).      *
C *   Note: A new correction to increase mixing below the thermocline  *
C *         (Mellor, 2001; Ezer, 2000) involves an empirical critical  *
C *         number "ghc", less negative value gives more mixing.       *
C * SEE:                                                               *
C *   Mellor, G.L. and T. Yamada, Development of a turbulence          *
C *     closure model for geophysical fluid fluid problems,            *
C *     Rev. Geophys. Space Phys., 20, 851-875, 1982.                  *
C *                                                                    *
C *   Mellor, G. L., One-dimensional, ocean surface layer modeling,    *
C *     a problem and a solution. J. Phys. Oceanogr., 31(3), 790-809,  *
C *     2001.                                                          *
C *                                                                    *
C *   Ezer, T., On the seasonal mixed-layer simulated by a basin-scale *
C *     ocean model and the Mellor-Yamada turbulence scheme,           *
C *     J. Geophys. Res., 105(C7), 16,843-16,855, 2000.                *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real sm(IM,JM,KB),sh(IM,JM,KB),cc(IM,JM,KB)
      real gh(IM,JM,KB),boygr(IM,JM,KB),dh(IM,JM),stf(IM,JM,KB)
      real prod(IM,JM,KB),kn(IM,JM,KB),fsave(IM,JM)
      real ustar,temp,df0,df1,df2,twothr,onethr
      real a1,a2,b1,b2,c1
      real coef1,coef2,coef3,coef4,coef5
      real const1,e1,e2,ghc,const2,alp
      real xnsq,xnsqm,cmp,lx(IM,JM,KB)
      real p,sef,sp,tp,dtop,dbot
C
      integer i,j,k,ki
C
c      equivalence (prod,kn)
C
      data a1,b1,a2,b2,c1/0.92e0,16.6e0,0.74e0,10.1e0,0.08e0/
      data e1/1.8e0/,e2/1.33e0/
      data sef/1.e0/
      save a1,b1,a2,b2,c1,e1,e2,sef
C
      do j=1,JM
        do i=1,IM
          dh(i,j)=h(i,j)+etf(i,j)
        end do
      end do
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            a(i,j,k)=-dti2*(kq(i,j,k+1)+kq(i,j,k)+2.e0*umol)*.5e0
     $                /(dzz(k-1)*dz(k)*dh(i,j)*dh(i,j))
            c(i,j,k)=-dti2*(kq(i,j,k-1)+kq(i,j,k)+2.e0*umol)*.5e0
     $                /(dzz(k-1)*dz(k-1)*dh(i,j)*dh(i,j))
          end do
        end do
      end do
C
C-----------------------------------------------------------------------
C
C     The following section solves the equation:
C
C       dti2*(kq*q2')' - q2*(2.*dti2*dtef+1.) = -q2b
C
C     Surface and bottom boundary conditions:
C
      twothr=2.e0/3.e0
      onethr=1.e0-twothr
      const1=(16.6e0**twothr)*sef
      alp=100.e0
      const2=2.e0*alp
C
    
C
C    Calculate speed of sound squared:
C
      if(istrat.ne.0)then
        if(istrat.eq.2)then
C     Calculate buoyancy gradient:
C     Calculate pressure in units of decibars:
          do k=1,KBM1
            do j=1,JM
              do i=1,IM
                tp=t(i,j,k)+tbias
                sp=s(i,j,k)+sbias
C
                p=grav*rhoref*(-zz(k)* h(i,j))*1.e-4
                cc(i,j,k)=1449.1e0+.00821e0*p+4.55e0*tp -.045e0*tp**2
     $                 +1.34e0*(sp-35.0e0)
                cc(i,j,k)=cc(i,j,k)
     $                 /sqrt((1.e0-.01642e0*p/cc(i,j,k))
     $                   *(1.e0-0.40e0*p/cc(i,j,k)**2))
              end do
            end do
          end do
          do k=2,KBM1
            do j=1,JM
              do i=1,IM
                boygr(i,j,k)=grav*(rho(i,j,k-1)-rho(i,j,k))
     $                    /(dzz(k-1)* h(i,j))
     $                  +(grav**2)*2.e0
     $                    /(cc(i,j,k-1)**2+cc(i,j,k)**2)
              end do
            end do
          end do
        else if(istrat.eq.1)then
          do k=2,KBM1
            do j=1,JM
              do i=1,IM
                boygr(i,j,k)=grav*(rho(i,j,k-1)-rho(i,j,k))
     $                    /(dzz(k-1)* h(i,j))
              end do
            end do
          end do
        end if              
C
C
      else
        do k=2,KBM1
          do j=1,JM
            do i=1,IM
              boygr(i,j,k)=0.
            end do
          end do
        end do
      endif 
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            q2b(i,j,k)=abs(q2b(i,j,k))
            q2lb(i,j,k)=abs(q2lb(i,j,k))
            l(i,j,k)=q2lb(i,j,k)/q2b(i,j,k)
            if(istrat.ne.0)then
              xnsq=-boygr(i,j,k)
              xnsqm=max(xnsq,0.e0)
              cmp=.5*sqrt(abs(uf(i,j,k)/(small**2+xnsqm)))
              lx(i,j,k)=min(l(i,j,k),cmp)
            else
              lx(i,j,k)=l(i,j,k)
            endif
            gh(i,j,k)=(lx(i,j,k)**2)*boygr(i,j,k)/q2b(i,j,k)
            gh(i,j,k)=min(gh(i,j,k),.028e0)
          end do
        end do
      end do
C
      do j=1,JM
        do i=1,IM
          l(i,j,1)=kappa*z0s(i,j)
          l(i,j,KB)=kappa*z0c(i,j)
          lx(i,j,1)=kappa*z0s(i,j)
          lx(i,j,KB)=kappa*z0c(i,j)
          gh(i,j,1)=0.e0
          gh(i,j,KB)=0.e0
        end do
      end do
C
C    Calculate production of turbulent kinetic energy:
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            prod(i,j,k)=.25e0*sef
     $                   *((u(i,j,k)-u(i,j,k-1)
     $                      +u(i+1,j,k)-u(i+1,j,k-1))**2
     $                     +(v(i,j,k)-v(i,j,k-1)
     $                      +v(i,j+1,k)-v(i,j+1,k-1))**2)
     $                   /(dzz(k-1)*dh(i,j))**2
          end do
        end do
      end do
      if(iprod.eq.1)then
        if(ibcon.eq.0)then
          call perchanv(prod)
          call perchanv(boygr)
        endif
        call aver9(prod)
        call aver9(boygr)
        if(ibcon.eq.0)then
          call perchanv(prod)
          call perchanv(boygr)
        endif
      endif
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            prod(i,j,k)=km(i,j,k)*prod(i,j,k)+kh(i,j,k)*boygr(i,j,k)
          end do
        end do
      end do
      if(ibot.eq.-1)then
        call osprod
        if(iprod.eq.1)then
          if(ibcon.eq.0)call perchanv(pros)
          call aver9(pros)
          if(ibcon.eq.0)call perchanv(pros)
        endif
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              prod(i,j,k)=prod(i,j,k)+pros(i,j,k)
            end do
          end do
        end do
      endif    
C
c      ghc=-6.0e0
      do k=1,KB
        do j=1,JM
          do i=1,IM
            stf(i,j,k)=1.e0
c            if(gh(i,j,k).lt.0.e0)
c     $        stf(i,j,k)=1.0e0-0.9e0*(gh(i,j,k)/ghc)**1.5e0
c            if(gh(i,j,k).lt.ghc) stf(i,j,k)=0.1e0
            dtef(i,j,k)=q2b(i,j,k)*sqrt(q2b(i,j,k))*stf(i,j,k)
     $                   /(b1*q2lb(i,j,k)+small)
          end do
        end do
      end do
      if(isurf.ne.0)then
        do j=1,JMM1
          do i=1,IMM1
            ee(i,j,1)=0.e0
            gg(i,j,1)=sqrt((.5e0*(wusurf(i,j)+wusurf(i+1,j)))**2
     $                  +(.5e0*(wvsurf(i,j)+wvsurf(i,j+1)))**2)*const1
            uf(i,j,KB)=sqrt((.5e0*(wubot(i,j)+wubot(i+1,j)))**2
     $                   +(.5e0*(wvbot(i,j)+wvbot(i,j+1)))**2)*const1
          end do
        end do
      else
        do j=1,JMM1
          do i=1,IMM1
            ee(i,j,1)=1.e0
            ustar=sqrt(sqrt( (.5*(wusurf(i,j)+wusurf(i+1,j)))**2
     1          +(.5*(wvsurf(i,j)+wvsurf(i,j+1)))**2 ))
            df0=const2*ustar**3
            df2=.5*(kq(i,j,2)+kq(i,j,3))*(q2b(i,j,2)-q2b(i,j,3))
     *        /(dz(2)*dh(i,j))
            df1=twothr*df0+onethr*df2
            gg(i,j,1)=df1*dz(1)*dh(i,j)*2/abs(kq(i,j,1)+kq(i,j,2))
            uf(i,j,KB)=sqrt((.5e0*(wubot(i,j)+wubot(i+1,j)))**2
     $                   +(.5e0*(wvbot(i,j)+wvbot(i,j+1)))**2)*const1
           enddo
         enddo 
      end if
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            gg(i,j,k)=1.e0/(a(i,j,k)+c(i,j,k)*(1.e0-ee(i,j,k-1))
     $                      -(2.e0*dti2*dtef(i,j,k)+1.e0))
            ee(i,j,k)=a(i,j,k)*gg(i,j,k)
            gg(i,j,k)=(-2.e0*dti2*prod(i,j,k)+c(i,j,k)*gg(i,j,k-1)
     $                 -uf(i,j,k))*gg(i,j,k)
          end do
        end do
      end do
C
      do k=1,KBM1
        ki=KB-k
        do j=1,JM
          do i=1,IM
            uf(i,j,ki)=ee(i,j,ki)*uf(i,j,ki+1)+gg(i,j,ki)
          end do
        end do
      end do
C
C-----------------------------------------------------------------------
C
C     The following section solves the equation:
C
C       dti2(kq*q2l')' - q2l*(dti2*dtef+1.) = -q2lb
C
      do j=1,JM
        do i=1,IM
          if(uf(i,j,1).lt.small) uf(i,j,1)=small
          ee(i,j,1)=0.e0
          gg(i,j,1)=l(i,j,1)*uf(i,j,1)
          vf(i,j,KB)=l(i,j,KB)*uf(i,j,KB)
        end do
      end do
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            dtop=((z(1)-z(k))*dh(i,j)+z0s(i,j))
            dbot=((z(k)-z(kb))*dh(i,j)+z0c(i,j))
            dtef(i,j,k)=dtef(i,j,k)
     $          *(1.e0+e2*((1.e0/dtop+1.e0/dbot)*l(i,j,k)/kappa)**2)
            gg(i,j,k)=1.e0/(a(i,j,k)+c(i,j,k)*(1.e0-ee(i,j,k-1))
     $                      -(dti2*dtef(i,j,k)+1.e0))
            ee(i,j,k)=a(i,j,k)*gg(i,j,k)
            gg(i,j,k)=(dti2*(-prod(i,j,k)*l(i,j,k)*e1)
     $                 +c(i,j,k)*gg(i,j,k-1)-vf(i,j,k))*gg(i,j,k)
          end do
        end do
      end do
C
      do ki=KBM1,1,-1
        do j=1,JM
          do i=1,IM
            vf(i,j,ki)=ee(i,j,ki)*vf(i,j,ki+1)+gg(i,j,ki)
          end do
        end do
      end do
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            if(uf(i,j,k).le.small.or.vf(i,j,k).le.small) then
              uf(i,j,k)=small
              vf(i,j,k)=0.1d0*dt(i,j)*small
            endif
          end do
        end do
      end do
C
C-----------------------------------------------------------------------
C
C     The following section solves for km and kh:
C
      coef4=18.e0*a1*a1+9.e0*a1*a2
      coef5=9.e0*a1*a2
C
C     Note that sm and sh limit to infinity when gh approaches 0.0288:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            coef1=a2*(1.e0-6.e0*a1/b1*stf(i,j,k))
            coef2=3.e0*a2*b2/stf(i,j,k)+18.e0*a1*a2
            coef3=a1*(1.e0-3.e0*c1-6.e0*a1/b1*stf(i,j,k))
            sh(i,j,k)=coef1/(1.e0-coef2*gh(i,j,k))
            sm(i,j,k)=coef3+sh(i,j,k)*coef4*gh(i,j,k)
            sm(i,j,k)=sm(i,j,k)/(1.e0-coef5*gh(i,j,k))
          end do
        end do
      end do
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            kn(i,j,k)=lx(i,j,k)*sqrt(abs(q2(i,j,k)))
            kq(i,j,k)=(kn(i,j,k)*.41e0*sh(i,j,k)+kq(i,j,k))*.5e0
            km(i,j,k)=(kn(i,j,k)*sm(i,j,k)+km(i,j,k))*.5e0
            kh(i,j,k)=(kn(i,j,k)*sh(i,j,k)+kh(i,j,k))*.5e0
          end do
        end do
      end do
C
      return
C
      end
C
      subroutine proft(f,wfsurf,fsurf,nbc)
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Solves for vertical diffusion of temperature and    *
C *                salinity using method described by Richmeyer and    *
C *                Morton.                                             *
C *                                                                    *
C *                Irradiance parameters are from Paulson and Simpson. *
C *                                                                    *
C *                See:                                                *
C *                                                                    *
C *                Richtmeyer R.D., and K.W. Morton, 1967. Difference  *
C *                  Methods for Initial-Value Problems, 2nd edition,  *
C *                  Interscience, New York, 198-201.                  *
C *                                                                    *
C *                Paulson, C. A., and J. Simpson, 1977: Irradiance    *
C *                  measurements in the upper ocean, J. Phys.         *
C *                  Oceanogr., 7, 952-956.                            *
C *                                                                    *
C *                NOTES:                                              *
C *                                                                    *
C *                (1) wfsurf and swrad are negative values when water *
C *                    column is warming or salt is being added.       *
C *                                                                    *
C *                (2) nbc may only be 1 and 3 for salinity.           *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real f(IM,JM,KB),wfsurf(IM,JM)
      real fsurf(IM,JM),dh(IM,JM)
      integer nbc
      real rad(IM,JM,KB),r(5),ad1(5),ad2(5)
      integer i,j,k,ki
C
C-----------------------------------------------------------------------
C
C     Irradiance parameters after Paulson and Simpson:
C
C       ntp               1      2       3       4       5
C   Jerlov type           i      ia      ib      ii     iii
C
      data r   /       .58e0,  .62e0,  .67e0,  .77e0,  .78e0 /
      data ad1 /       .35e0,  .60e0,  1.0e0,  1.5e0,  1.4e0 /
      data ad2 /       23.e0,  20.e0,  17.e0,  14.e0,  7.9e0 /
C
C-----------------------------------------------------------------------
C
C     Surface boundary condition:
C
C       nbc   prescribed    prescribed   short wave
C             temperature      flux      penetration
C             or salinity               (temperature
C                                           only)
C
C        1        no           yes           no
C        2        no           yes           yes
C        3        yes          no            no
C        4        yes          no            yes
C
C     NOTE that only 1 and 3 are allowed for salinity.
C
C-----------------------------------------------------------------------
C
C     The following section solves the equation:
C
C       dti2*(kh*f')'-f=-fb
C
      do j=1,JM
        do i=1,IM
          dh(i,j)=h(i,j)+etf(i,j)
        end do
      end do
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            a(i,j,k-1)=-dti2*(kh(i,j,k)+umol)
     $                  /(dz(k-1)*dzz(k-1)*dh(i,j)*dh(i,j))
            c(i,j,k)=-dti2*(kh(i,j,k)+umol)
     $                  /(dz(k)*dzz(k-1)*dh(i,j)*dh(i,j))
          end do
        end do
      end do
C
C     Calculate penetrative radiation. At the bottom any unattenuated
C     radiation is deposited in the bottom layer:
C
      do k=1,KB
        do j=1,JM
          do i=1,IM
            rad(i,j,k)=0.e0
          end do
        end do
      end do
C
      if(nbc.eq.2.or.nbc.eq.4) then
C
        do k=1,KBM1
          do j=1,JM
            do i=1,IM
              rad(i,j,k)=swrad(i,j)
     $                    *(r(ntp)*exp(z(k)*dh(i,j)/ad1(ntp))
     $                      +(1.e0-r(ntp))*exp(z(k)*dh(i,j)/ad2(ntp)))
            end do
          end do
        end do
C
      endif
C
      if(nbc.eq.1) then
C
        do j=1,JM
          do i=1,IM
            ee(i,j,1)=a(i,j,1)/(a(i,j,1)-1.e0)
            gg(i,j,1)=-dti2*wfsurf(i,j)/(-dz(1)*dh(i,j))-f(i,j,1)
            gg(i,j,1)=gg(i,j,1)/(a(i,j,1)-1.e0)
          end do
        end do
C
      else if(nbc.eq.2) then
C
        do j=1,JM
          do i=1,IM
            ee(i,j,1)=a(i,j,1)/(a(i,j,1)-1.e0)
            gg(i,j,1)=dti2*(wfsurf(i,j)+rad(i,j,1)-rad(i,j,2))
     $                 /(dz(1)*dh(i,j))
     $                   -f(i,j,1)
            gg(i,j,1)=gg(i,j,1)/(a(i,j,1)-1.e0)
          end do
        end do
C
      else if(nbc.eq.3.or.nbc.eq.4) then
C
        do j=1,JM
          do i=1,IM
            ee(i,j,1)=0.e0
            gg(i,j,1)=fsurf(i,j)
          end do
        end do
C
      endif
C
      do k=2,KBM2
        do j=1,JM
          do i=1,IM
            gg(i,j,k)=1.e0/(a(i,j,k)+c(i,j,k)*(1.e0-ee(i,j,k-1))-1.e0)
            ee(i,j,k)=a(i,j,k)*gg(i,j,k)
            gg(i,j,k)=(c(i,j,k)*gg(i,j,k-1)-f(i,j,k)
     $                 +dti2*(rad(i,j,k)-rad(i,j,k+1))
     $                   /(dh(i,j)*dz(k)))
     $                 *gg(i,j,k)
          end do
        end do
      end do
C
C     Bottom adiabatic boundary condition:
C
      do j=1,JM
        do i=1,IM
          f(i,j,KBM1)=(c(i,j,KBM1)*gg(i,j,KBM2)-f(i,j,KBM1)
     $                 +dti2*(rad(i,j,KBM1)-rad(i,j,KB))
     $                   /(dh(i,j)*dz(KBM1)))
     $                 /(c(i,j,KBM1)*(1.e0-ee(i,j,KBM2))-1.e0)
        end do
      end do
C
      do k=2,KBM1
        ki=KB-k
        do j=1,JM
          do i=1,IM
          f(i,j,ki)=(ee(i,j,ki)*f(i,j,ki+1)+gg(i,j,ki))
          end do
        end do
      end do
C
      return
C
      end
C
C
C
      subroutine profu
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Solves for vertical diffusion of x-momentum using   *
C *                method described by Richmeyer and Morton.           *
C *                                                                    *
C *                See:                                                *
C *                                                                    *
C *                Richtmeyer R.D., and K.W. Morton, 1967. Difference  *
C *                  Methods for Initial-Value Problems, 2nd edition,  *
C *                  Interscience, New York, 198-201.                  *
C *                                                                    *
C *                NOTE that wusurf has the opposite sign to the wind  *
C *                speed.                                              *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'combal3.h'
      real dh(IM,JM),fsave(IM,JM,KB)
      real smx,dfact,dxu
      integer i,j,k,ki,ju,iu,iup,ium
      integer imx,kmx
C
C     The following section solves the equation:
C
C       dti2*(km*u')'-u=-ub
C
      do j=1,JM
        do i=1,IM
          dh(i,j)=1.e0
        end do
      end do
C
      do j=2,JM
        do i=2,IM
          dh(i,j)=(h(i,j)+etf(i,j)+h(i-1,j)+etf(i-1,j))*.5e0
        end do
      end do
C
      do k=1,KB
        do j=2,JM
          do i=2,IM
            c(i,j,k)=(km(i,j,k)+km(i-1,j,k))*.5e0
            fsave(i,j,k)=uf(i,j,k)
          end do
        end do
      end do
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            a(i,j,k-1)=-dti2*(c(i,j,k)+umol)
     $                  /(dz(k-1)*dzz(k-1)*dh(i,j)*dh(i,j))
            c(i,j,k)=-dti2*(c(i,j,k)+umol)
     $                /(dz(k)*dzz(k-1)*dh(i,j)*dh(i,j))
          end do
        end do
      end do
      do i=1,IM
        do j=1,JM
          if(impflg(i,j).eq.0)then
            uf(i,j,KBM1)=uf(i,j,KBM1)+
     *      dti2*wubot(i,j)/(dz(KBM1)*dh(i,j))
          endif
        enddo
      enddo
C
      do j=2,JMM1
        ju=2*j-2
        do i=IMM1,3,-1
          iu=2*i-3
          iup=iu+1
          ium=iu-1
          dxu=.5*(dx(i,j)+dx(i-1,j))
          ee(i,j,1)=a(i,j,1)/(a(i,j,1)-1.e0)
          gg(i,j,1)=(-dti2*wusurf(i,j)/(-dz(1)*dh(i,j))
     $               -uf(i,j,1))
     $               /(a(i,j,1)-1.e0)
C
          do k=2,KBM2
            gg(i,j,k)=1.e0/(a(i,j,k)+c(i,j,k)*(1.e0-ee(i,j,k-1))-1.e0)
            ee(i,j,k)=a(i,j,k)*gg(i,j,k)
            gg(i,j,k)=(c(i,j,k)*gg(i,j,k-1)-uf(i,j,k))*gg(i,j,k)
          end do
C
          if(impflg(i,j).ne.0)then
            tps(i,j)=0.5e0*(cbc(i,j)+cbc(i-1,j))
     $                *sqrt(ub(i,j,KBM1)**2
     $                  +(.25e0*(vb(i,j,KBM1)+vb(i,j+1,KBM1)
     $                           +vb(i-1,j,KBM1)+vb(i-1,j+1,KBM1)))**2)
            uf(i,j,KBM1)=(c(i,j,KBM1)*gg(i,j,KBM2)-uf(i,j,KBM1))
     $                    /(tps(i,j)*dti2/(-dz(KBM1)*dh(i,j))-1.e0
     $                      -(ee(i,j,KBM2)-1.e0)*c(i,j,KBM1))
            uf(i,j,KBM1)=uf(i,j,KBM1)*dum(i,j)
          else
            uf(i,j,KBM1)=(c(i,j,KBM1)*gg(i,j,KBM2)-uf(i,j,KBM1))
     $                 /(-1.e0-(ee(i,j,KBM2)-1.e0)*c(i,j,KBM1))
            uf(i,j,KBM1)=uf(i,j,KBM1)*dum(i,j)
          endif 
C

          do k=2,KBM1
            ki=KB-k
            uf(i,j,ki)=(ee(i,j,ki)*uf(i,j,ki+1)+gg(i,j,ki))*dum(i,j)
          end do
        enddo
      enddo
C
      if(ibcon.eq.0)then
        call perchanu1(wusurf)
        call perchanu(uf)
      endif
      do i=2,IMM1
        do j=2,JMM1
          if(impflg(i,j).ne.0)then
            wubot(i,j)=-tps(i,j)*uf(i,j,KBM1)
          endif
        end do
      end do
      if(ibcon.eq.0)call perchanu1(wubot)
      if(ibal.ne.0)then
        smx=0.
        do k=1,KBM1
          do j=2,JMM1
            do i=3,IMM1
              if(idiv.ne.0)then
                dfact=1./dh(i,j)
              else
                dfact=1.
              endif
              uver(i,j,k)=-(uf(i,j,k)-fsave(i,j,k))*dh(i,j)/
     *           dti2*dfact
              udt(i,j,k)= (dh(i,j)*uf(i,j,k)
     1          -.5e0*(h(i,j)+etb(i,j)+h(i-1,j)+etb(i-1,j))*
     *        ub(i,j,k))/dti2*dfact
              su(i,j,k)=udt(i,j,k)+uver(i,j,k)+ucor(i,j,k)+
     *          uadv(i,j,k)+udi(i,j,k)+up(i,j,k)+ubod(i,j)
              smx=max(abs(su(i,j,k)),smx)
            enddo
          enddo
        enddo
        if(mod(iint,ibalo).eq.0)write(*,'(a10,e12.4)')' u sum ',smx
      endif
C
      return
C
      end
C
C
      subroutine profv
C **********************************************************************
C                                                                      *
C * FUNCTION    :  Solves for vertical diffusion of y-momentum using   *
C *                method described by Richmeyer and Morton.           *
C *                                                                    *
C *                See:                                                *
C *                                                                    *
C *                Richtmeyer R.D., and K.W. Morton, 1967. Difference  *
C *                  Methods for Initial-Value Problems, 2nd edition,  *
C *                  Interscience, New York, 198-201.                  *
C *                                                                    *
C *                NOTE that wvsurf has the opposite sign to the wind  *
C *                speed.                                              *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'combal3.h'
      real dh(IM,JM),fsave(IM,JM,KB)
      integer i,j,k,ki,jv,ivp
      real smx,dfact,dxv
C
C     The following section solves the equation:
C
C       dti2*(km*u')'-u=-ub
C
      do j=1,JM
        do i=1,IM
          dh(i,j)=1.e0
        end do
      end do
C
      do j=2,JM
        do i=2,IM
          dh(i,j)=.5e0*(h(i,j)+etf(i,j)+h(i,j-1)+etf(i,j-1))
        end do
      end do
C
      do k=1,KB
        do j=2,JM
          do i=2,IM
            c(i,j,k)=(km(i,j,k)+km(i,j-1,k))*.5e0
            fsave(i,j,k)=vf(i,j,k)
          end do
        end do
      end do
C
      do k=2,KBM1
        do j=1,JM
          do i=1,IM
            a(i,j,k-1)=-dti2*(c(i,j,k)+umol)
     $                  /(dz(k-1)*dzz(k-1)*dh(i,j)*dh(i,j))
            c(i,j,k)=-dti2*(c(i,j,k)+umol)
     $                /(dz(k)*dzz(k-1)*dh(i,j)*dh(i,j))
          end do
        end do
      end do
      do i=1,IM
        do j=1,JM
          if(impflg(i,j).eq.0)then
            vf(i,j,KBM1)=vf(i,j,KBM1)+
     *         dti2*wvbot(i,j)/(dz(KBM1)*dh(i,j))
          endif
        enddo
      enddo
C
      do j=2,JMM1
        jv=2*j-3
        do i=IMM1,2,-1
          ivp=2*i-1
          dxv=.5*(dx(i,j)+dx(i,j-1))
          ee(i,j,1)=a(i,j,1)/(a(i,j,1)-1.e0)
          gg(i,j,1)=(-dti2*wvsurf(i,j)/(-dz(1)*dh(i,j))-vf(i,j,1))
     $               /(a(i,j,1)-1.e0)
C
          do k=2,KBM2
            gg(i,j,k)=1.e0/(a(i,j,k)+c(i,j,k)*(1.e0-ee(i,j,k-1))-1.e0)
            ee(i,j,k)=a(i,j,k)*gg(i,j,k)
            gg(i,j,k)=(c(i,j,k)*gg(i,j,k-1)-vf(i,j,k))*gg(i,j,k)
          end do
C
          if(impflg(i,j).ne.0)then
            tps(i,j)=0.5e0*(cbc(i,j)+cbc(i,j-1))
     $                *sqrt((.25e0*(ub(i,j,KBM1)+ub(i+1,j,KBM1)
     $                       +ub(i,j-1,KBM1)+ub(i+1,j-1,KBM1)))**2
     $                    +vb(i,j,KBM1)**2)
            vf(i,j,KBM1)=(c(i,j,KBM1)*gg(i,j,KBM2)-vf(i,j,KBM1))
     $                  /(tps(i,j)*dti2/(-dz(KBM1)*dh(i,j))-1.e0
     $                    -(ee(i,j,KBM2)-1.e0)*c(i,j,KBM1))
            vf(i,j,KBM1)=vf(i,j,KBM1)*dvm(i,j)
          else
            vf(i,j,KBM1)=(c(i,j,KBM1)*gg(i,j,KBM2)-vf(i,j,KBM1))
     $                  /(-1.e0-(ee(i,j,KBM2)-1.e0)*c(i,j,KBM1))
            vf(i,j,KBM1)=vf(i,j,KBM1)*dvm(i,j)
          endif
C
          do k=2,KBM1
            ki=KB-k
            vf(i,j,ki)=(ee(i,j,ki)*vf(i,j,ki+1)+gg(i,j,ki))*dvm(i,j)
          end do
        enddo
      enddo
C
      if(ibcon.eq.0)then
        call perchanv1(wvsurf)
        call perchanv(vf)
      endif
        do j=2,JMM1
          do i=2,IMM1
            if(impflg(i,j).ne.0)then
              wvbot(i,j)=-tps(i,j)*vf(i,j,KBM1)
            endif
          end do
        end do
        if(ibcon.eq.0)call perchanv1(wvbot)
C
      if(ibal.ne.0)then
        smx=0.
        do k=1,KBM1
          do j=2,JMM1
            do i=2,IMM1
              if(idiv.ne.0)then
                dfact=1./dh(i,j)
              else
                dfact=1.
              endif
              vver(i,j,k)=-(vf(i,j,k)-fsave(i,j,k))*dh(i,j)/dti2*dfact
              vdt(i,j,k)= (dh(i,j)*vf(i,j,k)
     1            -.5*(h(i,j)+etb(i,j)+h(i,j-1)+etb(i,j-1))*
     *            vb(i,j,k))/dti2*dfact
              sv(i,j,k)=vdt(i,j,k)+vver(i,j,k)+vcor(i,j,k)+
     *            vadv(i,j,k)+vdi(i,j,k)+vp(i,j,k)+vbod(i,j)
              smx=max(abs(sv(i,j,k)),smx)
            enddo
          enddo
        enddo
        if(mod(iint,ibalo).eq.0)write(*,'(a10,e12.4)')' v sum ',smx
      endif

      return
C
      end
!
      subroutine  purwv(row,ubouwm,znotp,ro)
      implicit none
      include "bblcom.h"
      include "def.h"
      real x,znotp,ubouwm,ubouwmn
      real ro,row,phi
      real ber,bei,ker,kei,berp
      real beip,kerp,keip
      integer ii,i
      complex bnot,knot
      complex bnotp,knotp
      complex gammai,argi

      do ii=1,n
        ro=row/ubouwm
        znotp=1./(kappa*ro)
        if(z1p/znotp .gt. 1.e0) then
          x=2.e0*sqrt(znotp)
          if(x .le. 8.e0) then
            call klvn2(x,ber,bei,ker,
     Z                            kei,berp,beip,kerp,
     Z                            keip,pi)
          else
            call kel2(x,ker,kei,ber,
     Z                bei,kerp,keip,berp,beip,pi)
          endif
          bnot=cmplx(ber,bei)
          knot=cmplx(ker,kei)
          bnotp=cmplx(berp,beip)/sqrt(znotp)
          knotp=cmplx(kerp,keip)/sqrt(znotp)
          argi=bnotp*nnb/(bnot*nnb-knot*llb)+
     Z           knotp*llb/(knot*llb-bnot*nnb)
          gammai=-kappa*znotp*argi
          phi=cabs(gammai)
        else
          gammai=-kappa*z1p*mp
          phi=cabs(gammai)
        endif
        ubouwmn=1./phi
        if(abs((ubouwmn-ubouwm)/ubouwmn) .le. tol)then
          ubouwm=ubouwmn
          return
        else
          ubouwm=ubouwmn
        endif
      enddo 

      return
      end
      subroutine read2d
      include "pom2k.h"
      integer n,i,j,k
      real  wubot2(IM,3),wvbot2(IM,3),aam2d2(IM,3),ua2(IM,3),
     *   uab2(IM,3),va2(IM,3),vab2(IM,3),el2(IM,3),elb2(IM,3),
     *   et2(IM,3),etb2(IM,3),egb2(IM,3),utb2(IM,3),vtb2(IM,3),
     *   u2(IM,3,KB),ub2(IM,3,KB),w2(IM,3,KB),v2(IM,3,KB),
     *   vb2(IM,3,KB),adx2d2(IM,3),ady2d2(IM,3),advua2(IM,3),
     *   advva2(IM,3),km2(IM,3,KB),kh2(IM,3,KB),kq2(IM,3,KB),
     *   l2(IM,3,KB),q22(IM,3,KB),q2b2(IM,3,KB),aam2(IM,3,KB),
     *   q2l2(IM,3,KB),q2lb2(IM,3,KB),wusurf2(IM,3),wvsurf2(IM,3),
     *   t2(IM,3,KB),tb2(IM,3,KB),s2(IM,3,KB),sb2(IM,3,KB),
     *   rho2(IM,3,KB),z0c2(IM,3)
         open(unit=199,file='restart.in',status='old',
     *     form='unformatted')
      do  n=1,-nread
        read(199) time0,
     *    wubot2,wvbot2,aam2d2,ua2,uab2,va2,vab2,el2,elb2,et2,etb2,egb2,
     *    utb2,vtb2,u2,ub2,w2,v2,vb2,
     $         t2,tb2,s2,sb2,rho2,
     *    adx2d2,ady2d2,advua2,advva2,
     *    km2,kh2,kq2,l2,q22,q2b2,aam2,q2l2,q2lb2,
     *    wusurf2,wvsurf2,z0c2
      enddo
      close(199)
      time=time0
      do i=1,IM
        do j=1,JM
          wubot(i,j)=wubot2(i,2) 
          wvbot(i,j)=wvbot2(i,2) 
          z0c(i,j)=z0c2(i,2)
          aam2d(i,j)=aam2d2(i,2)
          ua(i,j)=ua2(i,2)
          va(i,j)=va2(i,2)
          uab(i,j)=uab2(i,2)
          vab(i,j)=vab2(i,2)
          utb(i,j)=utb2(i,2)
          vtb(i,j)=vtb2(i,2)
          el(i,j)=el2(i,2)
          et(i,j)=et2(i,2)
          elb(i,j)=elb2(i,2)
          etb(i,j)=etb2(i,2)
          egb(i,j)=egb2(i,2)
          adx2d(i,j)=ADX2D2(i,2)
          ady2d(i,j)=ADY2D2(i,2)
          advua(i,j)=ADVUA2(i,2)
          advva(i,j)=ADVVA2(i,2)
          wusurf(i,j)=wusurf2(i,2) 
          wvsurf(i,j)=wvsurf2(i,2) 
        enddo
      enddo
      if(ibcon.eq.0)call perchanv1(z0c)
      do k=1,KB
        do i=1,IM
          do j=1,JM
            u(i,j,k)=u2(i,2,k)
            v(i,j,k)=v2(i,2,k)
            w(i,j,k)=w2(i,2,k)
            ub(i,j,k)=ub2(i,2,k)
            vb(i,j,k)=vb2(i,2,k)
            t(i,j,k)=t2(i,2,k)
            tb(i,j,k)=tb2(i,2,k)
            s(i,j,k)=s2(i,2,k)
            sb(i,j,k)=sb2(i,2,k)
            rho(i,j,k)=rho2(i,2,k)
            km(i,j,k)=km2(i,2,k)
            kh(i,j,k)=kh2(i,2,k)
            kq(i,j,k)=kq2(i,2,k)
            q2(i,j,k)=q22(i,2,k)
            q2l(i,j,k)=q2l2(i,2,k)
            l(i,j,k)=l2(i,2,k)
            q2b(i,j,k)=q2b2(i,2,k)
            q2lb(i,j,k)=q2lb2(i,2,k)
            aam(i,j,k)=aam2(i,2,k)
          enddo
        enddo
      enddo
      return
      end
      subroutine setup
C **********************************************************************
C *                                                                    *
C * FUNCTION    Set up problem.                                        *
C ******** this subroutine must be modified to set up a problem ********
C **********************************************************************
C
C
      include 'pom2k.h'
      include 'pass.h'
      integer i,j
      integer k,icurv,iu,iv,ju,jv,nadep
      real ang,elejmid,elwjmid,dtw,ela,xl,dtop,dbot,denom,pmax
      character*80 maskfile,stratfile,windfile,tfluxfile,
     *  pertfile
      namelist/set/iread,iwind,itflux,xpert,deltap,xlast
      namelist/inifile/maskfile,stratfile,windfile,tfluxfile,
     *  pertfile
      nadep=max(nav,1)
      iread=0
      read(11,set)
      write(*,set)
      maskfile = ''
      windfile = 'wind.dat'
      stratfile = 'strat.in'
      pertfile = ''
      read(11,inifile)  
      write(*,inifile)
      if(maskfile.ne.'')then
        open(unit=12,file=maskfile,status='old',form='formatted')
        do i=1,IM
          read(12,*)(fsm(i,j),j=1,JM)
        enddo 
        close(12)
      else
c mask will be calculated from depths (set zero on land)
        write(0,*)'this program requires a mask file'
        stop
      endif
      ipert=0
      if(pertfile.ne.'')then 
        ipert=1
        if(toff.eq.0)then
          if(ton.ne.0)then
             toff=ton
          else
             toff=hours
          endif 
        endif
        open(unit=12,file=pertfile, status='old',form='formatted')
        pmax=0.
        do j=2,JMM1
          read(12,*)(pert(i,j),i=2,IMM1)
          do i=2,IMM1
            pmax=max(pmax,abs(pert(i,j)))
          enddo
        enddo   
        close(12)
        write(*,*)' pmax = ',pmax
        do i=2,IMM1
          do j=2,JMM1
            pert(i,j)=pert(i,j)*deltap/pmax
          enddo
        enddo
        pmax=0.
        do i=2,IMM1
          do j=2,JMM1
            pmax=max(pmax,abs(pert(i,j)))
          enddo
        enddo
        write(*,*)' pmax = ',pmax
        call perchanv1(pert)
c        do j=1,JM
c          write(204,'(600e23.14)')(pert(i,j),i=1,IM)
c        enddo
        close(204)
      else
        pert=0.
      endif
C
C     Calculate horizontal coordinates of grid points. rotation
C     angle calculated in force
C
C     NOTE that this conforms with the requirements
C     of the NetCDF Climate and Forecast (CF) Metadata Conventions.
C
C     There are four horizontal coordinate systems, denoted by the
C     subscripts u, v, e and c ("u" is a u-point, "v" is a v-point,
C     "e" is an elevation point and "c" is a cell corner), as shown
C     below. In addition, "east_*" is an easting and "north_*" is a
C     northing. Hence the coordinates of the "u" points are given by
C     (east_u,north_u).
C
C     Also, if the centre point of the cell shown below is at
C     (east_e(i,j),north_e(i,j)), then (east_u(i,j),north_u(i,j)) are
C     the coordinates of the western of the two "u" points,
C     (east_v(i,j),north_v(i,j)) are the coordinates of the southern of
C     the two "v" points, and (east_c(i,j),north_c(i,j)) are the
C     coordinates of the southwestern corner point of the cell. The
C     southwest corner of the entire grid is at
C     (east_c(1,1),north_c(1,1)).
C
C                      |              |
C                    --c------v-------c--
C                      |              |
C                      |              |
C                      |              |
C                      |              |
C                      u      e       u
C                      |              |
C                      |              |
C                      |              |
C                      |              |
C                    --c------v-------c--
C                      |              |
C
C
C     NOTE that  east_c and north_c are the coordinates read
C      in by the master program and the depth from the master
C      program is at the corner
C    
C
      if(IDB.eq.2*IM-3)then
        do j=2,JM
          jv=2*j-3
          do i=2,IM
            iu=2*i-3
            east_c(i,j)=X_Circ(iu,jv)
            north_c(i,j)=Y_Circ(iu,jv)
          end do
c extrapolate
          east_c(1,j)=2.*east_c(2,j)-east_c(3,j)
          north_c(1,j)=2.*north_c(2,j)-north_c(3,j)
        end do
c extrapolate
        do i=1,IM
          east_c(i,1)=2.*east_c(i,2)-east_c(i,3)
          north_c(i,1)=2.*north_c(i,2)-north_c(i,3)
        enddo
C
C     fill other locations from double grid
C
C     Elevation points:
C
        call averw(Depth_Circ,nadep,Nx_Circ,Ny_Circ,ibcon)
        do j=2,JMM1
          ju=j*2-2
          do i=2,IMM1
            iv=i*2-2
            east_e(i,j)=x_Circ(iv,ju)
            north_e(i,j)=y_Circ(iv,ju)
            h(i,j)=Depth_Circ(iv,ju)*fsm(i,j)
          end do
        end do
C
C     Extrapolate ends:
C
C note that if JM=3, we assume ibcon = 0 so j=1,JM are written over below
        do i=2,IMM1
          h(i,1)=(2.e0*h(i,2)-h(i,3))*fsm(i,j)
          h(i,JM)=(2.e0*h(i,JMM1)-h(i,JMM2))*fsm(i,j)
          east_e(i,1)=2.e0*east_e(i,2)-east_e(i,3)
          north_e(i,1)=2.e0*north_e(i,2)-north_e(i,3)
          east_e(i,JM)=2.e0*east_e(i,JMM1)-east_e(i,JMM2)
          north_e(i,JM)=2.e0*north_e(i,JMM1)-north_e(i,JMM2)
        end do
C
        do j=1,JM
          h(1,j)=(2.e0*h(2,j)-h(3,j))*fsm(i,j)
          east_e(1,j)=2.e0*east_e(2,j)-east_e(3,j)
          north_e(1,j)=2.e0*north_e(2,j)-north_e(3,j)
          h(IM,j)=(2.e0*h(IMM1,j)-h(IMM2,j))*fsm(i,j)
          east_e(IM,j)=2.e0*east_e(IMM1,j)-east_e(IMM2,j)
          north_e(IM,j)=2.e0*north_e(IMM1,j)-north_e(IMM2,j)
        end do
C
C     u-points:
C
        do j=2,JMM1
          ju=j*2-2
          do i=2,IM
            iu=i*2-3
            east_u(i,j)=X_Circ(iu,ju)
            north_u(i,j)=Y_Circ(iu,ju)
          end do
        end do
C
C     Extrapolate ends:
C
        do i=2,IM
          east_u(i,1)=2.e0*east_u(i,2)-east_u(i,3)
          north_u(i,1)=2.e0*north_u(i,2)-north_u(i,3)
          east_u(i,JM)=2.e0*east_u(i,JMM1)-east_u(i,JMM2)
          north_u(i,JM)=2.e0*north_u(i,JMM1)-north_u(i,JMM2)
        end do
        do j=1,JM
          east_u(1,j)=2.e0*east_u(2,j)-east_u(3,j)
          north_u(1,j)=2.e0*north_u(2,j)-north_u(3,j)
        enddo
C
C     v-points:
C
        do j=2,JM
          jv=j*2-3
          do i=2,IMM1
            iv=i*2-2
            east_v(i,j)=X_Circ(iv,jv)
            north_v(i,j)=Y_circ(iv,jv)
          end do
        end do
C
C     Extrapolate ends:
C
        do j=2,JM
          east_v(IM,j)=2.e0*east_v(IMM1,j)-east_v(IMM2,j)
          north_v(IM,j)=2.e0*north_v(IMM1,j)-north_v(IMM2,j)
          east_v(1,j)=2.e0*east_v(2,j)-east_v(3,j)
          north_v(1,j)=2.e0*north_v(2,j)-north_v(3,j)
        end do
        do i=1,IM
          east_v(i,1)=2.e0*east_v(i,2)-east_v(i,3)
          north_v(i,1)=2.e0*north_v(i,2)-north_v(i,3)
        enddo
      else if(IDB.eq.IMM1)then
        do j=2,JM
          jv=j-1
          do i=2,IM
            iu=i-1
            east_c(i,j)=X_Circ(iu,jv)
            north_c(i,j)=Y_Circ(iu,jv)
          end do
c extrapolate
          east_c(1,j)=2.*east_c(2,j)-east_c(3,j)
          north_c(1,j)=2.*north_c(2,j)-north_c(3,j)
        end do
c extrapolate
        do i=1,IM
          east_c(i,1)=2.*east_c(i,2)-east_c(i,3)
          north_c(i,1)=2.*north_c(i,2)-north_c(i,3)
        enddo
C
C     fill other locations from passed grid
C
C     Elevation points:
C
        call averw(Depth_Circ,nadep,Nx_Circ,Ny_Circ,ibcon)
        do j=2,JMM1
          do i=2,IMM1
            east_e(i,j)=.25e0*(x_Circ(i,j)+x_Circ(i-1,j)+
     *        x_Circ(i,j-1)+x_Circ(i-1,j-1))
            north_e(i,j)=.25e0*(y_Circ(i,j)+y_Circ(i-1,j)+
     *        y_Circ(i,j-1)+y_Circ(i-1,j-1))
            h(i,j)=(.25e0*(Depth_Circ(i,j)+Depth_Circ(i-1,j)+
     *        Depth_Circ(i,j-1)+Depth_Circ(i-1,j-1)))*fsm(i,j)
          end do
        end do
C
C     Extrapolate ends:
C
C note that if JM=3, we assume ibcon = 0 so j=1,JM are written over below
        do i=2,IMM1
          h(i,1)=(2.e0*h(i,2)-h(i,3))*fsm(i,j)
          h(i,JM)=(2.e0*h(i,JMM1)-h(i,JMM2))*fsm(i,j)
          east_e(i,1)=2.e0*east_e(i,2)-east_e(i,3)
          north_e(i,1)=2.e0*north_e(i,2)-north_e(i,3)
          east_e(i,JM)=2.e0*east_e(i,JMM1)-east_e(i,JMM2)
          north_e(i,JM)=2.e0*north_e(i,JMM1)-north_e(i,JMM2)
        end do
C
        do j=1,JM
          h(1,j)=(2.e0*h(2,j)-h(3,j))*fsm(i,j)
          east_e(1,j)=2.e0*east_e(2,j)-east_e(3,j)
          north_e(1,j)=2.e0*north_e(2,j)-north_e(3,j)
          h(IM,j)=2.e0*h(IMM1,j)-h(IMM2,j)
          east_e(IM,j)=2.e0*east_e(IMM1,j)-east_e(IMM2,j)
          north_e(IM,j)=2.e0*north_e(IMM1,j)-north_e(IMM2,j)
        end do
C
C     u-points:
C
        do j=2,JMM1
          do i=2,IM
            east_u(i,j)=.5e0*(X_Circ(i-1,j)+X_Circ(i-1,j-1))
            north_u(i,j)=.5e0*(Y_Circ(i-1,j)+Y_Circ(i-1,j-1))
          end do
        end do
C
C     Extrapolate ends:
C
        do i=2,IM
          east_u(i,1)=2.e0*east_u(i,2)-east_u(i,3)
          north_u(i,1)=2.e0*north_u(i,2)-north_u(i,3)
          east_u(i,JM)=2.e0*east_u(i,JMM1)-east_u(i,JMM2)
          north_u(i,JM)=2.e0*north_u(i,JMM1)-north_u(i,JMM2)
        end do
        do j=1,JM
          east_u(1,j)=2.e0*east_u(2,j)-east_u(3,j)
          north_u(1,j)=2.e0*north_u(2,j)-north_u(3,j)
        enddo
C
C     v-points:
C
        do j=2,JM
          do i=2,IMM1
            east_v(i,j)=.5e0*(X_Circ(i,j-1)+X_Circ(i-1,j-1))
            north_v(i,j)=.5e0*(Y_circ(i,j-1)+Y_Circ(i-1,j-1))
          end do
        end do
C
C     Extrapolate ends:
C
        do j=2,JM
          east_v(IM,j)=2.e0*east_v(IMM1,j)-east_v(IMM2,j)
          north_v(IM,j)=2.e0*north_v(IMM1,j)-north_v(IMM2,j)
          east_v(1,j)=2.e0*east_v(2,j)-east_v(3,j)
          north_v(1,j)=2.e0*north_v(2,j)-north_v(3,j)
        end do
        do i=1,IM
          east_v(i,1)=2.e0*east_v(i,2)-east_v(i,3)
          north_v(i,1)=2.e0*north_v(i,2)-north_v(i,3)
        enddo
      else
       stop 'IDB size'
      endif
c
      do j=1,JMM1
        do i=1,IMM1
          dx(i,j)=east_u(i+1,j)-east_u(i,j)
          dy(i,j)=north_v(i,j+1)-north_v(i,j)
        enddo
        dx(IM,j)=2.*dx(IMM1,j)-dx(IM-2,j)
        dy(IM,j)=2.*dy(IMM1,j)-dy(IM-2,j)
      enddo
      do i=1,IM
         dx(i,JM)=2.*dx(i,JMM1)-dx(i,JM-2) 
         dy(i,JM)=2.*dy(i,JMM1)-dy(i,JM-2) 
      enddo
C
C
C
C
! 
      if(ibcon.eq.0)then
        call perchanv1(dx)
        call perchanv1(dy)
        call perchan1(h)
      else
        if(JM.eq.3)stop 'JM=3'
      endif
       
           
c
c if needed open file for initial conditions, add additional files
c if desired
c
c initial values have been zeroed previously
c it is only necessary to initialize non zero fields
c
c set land masks dum, dvm and if necessary fsm
      call areas_masks
      if(ibcon.eq.0)call perchanv1(h)
      if(z0sflg.ne.0.e0)then
        do i=2,IMM1
          do j=2,JMM1
            z0s(i,j)=min(abs(z0sflg),.5*h(i,j))
          enddo
        enddo
      else
        do i=2,IMM1
          do j=2,JMM1
            z0s(i,j)=0.e0
          enddo
        enddo
      endif
        do i=1,IM
          do j=1,JM
            cor(i,j)=f0
c
c if not constant it must be calculated on model grid
C
          end do
        end do
c initial stratification flat so rmean = rho(t=0),
c rmean should be (rho-1000)/rhoref
      if(istrat.ne.0)then
        open(unit=12,file=stratfile,status='old',form=
     *      'unformatted')
        if(iread.eq.0)then
          do k=1,KBM1
            do j=2,JMM1
              read(12)(tb(i,j,k),i=2,imm1)
            enddo
          enddo
          if(ibcon.eq.0) call perchanv(tb)
C input tb=rho-1000. ie sigma_theta set tbias to zero
          if(istrat.eq.1)then
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  tb(i,j,k)=tb(i,j,k)/rhoref
                enddo
              enddo
            enddo
          endif
          if(istrat.eq.2)then
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  tb(i,j,k)=tb(i,j,k)-tbias
                enddo
              enddo
            enddo   
            do k=1,KBM1
              read(12)(sb(i,2,k),i=2,imm1)
            enddo
            if(ibcon.eq.0) call perchanv(sb)
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  sb(i,j,k)=sb(i,j,k)-sbias
                  sclim(i,j,k)=sb(i,j,k)
                enddo
              enddo
            enddo
          endif
        else
          do k=1,KBM1
            read(12)(tclim(i,2,k),i=2,imm1)
          enddo
          if(ibcon.eq.0) call perchanv(tclim)
C input tb=rho-1000. ie sigma_theta set tbias to zero
          if(istrat.eq.1)then
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  tclim(i,j,k)=tclim(i,j,k)/rhoref
                  rmean(i,j,k)=tclim(i,j,k)
                enddo
              enddo
            enddo
          endif
        endif           
        close(12)
      endif
      if(iread.ne.0)then
        open(unit=10,file='uf',status='old',form='unformatted')
        do k=1,KBM1
          read(10)((ub(i,j,k),i=2,IM),j=2,JMM1)  
          do j=2,JMM1
            do i=2,IMM1
              uab(i,j)=uab(i,j)+ub(i,j,k)*dz(k)
            enddo
          enddo
        enddo
        close(10)           
        open(unit=10,file='vf',status='old',form='unformatted')
        do k=1,KBM1
          read(10)((vb(i,j,k),i=2,IM),j=2,JMM1)  
          do j=2,JMM1
            do i=2,IMM1
              vab(i,j)=vab(i,j)+vb(i,j,k)*dz(k)
            enddo
          enddo
        enddo
        close(10)           
        if(istrat.eq.1)then
          open(unit=10,file='sigtf',status='old',form='unformatted')
          do k=1,KBM1
            read(10)((tb(i,j,k),i=2,IM),j=2,JMM1)  
            do j=2,JMM1
              do i=2,IMM1
                tb(i,j,k)=tb(i,j,k)/rhoref
              enddo
            enddo
          enddo
          close(10)           
        else if(istrat.eq.2)then
          open(unit=10,file='tf',status='old',form='unformatted')
          do k=1,KBM1
            read(10)((tb(i,j,k),i=2,IM),j=2,JMM1)  
          enddo
          close(10)           
          open(unit=10,file='sf',status='old',form='unformatted')
          do k=1,KBM1
            read(10)((sb(i,j,k),i=2,im),j=2,jmm1)  
          enddo
          close(10)           
        endif
        open(unit=10,file='q2f',status='old',form='unformatted')
        do k=1,KB
          read(10)((q2b(i,j,k),i=2,IM),j=2,JMM1)  
        enddo
        close(10)           
        open(unit=10,file='kmf',status='old',form='unformatted')
        do k=1,KB
          read(10)((km(i,j,k),i=2,IM),j=2,JMM1)  
        enddo
        close(10)           
        open(unit=10,file='khf',status='old',form='unformatted')
        do k=1,KB
          read(10)((kh(i,j,k),i=2,IM),j=2,JMM1)  
        enddo
        close(10)           
        open(unit=10,file='elf',status='old',form='unformatted')
        read(10)((elb(i,j),i=2,im),j=2,jmm1)  
        ela=0.
        xl=0.
        do j=2,JMM1
          do i=2,IMM1
            ela=ela+elb(i,j)*dx(i,j)
            xl=xl+dx(i,j)
          enddo
        enddo
        ela=ela/xl
        do j=2,JMM1
          do i=2,IMM1
            elb(i,j)=elb(i,j)-ela
            etb(i,j)=elb(i,j)
            dt(i,j)=h(i,j)+elb(i,j)
            d(i,j)=dt(i,j)
          enddo
        enddo
        close(10)           
        do k=2,KBM1
          do j=2,JMM1
            do i=2,IMM1
              dtop=((z(1)-z(k))*dt(i,j)+z0s(i,j))
              dbot=((z(k)-z(kb))*dt(i,j)+z0b)
              denom=1./dtop+1./dbot
              l(i,j,k)= kappa/denom
            enddo
          enddo
        enddo
        do j=2,JMM1
          do i=2,IMM1
            l(i,j,1)=kappa*z0s(i,j)
            l(i,j,kb)=kappa*z0b
          enddo
        enddo
        do k=1,KB
          do j=2,JMM1
            do i=2,IMM1
              kq(i,j,k)=.41*kh(i,j,k)
              if(q2b(i,j,k).gt.1.e-8)then
                q2lb(i,j,k)=l(i,j,k)*q2b(i,j,k)
              else
                q2b(i,j,k)=small
                q2lb(i,j,k)=small
              endif
            enddo
          enddo
        enddo
        if(ibc.ne.0)then 
          open(unit=211,file='ubc',status='old',form=
     *      'unformatted')
          read(211)dtw
          if(dtw.ne.dti .and. ibc.gt.1)stop 'ubc time step'
          read(211)(ubc(k),k=1,kbm1)
          uabc=0
          do k=1,kbm1
             uabc=uabc+ubc(k)*dz(k)
          enddo
          do k=1,kbm1
             ubc(k)=ubc(k)-uabc 
          enddo
          do k=1,kbm1
            do j=2,JMM1
              do i=2,IMM1
                ub(i,j,k)=ub(i,j,k)-uabc
              enddo
            enddo
          enddo
          do j=2,JMM1
            do i=2,IMM1
               uab(i,j)=uab(i,j)-uabc
             enddo
          enddo
          uabc=0.e0
          open(unit=212,file='vbc',status='old',form=
     *       'unformatted') 
          read(212)dtw
          if(dtw.ne.dti .and. ibc.gt.1)stop 'vbc time step'
          read(212)(vbc(k),k=1,kbm1)
          vabc=0
          do k=1,kbm1
             vabc=vabc+vbc(k)*dz(k)
          enddo
          if(istrat.eq.1)then
            open(unit=213,file='sigtbc',status='old',form=
     *        'unformatted')
            read(213)dtw
            if(dtw.ne.dti .and. ibc.gt.1)stop 'tbc time step'
            read(213)(tbc(k),k=1,kbm1)
            do k=1,kbm1
              tbc(k)=tbc(k)/rhoref
            enddo
          else if(istrat.eq.2)then
             open(unit=213,file='tbc',status='old',form=
     *          'unformatted')
             read(213)dtw
             if(dtw.ne.dti .and. ibc.gt.1)stop 'tbc time step'
             read(213)(tbc(k),k=1,kbm1)
             open(unit=214,file='sbc',status='old',form=
     *          'unformatted')
             read(214)dtw
             if(dtw.ne.dti .and. ibc.gt.1)stop 'sbc time step'
             read(214)(sbc(k),k=1,kbm1)
          endif 
        endif
        if(ibcon.eq.0)then
            call perchanv(l)
            call perchanv(kq)
            call perchanv(km)
            call perchanv(kh)
            call perchanv1(elb)
            call perchanv(q2b)
            call perchanv(q2lb)
            call perchanv1(etb)
            call perchanv1(dt)
            call perchanv1(d)
          if(ibc.eq.0)then
            call perchanv(vb)
            call perchanu(ub)
            call perchanv(tb)
            call perchanv(sb)
            call perchanv1(vab)
            call perchanu1(uab)
          else
            call perchanvb(vb,vbc)
            call perchanub(ub,ubc)
            if(istrat.ne.0)call perchanvb(tb,tbc)
            if(istrat.eq.2)call perchanvb(sb,sbc)
            call perchanv1b(vab,vabc)
            call perchanu1b(uab,uabc)
          endif
        endif
          Circupdat_for_wave = .true.
        call passit
      endif
C
      do j=1,JM
        do i=1,IM
          elb(i,j)=elb(i,j)-e_atmos(i,j)
          etb(i,j)=elb(i,j)-e_atmos(i,j)
          dt(i,j)=h(i,j)+elb(i,j)-e_atmos(i,j)
          aam2d(i,j)=aam(i,j,1)
        end do
      end do
C
      if(istrat.eq.2) call dens(sb,tb,rho)
      if(istrat.eq.1)then
        do k=1,kb
          do i=1,IM
            do j=1,JM
              rho(i,j,k)=tb(i,j,k)
            enddo
          enddo
        enddo
      endif
       
C
C     Generated horizontally averaged density field (in this
C     application, the initial condition for density is a function
C     of z only (ie equal to its area average) (z=the vertical cartesian 
C     coordinate) -- when this is not so, make sure that rmean has been 
C     area averaged BEFORE transfer to sigma coordinates): 
C
      if(iread.eq.0)then
        if(istrat.ne.0)then
          do k=1,kbm1
            do j=1,JM
              do i=1,IM
                rmean(i,j,k)=rho(i,j,k)
              end do
            end do
          end do
          if(istrat.eq.1)then
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  tclim(i,j,k)=rmean(i,j,k)
                enddo
              enddo
            enddo
          else
            do k=1,KBM1
              do j=1,JM
                do i=1,IM
                  tclim(i,j,k)=tb(i,j,k)
                enddo
              enddo
            enddo
          endif
        endif
      endif
C
C     Set lateral boundary conditions, for use in subroutine bcond
C     (in the seamount problem, the east and west boundaries are open,
C     while the south and north boundaries are closed through the
C     specification of the masks fsm, dum and dvm):
C
c   Note that these are included as an example (the seamount
C   problem distributed in the unmodified POM code) and have to be 
c   changed for each problem.
      if(Ibcon.eq.1)then
        rfe=1.e0
        rfw=1.e0
        rfn=1.e0
        rfs=1.e0
C
        do j=2,JMm1
          uabw(j)=uab(2,j)
          uabe(j)=uab(IMM1,j)
C
C     Set geostrophically conditioned elevations at the boundaries:
C
          ele(j)=ele(j-1)-cor(IMM1,j)*uab(IMM1,j)/grav*dy(IMM1,j-1)
          elw(j)=elw(j-1)-cor(2,j)*uab(2,j)/grav*dy(2,j-1)
        end do
C
C     Adjust boundary elevations so that they are zero in the middle
C     of the channel:
C
        elejmid=ele(JMM1/2)
        elwjmid=elw(JMM1/2)
        do j=2,JMM1
          ele(j)=(ele(j)-elejmid*fsm(IM,j))
          elw(j)=(elw(j)-elwjmid)*fsm(2,j)
        end do
C
C     Set thermodynamic boundary conditions (for the seamount
C     problem, and other possible applications, lateral thermodynamic
C     boundary conditions are set equal to the initial conditions and
C     are held constant thereafter - users may, of course, create
C     variable boundary conditions):
C
        do k=1,kbm1
C
          do j=1,JM
            tbe(j,k)=tb(IM,j,k)
            tbw(j,k)=tb(1,j,k)
            sbe(j,k)=sb(IM,j,k)
            sbw(j,k)=sb(1,j,k)
          end do
C
          do i=1,IM
            tbn(i,k)=tb(i,JM,k)
            tbs(i,k)=tb(i,1,k)
            sbn(i,k)=sb(i,JM,k)
            sbs(i,k)=sb(i,1,k)
          end do
C
        end do
      endif
      if(slmax.lt.1.e0) call slpmax
c set up force calculation
      if(iwind.ne.0)then
        open(unit=13,file=windfile,status='old')
        read(13,*)dtw
        if(dtw.ne.dti)stop 'wind time step'
      endif
      if(istrat.eq.0)itflux=0
      if(itflux.ne.0)then
        open(unit=14,file=tfluxfile,status='old')
        read(14,*)dtw
        if(dtw.ne.dti)stop 'tflux time step'
      endif
      call force
C
      if(iread.eq.0)then 
        do k=1,KB
          do j=1,JM
            do i=1,IM
              l(i,j,k)=0.1d0*dt(i,j)
              q2b(i,j,k)=small
              q2lb(i,j,k)=l(i,j,k)*q2b(i,j,k)
              kh(i,j,k)=l(i,j,k)*sqrt(q2b(i,j,k))
              km(i,j,k)=kh(i,j,k)
              kq(i,j,k)=kh(i,j,k)
              q2(i,j,k)=q2b(i,j,k)
              q2l(i,j,k)=q2lb(i,j,k)
            end do
          end do
        end do
      else
        do k=1,KB
          do j=1,JM
            do i=1,IM
              q2(i,j,k)=q2b(i,j,k)
              q2l(i,j,k)=q2lb(i,j,k)
            end do
          end do
        end do
      endif
      return
C
      end
C
      subroutine slpmax
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Limits the maximum of:                              *
C *                                                                    *
C *                  <difference of depths>/<sum of depths>            *
C *                                                                    *
C *                for two adjacent cells. The maximum possible value  *
C *                is unity.                                           *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real mean,del
      integer i,j,loop
C
      do loop=1,10
C
C     Sweep right:
C
        do j=2,JMM1
C
          do i=2,IMM1
            if(fsm(i,j).ne.0.e0.and.fsm(i+1,j).ne.0.e0) then
              if(abs(h(i+1,j)-h(i,j))/(h(i,j)+h(i+1,j)).ge.slmax) then
                mean=(h(i+1,j)+h(i,j))/2.e0
                del=sign(slmax,h(i+1,j)-h(i,j))
                h(i+1,j)=mean*(1.e0+del)
                h(i,j)=mean*(1.e0-del)
              endif
            endif
          end do
C
C    Sweep left:
C
          do i=IMM1,2,-1
            if(fsm(i,j).ne.0.e0.and.fsm(i+1,j).ne.0.e0) then
              if(abs(h(i+1,j)-h(i,j))/(h(i,j)+h(i+1,j)).ge.slmax) then
                mean=(h(i+1,j)+h(i,j))/2.e0
                del=sign(slmax,h(i+1,j)-h(i,j))
                h(i+1,j)=mean*(1.e0+del)
                h(i,j)=mean*(1.e0-del)
              endif
            endif
          end do
C
        end do
C
C   Sweep up:
C
        do i=2,IMM1
C
          do j=2,JMM1
            if(fsm(i,j).ne.0.e0.and.fsm(i,j+1).ne.0.e0) then
              if(abs(h(i,j+1)-h(i,j))/(h(i,j)+h(i,j+1)).ge.slmax) then
                mean=(h(i,j+1)+h(i,j))/2.e0
                del=sign(slmax,h(i,j+1)-h(i,j))
                h(i,j+1)=mean*(1.e0+del)
                h(i,j)=mean*(1.e0-del)
              endif
            endif
          end do
C
C   Sweep down:
C
          do j=JMM1,2,-1
            if(fsm(i,j).ne.0.e0.and.fsm(i,j+1).ne.0.e0) then
              if(abs(h(i,j+1)-h(i,j))/(h(i,j)+h(i,j+1)).ge.slmax) then
                mean=(h(i,j+1)+h(i,j))/2.e0
                del=sign(slmax,h(i,j+1)-h(i,j))
                h(i,j+1)=mean*(1.e0+del)
                h(i,j)=mean*(1.e0-del)
              endif
            endif
          end do
C
        end do
C
      end do
C
      if(ibcon.eq.0) call perchan1(h)
      return
C
      end
C
      subroutine smol_adif(xmassflux,ymassflux,zwflux,ff)
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates the antidiffusive velocity used to       *
C *                reduce the numerical diffusion associated with the  *
C *                upstream differencing scheme.                       *
C *                                                                    *
C *                This is based on a subroutine of Gianmaria Sannino  *
C *                (Inter-university Computing Consortium, Rome, Italy)*
C *                and Vincenzo Artale (Italian National Agency for    *
C *                New Technology and Environment, Rome, Italy),       *
C *                downloaded from the POM FTP site on 1 Nov. 2001.    *
C *                The calculations have been simplified by removing   *
C *                the shock switch option.                            *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real ff(IM,JM,KB)
      real xmassflux(IM,JM,KB),ymassflux(IM,JM,KB),zwflux(IM,JM,KB)
      real mol,abs_1,abs_2
      real value_min,epsilon
      real udx,u2dt,vdy,v2dt,wdz,w2dt
      integer i,j,k
C
      parameter (value_min=1.e-9,epsilon=1.0e-14)
C
C     Apply temperature and salinity mask:
C
      if(ibcon.eq.0)then
        do k=1,KB
          do j=1,JM
            ff(1,j,k)=ff(2,j,k)
            ff(IM,j,j)=ff(IMM1,j,k)
          enddo
        enddo
        call perchan(ff)
      else if(ibcon.eq.2)then
        do k=1,KB
          do j=1,JM
            ff(1,j,k)=ff(2,j,k)
            ff(IM,j,j)=ff(IMM1,j,k)
          enddo
          do i=1,IM
            ff(i,1,k)=ff(i,2,k)
            ff(i,JM,k)=ff(i,JMM1,k)
          enddo
        enddo
      else
        do k=1,KB
          do i=1,IM
            do j=1,JM
              ff(i,j,k)=ff(i,j,k)*fsm(i,j)
            end do
          end do
        end do
      endif
C
C     Recalculate mass fluxes with antidiffusion velocity:
C
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IM
            if(ff(i,j,k).lt.value_min.or.
     $         ff(i-1,j,k).lt.value_min) then
              xmassflux(i,j,k)=0.e0
            else
              udx=abs(xmassflux(i,j,k))
              u2dt=dti2*xmassflux(i,j,k)*xmassflux(i,j,k)*2.e0
     $              /(aru(i,j)*(dt(i-1,j)+dt(i,j)))
              mol=(ff(i,j,k)-ff(i-1,j,k))
     $             /(ff(i-1,j,k)+ff(i,j,k)+epsilon)
              xmassflux(i,j,k)=(udx-u2dt)*mol*sw
              abs_1=abs(udx)
              abs_2=abs(u2dt)
              if(abs_1.lt.abs_2) xmassflux(i,j,k)=0.e0
            end if
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IMM1
            if(ff(i,j,k).lt.value_min.or.
     $         ff(i,j-1,k).lt.value_min) then
              ymassflux(i,j,k)=0.e0
            else
             vdy=abs(ymassflux(i,j,k))
             v2dt=dti2*ymassflux(i,j,k)*ymassflux(i,j,k)*2.e0
     $             /(arv(i,j)*(dt(i,j-1)+dt(i,j)))
             mol=(ff(i,j,k)-ff(i,j-1,k))
     $            /(ff(i,j-1,k)+ff(i,j,k)+epsilon)
             ymassflux(i,j,k)=(vdy-v2dt)*mol*sw
             abs_1=abs(vdy)
             abs_2=abs(v2dt)
             if(abs_1.lt.abs_2) ymassflux(i,j,k)=0.e0
            end if
          end do
        end do
      end do
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            if(ff(i,j,k).lt.value_min.or.
     $         ff(i,j,k-1).lt.value_min) then
              zwflux(i,j,k)=0.e0
            else
              wdz=abs(zwflux(i,j,k))
              w2dt=dti2*zwflux(i,j,k)*zwflux(i,j,k)/(dzz(k-1)*dt(i,j))
              mol=(ff(i,j,k-1)-ff(i,j,k))
     $             /(ff(i,j,k)+ff(i,j,k-1)+epsilon)
              zwflux(i,j,k)=(wdz-w2dt)*mol*sw
              abs_1=abs(wdz)
              abs_2=abs(w2dt)
              if(abs_1.lt.abs_2)zwflux(i,j,k)=0.e0
            end if
          end do
        end do
      end do
C
      return
C
      end

      subroutine smol_adifq
C**********************************************************************
C   THIS SUBROUTINE CALCULATES THE ANTIDIFFUSIVE VELOCITY USED TO     *
C   REDUCE THE NUMERICAL DIFFUSION ASSOCIATED WITH THE UPSTREAM       *
C   DIFFERENCING SCHEME. A SWITCH OPTION IS ALSO IMPLEMENTED FOR      *
C   THE SHOCK-TYPE INITIAL CONDITIONS                                 *
C**********************************************************************
C
      include 'pom2k.h'
      real VALUE_MAX,VALUE_MIN,EPSILON
      parameter (VALUE_MAX=1.E20,VALUE_MIN=1.E-9,EPSILON=1.0E-14)
c      parameter (ES=.15E-2)
C
      common/pom_smlq/xflux1,xflux2,yflux1,yflux2,zflux1,
     *  zflux2
      real xflux1(IM,JM,KB),yflux1(IM,JM,KB),zflux1(IM,JM,KB)
      real xflux2(IM,JM,KB),yflux2(IM,JM,KB),zflux2(IM,JM,KB)
      real mol,vdy,v2dt,udx,u2dt,wdz,w2dt,abs_1,abs_2
      integer i,j,k
C
C------------------------------------------------------------------------
C                  Q2 and Q2L MASK AND BC
C------------------------------------------------------------------------
      do k=1,KB
        do j=1,JM
          do i=1,IM
            uf(i,j,k)=uf(i,j,k)*fsm(i,j)
            vf(i,j,k)=vf(i,j,k)*fsm(i,j)
          enddo
        enddo
      enddo
      if(ibcon.ne.1)then
        do k=1,KB
          do j=2,JMM1
            uf(1,j,k)=uf(2,j,k)
            uf(im,j,k)=uf(imm1,j,k)      
            vf(1,j,k)=vf(2,j,k)
            vf(im,j,k)=vf(imm1,j,k)      
          enddo
        enddo
        if(ibcon.eq.0)then
          call perchan(uf)
          call perchan(vf)
        else 
          do k=1,KB
            do i=1,IM
              uf(i,1,k)=uf(i,2,k)
              uf(i,JM,k)=uf(i,JMM1,k)      
              vf(i,1,k)=vf(i,2,k)
              vf(i,JM,k)=vf(i,JMM1,k)      
            enddo
          enddo
        endif
      endif
C-----------------------------------------------------------------------
C    RECALCULATE MASS FLUXES WITH ANTIDIFFUSION VELOCITY 
C-----------------------------------------------------------------------
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IM
            if(uf(i,j,k) .LT. VALUE_MIN .OR. 
     *          uf(i-1,j,k).LT.VALUE_MIN)then
              xflux1(i,j,k)=0.0 
            else
c       sw=min(sw_u(i-1,j,k),sw_u(i,j,k))
              udx=abs(xflux1(i,j,k))
              u2dt=( 2.*dti2*xflux1(i,j,k)*xflux1(i,j,k)/
     &             (aru(i,j)*(dt(i-1,j)+dt(i,j))) )
              mol=(uf(i,j,k)-uf(i-1,j,k))/
     *            (uf(i-1,j,k)+uf(i,j,k)+EPSILON)
              xflux1(i,j,k)=(udx - u2dt)*mol*sw
              abs_1=abs(udx) 
              abs_2=abs(u2dt)
              if(abs_1 .LT. abs_2) xflux1(i,j,k)=0.0
            endif
          enddo
        enddo
      enddo
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IMM1
            if(uf(i,j,k) .lt. VALUE_MIN .or. 
     *           uf(i,j-1,k) .lt. VALUE_MIN)then
              yflux1(i,j,k)=0.0  
            else
c   SW=min(SW_V(I,J-1,K),SW_V(I,J,K))
              vdy=abs(yflux1(i,j,k))
              v2dt=( 2.*dti2*yflux1(i,j,k)*yflux1(i,j,k)/
     &             (arv(i,j)*(dt(i,j-1)+dt(i,j))) )
              mol=(uf(i,j,k)-uf(i,j-1,k))/
     *            (uf(i,j-1,k)+uf(i,j,k)+EPSILON)
              yflux1(i,j,k)= (vdy - v2dt)*mol*sw
              abs_1=abs(vdy)
              abs_2=abs(v2dt)
              if(abs_1 .lt. abs_2)yflux1(i,j,k)=0.0
            endif
          enddo
        enddo
      enddo
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            if(uf(i,j,k) .lt. VALUE_MIN .or. 
     *           uf(i,j,k-1) .lt. VALUE_MIN)then
              zflux1(I,J,K)=0.0 
            else
c         SW=min(SW_Z(I,J,K-1),SW_Z(I,J,K))
              wdz=abs(zflux1(i,j,k))
              w2dt=(dti2*zflux1(i,j,k)*zflux1(i,j,k)/
     &             (dzz(k-1)*dt(i,j)) )
              mol=(uf(i,j,k-1)-uf(i,j,k))/
     *            (uf(i,j,k)+uf(i,j,k-1)+EPSILON)
              zflux1(i,j,k)= (wdz - w2dt)*mol*sw
              abs_1=abs(wdz)
              abs_2=abs(w2dt)
              if(abs_1 .lt. abs_2)zfLUX1(i,j,k)=0.0
            endif
C
          enddo
        enddo
      enddo
C-----------------------------------------------------------------------
C    RECALCULATE MASS FLUXES WITH ANTIDIFFUSION VELOCITY 
C-----------------------------------------------------------------------
      do k=1,KBM1
        do j=2,JMM1
          do i=2,IM
            if(vf(i,j,k) .lt. VALUE_MIN .or. 
     *            vf(i-1,j,k) .LT. VALUE_MIN)then
               xflux2(i,j,k)=0.0 
            else
c         SW=min(SW_U(I-1,J,K),SW_U(I,J,K))
               udx=abs(xflux2(i,j,k))
               u2dt=( 2.e0*dti2*xflux2(i,j,k)*xflux2(i,j,k)/
     &             (aru(i,j)*(dt(i-1,j)+dt(i,j))) )
               mol=(vf(i,j,k)-vf(i-1,j,k))/
     *             (vf(i-1,j,k)+vf(i,j,k)+EPSILON)
               xflux2(i,j,k)= (udx - u2dt)*mol*sw
               abs_1=abs(udx) 
               abs_2=abs(u2dt)
               if(abs_1 .lt. abs_2) xflux2(i,j,k)=0.0
             endif
           enddo
         enddo
       enddo
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IMM1
            IF(vf(i,j,k) .lt. VALUE_MIN .or. 
     *           vf(i,j-1,k).lt.VALUE_MIN)then
              yflux2(I,J,K)=0.0  
            ELSE
c   SW=min(SW_V(I,J-1,K),SW_V(I,J,K))
              vdy=abs(yflux2(i,j,k))
              v2dt=( 2.*dti2*yflux2(i,j,k)*Yflux2(i,j,k)/
     &             (arv(i,j)*(dt(i,j-1)+dt(i,j))) )
              mol=(vf(i,j,k)-vf(i,j-1,k))/
     *            (vf(i,j-1,k)+vf(i,j,k)+EPSILON)
              yflux2(i,j,k)= (vdy - v2dt)*mol*sw
              abs_1=abs(vdy)
              abs_2=abs(v2dt)
              if(abs_1 .lt. abs_2)yflux2(i,j,k)=0.0
            endif
           enddo
         enddo
       enddo
C
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            IF(vf(i,j,k) .lt. VALUE_MIN .OR. 
     *          vf(i,j,k-1).lt.VALUE_MIN)then
              zflux2(i,j,k)=0.0 
            else
c         SW=min(SW_Z(I,J,K-1),SW_Z(I,J,K))
              wdz=abs(zflux2(i,j,k))
              w2dt=( dti2*zflux2(i,j,k)*zflux2(i,j,k)/
     &             (dzz(k-1)*dt(i,j)) )
              mol=(vf(i,j,k-1)-vf(i,j,k))/
     *            (vf(i,j,k)+vf(i,j,k-1)+EPSILON)
              zflux2(i,j,k)= (wdz - w2dt)*mol*sw
              abs_1=abs(wdz)
              abs_2=abs(w2dt)
              if(abs_1 .lt. abs_2)zflux2(i,j,k)=0.0
            endif
          enddo
        enddo
      enddo
C
      return
      end
C
      subroutine vertvl
C **********************************************************************
C *                                                                    *
C * FUNCTION    :  Calculates vertical velocity.                       *
C *                                                                    *
C **********************************************************************
C
C
      include 'pom2k.h'
C
      real xflux(IM,JM,KB),yflux(IM,JM,KB),wmx
      real xint(IM,JM)
      integer i,j,k,imax,jmax
C
C     Reestablish boundary conditions:
C
      do j=2,JMM1
        do i=2,IMM1
          xint(i,j)=0.
        enddo
      enddo
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            xflux(i,j,k)=.25e0*(dy(i,j)+dy(i-1,j))
     $                    *(dt(i,j)+dt(i-1,j))*u(i,j,k)
          end do
        end do
      end do
C
      do k=1,KBM1
        do j=2,JM
          do i=2,IM
            yflux(i,j,k)=.25e0*(dx(i,j)+dx(i,j-1))
     $                    *(dt(i,j)+dt(i,j-1))*v(i,j,k)
          end do
        end do
      end do
      if(ibcon.eq.0)call perchan(yflux)
      
C
C     NOTE that, if one wishes to include freshwater flux, the
C     surface velocity should be set to vflux(i,j). See also
C     change made to 2-D volume conservation equation which
C     calculates elf.
C
      k=1
      do j=2,JMM1
        do i=2,IMM1
          w(i,j,k+1)=wavg(i,j)
     $                +dz(k)*((xflux(i+1,j,k)-xflux(i,j,k)
     $                        +yflux(i,j+1,k)-yflux(i,j,k))
     $                        /(dx(i,j)*dy(i,j))
     $                        +(etf(i,j)-etb(i,j))/dti2)
        end do
      end do
      do k=2,KBM1
        do j=2,JMM1
          do i=2,IMM1
            w(i,j,k+1)=w(i,j,k)
     $                +dz(k)*((xflux(i+1,j,k)-xflux(i,j,k)
     $                        +yflux(i,j+1,k)-yflux(i,j,k))
     $                        /art(i,j)
     $                        +(etf(i,j)-etb(i,j))/dti2)
          end do
        end do
      end do
      if(mod(iint,icm*10).eq.0)then
        wmx=-100.
        imax=0
        jmax=0
        do j=2,JMM1
          do i=2,IMM1
            if(abs(w(i,j,KB)).gt.wmx)then
              wmx=abs(w(i,j,KB))
              imax=i
              jmax=j
            endif
            w(i,j,KB)=0.e0
          enddo
        enddo    
        write(*,*)'w bot max ',wmx,'i,j ',imax,jmax
      endif
C
      return
      end
      subroutine averw(f1,nav,nx,ny,ibc)
      implicit none
      include "pass.h"
      integer i,j,nx,ny,ibc
      integer nav
      real f1(Nx_Max,Ny_Max),tm1(Nx_Max,Ny_Max)
      integer ipp,imm,l,jmm,jpp
c      write(0,*)Nx_wave-1,f1(Nx_wave,2),f1(Nx_wave-1,2)
      do l=1,nav
      do i=2,nx-1
         ipp=i+1
         imm=i-1
         do j=2,ny-1
           jpp=j+1
           jmm=j-1
           tm1(i,j) = .125*(f1(ipp,j)+f1(imm,j)+f1(i,jpp)+f1(i,jmm))
     *     +.25*f1(i,j)+.0625*(f1(ipp,jpp)+f1(ipp,jmm)+f1(imm,jpp)+
     *     f1(imm,jmm))
        enddo
         if(ibc.eq.0)then
           tm1(i,1) = .125*(f1(ipp,1)+f1(imm,1)+f1(i,2)+f1(i,ny-1))
     *     +.25*f1(i,1)+.0625*(f1(ipp,2)+f1(ipp,ny-1)+f1(imm,2)+
     *     f1(imm,ny-1))
           tm1(i,ny) = tm1(i,1)
           endif
       enddo
       do i=2,nx-1
       do j=2,ny-1
          f1(i,j)=tm1(i,j)
        enddo
          if(ibc.eq.0)then
          f1(i,1)=tm1(i,1)
          f1(i,ny)=tm1(i,ny)
          endif
       enddo
c      write(0,*)l,f1(Nx_wave,2),f1(Nx_wave-1,2)
      enddo
      return
      end
